/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs
#define yylval          cf_lval
#define yychar          cf_char

/* First part of user prologue.  */
#line 49 "conf/gen_parser.m4"

#line 9 "conf/confbase.Y"
/* Headers from conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from conf/confbase.Y */

static void
check_u16(uint val)
{
  if (val > 0xFFFF)
    cf_error("Value %u out of range (0-65535)", val);
}

#define cf_assert(cond, ...) do { if (!(cond)) cf_error(__VA_ARGS__); } while (0)
static inline void cf_assert_symbol(const struct symbol *sym, uint class) {
  switch (class) {
    case SYM_PROTO: cf_assert(sym->class == SYM_PROTO, "Protocol name required"); break;
    case SYM_TEMPLATE: cf_assert(sym->class == SYM_TEMPLATE, "Protocol template name required"); break;
    case SYM_FUNCTION: cf_assert(sym->class == SYM_FUNCTION, "Function name required"); break;
    case SYM_FILTER: cf_assert(sym->class == SYM_FILTER, "Filter name required"); break;
    case SYM_TABLE: cf_assert(sym->class == SYM_TABLE, "Table name required"); break;
    case SYM_ATTRIBUTE: cf_assert(sym->class == SYM_ATTRIBUTE, "Custom attribute name required"); break;
    case SYM_VARIABLE: cf_assert((sym->class & ~0xff) == SYM_VARIABLE, "Variable name required"); break;
    case SYM_CONSTANT: cf_assert((sym->class & ~0xff) == SYM_CONSTANT, "Constant name required"); break;
    default: bug("This shall not happen");
  }
}

#line 9 "conf/flowspec.Y"
/* Headers from conf/flowspec.Y */

#define PARSER 1

#include "nest/bird.h"
#include "lib/flowspec.h"


/* Defines from conf/flowspec.Y */

struct flow_builder *this_flow;


#line 11 "filter/config.Y"
/* Headers from filter/config.Y */

#include "filter/f-inst.h"
#include "filter/data.h"

/* Defines from filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }

#define f_generate_complex(fi_code, da, arg) \
  f_new_inst(FI_EA_SET, f_new_inst(fi_code, f_new_inst(FI_EA_GET, da), arg), da)

/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
  case T_RD:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_val empty;

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      empty = f_const_empty_path;
      break;
    case EAF_TYPE_INT_SET:
      empty = f_const_empty_clist;
      break;
    case EAF_TYPE_EC_SET:
      empty = f_const_empty_eclist;
      break;
    case EAF_TYPE_LC_SET:
      empty = f_const_empty_lclist;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  return f_new_inst(FI_EA_SET, f_new_inst(FI_CONSTANT, empty), dyn);
}

#if 0

static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->val.type != T_INT) || (t2->val.type != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a[1].i);
    check_u16(t2->a[1].i);

    rv = f_new_inst(FI_CONSTANT);
    rv->val = (struct f_val) {
      .type = T_PAIR,
      .val.i = pair(t1->a[1].i, t2->a[1].i),
    };
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a[0].p = t1;
    rv->a[1].p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;
    struct f_val *val = &(tk->val);

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (tk->val.type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if ((val->type == T_IP) && ipa_is_ip4(val->val.ip)) {
      ipv4_used = 1; key = ipa_to_u32(val->val.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->val.type != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->val.val.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    rv = f_new_inst(FI_CONSTANT);
    rv->val = (struct f_val) {
      .type = T_EC,
      .val.ec = ec,
    };
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a[0].p = tk;
    rv->a[1].p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->val.type != T_INT) || (t2->val.type != T_INT) || (t3->val.type != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT);
    rv->val = (struct f_val) {
      .type = T_LC,
      .val.lc = (lcomm) { t1->a[1].i, t2->a[1].i, t3->a[1].i },
    };
  }
  else
  {
    rv = f_new_inst(FI_LC_CONSTRUCT);
    rv->a[0].p = t1;
    rv->a[1].p = t2;
    rv->a[2].p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_inst *t)
{
  uint len = 0;
  uint dyn = 0;
  for (const struct f_inst *tt = t; tt; tt = tt->next) {
    if (tt->fi_code != FI_CONSTANT)
      dyn++;
    len++;
  }

  if (dyn) {
    struct f_inst *pmc = f_new_inst(FI_PATHMASK_CONSTRUCT);
    pmc->a[0].p = t;
    pmc->a[1].i = len;
    return pmc;
  }

  struct f_path_mask *pm = cfg_allocz(sizeof(struct f_path_mask) + len * sizeof(struct f_path_mask_item));

  uint i = 0;
  for (const struct f_inst *tt = t; tt; tt = tt->next)
    pm->item[i++] = tt->val.val.pmi;

  pm->len = i;
  struct f_inst *pmc = f_new_inst(FI_CONSTANT);
  pmc->val = (struct f_val) { .type = T_PATH_MASK, .val.path_mask = pm, };

  return pmc;
}

#endif

/*
 * Remove all new lines and doubled whitespaces
 * and convert all tabulators to spaces
 * and return a copy of string
 */
char *
assert_copy_expr(const char *start, size_t len)
{
  /* XXX: Allocates maybe a little more memory than we really finally need */
  char *str = cfg_alloc(len + 1);

  char *dst = str;
  const char *src = start - 1;
  const char *end = start + len;
  while (++src < end)
  {
    if (*src == '\n')
      continue;

    /* Skip doubled whitespaces */
    if (src != start)
    {
      const char *prev = src - 1;
      if ((*src == ' ' || *src == '\t') && (*prev == ' ' || *prev == '\t'))
	continue;
    }

    if (*src == '\t')
      *dst = ' ';
    else
      *dst = *src;

    dst++;
  }
  *dst = '\0';

  return str;
}

/*
 * assert_done - create f_instruction of bt_assert
 * @expr: expression in bt_assert()
 * @start: pointer to first char of test expression
 * @end: pointer to the last char of test expression
 */
static struct f_inst *
assert_done(struct f_inst *expr, const char *start, const char *end)
{
  return f_new_inst(FI_ASSERT, expr,
    (end >= start) ?
      assert_copy_expr(start, end - start + 1)
    : "???");
}

static struct f_inst *
assert_assign(struct f_lval *lval, struct f_inst *expr, const char *start, const char *end)
{
  struct f_inst *setter, *getter, *checker;
  switch (lval->type) {
    case F_LVAL_VARIABLE:
      setter = f_new_inst(FI_VAR_SET, expr, lval->sym);
      getter = f_new_inst(FI_VAR_GET, lval->sym);
      break;
    case F_LVAL_PREFERENCE:
      setter = f_new_inst(FI_PREF_SET, expr);
      getter = f_new_inst(FI_PREF_GET);
      break;
    case F_LVAL_SA:
      setter = f_new_inst(FI_RTA_SET, expr, lval->sa);
      getter = f_new_inst(FI_RTA_GET, lval->sa);
      break;
    case F_LVAL_EA:
      setter = f_new_inst(FI_EA_SET, expr, lval->da);
      getter = f_new_inst(FI_EA_GET, lval->da);
      break;
    default:
      bug("Unknown lval type");
  }

  checker = f_new_inst(FI_EQ, expr, getter);
  setter->next = checker;
  
  return assert_done(setter, start, end);
}

#line 10 "nest/config.Y"
/* Headers from nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from nest/config.Y */

static struct proto_config *this_proto;
static struct channel_config *this_channel;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
/* static struct roa_table_config *this_roa_table; */
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->prefix.type)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

static void
proto_postconfig(void)
{
  CALL(this_proto->protocol->postconfig, this_proto);
  this_channel = NULL;
  this_proto = NULL;
}


#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

#line 8 "proto/bfd/config.Y"
/* Headers from proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

#line 13 "proto/babel/config.Y"
/* Headers from proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)

#line 9 "proto/bgp/config.Y"
/* Headers from proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)
#define BGP_CC ((struct bgp_channel_config *) this_channel)

#line 10 "proto/mrt/config.Y"
/* Headers from proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

#line 9 "proto/ospf/config.Y"
/* Headers from proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if (ospf_cfg_is_v2() && (ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;

      if (ospf_cfg_is_v3() && ip->autype && (pass->alg < ALG_HMAC))
	cf_error("Keyed hash algorithms are not allowed, use HMAC algorithms");
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;
  struct ospf_area_config *ac;
  struct ospf_iface_patt *ic;

  /* Define default channel */
  if (EMPTY_LIST(this_proto->channels))
  {
    uint net_type = this_proto->net_type = ospf_cfg_is_v2() ? NET_IP4 : NET_IP6;
    channel_config_new(NULL, net_label[net_type], net_type, this_proto);
  }

  /* Propagate global instance ID to interfaces */
  if (cf->instance_id_set)
  {
    WALK_LIST(ac, cf->area_list)
      WALK_LIST(ic, ac->patt_list)
	if (!ic->instance_id_set)
	{ ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }

    WALK_LIST(ic, cf->vlink_list)
      if (!ic->instance_id_set)
      { ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }
  }

  if (ospf_cfg_is_v3())
  {
    uint ipv4 = (this_proto->net_type == NET_IP4);
    uint base = (ipv4 ? 64 : 0) + (cf->af_mc ? 32 : 0);

    /* RFC 5838 - OSPFv3-AF */
    if (cf->af_ext)
    {
      /* RFC 5838 2.1 - instance IDs based on AFs */
      WALK_LIST(ac, cf->area_list)
	WALK_LIST(ic, ac->patt_list)
	{
	  if (!ic->instance_id_set)
	    ic->instance_id = base;
	  else if (ic->instance_id >= 128)
	    log(L_WARN "Instance ID %d from unassigned/private range", ic->instance_id);
	  else if ((ic->instance_id < base) || (ic->instance_id >= (base + 32)))
	    cf_error("Instance ID %d invalid for given channel type", ic->instance_id);
	}

      /* RFC 5838 2.8 - vlinks limited to IPv6 unicast */
      if ((ipv4 || cf->af_mc) && !EMPTY_LIST(cf->vlink_list))
	cf_error("Vlinks not supported in AFs other than IPv6 unicast");
    }
    else
    {
      if (ipv4 || cf->af_mc)
	cf_error("Different channel type");
    }
  }

  if (EMPTY_LIST(cf->area_list))
    cf_error("No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (proto_cf_main_channel(this_proto)->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%u", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Plaintext authentication not supported in OSPFv3");
}


#line 9 "proto/perf/config.Y"
/* Headers from proto/perf/config.Y */

#include "filter/filter.h"
#include "proto/perf/perf.h"

/* Defines from proto/perf/config.Y */

#define PERF_CFG ((struct perf_config *) this_proto)

#line 9 "proto/pipe/config.Y"
/* Headers from proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

#line 10 "proto/radv/config.Y"
/* Headers from proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


#line 12 "proto/rip/config.Y"
/* Headers from proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


#line 9 "proto/rpki/config.Y"
/* Headers from proto/rpki/config.Y */

#include "proto/rpki/rpki.h"

/* Defines from proto/rpki/config.Y */

#define RPKI_CFG ((struct rpki_config *) this_proto)
#define RPKI_TR_SSH_CFG ((struct rpki_tr_ssh_config *) RPKI_CFG->tr_config.spec)

static void
rpki_check_unused_hostname(void)
{
  if (RPKI_CFG->hostname != NULL)
    cf_error("Only one cache server per protocol allowed");
}

static void
rpki_check_unused_transport(void)
{
  if (RPKI_CFG->tr_config.spec != NULL)
    cf_error("At the most one transport per protocol allowed");
}

#line 9 "proto/static/config.Y"
/* Headers from proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_snh;
static struct f_inst *this_srt_cmds, *this_srt_last_cmd;

static struct static_route *
static_nexthop_new(void)
{
  struct static_route *nh = this_srt;

  if (this_snh)
  {
    /* Additional next hop */
    nh = cfg_allocz(sizeof(struct static_route));
    nh->net = this_srt->net;
    this_snh->mp_next = nh;
  }

  nh->dest = RTD_UNICAST;
  nh->mp_head = this_srt;
  return nh;
};

static void
static_route_finish(void)
{
  if (net_type_match(this_srt->net, NB_DEST) == !this_srt->dest)
    cf_error("Unexpected or missing nexthop/type");

  this_srt->cmds = f_linearize(this_srt_cmds);
}

#line 9 "sysdep/linux/netlink.Y"
/* Headers from sysdep/linux/netlink.Y */

#line 9 "sysdep/unix/config.Y"
/* Headers from sysdep/unix/config.Y */

#include "sysdep/unix/unix.h"
#include <stdio.h>

/* Defines from sysdep/unix/config.Y */

static struct log_config *this_log;

#line 9 "sysdep/unix/krt.Y"
/* Headers from sysdep/unix/krt.Y */

#include "sysdep/unix/krt.h"

/* Defines from sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)
#define KIF_IFACE ((struct kif_iface_config *) this_ipatt)

static void
kif_set_preferred(ip_addr ip)
{
  if (ipa_is_ip4(ip))
    KIF_IFACE->pref_v4 = ip;
  else if (!ipa_is_link_local(ip))
    KIF_IFACE->pref_v6 = ip;
  else
    KIF_IFACE->pref_ll = ip;
}

#line 49 "conf/gen_parser.m4"

#line 997 "obj/conf/cf-parse.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cf-parse.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_QUIT = 3,                       /* QUIT  */
  YYSYMBOL_EXIT = 4,                       /* EXIT  */
  YYSYMBOL_HELP = 5,                       /* HELP  */
  YYSYMBOL_END = 6,                        /* END  */
  YYSYMBOL_CLI_MARKER = 7,                 /* CLI_MARKER  */
  YYSYMBOL_INVALID_TOKEN = 8,              /* INVALID_TOKEN  */
  YYSYMBOL_ELSECOL = 9,                    /* ELSECOL  */
  YYSYMBOL_DDOT = 10,                      /* DDOT  */
  YYSYMBOL_GEQ = 11,                       /* GEQ  */
  YYSYMBOL_LEQ = 12,                       /* LEQ  */
  YYSYMBOL_NEQ = 13,                       /* NEQ  */
  YYSYMBOL_AND = 14,                       /* AND  */
  YYSYMBOL_OR = 15,                        /* OR  */
  YYSYMBOL_PO = 16,                        /* PO  */
  YYSYMBOL_PC = 17,                        /* PC  */
  YYSYMBOL_NUM = 18,                       /* NUM  */
  YYSYMBOL_ENUM = 19,                      /* ENUM  */
  YYSYMBOL_IP4 = 20,                       /* IP4  */
  YYSYMBOL_IP6 = 21,                       /* IP6  */
  YYSYMBOL_VPN_RD = 22,                    /* VPN_RD  */
  YYSYMBOL_CF_SYM_KNOWN = 23,              /* CF_SYM_KNOWN  */
  YYSYMBOL_CF_SYM_UNDEFINED = 24,          /* CF_SYM_UNDEFINED  */
  YYSYMBOL_TEXT = 25,                      /* TEXT  */
  YYSYMBOL_PREFIX_DUMMY = 26,              /* PREFIX_DUMMY  */
  YYSYMBOL_27_ = 27,                       /* '='  */
  YYSYMBOL_28_ = 28,                       /* '<'  */
  YYSYMBOL_29_ = 29,                       /* '>'  */
  YYSYMBOL_30_ = 30,                       /* '~'  */
  YYSYMBOL_NMA = 31,                       /* NMA  */
  YYSYMBOL_32_ = 32,                       /* '+'  */
  YYSYMBOL_33_ = 33,                       /* '-'  */
  YYSYMBOL_34_ = 34,                       /* '*'  */
  YYSYMBOL_35_ = 35,                       /* '/'  */
  YYSYMBOL_36_ = 36,                       /* '%'  */
  YYSYMBOL_37_ = 37,                       /* '!'  */
  YYSYMBOL_38_ = 38,                       /* '.'  */
  YYSYMBOL_DEFINE = 39,                    /* DEFINE  */
  YYSYMBOL_ON = 40,                        /* ON  */
  YYSYMBOL_OFF = 41,                       /* OFF  */
  YYSYMBOL_YES = 42,                       /* YES  */
  YYSYMBOL_NO = 43,                        /* NO  */
  YYSYMBOL_S = 44,                         /* S  */
  YYSYMBOL_MS = 45,                        /* MS  */
  YYSYMBOL_US = 46,                        /* US  */
  YYSYMBOL_PORT = 47,                      /* PORT  */
  YYSYMBOL_VPN = 48,                       /* VPN  */
  YYSYMBOL_MPLS = 49,                      /* MPLS  */
  YYSYMBOL_FROM = 50,                      /* FROM  */
  YYSYMBOL_51_ = 51,                       /* ';'  */
  YYSYMBOL_52_ = 52,                       /* '('  */
  YYSYMBOL_53_ = 53,                       /* ')'  */
  YYSYMBOL_FLOW4 = 54,                     /* FLOW4  */
  YYSYMBOL_FLOW6 = 55,                     /* FLOW6  */
  YYSYMBOL_DST = 56,                       /* DST  */
  YYSYMBOL_SRC = 57,                       /* SRC  */
  YYSYMBOL_PROTO = 58,                     /* PROTO  */
  YYSYMBOL_NEXT = 59,                      /* NEXT  */
  YYSYMBOL_HEADER = 60,                    /* HEADER  */
  YYSYMBOL_DPORT = 61,                     /* DPORT  */
  YYSYMBOL_SPORT = 62,                     /* SPORT  */
  YYSYMBOL_ICMP = 63,                      /* ICMP  */
  YYSYMBOL_TYPE = 64,                      /* TYPE  */
  YYSYMBOL_CODE = 65,                      /* CODE  */
  YYSYMBOL_TCP = 66,                       /* TCP  */
  YYSYMBOL_FLAGS = 67,                     /* FLAGS  */
  YYSYMBOL_LENGTH = 68,                    /* LENGTH  */
  YYSYMBOL_DSCP = 69,                      /* DSCP  */
  YYSYMBOL_DONT_FRAGMENT = 70,             /* DONT_FRAGMENT  */
  YYSYMBOL_IS_FRAGMENT = 71,               /* IS_FRAGMENT  */
  YYSYMBOL_FIRST_FRAGMENT = 72,            /* FIRST_FRAGMENT  */
  YYSYMBOL_LAST_FRAGMENT = 73,             /* LAST_FRAGMENT  */
  YYSYMBOL_FRAGMENT = 74,                  /* FRAGMENT  */
  YYSYMBOL_LABEL = 75,                     /* LABEL  */
  YYSYMBOL_OFFSET = 76,                    /* OFFSET  */
  YYSYMBOL_77_ = 77,                       /* ','  */
  YYSYMBOL_78_ = 78,                       /* '{'  */
  YYSYMBOL_79_ = 79,                       /* '}'  */
  YYSYMBOL_FUNCTION = 80,                  /* FUNCTION  */
  YYSYMBOL_PRINT = 81,                     /* PRINT  */
  YYSYMBOL_PRINTN = 82,                    /* PRINTN  */
  YYSYMBOL_UNSET = 83,                     /* UNSET  */
  YYSYMBOL_RETURN = 84,                    /* RETURN  */
  YYSYMBOL_ACCEPT = 85,                    /* ACCEPT  */
  YYSYMBOL_REJECT = 86,                    /* REJECT  */
  YYSYMBOL_ERROR = 87,                     /* ERROR  */
  YYSYMBOL_QUITBIRD = 88,                  /* QUITBIRD  */
  YYSYMBOL_INT = 89,                       /* INT  */
  YYSYMBOL_BOOL = 90,                      /* BOOL  */
  YYSYMBOL_IP = 91,                        /* IP  */
  YYSYMBOL_PREFIX = 92,                    /* PREFIX  */
  YYSYMBOL_RD = 93,                        /* RD  */
  YYSYMBOL_PAIR = 94,                      /* PAIR  */
  YYSYMBOL_QUAD = 95,                      /* QUAD  */
  YYSYMBOL_EC = 96,                        /* EC  */
  YYSYMBOL_LC = 97,                        /* LC  */
  YYSYMBOL_SET = 98,                       /* SET  */
  YYSYMBOL_STRING = 99,                    /* STRING  */
  YYSYMBOL_BGPMASK = 100,                  /* BGPMASK  */
  YYSYMBOL_BGPPATH = 101,                  /* BGPPATH  */
  YYSYMBOL_CLIST = 102,                    /* CLIST  */
  YYSYMBOL_ECLIST = 103,                   /* ECLIST  */
  YYSYMBOL_LCLIST = 104,                   /* LCLIST  */
  YYSYMBOL_IF = 105,                       /* IF  */
  YYSYMBOL_THEN = 106,                     /* THEN  */
  YYSYMBOL_ELSE = 107,                     /* ELSE  */
  YYSYMBOL_CASE = 108,                     /* CASE  */
  YYSYMBOL_TRUE = 109,                     /* TRUE  */
  YYSYMBOL_FALSE = 110,                    /* FALSE  */
  YYSYMBOL_RT = 111,                       /* RT  */
  YYSYMBOL_RO = 112,                       /* RO  */
  YYSYMBOL_UNKNOWN = 113,                  /* UNKNOWN  */
  YYSYMBOL_GENERIC = 114,                  /* GENERIC  */
  YYSYMBOL_GW = 115,                       /* GW  */
  YYSYMBOL_NET = 116,                      /* NET  */
  YYSYMBOL_MASK = 117,                     /* MASK  */
  YYSYMBOL_SOURCE = 118,                   /* SOURCE  */
  YYSYMBOL_SCOPE = 119,                    /* SCOPE  */
  YYSYMBOL_DEST = 120,                     /* DEST  */
  YYSYMBOL_IFNAME = 121,                   /* IFNAME  */
  YYSYMBOL_IFINDEX = 122,                  /* IFINDEX  */
  YYSYMBOL_PREFERENCE = 123,               /* PREFERENCE  */
  YYSYMBOL_ROA_CHECK = 124,                /* ROA_CHECK  */
  YYSYMBOL_ASN = 125,                      /* ASN  */
  YYSYMBOL_IS_V4 = 126,                    /* IS_V4  */
  YYSYMBOL_IS_V6 = 127,                    /* IS_V6  */
  YYSYMBOL_LEN = 128,                      /* LEN  */
  YYSYMBOL_MAXLEN = 129,                   /* MAXLEN  */
  YYSYMBOL_DEFINED = 130,                  /* DEFINED  */
  YYSYMBOL_ADD = 131,                      /* ADD  */
  YYSYMBOL_DELETE = 132,                   /* DELETE  */
  YYSYMBOL_CONTAINS = 133,                 /* CONTAINS  */
  YYSYMBOL_RESET = 134,                    /* RESET  */
  YYSYMBOL_PREPEND = 135,                  /* PREPEND  */
  YYSYMBOL_FIRST = 136,                    /* FIRST  */
  YYSYMBOL_LAST = 137,                     /* LAST  */
  YYSYMBOL_LAST_NONAGGREGATED = 138,       /* LAST_NONAGGREGATED  */
  YYSYMBOL_MATCH = 139,                    /* MATCH  */
  YYSYMBOL_EMPTY = 140,                    /* EMPTY  */
  YYSYMBOL_FILTER = 141,                   /* FILTER  */
  YYSYMBOL_WHERE = 142,                    /* WHERE  */
  YYSYMBOL_EVAL = 143,                     /* EVAL  */
  YYSYMBOL_ATTRIBUTE = 144,                /* ATTRIBUTE  */
  YYSYMBOL_BT_ASSERT = 145,                /* BT_ASSERT  */
  YYSYMBOL_BT_TEST_SUITE = 146,            /* BT_TEST_SUITE  */
  YYSYMBOL_BT_CHECK_ASSIGN = 147,          /* BT_CHECK_ASSIGN  */
  YYSYMBOL_BT_TEST_SAME = 148,             /* BT_TEST_SAME  */
  YYSYMBOL_FORMAT = 149,                   /* FORMAT  */
  YYSYMBOL_150_ = 150,                     /* ':'  */
  YYSYMBOL_151_ = 151,                     /* '['  */
  YYSYMBOL_152_ = 152,                     /* ']'  */
  YYSYMBOL_153_ = 153,                     /* '?'  */
  YYSYMBOL_ROUTER = 154,                   /* ROUTER  */
  YYSYMBOL_ID = 155,                       /* ID  */
  YYSYMBOL_PROTOCOL = 156,                 /* PROTOCOL  */
  YYSYMBOL_TEMPLATE = 157,                 /* TEMPLATE  */
  YYSYMBOL_DISABLED = 158,                 /* DISABLED  */
  YYSYMBOL_DEBUG = 159,                    /* DEBUG  */
  YYSYMBOL_ALL = 160,                      /* ALL  */
  YYSYMBOL_DIRECT = 161,                   /* DIRECT  */
  YYSYMBOL_INTERFACE = 162,                /* INTERFACE  */
  YYSYMBOL_IMPORT = 163,                   /* IMPORT  */
  YYSYMBOL_EXPORT = 164,                   /* EXPORT  */
  YYSYMBOL_NONE = 165,                     /* NONE  */
  YYSYMBOL_VRF = 166,                      /* VRF  */
  YYSYMBOL_DEFAULT = 167,                  /* DEFAULT  */
  YYSYMBOL_TABLE = 168,                    /* TABLE  */
  YYSYMBOL_STATES = 169,                   /* STATES  */
  YYSYMBOL_ROUTES = 170,                   /* ROUTES  */
  YYSYMBOL_FILTERS = 171,                  /* FILTERS  */
  YYSYMBOL_IPV4 = 172,                     /* IPV4  */
  YYSYMBOL_IPV6 = 173,                     /* IPV6  */
  YYSYMBOL_VPN4 = 174,                     /* VPN4  */
  YYSYMBOL_VPN6 = 175,                     /* VPN6  */
  YYSYMBOL_ROA4 = 176,                     /* ROA4  */
  YYSYMBOL_ROA6 = 177,                     /* ROA6  */
  YYSYMBOL_SADR = 178,                     /* SADR  */
  YYSYMBOL_RECEIVE = 179,                  /* RECEIVE  */
  YYSYMBOL_LIMIT = 180,                    /* LIMIT  */
  YYSYMBOL_ACTION = 181,                   /* ACTION  */
  YYSYMBOL_WARN = 182,                     /* WARN  */
  YYSYMBOL_BLOCK = 183,                    /* BLOCK  */
  YYSYMBOL_RESTART = 184,                  /* RESTART  */
  YYSYMBOL_DISABLE = 185,                  /* DISABLE  */
  YYSYMBOL_KEEP = 186,                     /* KEEP  */
  YYSYMBOL_FILTERED = 187,                 /* FILTERED  */
  YYSYMBOL_PASSWORD = 188,                 /* PASSWORD  */
  YYSYMBOL_PASSIVE = 189,                  /* PASSIVE  */
  YYSYMBOL_TO = 190,                       /* TO  */
  YYSYMBOL_EVENTS = 191,                   /* EVENTS  */
  YYSYMBOL_PACKETS = 192,                  /* PACKETS  */
  YYSYMBOL_PROTOCOLS = 193,                /* PROTOCOLS  */
  YYSYMBOL_INTERFACES = 194,               /* INTERFACES  */
  YYSYMBOL_ALGORITHM = 195,                /* ALGORITHM  */
  YYSYMBOL_KEYED = 196,                    /* KEYED  */
  YYSYMBOL_HMAC = 197,                     /* HMAC  */
  YYSYMBOL_MD5 = 198,                      /* MD5  */
  YYSYMBOL_SHA1 = 199,                     /* SHA1  */
  YYSYMBOL_SHA256 = 200,                   /* SHA256  */
  YYSYMBOL_SHA384 = 201,                   /* SHA384  */
  YYSYMBOL_SHA512 = 202,                   /* SHA512  */
  YYSYMBOL_PRIMARY = 203,                  /* PRIMARY  */
  YYSYMBOL_STATS = 204,                    /* STATS  */
  YYSYMBOL_COUNT = 205,                    /* COUNT  */
  YYSYMBOL_BY = 206,                       /* BY  */
  YYSYMBOL_FOR = 207,                      /* FOR  */
  YYSYMBOL_COMMANDS = 208,                 /* COMMANDS  */
  YYSYMBOL_PREEXPORT = 209,                /* PREEXPORT  */
  YYSYMBOL_NOEXPORT = 210,                 /* NOEXPORT  */
  YYSYMBOL_GENERATE = 211,                 /* GENERATE  */
  YYSYMBOL_BGP = 212,                      /* BGP  */
  YYSYMBOL_PASSWORDS = 213,                /* PASSWORDS  */
  YYSYMBOL_DESCRIPTION = 214,              /* DESCRIPTION  */
  YYSYMBOL_SORTED = 215,                   /* SORTED  */
  YYSYMBOL_RELOAD = 216,                   /* RELOAD  */
  YYSYMBOL_IN = 217,                       /* IN  */
  YYSYMBOL_OUT = 218,                      /* OUT  */
  YYSYMBOL_MRTDUMP = 219,                  /* MRTDUMP  */
  YYSYMBOL_MESSAGES = 220,                 /* MESSAGES  */
  YYSYMBOL_RESTRICT = 221,                 /* RESTRICT  */
  YYSYMBOL_MEMORY = 222,                   /* MEMORY  */
  YYSYMBOL_IGP_METRIC = 223,               /* IGP_METRIC  */
  YYSYMBOL_CLASS = 224,                    /* CLASS  */
  YYSYMBOL_TIMEFORMAT = 225,               /* TIMEFORMAT  */
  YYSYMBOL_ISO = 226,                      /* ISO  */
  YYSYMBOL_SHORT = 227,                    /* SHORT  */
  YYSYMBOL_LONG = 228,                     /* LONG  */
  YYSYMBOL_ROUTE = 229,                    /* ROUTE  */
  YYSYMBOL_BASE = 230,                     /* BASE  */
  YYSYMBOL_LOG = 231,                      /* LOG  */
  YYSYMBOL_GRACEFUL = 232,                 /* GRACEFUL  */
  YYSYMBOL_WAIT = 233,                     /* WAIT  */
  YYSYMBOL_MAX = 234,                      /* MAX  */
  YYSYMBOL_FLUSH = 235,                    /* FLUSH  */
  YYSYMBOL_AS = 236,                       /* AS  */
  YYSYMBOL_IPV4_MC = 237,                  /* IPV4_MC  */
  YYSYMBOL_IPV4_MPLS = 238,                /* IPV4_MPLS  */
  YYSYMBOL_IPV6_MC = 239,                  /* IPV6_MC  */
  YYSYMBOL_IPV6_MPLS = 240,                /* IPV6_MPLS  */
  YYSYMBOL_IPV6_SADR = 241,                /* IPV6_SADR  */
  YYSYMBOL_VPN4_MC = 242,                  /* VPN4_MC  */
  YYSYMBOL_VPN4_MPLS = 243,                /* VPN4_MPLS  */
  YYSYMBOL_VPN6_MC = 244,                  /* VPN6_MC  */
  YYSYMBOL_VPN6_MPLS = 245,                /* VPN6_MPLS  */
  YYSYMBOL_PRI = 246,                      /* PRI  */
  YYSYMBOL_SEC = 247,                      /* SEC  */
  YYSYMBOL_SHOW = 248,                     /* SHOW  */
  YYSYMBOL_STATUS = 249,                   /* STATUS  */
  YYSYMBOL_SUMMARY = 250,                  /* SUMMARY  */
  YYSYMBOL_SYMBOLS = 251,                  /* SYMBOLS  */
  YYSYMBOL_DUMP = 252,                     /* DUMP  */
  YYSYMBOL_RESOURCES = 253,                /* RESOURCES  */
  YYSYMBOL_SOCKETS = 254,                  /* SOCKETS  */
  YYSYMBOL_NEIGHBORS = 255,                /* NEIGHBORS  */
  YYSYMBOL_ATTRIBUTES = 256,               /* ATTRIBUTES  */
  YYSYMBOL_ECHO = 257,                     /* ECHO  */
  YYSYMBOL_ENABLE = 258,                   /* ENABLE  */
  YYSYMBOL_BABEL = 259,                    /* BABEL  */
  YYSYMBOL_METRIC = 260,                   /* METRIC  */
  YYSYMBOL_RXCOST = 261,                   /* RXCOST  */
  YYSYMBOL_HELLO = 262,                    /* HELLO  */
  YYSYMBOL_UPDATE = 263,                   /* UPDATE  */
  YYSYMBOL_WIRED = 264,                    /* WIRED  */
  YYSYMBOL_WIRELESS = 265,                 /* WIRELESS  */
  YYSYMBOL_BUFFER = 266,                   /* BUFFER  */
  YYSYMBOL_PRIORITY = 267,                 /* PRIORITY  */
  YYSYMBOL_CHECK = 268,                    /* CHECK  */
  YYSYMBOL_LINK = 269,                     /* LINK  */
  YYSYMBOL_HOP = 270,                      /* HOP  */
  YYSYMBOL_BABEL_METRIC = 271,             /* BABEL_METRIC  */
  YYSYMBOL_ENTRIES = 272,                  /* ENTRIES  */
  YYSYMBOL_RANDOMIZE = 273,                /* RANDOMIZE  */
  YYSYMBOL_BFD = 274,                      /* BFD  */
  YYSYMBOL_MIN = 275,                      /* MIN  */
  YYSYMBOL_IDLE = 276,                     /* IDLE  */
  YYSYMBOL_RX = 277,                       /* RX  */
  YYSYMBOL_TX = 278,                       /* TX  */
  YYSYMBOL_INTERVAL = 279,                 /* INTERVAL  */
  YYSYMBOL_MULTIPLIER = 280,               /* MULTIPLIER  */
  YYSYMBOL_MULTIHOP = 281,                 /* MULTIHOP  */
  YYSYMBOL_NEIGHBOR = 282,                 /* NEIGHBOR  */
  YYSYMBOL_DEV = 283,                      /* DEV  */
  YYSYMBOL_LOCAL = 284,                    /* LOCAL  */
  YYSYMBOL_AUTHENTICATION = 285,           /* AUTHENTICATION  */
  YYSYMBOL_SIMPLE = 286,                   /* SIMPLE  */
  YYSYMBOL_METICULOUS = 287,               /* METICULOUS  */
  YYSYMBOL_SESSIONS = 288,                 /* SESSIONS  */
  YYSYMBOL_HOLD = 289,                     /* HOLD  */
  YYSYMBOL_TIME = 290,                     /* TIME  */
  YYSYMBOL_CONNECT = 291,                  /* CONNECT  */
  YYSYMBOL_RETRY = 292,                    /* RETRY  */
  YYSYMBOL_KEEPALIVE = 293,                /* KEEPALIVE  */
  YYSYMBOL_STARTUP = 294,                  /* STARTUP  */
  YYSYMBOL_VIA = 295,                      /* VIA  */
  YYSYMBOL_SELF = 296,                     /* SELF  */
  YYSYMBOL_PATH = 297,                     /* PATH  */
  YYSYMBOL_START = 298,                    /* START  */
  YYSYMBOL_DELAY = 299,                    /* DELAY  */
  YYSYMBOL_FORGET = 300,                   /* FORGET  */
  YYSYMBOL_AFTER = 301,                    /* AFTER  */
  YYSYMBOL_BGP_PATH = 302,                 /* BGP_PATH  */
  YYSYMBOL_BGP_LOCAL_PREF = 303,           /* BGP_LOCAL_PREF  */
  YYSYMBOL_BGP_MED = 304,                  /* BGP_MED  */
  YYSYMBOL_BGP_ORIGIN = 305,               /* BGP_ORIGIN  */
  YYSYMBOL_BGP_NEXT_HOP = 306,             /* BGP_NEXT_HOP  */
  YYSYMBOL_BGP_ATOMIC_AGGR = 307,          /* BGP_ATOMIC_AGGR  */
  YYSYMBOL_BGP_AGGREGATOR = 308,           /* BGP_AGGREGATOR  */
  YYSYMBOL_BGP_COMMUNITY = 309,            /* BGP_COMMUNITY  */
  YYSYMBOL_BGP_EXT_COMMUNITY = 310,        /* BGP_EXT_COMMUNITY  */
  YYSYMBOL_BGP_LARGE_COMMUNITY = 311,      /* BGP_LARGE_COMMUNITY  */
  YYSYMBOL_ADDRESS = 312,                  /* ADDRESS  */
  YYSYMBOL_RR = 313,                       /* RR  */
  YYSYMBOL_RS = 314,                       /* RS  */
  YYSYMBOL_CLIENT = 315,                   /* CLIENT  */
  YYSYMBOL_CLUSTER = 316,                  /* CLUSTER  */
  YYSYMBOL_AS4 = 317,                      /* AS4  */
  YYSYMBOL_ADVERTISE = 318,                /* ADVERTISE  */
  YYSYMBOL_CAPABILITIES = 319,             /* CAPABILITIES  */
  YYSYMBOL_PREFER = 320,                   /* PREFER  */
  YYSYMBOL_OLDER = 321,                    /* OLDER  */
  YYSYMBOL_MISSING = 322,                  /* MISSING  */
  YYSYMBOL_LLADDR = 323,                   /* LLADDR  */
  YYSYMBOL_DROP = 324,                     /* DROP  */
  YYSYMBOL_IGNORE = 325,                   /* IGNORE  */
  YYSYMBOL_REFRESH = 326,                  /* REFRESH  */
  YYSYMBOL_INTERPRET = 327,                /* INTERPRET  */
  YYSYMBOL_COMMUNITIES = 328,              /* COMMUNITIES  */
  YYSYMBOL_BGP_ORIGINATOR_ID = 329,        /* BGP_ORIGINATOR_ID  */
  YYSYMBOL_BGP_CLUSTER_LIST = 330,         /* BGP_CLUSTER_LIST  */
  YYSYMBOL_IGP = 331,                      /* IGP  */
  YYSYMBOL_GATEWAY = 332,                  /* GATEWAY  */
  YYSYMBOL_RECURSIVE = 333,                /* RECURSIVE  */
  YYSYMBOL_MED = 334,                      /* MED  */
  YYSYMBOL_TTL = 335,                      /* TTL  */
  YYSYMBOL_SECURITY = 336,                 /* SECURITY  */
  YYSYMBOL_DETERMINISTIC = 337,            /* DETERMINISTIC  */
  YYSYMBOL_SECONDARY = 338,                /* SECONDARY  */
  YYSYMBOL_ALLOW = 339,                    /* ALLOW  */
  YYSYMBOL_PATHS = 340,                    /* PATHS  */
  YYSYMBOL_AWARE = 341,                    /* AWARE  */
  YYSYMBOL_EXTENDED = 342,                 /* EXTENDED  */
  YYSYMBOL_SETKEY = 343,                   /* SETKEY  */
  YYSYMBOL_STRICT = 344,                   /* STRICT  */
  YYSYMBOL_BIND = 345,                     /* BIND  */
  YYSYMBOL_CONFEDERATION = 346,            /* CONFEDERATION  */
  YYSYMBOL_MEMBER = 347,                   /* MEMBER  */
  YYSYMBOL_MULTICAST = 348,                /* MULTICAST  */
  YYSYMBOL_LIVED = 349,                    /* LIVED  */
  YYSYMBOL_STALE = 350,                    /* STALE  */
  YYSYMBOL_IBGP = 351,                     /* IBGP  */
  YYSYMBOL_EBGP = 352,                     /* EBGP  */
  YYSYMBOL_MANDATORY = 353,                /* MANDATORY  */
  YYSYMBOL_INTERNAL = 354,                 /* INTERNAL  */
  YYSYMBOL_EXTERNAL = 355,                 /* EXTERNAL  */
  YYSYMBOL_DYNAMIC = 356,                  /* DYNAMIC  */
  YYSYMBOL_RANGE = 357,                    /* RANGE  */
  YYSYMBOL_NAME = 358,                     /* NAME  */
  YYSYMBOL_DIGITS = 359,                   /* DIGITS  */
  YYSYMBOL_BGP_AIGP = 360,                 /* BGP_AIGP  */
  YYSYMBOL_AIGP = 361,                     /* AIGP  */
  YYSYMBOL_ORIGINATE = 362,                /* ORIGINATE  */
  YYSYMBOL_COST = 363,                     /* COST  */
  YYSYMBOL_CEASE = 364,                    /* CEASE  */
  YYSYMBOL_HIT = 365,                      /* HIT  */
  YYSYMBOL_ADMINISTRATIVE = 366,           /* ADMINISTRATIVE  */
  YYSYMBOL_SHUTDOWN = 367,                 /* SHUTDOWN  */
  YYSYMBOL_PEER = 368,                     /* PEER  */
  YYSYMBOL_CONFIGURATION = 369,            /* CONFIGURATION  */
  YYSYMBOL_CHANGE = 370,                   /* CHANGE  */
  YYSYMBOL_DECONFIGURED = 371,             /* DECONFIGURED  */
  YYSYMBOL_CONNECTION = 372,               /* CONNECTION  */
  YYSYMBOL_REJECTED = 373,                 /* REJECTED  */
  YYSYMBOL_COLLISION = 374,                /* COLLISION  */
  YYSYMBOL_OF = 375,                       /* OF  */
  YYSYMBOL_MRT = 376,                      /* MRT  */
  YYSYMBOL_FILENAME = 377,                 /* FILENAME  */
  YYSYMBOL_PERIOD = 378,                   /* PERIOD  */
  YYSYMBOL_ALWAYS = 379,                   /* ALWAYS  */
  YYSYMBOL_OSPF = 380,                     /* OSPF  */
  YYSYMBOL_V2 = 381,                       /* V2  */
  YYSYMBOL_V3 = 382,                       /* V3  */
  YYSYMBOL_OSPF_METRIC1 = 383,             /* OSPF_METRIC1  */
  YYSYMBOL_OSPF_METRIC2 = 384,             /* OSPF_METRIC2  */
  YYSYMBOL_OSPF_TAG = 385,                 /* OSPF_TAG  */
  YYSYMBOL_OSPF_ROUTER_ID = 386,           /* OSPF_ROUTER_ID  */
  YYSYMBOL_AREA = 387,                     /* AREA  */
  YYSYMBOL_RFC1583COMPAT = 388,            /* RFC1583COMPAT  */
  YYSYMBOL_STUB = 389,                     /* STUB  */
  YYSYMBOL_TICK = 390,                     /* TICK  */
  YYSYMBOL_COST2 = 391,                    /* COST2  */
  YYSYMBOL_RETRANSMIT = 392,               /* RETRANSMIT  */
  YYSYMBOL_TRANSMIT = 393,                 /* TRANSMIT  */
  YYSYMBOL_DEAD = 394,                     /* DEAD  */
  YYSYMBOL_BROADCAST = 395,                /* BROADCAST  */
  YYSYMBOL_BCAST = 396,                    /* BCAST  */
  YYSYMBOL_NONBROADCAST = 397,             /* NONBROADCAST  */
  YYSYMBOL_NBMA = 398,                     /* NBMA  */
  YYSYMBOL_POINTOPOINT = 399,              /* POINTOPOINT  */
  YYSYMBOL_PTP = 400,                      /* PTP  */
  YYSYMBOL_POINTOMULTIPOINT = 401,         /* POINTOMULTIPOINT  */
  YYSYMBOL_PTMP = 402,                     /* PTMP  */
  YYSYMBOL_CRYPTOGRAPHIC = 403,            /* CRYPTOGRAPHIC  */
  YYSYMBOL_ELIGIBLE = 404,                 /* ELIGIBLE  */
  YYSYMBOL_POLL = 405,                     /* POLL  */
  YYSYMBOL_NETWORKS = 406,                 /* NETWORKS  */
  YYSYMBOL_HIDDEN = 407,                   /* HIDDEN  */
  YYSYMBOL_VIRTUAL = 408,                  /* VIRTUAL  */
  YYSYMBOL_ONLY = 409,                     /* ONLY  */
  YYSYMBOL_LARGE = 410,                    /* LARGE  */
  YYSYMBOL_NORMAL = 411,                   /* NORMAL  */
  YYSYMBOL_STUBNET = 412,                  /* STUBNET  */
  YYSYMBOL_TAG = 413,                      /* TAG  */
  YYSYMBOL_LSADB = 414,                    /* LSADB  */
  YYSYMBOL_ECMP = 415,                     /* ECMP  */
  YYSYMBOL_WEIGHT = 416,                   /* WEIGHT  */
  YYSYMBOL_NSSA = 417,                     /* NSSA  */
  YYSYMBOL_TRANSLATOR = 418,               /* TRANSLATOR  */
  YYSYMBOL_STABILITY = 419,                /* STABILITY  */
  YYSYMBOL_GLOBAL = 420,                   /* GLOBAL  */
  YYSYMBOL_LSID = 421,                     /* LSID  */
  YYSYMBOL_INSTANCE = 422,                 /* INSTANCE  */
  YYSYMBOL_REAL = 423,                     /* REAL  */
  YYSYMBOL_NETMASK = 424,                  /* NETMASK  */
  YYSYMBOL_MERGE = 425,                    /* MERGE  */
  YYSYMBOL_LSA = 426,                      /* LSA  */
  YYSYMBOL_SUPPRESSION = 427,              /* SUPPRESSION  */
  YYSYMBOL_RFC5838 = 428,                  /* RFC5838  */
  YYSYMBOL_PE = 429,                       /* PE  */
  YYSYMBOL_TOPOLOGY = 430,                 /* TOPOLOGY  */
  YYSYMBOL_STATE = 431,                    /* STATE  */
  YYSYMBOL_PERF = 432,                     /* PERF  */
  YYSYMBOL_EXP = 433,                      /* EXP  */
  YYSYMBOL_REPEAT = 434,                   /* REPEAT  */
  YYSYMBOL_THRESHOLD = 435,                /* THRESHOLD  */
  YYSYMBOL_MODE = 436,                     /* MODE  */
  YYSYMBOL_PIPE = 437,                     /* PIPE  */
  YYSYMBOL_RADV = 438,                     /* RADV  */
  YYSYMBOL_RA = 439,                       /* RA  */
  YYSYMBOL_SOLICITED = 440,                /* SOLICITED  */
  YYSYMBOL_UNICAST = 441,                  /* UNICAST  */
  YYSYMBOL_MANAGED = 442,                  /* MANAGED  */
  YYSYMBOL_OTHER = 443,                    /* OTHER  */
  YYSYMBOL_CONFIG = 444,                   /* CONFIG  */
  YYSYMBOL_LINGER = 445,                   /* LINGER  */
  YYSYMBOL_MTU = 446,                      /* MTU  */
  YYSYMBOL_REACHABLE = 447,                /* REACHABLE  */
  YYSYMBOL_RETRANS = 448,                  /* RETRANS  */
  YYSYMBOL_TIMER = 449,                    /* TIMER  */
  YYSYMBOL_CURRENT = 450,                  /* CURRENT  */
  YYSYMBOL_VALID = 451,                    /* VALID  */
  YYSYMBOL_PREFERRED = 452,                /* PREFERRED  */
  YYSYMBOL_MULT = 453,                     /* MULT  */
  YYSYMBOL_LIFETIME = 454,                 /* LIFETIME  */
  YYSYMBOL_SKIP = 455,                     /* SKIP  */
  YYSYMBOL_ONLINK = 456,                   /* ONLINK  */
  YYSYMBOL_AUTONOMOUS = 457,               /* AUTONOMOUS  */
  YYSYMBOL_RDNSS = 458,                    /* RDNSS  */
  YYSYMBOL_DNSSL = 459,                    /* DNSSL  */
  YYSYMBOL_NS = 460,                       /* NS  */
  YYSYMBOL_DOMAIN = 461,                   /* DOMAIN  */
  YYSYMBOL_TRIGGER = 462,                  /* TRIGGER  */
  YYSYMBOL_SENSITIVE = 463,                /* SENSITIVE  */
  YYSYMBOL_LOW = 464,                      /* LOW  */
  YYSYMBOL_MEDIUM = 465,                   /* MEDIUM  */
  YYSYMBOL_HIGH = 466,                     /* HIGH  */
  YYSYMBOL_PROPAGATE = 467,                /* PROPAGATE  */
  YYSYMBOL_RA_PREFERENCE = 468,            /* RA_PREFERENCE  */
  YYSYMBOL_RA_LIFETIME = 469,              /* RA_LIFETIME  */
  YYSYMBOL_RIP = 470,                      /* RIP  */
  YYSYMBOL_NG = 471,                       /* NG  */
  YYSYMBOL_INFINITY = 472,                 /* INFINITY  */
  YYSYMBOL_TIMEOUT = 473,                  /* TIMEOUT  */
  YYSYMBOL_GARBAGE = 474,                  /* GARBAGE  */
  YYSYMBOL_VERSION = 475,                  /* VERSION  */
  YYSYMBOL_SPLIT = 476,                    /* SPLIT  */
  YYSYMBOL_HORIZON = 477,                  /* HORIZON  */
  YYSYMBOL_POISON = 478,                   /* POISON  */
  YYSYMBOL_REVERSE = 479,                  /* REVERSE  */
  YYSYMBOL_ZERO = 480,                     /* ZERO  */
  YYSYMBOL_PLAINTEXT = 481,                /* PLAINTEXT  */
  YYSYMBOL_RIP_METRIC = 482,               /* RIP_METRIC  */
  YYSYMBOL_RIP_TAG = 483,                  /* RIP_TAG  */
  YYSYMBOL_RPKI = 484,                     /* RPKI  */
  YYSYMBOL_REMOTE = 485,                   /* REMOTE  */
  YYSYMBOL_BIRD = 486,                     /* BIRD  */
  YYSYMBOL_PRIVATE = 487,                  /* PRIVATE  */
  YYSYMBOL_PUBLIC = 488,                   /* PUBLIC  */
  YYSYMBOL_KEY = 489,                      /* KEY  */
  YYSYMBOL_SSH = 490,                      /* SSH  */
  YYSYMBOL_TRANSPORT = 491,                /* TRANSPORT  */
  YYSYMBOL_USER = 492,                     /* USER  */
  YYSYMBOL_EXPIRE = 493,                   /* EXPIRE  */
  YYSYMBOL_STATIC = 494,                   /* STATIC  */
  YYSYMBOL_PROHIBIT = 495,                 /* PROHIBIT  */
  YYSYMBOL_BLACKHOLE = 496,                /* BLACKHOLE  */
  YYSYMBOL_UNREACHABLE = 497,              /* UNREACHABLE  */
  YYSYMBOL_KERNEL = 498,                   /* KERNEL  */
  YYSYMBOL_KRT_PREFSRC = 499,              /* KRT_PREFSRC  */
  YYSYMBOL_KRT_REALM = 500,                /* KRT_REALM  */
  YYSYMBOL_KRT_SCOPE = 501,                /* KRT_SCOPE  */
  YYSYMBOL_KRT_MTU = 502,                  /* KRT_MTU  */
  YYSYMBOL_KRT_WINDOW = 503,               /* KRT_WINDOW  */
  YYSYMBOL_KRT_RTT = 504,                  /* KRT_RTT  */
  YYSYMBOL_KRT_RTTVAR = 505,               /* KRT_RTTVAR  */
  YYSYMBOL_KRT_SSTRESH = 506,              /* KRT_SSTRESH  */
  YYSYMBOL_KRT_CWND = 507,                 /* KRT_CWND  */
  YYSYMBOL_KRT_ADVMSS = 508,               /* KRT_ADVMSS  */
  YYSYMBOL_KRT_REORDERING = 509,           /* KRT_REORDERING  */
  YYSYMBOL_KRT_HOPLIMIT = 510,             /* KRT_HOPLIMIT  */
  YYSYMBOL_KRT_INITCWND = 511,             /* KRT_INITCWND  */
  YYSYMBOL_KRT_RTO_MIN = 512,              /* KRT_RTO_MIN  */
  YYSYMBOL_KRT_INITRWND = 513,             /* KRT_INITRWND  */
  YYSYMBOL_KRT_QUICKACK = 514,             /* KRT_QUICKACK  */
  YYSYMBOL_KRT_LOCK_MTU = 515,             /* KRT_LOCK_MTU  */
  YYSYMBOL_KRT_LOCK_WINDOW = 516,          /* KRT_LOCK_WINDOW  */
  YYSYMBOL_KRT_LOCK_RTT = 517,             /* KRT_LOCK_RTT  */
  YYSYMBOL_KRT_LOCK_RTTVAR = 518,          /* KRT_LOCK_RTTVAR  */
  YYSYMBOL_KRT_LOCK_SSTRESH = 519,         /* KRT_LOCK_SSTRESH  */
  YYSYMBOL_KRT_LOCK_CWND = 520,            /* KRT_LOCK_CWND  */
  YYSYMBOL_KRT_LOCK_ADVMSS = 521,          /* KRT_LOCK_ADVMSS  */
  YYSYMBOL_KRT_LOCK_REORDERING = 522,      /* KRT_LOCK_REORDERING  */
  YYSYMBOL_KRT_LOCK_HOPLIMIT = 523,        /* KRT_LOCK_HOPLIMIT  */
  YYSYMBOL_KRT_LOCK_RTO_MIN = 524,         /* KRT_LOCK_RTO_MIN  */
  YYSYMBOL_KRT_FEATURE_ECN = 525,          /* KRT_FEATURE_ECN  */
  YYSYMBOL_KRT_FEATURE_ALLFRAG = 526,      /* KRT_FEATURE_ALLFRAG  */
  YYSYMBOL_SYSLOG = 527,                   /* SYSLOG  */
  YYSYMBOL_TRACE = 528,                    /* TRACE  */
  YYSYMBOL_INFO = 529,                     /* INFO  */
  YYSYMBOL_WARNING = 530,                  /* WARNING  */
  YYSYMBOL_AUTH = 531,                     /* AUTH  */
  YYSYMBOL_FATAL = 532,                    /* FATAL  */
  YYSYMBOL_BUG = 533,                      /* BUG  */
  YYSYMBOL_STDERR = 534,                   /* STDERR  */
  YYSYMBOL_SOFT = 535,                     /* SOFT  */
  YYSYMBOL_CONFIRM = 536,                  /* CONFIRM  */
  YYSYMBOL_UNDO = 537,                     /* UNDO  */
  YYSYMBOL_LATENCY = 538,                  /* LATENCY  */
  YYSYMBOL_WATCHDOG = 539,                 /* WATCHDOG  */
  YYSYMBOL_CONFIGURE = 540,                /* CONFIGURE  */
  YYSYMBOL_DOWN = 541,                     /* DOWN  */
  YYSYMBOL_PERSIST = 542,                  /* PERSIST  */
  YYSYMBOL_SCAN = 543,                     /* SCAN  */
  YYSYMBOL_LEARN = 544,                    /* LEARN  */
  YYSYMBOL_DEVICE = 545,                   /* DEVICE  */
  YYSYMBOL_KRT_SOURCE = 546,               /* KRT_SOURCE  */
  YYSYMBOL_KRT_METRIC = 547,               /* KRT_METRIC  */
  YYSYMBOL_YYACCEPT = 548,                 /* $accept  */
  YYSYMBOL_cli_cmd = 549,                  /* cli_cmd  */
  YYSYMBOL_cmd_QUIT = 550,                 /* cmd_QUIT  */
  YYSYMBOL_cmd_EXIT = 551,                 /* cmd_EXIT  */
  YYSYMBOL_cmd_HELP = 552,                 /* cmd_HELP  */
  YYSYMBOL_config = 553,                   /* config  */
  YYSYMBOL_conf_entries = 554,             /* conf_entries  */
  YYSYMBOL_conf = 555,                     /* conf  */
  YYSYMBOL_definition = 556,               /* definition  */
  YYSYMBOL_expr = 557,                     /* expr  */
  YYSYMBOL_expr_us = 558,                  /* expr_us  */
  YYSYMBOL_symbol = 559,                   /* symbol  */
  YYSYMBOL_bool = 560,                     /* bool  */
  YYSYMBOL_ipa = 561,                      /* ipa  */
  YYSYMBOL_ipa_scope = 562,                /* ipa_scope  */
  YYSYMBOL_pxlen4 = 563,                   /* pxlen4  */
  YYSYMBOL_net_ip4_ = 564,                 /* net_ip4_  */
  YYSYMBOL_net_ip6_ = 565,                 /* net_ip6_  */
  YYSYMBOL_net_ip6_sadr_ = 566,            /* net_ip6_sadr_  */
  YYSYMBOL_net_vpn4_ = 567,                /* net_vpn4_  */
  YYSYMBOL_net_vpn6_ = 568,                /* net_vpn6_  */
  YYSYMBOL_net_roa4_ = 569,                /* net_roa4_  */
  YYSYMBOL_net_roa6_ = 570,                /* net_roa6_  */
  YYSYMBOL_net_mpls_ = 571,                /* net_mpls_  */
  YYSYMBOL_net_ip_ = 572,                  /* net_ip_  */
  YYSYMBOL_net_vpn_ = 573,                 /* net_vpn_  */
  YYSYMBOL_net_roa_ = 574,                 /* net_roa_  */
  YYSYMBOL_net_ = 575,                     /* net_  */
  YYSYMBOL_net_ip6 = 576,                  /* net_ip6  */
  YYSYMBOL_net_ip = 577,                   /* net_ip  */
  YYSYMBOL_net_any = 578,                  /* net_any  */
  YYSYMBOL_net_or_ipa = 579,               /* net_or_ipa  */
  YYSYMBOL_label_stack_start = 580,        /* label_stack_start  */
  YYSYMBOL_label_stack = 581,              /* label_stack  */
  YYSYMBOL_time = 582,                     /* time  */
  YYSYMBOL_text = 583,                     /* text  */
  YYSYMBOL_opttext = 584,                  /* opttext  */
  YYSYMBOL_flow_num_op = 585,              /* flow_num_op  */
  YYSYMBOL_flow_logic_op = 586,            /* flow_logic_op  */
  YYSYMBOL_flow_num_type_ = 587,           /* flow_num_type_  */
  YYSYMBOL_flow_num_type = 588,            /* flow_num_type  */
  YYSYMBOL_flow_flag_type = 589,           /* flow_flag_type  */
  YYSYMBOL_flow_frag_type = 590,           /* flow_frag_type  */
  YYSYMBOL_flow_label_type = 591,          /* flow_label_type  */
  YYSYMBOL_flow_srcdst = 592,              /* flow_srcdst  */
  YYSYMBOL_flow_num_opts = 593,            /* flow_num_opts  */
  YYSYMBOL_flow_num_opt_ext_expr = 594,    /* flow_num_opt_ext_expr  */
  YYSYMBOL_flow_num_opt_ext = 595,         /* flow_num_opt_ext  */
  YYSYMBOL_flow_bmk_opts = 596,            /* flow_bmk_opts  */
  YYSYMBOL_flow_neg = 597,                 /* flow_neg  */
  YYSYMBOL_flow_frag_val = 598,            /* flow_frag_val  */
  YYSYMBOL_flow_frag_opts = 599,           /* flow_frag_opts  */
  YYSYMBOL_flow4_item = 600,               /* flow4_item  */
  YYSYMBOL_flow6_item = 601,               /* flow6_item  */
  YYSYMBOL_flow4_opts = 602,               /* flow4_opts  */
  YYSYMBOL_flow6_opts = 603,               /* flow6_opts  */
  YYSYMBOL_flow_builder_init = 604,        /* flow_builder_init  */
  YYSYMBOL_flow_builder_set_ipv4 = 605,    /* flow_builder_set_ipv4  */
  YYSYMBOL_flow_builder_set_ipv6 = 606,    /* flow_builder_set_ipv6  */
  YYSYMBOL_net_flow4_ = 607,               /* net_flow4_  */
  YYSYMBOL_net_flow6_ = 608,               /* net_flow6_  */
  YYSYMBOL_net_flow_ = 609,                /* net_flow_  */
  YYSYMBOL_filter_def = 610,               /* filter_def  */
  YYSYMBOL_611_1 = 611,                    /* $@1  */
  YYSYMBOL_filter_eval = 612,              /* filter_eval  */
  YYSYMBOL_custom_attr = 613,              /* custom_attr  */
  YYSYMBOL_bt_test_suite = 614,            /* bt_test_suite  */
  YYSYMBOL_bt_test_same = 615,             /* bt_test_same  */
  YYSYMBOL_type = 616,                     /* type  */
  YYSYMBOL_function_argsn = 617,           /* function_argsn  */
  YYSYMBOL_function_args = 618,            /* function_args  */
  YYSYMBOL_function_vars = 619,            /* function_vars  */
  YYSYMBOL_filter_body = 620,              /* filter_body  */
  YYSYMBOL_filter = 621,                   /* filter  */
  YYSYMBOL_where_filter = 622,             /* where_filter  */
  YYSYMBOL_function_body = 623,            /* function_body  */
  YYSYMBOL_function_def = 624,             /* function_def  */
  YYSYMBOL_625_2 = 625,                    /* $@2  */
  YYSYMBOL_cmds = 626,                     /* cmds  */
  YYSYMBOL_cmd_prep = 627,                 /* cmd_prep  */
  YYSYMBOL_cmds_int = 628,                 /* cmds_int  */
  YYSYMBOL_block = 629,                    /* block  */
  YYSYMBOL_fipa = 630,                     /* fipa  */
  YYSYMBOL_set_atom = 631,                 /* set_atom  */
  YYSYMBOL_switch_atom = 632,              /* switch_atom  */
  YYSYMBOL_cnum = 633,                     /* cnum  */
  YYSYMBOL_pair_item = 634,                /* pair_item  */
  YYSYMBOL_ec_kind = 635,                  /* ec_kind  */
  YYSYMBOL_ec_item = 636,                  /* ec_item  */
  YYSYMBOL_lc_item = 637,                  /* lc_item  */
  YYSYMBOL_set_item = 638,                 /* set_item  */
  YYSYMBOL_switch_item = 639,              /* switch_item  */
  YYSYMBOL_set_items = 640,                /* set_items  */
  YYSYMBOL_switch_items = 641,             /* switch_items  */
  YYSYMBOL_fprefix = 642,                  /* fprefix  */
  YYSYMBOL_fprefix_set = 643,              /* fprefix_set  */
  YYSYMBOL_switch_body = 644,              /* switch_body  */
  YYSYMBOL_bgp_path_expr = 645,            /* bgp_path_expr  */
  YYSYMBOL_bgp_path = 646,                 /* bgp_path  */
  YYSYMBOL_bgp_path_tail = 647,            /* bgp_path_tail  */
  YYSYMBOL_constant = 648,                 /* constant  */
  YYSYMBOL_constructor = 649,              /* constructor  */
  YYSYMBOL_var_list = 650,                 /* var_list  */
  YYSYMBOL_function_call = 651,            /* function_call  */
  YYSYMBOL_symbol_value = 652,             /* symbol_value  */
  YYSYMBOL_static_attr = 653,              /* static_attr  */
  YYSYMBOL_term = 654,                     /* term  */
  YYSYMBOL_break_command = 655,            /* break_command  */
  YYSYMBOL_print_list = 656,               /* print_list  */
  YYSYMBOL_cmd = 657,                      /* cmd  */
  YYSYMBOL_get_cf_position = 658,          /* get_cf_position  */
  YYSYMBOL_lvalue = 659,                   /* lvalue  */
  YYSYMBOL_rtrid = 660,                    /* rtrid  */
  YYSYMBOL_idval = 661,                    /* idval  */
  YYSYMBOL_gr_opts = 662,                  /* gr_opts  */
  YYSYMBOL_net_type = 663,                 /* net_type  */
  YYSYMBOL_table_sorted = 664,             /* table_sorted  */
  YYSYMBOL_table = 665,                    /* table  */
  YYSYMBOL_proto_start = 666,              /* proto_start  */
  YYSYMBOL_proto_name = 667,               /* proto_name  */
  YYSYMBOL_proto_item = 668,               /* proto_item  */
  YYSYMBOL_channel_start = 669,            /* channel_start  */
  YYSYMBOL_channel_item = 670,             /* channel_item  */
  YYSYMBOL_channel_opts = 671,             /* channel_opts  */
  YYSYMBOL_channel_opt_list = 672,         /* channel_opt_list  */
  YYSYMBOL_channel_end = 673,              /* channel_end  */
  YYSYMBOL_proto_channel = 674,            /* proto_channel  */
  YYSYMBOL_rtable = 675,                   /* rtable  */
  YYSYMBOL_imexport = 676,                 /* imexport  */
  YYSYMBOL_limit_action = 677,             /* limit_action  */
  YYSYMBOL_limit_spec = 678,               /* limit_spec  */
  YYSYMBOL_debug_default = 679,            /* debug_default  */
  YYSYMBOL_timeformat_which = 680,         /* timeformat_which  */
  YYSYMBOL_timeformat_spec = 681,          /* timeformat_spec  */
  YYSYMBOL_timeformat_base = 682,          /* timeformat_base  */
  YYSYMBOL_iface_patt_node_init = 683,     /* iface_patt_node_init  */
  YYSYMBOL_iface_patt_node_body = 684,     /* iface_patt_node_body  */
  YYSYMBOL_iface_negate = 685,             /* iface_negate  */
  YYSYMBOL_iface_patt_node = 686,          /* iface_patt_node  */
  YYSYMBOL_iface_patt_list = 687,          /* iface_patt_list  */
  YYSYMBOL_iface_patt_list_nopx = 688,     /* iface_patt_list_nopx  */
  YYSYMBOL_iface_patt_init = 689,          /* iface_patt_init  */
  YYSYMBOL_iface_patt = 690,               /* iface_patt  */
  YYSYMBOL_tos = 691,                      /* tos  */
  YYSYMBOL_proto = 692,                    /* proto  */
  YYSYMBOL_dev_proto_start = 693,          /* dev_proto_start  */
  YYSYMBOL_dev_proto = 694,                /* dev_proto  */
  YYSYMBOL_dev_iface_init = 695,           /* dev_iface_init  */
  YYSYMBOL_dev_iface_patt = 696,           /* dev_iface_patt  */
  YYSYMBOL_debug_mask = 697,               /* debug_mask  */
  YYSYMBOL_debug_list = 698,               /* debug_list  */
  YYSYMBOL_debug_flag = 699,               /* debug_flag  */
  YYSYMBOL_mrtdump_mask = 700,             /* mrtdump_mask  */
  YYSYMBOL_mrtdump_list = 701,             /* mrtdump_list  */
  YYSYMBOL_mrtdump_flag = 702,             /* mrtdump_flag  */
  YYSYMBOL_password_list = 703,            /* password_list  */
  YYSYMBOL_password_items = 704,           /* password_items  */
  YYSYMBOL_password_item = 705,            /* password_item  */
  YYSYMBOL_password_item_begin = 706,      /* password_item_begin  */
  YYSYMBOL_password_item_params = 707,     /* password_item_params  */
  YYSYMBOL_password_algorithm = 708,       /* password_algorithm  */
  YYSYMBOL_cmd_SHOW_STATUS = 709,          /* cmd_SHOW_STATUS  */
  YYSYMBOL_cmd_SHOW_MEMORY = 710,          /* cmd_SHOW_MEMORY  */
  YYSYMBOL_cmd_SHOW_PROTOCOLS = 711,       /* cmd_SHOW_PROTOCOLS  */
  YYSYMBOL_cmd_SHOW_PROTOCOLS_ALL = 712,   /* cmd_SHOW_PROTOCOLS_ALL  */
  YYSYMBOL_optproto = 713,                 /* optproto  */
  YYSYMBOL_cmd_SHOW_INTERFACES = 714,      /* cmd_SHOW_INTERFACES  */
  YYSYMBOL_cmd_SHOW_INTERFACES_SUMMARY = 715, /* cmd_SHOW_INTERFACES_SUMMARY  */
  YYSYMBOL_cmd_SHOW_ROUTE = 716,           /* cmd_SHOW_ROUTE  */
  YYSYMBOL_r_args = 717,                   /* r_args  */
  YYSYMBOL_r_args_for = 718,               /* r_args_for  */
  YYSYMBOL_r_args_for_val = 719,           /* r_args_for_val  */
  YYSYMBOL_export_mode = 720,              /* export_mode  */
  YYSYMBOL_r_args_channel = 721,           /* r_args_channel  */
  YYSYMBOL_cmd_SHOW_SYMBOLS = 722,         /* cmd_SHOW_SYMBOLS  */
  YYSYMBOL_sym_args = 723,                 /* sym_args  */
  YYSYMBOL_cmd_DUMP_RESOURCES = 724,       /* cmd_DUMP_RESOURCES  */
  YYSYMBOL_cmd_DUMP_SOCKETS = 725,         /* cmd_DUMP_SOCKETS  */
  YYSYMBOL_cmd_DUMP_EVENTS = 726,          /* cmd_DUMP_EVENTS  */
  YYSYMBOL_cmd_DUMP_INTERFACES = 727,      /* cmd_DUMP_INTERFACES  */
  YYSYMBOL_cmd_DUMP_NEIGHBORS = 728,       /* cmd_DUMP_NEIGHBORS  */
  YYSYMBOL_cmd_DUMP_ATTRIBUTES = 729,      /* cmd_DUMP_ATTRIBUTES  */
  YYSYMBOL_cmd_DUMP_ROUTES = 730,          /* cmd_DUMP_ROUTES  */
  YYSYMBOL_cmd_DUMP_PROTOCOLS = 731,       /* cmd_DUMP_PROTOCOLS  */
  YYSYMBOL_cmd_DUMP_FILTER_ALL = 732,      /* cmd_DUMP_FILTER_ALL  */
  YYSYMBOL_cmd_EVAL = 733,                 /* cmd_EVAL  */
  YYSYMBOL_cmd_ECHO = 734,                 /* cmd_ECHO  */
  YYSYMBOL_echo_mask = 735,                /* echo_mask  */
  YYSYMBOL_echo_size = 736,                /* echo_size  */
  YYSYMBOL_cmd_DISABLE = 737,              /* cmd_DISABLE  */
  YYSYMBOL_cmd_ENABLE = 738,               /* cmd_ENABLE  */
  YYSYMBOL_cmd_RESTART = 739,              /* cmd_RESTART  */
  YYSYMBOL_cmd_RELOAD = 740,               /* cmd_RELOAD  */
  YYSYMBOL_cmd_RELOAD_IN = 741,            /* cmd_RELOAD_IN  */
  YYSYMBOL_cmd_RELOAD_OUT = 742,           /* cmd_RELOAD_OUT  */
  YYSYMBOL_cmd_DEBUG = 743,                /* cmd_DEBUG  */
  YYSYMBOL_cmd_MRTDUMP = 744,              /* cmd_MRTDUMP  */
  YYSYMBOL_cmd_RESTRICT = 745,             /* cmd_RESTRICT  */
  YYSYMBOL_proto_patt = 746,               /* proto_patt  */
  YYSYMBOL_proto_patt2 = 747,              /* proto_patt2  */
  YYSYMBOL_dynamic_attr = 748,             /* dynamic_attr  */
  YYSYMBOL_babel_proto_start = 749,        /* babel_proto_start  */
  YYSYMBOL_babel_proto_item = 750,         /* babel_proto_item  */
  YYSYMBOL_babel_proto_opts = 751,         /* babel_proto_opts  */
  YYSYMBOL_babel_proto = 752,              /* babel_proto  */
  YYSYMBOL_babel_iface_start = 753,        /* babel_iface_start  */
  YYSYMBOL_babel_iface_finish = 754,       /* babel_iface_finish  */
  YYSYMBOL_babel_iface_item = 755,         /* babel_iface_item  */
  YYSYMBOL_babel_iface_opts = 756,         /* babel_iface_opts  */
  YYSYMBOL_babel_iface_opt_list = 757,     /* babel_iface_opt_list  */
  YYSYMBOL_babel_iface = 758,              /* babel_iface  */
  YYSYMBOL_cmd_SHOW_BABEL_INTERFACES = 759, /* cmd_SHOW_BABEL_INTERFACES  */
  YYSYMBOL_cmd_SHOW_BABEL_NEIGHBORS = 760, /* cmd_SHOW_BABEL_NEIGHBORS  */
  YYSYMBOL_cmd_SHOW_BABEL_ENTRIES = 761,   /* cmd_SHOW_BABEL_ENTRIES  */
  YYSYMBOL_cmd_SHOW_BABEL_ROUTES = 762,    /* cmd_SHOW_BABEL_ROUTES  */
  YYSYMBOL_bfd_proto_start = 763,          /* bfd_proto_start  */
  YYSYMBOL_bfd_proto_item = 764,           /* bfd_proto_item  */
  YYSYMBOL_bfd_proto_opts = 765,           /* bfd_proto_opts  */
  YYSYMBOL_bfd_proto = 766,                /* bfd_proto  */
  YYSYMBOL_bfd_iface_start = 767,          /* bfd_iface_start  */
  YYSYMBOL_bfd_iface_finish = 768,         /* bfd_iface_finish  */
  YYSYMBOL_bfd_iface_item = 769,           /* bfd_iface_item  */
  YYSYMBOL_bfd_auth_type = 770,            /* bfd_auth_type  */
  YYSYMBOL_bfd_iface_opts = 771,           /* bfd_iface_opts  */
  YYSYMBOL_bfd_iface_opt_list = 772,       /* bfd_iface_opt_list  */
  YYSYMBOL_bfd_iface = 773,                /* bfd_iface  */
  YYSYMBOL_bfd_multihop = 774,             /* bfd_multihop  */
  YYSYMBOL_bfd_neigh_iface = 775,          /* bfd_neigh_iface  */
  YYSYMBOL_bfd_neigh_local = 776,          /* bfd_neigh_local  */
  YYSYMBOL_bfd_neigh_multihop = 777,       /* bfd_neigh_multihop  */
  YYSYMBOL_bfd_neighbor = 778,             /* bfd_neighbor  */
  YYSYMBOL_cmd_SHOW_BFD_SESSIONS = 779,    /* cmd_SHOW_BFD_SESSIONS  */
  YYSYMBOL_bgp_proto_start = 780,          /* bgp_proto_start  */
  YYSYMBOL_bgp_loc_opts = 781,             /* bgp_loc_opts  */
  YYSYMBOL_bgp_nbr_opts = 782,             /* bgp_nbr_opts  */
  YYSYMBOL_bgp_cease_mask = 783,           /* bgp_cease_mask  */
  YYSYMBOL_bgp_cease_list = 784,           /* bgp_cease_list  */
  YYSYMBOL_bgp_cease_flag = 785,           /* bgp_cease_flag  */
  YYSYMBOL_bgp_proto = 786,                /* bgp_proto  */
  YYSYMBOL_bgp_afi = 787,                  /* bgp_afi  */
  YYSYMBOL_bgp_channel_start = 788,        /* bgp_channel_start  */
  YYSYMBOL_bgp_nh = 789,                   /* bgp_nh  */
  YYSYMBOL_bgp_channel_item = 790,         /* bgp_channel_item  */
  YYSYMBOL_bgp_channel_opts = 791,         /* bgp_channel_opts  */
  YYSYMBOL_bgp_channel_opt_list = 792,     /* bgp_channel_opt_list  */
  YYSYMBOL_bgp_channel_end = 793,          /* bgp_channel_end  */
  YYSYMBOL_bgp_proto_channel = 794,        /* bgp_proto_channel  */
  YYSYMBOL_mrt_proto_start = 795,          /* mrt_proto_start  */
  YYSYMBOL_mrt_proto_item = 796,           /* mrt_proto_item  */
  YYSYMBOL_mrt_proto_opts = 797,           /* mrt_proto_opts  */
  YYSYMBOL_mrt_proto = 798,                /* mrt_proto  */
  YYSYMBOL_cmd_MRT_DUMP = 799,             /* cmd_MRT_DUMP  */
  YYSYMBOL_mrt_dump_args = 800,            /* mrt_dump_args  */
  YYSYMBOL_ospf_variant = 801,             /* ospf_variant  */
  YYSYMBOL_ospf_proto_start = 802,         /* ospf_proto_start  */
  YYSYMBOL_ospf_proto = 803,               /* ospf_proto  */
  YYSYMBOL_ospf_af_mc = 804,               /* ospf_af_mc  */
  YYSYMBOL_ospf_channel_start = 805,       /* ospf_channel_start  */
  YYSYMBOL_ospf_channel = 806,             /* ospf_channel  */
  YYSYMBOL_ospf_proto_item = 807,          /* ospf_proto_item  */
  YYSYMBOL_ospf_area_start = 808,          /* ospf_area_start  */
  YYSYMBOL_ospf_area = 809,                /* ospf_area  */
  YYSYMBOL_ospf_area_opts = 810,           /* ospf_area_opts  */
  YYSYMBOL_ospf_area_item = 811,           /* ospf_area_item  */
  YYSYMBOL_812_3 = 812,                    /* $@3  */
  YYSYMBOL_813_4 = 813,                    /* $@4  */
  YYSYMBOL_ospf_stubnet = 814,             /* ospf_stubnet  */
  YYSYMBOL_ospf_stubnet_start = 815,       /* ospf_stubnet_start  */
  YYSYMBOL_ospf_stubnet_opts = 816,        /* ospf_stubnet_opts  */
  YYSYMBOL_ospf_stubnet_item = 817,        /* ospf_stubnet_item  */
  YYSYMBOL_ospf_vlink = 818,               /* ospf_vlink  */
  YYSYMBOL_ospf_vlink_opts = 819,          /* ospf_vlink_opts  */
  YYSYMBOL_ospf_vlink_item = 820,          /* ospf_vlink_item  */
  YYSYMBOL_ospf_vlink_start = 821,         /* ospf_vlink_start  */
  YYSYMBOL_ospf_iface_item = 822,          /* ospf_iface_item  */
  YYSYMBOL_pref_list = 823,                /* pref_list  */
  YYSYMBOL_pref_item = 824,                /* pref_item  */
  YYSYMBOL_pref_base = 825,                /* pref_base  */
  YYSYMBOL_pref_opt = 826,                 /* pref_opt  */
  YYSYMBOL_nbma_list = 827,                /* nbma_list  */
  YYSYMBOL_nbma_eligible = 828,            /* nbma_eligible  */
  YYSYMBOL_nbma_item = 829,                /* nbma_item  */
  YYSYMBOL_ospf_iface_start = 830,         /* ospf_iface_start  */
  YYSYMBOL_ospf_instance_id = 831,         /* ospf_instance_id  */
  YYSYMBOL_ospf_iface_patt_list = 832,     /* ospf_iface_patt_list  */
  YYSYMBOL_833_5 = 833,                    /* $@5  */
  YYSYMBOL_ospf_iface_opts = 834,          /* ospf_iface_opts  */
  YYSYMBOL_ospf_iface_opt_list = 835,      /* ospf_iface_opt_list  */
  YYSYMBOL_ospf_iface = 836,               /* ospf_iface  */
  YYSYMBOL_cmd_SHOW_OSPF = 837,            /* cmd_SHOW_OSPF  */
  YYSYMBOL_cmd_SHOW_OSPF_NEIGHBORS = 838,  /* cmd_SHOW_OSPF_NEIGHBORS  */
  YYSYMBOL_cmd_SHOW_OSPF_INTERFACE = 839,  /* cmd_SHOW_OSPF_INTERFACE  */
  YYSYMBOL_cmd_SHOW_OSPF_TOPOLOGY = 840,   /* cmd_SHOW_OSPF_TOPOLOGY  */
  YYSYMBOL_cmd_SHOW_OSPF_TOPOLOGY_ALL = 841, /* cmd_SHOW_OSPF_TOPOLOGY_ALL  */
  YYSYMBOL_cmd_SHOW_OSPF_STATE = 842,      /* cmd_SHOW_OSPF_STATE  */
  YYSYMBOL_cmd_SHOW_OSPF_STATE_ALL = 843,  /* cmd_SHOW_OSPF_STATE_ALL  */
  YYSYMBOL_cmd_SHOW_OSPF_LSADB = 844,      /* cmd_SHOW_OSPF_LSADB  */
  YYSYMBOL_lsadb_args = 845,               /* lsadb_args  */
  YYSYMBOL_perf_proto_start = 846,         /* perf_proto_start  */
  YYSYMBOL_perf_proto = 847,               /* perf_proto  */
  YYSYMBOL_perf_proto_item = 848,          /* perf_proto_item  */
  YYSYMBOL_pipe_proto_start = 849,         /* pipe_proto_start  */
  YYSYMBOL_850_6 = 850,                    /* $@6  */
  YYSYMBOL_pipe_proto = 851,               /* pipe_proto  */
  YYSYMBOL_radv_proto_start = 852,         /* radv_proto_start  */
  YYSYMBOL_radv_proto_item = 853,          /* radv_proto_item  */
  YYSYMBOL_854_7 = 854,                    /* $@7  */
  YYSYMBOL_855_8 = 855,                    /* $@8  */
  YYSYMBOL_radv_proto_opts = 856,          /* radv_proto_opts  */
  YYSYMBOL_radv_proto = 857,               /* radv_proto  */
  YYSYMBOL_radv_iface_start = 858,         /* radv_iface_start  */
  YYSYMBOL_radv_iface_item = 859,          /* radv_iface_item  */
  YYSYMBOL_860_9 = 860,                    /* $@9  */
  YYSYMBOL_861_10 = 861,                   /* $@10  */
  YYSYMBOL_radv_preference = 862,          /* radv_preference  */
  YYSYMBOL_radv_iface_finish = 863,        /* radv_iface_finish  */
  YYSYMBOL_radv_iface_opts = 864,          /* radv_iface_opts  */
  YYSYMBOL_radv_iface_opt_list = 865,      /* radv_iface_opt_list  */
  YYSYMBOL_radv_iface = 866,               /* radv_iface  */
  YYSYMBOL_radv_prefix_start = 867,        /* radv_prefix_start  */
  YYSYMBOL_radv_prefix_item = 868,         /* radv_prefix_item  */
  YYSYMBOL_radv_prefix_finish = 869,       /* radv_prefix_finish  */
  YYSYMBOL_radv_prefix_opts = 870,         /* radv_prefix_opts  */
  YYSYMBOL_radv_prefix_opt_list = 871,     /* radv_prefix_opt_list  */
  YYSYMBOL_radv_prefix = 872,              /* radv_prefix  */
  YYSYMBOL_radv_rdnss_node = 873,          /* radv_rdnss_node  */
  YYSYMBOL_radv_rdnss_start = 874,         /* radv_rdnss_start  */
  YYSYMBOL_radv_rdnss_item = 875,          /* radv_rdnss_item  */
  YYSYMBOL_radv_rdnss_finish = 876,        /* radv_rdnss_finish  */
  YYSYMBOL_radv_rdnss_opts = 877,          /* radv_rdnss_opts  */
  YYSYMBOL_radv_rdnss = 878,               /* radv_rdnss  */
  YYSYMBOL_radv_dnssl_node = 879,          /* radv_dnssl_node  */
  YYSYMBOL_radv_dnssl_start = 880,         /* radv_dnssl_start  */
  YYSYMBOL_radv_dnssl_item = 881,          /* radv_dnssl_item  */
  YYSYMBOL_radv_dnssl_finish = 882,        /* radv_dnssl_finish  */
  YYSYMBOL_radv_dnssl_opts = 883,          /* radv_dnssl_opts  */
  YYSYMBOL_radv_dnssl = 884,               /* radv_dnssl  */
  YYSYMBOL_radv_mult = 885,                /* radv_mult  */
  YYSYMBOL_radv_sensitive = 886,           /* radv_sensitive  */
  YYSYMBOL_rip_variant = 887,              /* rip_variant  */
  YYSYMBOL_rip_proto_start = 888,          /* rip_proto_start  */
  YYSYMBOL_rip_proto_item = 889,           /* rip_proto_item  */
  YYSYMBOL_rip_proto_opts = 890,           /* rip_proto_opts  */
  YYSYMBOL_rip_proto = 891,                /* rip_proto  */
  YYSYMBOL_rip_iface_start = 892,          /* rip_iface_start  */
  YYSYMBOL_rip_iface_finish = 893,         /* rip_iface_finish  */
  YYSYMBOL_rip_iface_item = 894,           /* rip_iface_item  */
  YYSYMBOL_rip_auth = 895,                 /* rip_auth  */
  YYSYMBOL_rip_iface_opts = 896,           /* rip_iface_opts  */
  YYSYMBOL_rip_iface_opt_list = 897,       /* rip_iface_opt_list  */
  YYSYMBOL_rip_iface = 898,                /* rip_iface  */
  YYSYMBOL_cmd_SHOW_RIP_INTERFACES = 899,  /* cmd_SHOW_RIP_INTERFACES  */
  YYSYMBOL_cmd_SHOW_RIP_NEIGHBORS = 900,   /* cmd_SHOW_RIP_NEIGHBORS  */
  YYSYMBOL_rpki_proto_start = 901,         /* rpki_proto_start  */
  YYSYMBOL_rpki_proto = 902,               /* rpki_proto  */
  YYSYMBOL_rpki_proto_opts = 903,          /* rpki_proto_opts  */
  YYSYMBOL_rpki_proto_item = 904,          /* rpki_proto_item  */
  YYSYMBOL_rpki_keep_interval = 905,       /* rpki_keep_interval  */
  YYSYMBOL_rpki_proto_item_port = 906,     /* rpki_proto_item_port  */
  YYSYMBOL_rpki_cache_addr = 907,          /* rpki_cache_addr  */
  YYSYMBOL_rpki_transport = 908,           /* rpki_transport  */
  YYSYMBOL_rpki_transport_tcp_init = 909,  /* rpki_transport_tcp_init  */
  YYSYMBOL_rpki_transport_ssh_init = 910,  /* rpki_transport_ssh_init  */
  YYSYMBOL_rpki_transport_ssh_opts = 911,  /* rpki_transport_ssh_opts  */
  YYSYMBOL_rpki_transport_ssh_item = 912,  /* rpki_transport_ssh_item  */
  YYSYMBOL_rpki_transport_ssh_check = 913, /* rpki_transport_ssh_check  */
  YYSYMBOL_static_proto_start = 914,       /* static_proto_start  */
  YYSYMBOL_static_proto = 915,             /* static_proto  */
  YYSYMBOL_stat_nexthop = 916,             /* stat_nexthop  */
  YYSYMBOL_stat_nexthops = 917,            /* stat_nexthops  */
  YYSYMBOL_stat_route0 = 918,              /* stat_route0  */
  YYSYMBOL_stat_route = 919,               /* stat_route  */
  YYSYMBOL_stat_route_item = 920,          /* stat_route_item  */
  YYSYMBOL_stat_route_opts = 921,          /* stat_route_opts  */
  YYSYMBOL_stat_route_opt_list = 922,      /* stat_route_opt_list  */
  YYSYMBOL_cmd_SHOW_STATIC = 923,          /* cmd_SHOW_STATIC  */
  YYSYMBOL_kern_proto = 924,               /* kern_proto  */
  YYSYMBOL_kern_sys_item = 925,            /* kern_sys_item  */
  YYSYMBOL_log_begin = 926,                /* log_begin  */
  YYSYMBOL_log_config = 927,               /* log_config  */
  YYSYMBOL_syslog_name = 928,              /* syslog_name  */
  YYSYMBOL_log_limit = 929,                /* log_limit  */
  YYSYMBOL_log_file = 930,                 /* log_file  */
  YYSYMBOL_log_mask = 931,                 /* log_mask  */
  YYSYMBOL_log_mask_list = 932,            /* log_mask_list  */
  YYSYMBOL_log_cat = 933,                  /* log_cat  */
  YYSYMBOL_mrtdump_base = 934,             /* mrtdump_base  */
  YYSYMBOL_debug_unix = 935,               /* debug_unix  */
  YYSYMBOL_cmd_CONFIGURE = 936,            /* cmd_CONFIGURE  */
  YYSYMBOL_cmd_CONFIGURE_SOFT = 937,       /* cmd_CONFIGURE_SOFT  */
  YYSYMBOL_cmd_CONFIGURE_CONFIRM = 938,    /* cmd_CONFIGURE_CONFIRM  */
  YYSYMBOL_cmd_CONFIGURE_UNDO = 939,       /* cmd_CONFIGURE_UNDO  */
  YYSYMBOL_cmd_CONFIGURE_STATUS = 940,     /* cmd_CONFIGURE_STATUS  */
  YYSYMBOL_cmd_CONFIGURE_CHECK = 941,      /* cmd_CONFIGURE_CHECK  */
  YYSYMBOL_cmd_DOWN = 942,                 /* cmd_DOWN  */
  YYSYMBOL_cmd_GRACEFUL_RESTART = 943,     /* cmd_GRACEFUL_RESTART  */
  YYSYMBOL_cfg_name = 944,                 /* cfg_name  */
  YYSYMBOL_cfg_timeout = 945,              /* cfg_timeout  */
  YYSYMBOL_kern_proto_start = 946,         /* kern_proto_start  */
  YYSYMBOL_kern_mp_limit = 947,            /* kern_mp_limit  */
  YYSYMBOL_kern_item = 948,                /* kern_item  */
  YYSYMBOL_kif_proto_start = 949,          /* kif_proto_start  */
  YYSYMBOL_kif_proto = 950,                /* kif_proto  */
  YYSYMBOL_kif_item = 951,                 /* kif_item  */
  YYSYMBOL_kif_iface_start = 952,          /* kif_iface_start  */
  YYSYMBOL_kif_iface_item = 953,           /* kif_iface_item  */
  YYSYMBOL_kif_iface_opts = 954,           /* kif_iface_opts  */
  YYSYMBOL_kif_iface_opt_list = 955,       /* kif_iface_opt_list  */
  YYSYMBOL_kif_iface = 956                 /* kif_iface  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  79
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   5984

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  548
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  409
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1381
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2538

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   781


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    37,     2,     2,     2,    36,     2,     2,
      52,    53,    34,    32,    77,    33,    38,    35,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   150,    51,
      28,    27,    29,   153,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   151,     2,   152,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    78,     2,    79,    30,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    31,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   132,   132,   133,   136,   138,   141,   146,   149,   157,
     158,   159,   165,   166,   167,   170,   170,   175,   176,   177,
     178,   179,   180,   187,   188,   189,   196,   197,   204,   210,
     220,   233,   252,   258,   264,   272,   280,   286,   286,   287,
     287,   288,   288,   291,   292,   293,   294,   295,   296,   303,
     304,   312,   313,   321,   322,   330,   331,   332,   333,   334,
     344,   352,   353,   362,   370,   371,   378,   379,    37,    38,
      39,    40,    41,    42,    43,    44,    48,    49,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    64,    65,    66,
      67,    70,    71,    75,    79,    83,    84,    88,    92,   101,
     102,   106,   110,   114,   121,   122,   126,   127,   128,   129,
     133,   136,   139,   145,   149,   150,   151,   155,   159,   165,
     166,   167,   168,   171,   173,   176,   178,   182,   189,   190,
     192,   198,   204,   204,     9,     9,    10,    10,    11,    11,
     468,   470,   470,   480,   482,   485,   486,   490,   492,   503,
     505,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   556,   558,   565,
     566,   573,   574,   580,   583,   587,   595,   602,   608,   610,
     610,   623,   624,   627,   635,   636,   650,   653,   662,   663,
     676,   677,   678,   679,   680,   684,   692,   693,   694,   695,
     699,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   716,   717,   718,   719,   723,   724,   725,   729,   730,
     731,   732,   733,   734,   735,   736,   741,   742,   743,   744,
     745,   749,   750,   751,   752,   753,   757,   758,   762,   763,
     767,   768,   769,   770,   778,   779,   782,   783,   791,   801,
     802,   806,   810,   811,   812,   816,   817,   818,   819,   823,
     824,   825,   826,   827,   828,   829,   830,   835,   836,   840,
     841,   842,   843,   848,   849,   850,   853,   877,   896,   897,
     898,   899,   900,   901,   902,   903,   904,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   926,   927,   928,   930,   932,   934,
     936,   937,   938,   939,   940,   941,   942,   943,   944,   945,
     946,   947,   957,   958,   959,   960,   961,   962,   963,   964,
     966,   967,   969,   973,   977,   978,   979,   980,   983,   984,
     985,   994,   997,  1000,  1012,  1016,  1019,  1024,  1027,  1030,
    1041,  1045,  1048,  1049,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1063,  1068,  1069,  1070,  1071,   106,   109,   110,   114,
     115,   116,   117,   127,   129,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   152,   155,   156,   159,   169,
     172,   173,   177,   183,   187,   197,   207,   209,   210,   211,
     212,   213,   214,   215,   219,   225,   230,   231,   232,   233,
     234,   235,   236,   239,   241,   244,   246,   250,   257,   260,
     263,   264,   265,   266,   270,   271,   272,   273,   274,   278,
     279,   283,   286,   287,   292,   295,   296,   297,   298,   302,
     303,   304,   305,   306,   307,   308,   309,   313,   320,   328,
     329,   333,   334,   338,   343,   344,   348,   350,   358,   362,
     363,   368,   370,   377,   378,   379,   380,   381,   385,   393,
     399,   400,   401,   405,   406,   410,   411,   412,   413,   414,
     415,   421,   422,   423,   427,   428,   432,   433,   439,   440,
     443,   445,   449,   450,   454,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   501,   501,   504,   504,   507,   507,
     510,   510,   514,   515,   518,   518,   521,   521,   525,   525,
     529,   535,   540,   546,   552,   559,   570,   581,   586,   591,
     595,   599,   603,   613,   624,   633,   637,   644,   648,   649,
     650,   651,   655,   659,   663,   677,   678,   679,   680,   683,
     684,   685,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   713,   713,   717,   720,   721,   722,   723,   724,
     725,   730,   730,   732,   732,   734,   734,   736,   736,   738,
     738,   740,   740,   742,   742,   744,   744,   746,   746,   749,
     749,   753,   753,   759,   760,   761,   765,   766,   772,   772,
     774,   774,   776,   776,   778,   778,   780,   780,   782,   782,
     786,   786,   790,   790,   793,   793,   797,   798,   799,   803,
     804,   805,   808,    34,    36,    44,    45,    46,    47,    50,
      52,    56,    60,    74,    94,    95,    96,    97,    98,    99,
     100,   101,   105,   106,   107,   108,   109,   110,   113,   115,
     118,   120,   124,   127,   132,   133,   134,   138,   139,   143,
     144,   147,   166,   166,    32,    34,    42,    43,    44,    45,
      48,    50,    54,    58,    72,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     114,   116,   119,   121,   126,   128,   132,   132,   135,   135,
     138,   138,   141,   141,    46,    48,    77,    79,    80,    83,
      85,    86,    87,    88,    93,    94,    98,    99,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   115,   116,   117,
     118,   119,   123,   124,   130,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   209,   235,
     236,   237,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   276,   278,   281,   283,
     287,   294,   297,   299,   301,   303,   305,   307,   309,   311,
     313,   315,   317,   319,   321,    26,    28,    34,    35,    36,
      37,    38,    39,    40,    41,    44,    46,    50,    53,    53,
      57,    58,    59,    60,    61,    62,   211,   214,   215,   216,
     219,   235,   236,   240,   241,   245,   255,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   275,   290,   293,   295,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   308,   309,   309,   310,
     311,   312,   316,   317,   321,   329,   331,   335,   336,   337,
     341,   342,   345,   347,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   363,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   422,   424,   427,   429,   437,   439,
     440,   443,   445,   449,   450,   453,   463,   484,   486,   490,
     490,   493,   495,   498,   500,   504,   507,   508,   509,   510,
     513,   513,   516,   516,   519,   519,   524,   524,   527,   527,
     532,   532,   535,   535,   539,   539,   548,   551,   552,   553,
     554,   555,   556,   557,   558,    24,    26,    40,    41,    42,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      23,    26,    25,    40,    41,    42,    43,    44,    46,    57,
      58,    59,    60,    61,    61,    62,    62,    63,    64,    67,
      69,    73,    77,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   115,   119,   120,   121,   122,   123,
     124,   124,   125,   125,   126,   127,   131,   132,   133,   136,
     174,   176,   179,   181,   185,   188,   200,   201,   202,   203,
     207,   214,   222,   224,   227,   229,   233,   237,   247,   252,
     253,   254,   258,   270,   272,   276,   277,   281,   294,   299,
     300,   301,   305,   317,   319,   323,   324,   329,   330,   334,
     335,   338,   339,    45,    48,    49,    52,    66,    67,    68,
      69,    70,    71,    74,    76,    80,    84,   108,   138,   139,
     140,   141,   142,   143,   144,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   169,   170,   171,   172,   175,   177,   180,
     182,   186,   189,   190,   194,   194,   197,   197,    41,    43,
      50,    52,    54,    58,    59,    60,    61,    62,    63,    64,
      70,    76,    85,    86,    89,    92,    96,   107,   108,   112,
     119,   125,   127,   131,   132,   133,   137,    54,    56,    63,
      64,    65,    66,    67,    75,    79,    84,    89,    92,    95,
      99,   105,   106,   109,   121,   122,   126,   131,   132,   133,
     134,   135,   136,   140,   149,   151,   154,   156,   160,   160,
      22,    25,    26,    29,    30,    31,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    60,
      61,    31,    33,    35,    42,    43,    46,    48,    52,    59,
      60,    64,    65,    69,    70,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    86,    89,    90,    98,   101,   102,
     103,   104,   112,   112,   115,   115,   122,   122,   125,   125,
     128,   128,   131,   131,   134,   134,   139,   139,   144,   145,
     149,   150,   151,    41,    43,    48,    49,    52,    53,    57,
      58,    59,    60,    64,    71,    72,    83,    85,    88,    89,
      92,    93,    94,   101,   108,   111,   113,   116,   118,   122,
     125,   126
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "QUIT", "EXIT", "HELP",
  "END", "CLI_MARKER", "INVALID_TOKEN", "ELSECOL", "DDOT", "GEQ", "LEQ",
  "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM", "IP4", "IP6", "VPN_RD",
  "CF_SYM_KNOWN", "CF_SYM_UNDEFINED", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "VPN",
  "MPLS", "FROM", "';'", "'('", "')'", "FLOW4", "FLOW6", "DST", "SRC",
  "PROTO", "NEXT", "HEADER", "DPORT", "SPORT", "ICMP", "TYPE", "CODE",
  "TCP", "FLAGS", "LENGTH", "DSCP", "DONT_FRAGMENT", "IS_FRAGMENT",
  "FIRST_FRAGMENT", "LAST_FRAGMENT", "FRAGMENT", "LABEL", "OFFSET", "','",
  "'{'", "'}'", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "ERROR", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "RD",
  "PAIR", "QUAD", "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE",
  "FALSE", "RT", "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "SOURCE",
  "SCOPE", "DEST", "IFNAME", "IFINDEX", "PREFERENCE", "ROA_CHECK", "ASN",
  "IS_V4", "IS_V6", "LEN", "MAXLEN", "DEFINED", "ADD", "DELETE",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED",
  "MATCH", "EMPTY", "FILTER", "WHERE", "EVAL", "ATTRIBUTE", "BT_ASSERT",
  "BT_TEST_SUITE", "BT_CHECK_ASSIGN", "BT_TEST_SAME", "FORMAT", "':'",
  "'['", "']'", "'?'", "ROUTER", "ID", "PROTOCOL", "TEMPLATE", "DISABLED",
  "DEBUG", "ALL", "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "NONE", "VRF",
  "DEFAULT", "TABLE", "STATES", "ROUTES", "FILTERS", "IPV4", "IPV6",
  "VPN4", "VPN6", "ROA4", "ROA6", "SADR", "RECEIVE", "LIMIT", "ACTION",
  "WARN", "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED", "PASSWORD",
  "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1", "SHA256", "SHA384",
  "SHA512", "PRIMARY", "STATS", "COUNT", "BY", "FOR", "COMMANDS",
  "PREEXPORT", "NOEXPORT", "GENERATE", "BGP", "PASSWORDS", "DESCRIPTION",
  "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT",
  "MEMORY", "IGP_METRIC", "CLASS", "TIMEFORMAT", "ISO", "SHORT", "LONG",
  "ROUTE", "BASE", "LOG", "GRACEFUL", "WAIT", "MAX", "FLUSH", "AS",
  "IPV4_MC", "IPV4_MPLS", "IPV6_MC", "IPV6_MPLS", "IPV6_SADR", "VPN4_MC",
  "VPN4_MPLS", "VPN6_MC", "VPN6_MPLS", "PRI", "SEC", "SHOW", "STATUS",
  "SUMMARY", "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "ECHO", "ENABLE", "BABEL", "METRIC", "RXCOST", "HELLO",
  "UPDATE", "WIRED", "WIRELESS", "BUFFER", "PRIORITY", "CHECK", "LINK",
  "HOP", "BABEL_METRIC", "ENTRIES", "RANDOMIZE", "BFD", "MIN", "IDLE",
  "RX", "TX", "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV",
  "LOCAL", "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD",
  "TIME", "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "SELF",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "BGP_LARGE_COMMUNITY", "ADDRESS", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "CAPABILITIES", "PREFER",
  "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH", "INTERPRET",
  "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY",
  "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC", "SECONDARY",
  "ALLOW", "PATHS", "AWARE", "EXTENDED", "SETKEY", "STRICT", "BIND",
  "CONFEDERATION", "MEMBER", "MULTICAST", "LIVED", "STALE", "IBGP", "EBGP",
  "MANDATORY", "INTERNAL", "EXTERNAL", "DYNAMIC", "RANGE", "NAME",
  "DIGITS", "BGP_AIGP", "AIGP", "ORIGINATE", "COST", "CEASE", "HIT",
  "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT",
  "FILENAME", "PERIOD", "ALWAYS", "OSPF", "V2", "V3", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "AREA", "RFC1583COMPAT",
  "STUB", "TICK", "COST2", "RETRANSMIT", "TRANSMIT", "DEAD", "BROADCAST",
  "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL",
  "NETWORKS", "HIDDEN", "VIRTUAL", "ONLY", "LARGE", "NORMAL", "STUBNET",
  "TAG", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "MERGE", "LSA",
  "SUPPRESSION", "RFC5838", "PE", "TOPOLOGY", "STATE", "PERF", "EXP",
  "REPEAT", "THRESHOLD", "MODE", "PIPE", "RADV", "RA", "SOLICITED",
  "UNICAST", "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE",
  "RA_PREFERENCE", "RA_LIFETIME", "RIP", "NG", "INFINITY", "TIMEOUT",
  "GARBAGE", "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO",
  "PLAINTEXT", "RIP_METRIC", "RIP_TAG", "RPKI", "REMOTE", "BIRD",
  "PRIVATE", "PUBLIC", "KEY", "SSH", "TRANSPORT", "USER", "EXPIRE",
  "STATIC", "PROHIBIT", "BLACKHOLE", "UNREACHABLE", "KERNEL",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "SYSLOG",
  "TRACE", "INFO", "WARNING", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "CONFIRM", "UNDO", "LATENCY", "WATCHDOG", "CONFIGURE", "DOWN", "PERSIST",
  "SCAN", "LEARN", "DEVICE", "KRT_SOURCE", "KRT_METRIC", "$accept",
  "cli_cmd", "cmd_QUIT", "cmd_EXIT", "cmd_HELP", "config", "conf_entries",
  "conf", "definition", "expr", "expr_us", "symbol", "bool", "ipa",
  "ipa_scope", "pxlen4", "net_ip4_", "net_ip6_", "net_ip6_sadr_",
  "net_vpn4_", "net_vpn6_", "net_roa4_", "net_roa6_", "net_mpls_",
  "net_ip_", "net_vpn_", "net_roa_", "net_", "net_ip6", "net_ip",
  "net_any", "net_or_ipa", "label_stack_start", "label_stack", "time",
  "text", "opttext", "flow_num_op", "flow_logic_op", "flow_num_type_",
  "flow_num_type", "flow_flag_type", "flow_frag_type", "flow_label_type",
  "flow_srcdst", "flow_num_opts", "flow_num_opt_ext_expr",
  "flow_num_opt_ext", "flow_bmk_opts", "flow_neg", "flow_frag_val",
  "flow_frag_opts", "flow4_item", "flow6_item", "flow4_opts", "flow6_opts",
  "flow_builder_init", "flow_builder_set_ipv4", "flow_builder_set_ipv6",
  "net_flow4_", "net_flow6_", "net_flow_", "filter_def", "$@1",
  "filter_eval", "custom_attr", "bt_test_suite", "bt_test_same", "type",
  "function_argsn", "function_args", "function_vars", "filter_body",
  "filter", "where_filter", "function_body", "function_def", "$@2", "cmds",
  "cmd_prep", "cmds_int", "block", "fipa", "set_atom", "switch_atom",
  "cnum", "pair_item", "ec_kind", "ec_item", "lc_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix", "fprefix_set",
  "switch_body", "bgp_path_expr", "bgp_path", "bgp_path_tail", "constant",
  "constructor", "var_list", "function_call", "symbol_value",
  "static_attr", "term", "break_command", "print_list", "cmd",
  "get_cf_position", "lvalue", "rtrid", "idval", "gr_opts", "net_type",
  "table_sorted", "table", "proto_start", "proto_name", "proto_item",
  "channel_start", "channel_item", "channel_opts", "channel_opt_list",
  "channel_end", "proto_channel", "rtable", "imexport", "limit_action",
  "limit_spec", "debug_default", "timeformat_which", "timeformat_spec",
  "timeformat_base", "iface_patt_node_init", "iface_patt_node_body",
  "iface_negate", "iface_patt_node", "iface_patt_list",
  "iface_patt_list_nopx", "iface_patt_init", "iface_patt", "tos", "proto",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optproto", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "r_args_for",
  "r_args_for_val", "export_mode", "r_args_channel", "cmd_SHOW_SYMBOLS",
  "sym_args", "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_DUMP_FILTER_ALL",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "dynamic_attr", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "cmd_SHOW_BABEL_ROUTES", "bfd_proto_start",
  "bfd_proto_item", "bfd_proto_opts", "bfd_proto", "bfd_iface_start",
  "bfd_iface_finish", "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_loc_opts",
  "bgp_nbr_opts", "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag",
  "bgp_proto", "bgp_afi", "bgp_channel_start", "bgp_nh",
  "bgp_channel_item", "bgp_channel_opts", "bgp_channel_opt_list",
  "bgp_channel_end", "bgp_proto_channel", "mrt_proto_start",
  "mrt_proto_item", "mrt_proto_opts", "mrt_proto", "cmd_MRT_DUMP",
  "mrt_dump_args", "ospf_variant", "ospf_proto_start", "ospf_proto",
  "ospf_af_mc", "ospf_channel_start", "ospf_channel", "ospf_proto_item",
  "ospf_area_start", "ospf_area", "ospf_area_opts", "ospf_area_item",
  "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "perf_proto_start", "perf_proto", "perf_proto_item",
  "pipe_proto_start", "$@6", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@7", "$@8", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@9", "$@10", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_variant", "rip_proto_start", "rip_proto_item", "rip_proto_opts",
  "rip_proto", "rip_iface_start", "rip_iface_finish", "rip_iface_item",
  "rip_auth", "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS", "rpki_proto_start",
  "rpki_proto", "rpki_proto_opts", "rpki_proto_item", "rpki_keep_interval",
  "rpki_proto_item_port", "rpki_cache_addr", "rpki_transport",
  "rpki_transport_tcp_init", "rpki_transport_ssh_init",
  "rpki_transport_ssh_opts", "rpki_transport_ssh_item",
  "rpki_transport_ssh_check", "static_proto_start", "static_proto",
  "stat_nexthop", "stat_nexthops", "stat_route0", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "kern_proto", "kern_sys_item", "log_begin",
  "log_config", "syslog_name", "log_limit", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_STATUS", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cmd_GRACEFUL_RESTART", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_mp_limit", "kern_item", "kif_proto_start",
  "kif_proto", "kif_item", "kif_iface_start", "kif_iface_item",
  "kif_iface_opts", "kif_iface_opt_list", "kif_iface", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,    61,    60,    62,
     126,   282,    43,    45,    42,    47,    37,    33,    46,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,    59,    40,    41,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,    44,   123,   125,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
      58,    91,    93,    63,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   763,
     764,   765,   766,   767,   768,   769,   770,   771,   772,   773,
     774,   775,   776,   777,   778,   779,   780,   781
};
#endif

#define YYPACT_NINF (-2114)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-67)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     221,    63,   240,   698,   270,   308,   380,  4227,   204,   204,
     204,   180,   204,   440,   323,   631,  1383,   189,   204,   264,
      -5,   546, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114,   877, -2114, -2114, -2114, -2114,   877,   877,  4227,  3684,
     505,   555,   458, -2114, -2114,  -116, -2114,   447, -2114, -2114,
   -2114, -2114,   142,   585, -2114,   463,  -238, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,   474, -2114,   424,
   -2114, -2114, -2114,   845,  2096,   845, -2114,   845, -2114,   845,
    5628,   845, -2114,   845,  1286,   845,  1228,   579,  1165,   845,
   -2114,   845, -2114,   845, -2114,   845,  1716,    20, -2114, -2114,
   -2114,   845,   845,   -30, -2114, -2114, -2114,   725, -2114, -2114,
     630,   634,   911,   648, -2114,   571,   129,  4227,   664, -2114,
    2604,   637,   651, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114,   681,   686,   690,   738,   756,   784,
     807,  1458, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114,   567,   584, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,  2583, -2114, -2114,
   -2114, -2114,   542,   861,   861,   204,   204,   890,   570, -2114,
     909,   218,   125,   922, -2114,   936, -2114,   464,   619,    98,
     339,   945,   819,   969,   982,   996,  1003,  1006,  1017,  1028,
    1032, -2114,   -66, -2114,   975,   861, -2114, -2114,  1036,  1021,
    1021,  1047,  1071,   609, -2114, -2114, -2114,  1067, -2114, -2114,
    3064, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114,   284,  1079,  1093,  1325,
     542,   815,  1497, -2114, -2114, -2114,   570,  1055, -2114, -2114,
   -2114, -2114,   120,  1076,    17,   921,   815,   815,   877, -2114,
   -2114, -2114, -2114, -2114,   556, -2114, -2114, -2114,   714, -2114,
   -2114, -2114, -2114, -2114, -2114,  1134,  1111,  1121, -2114,  1034,
    1627,   542, -2114,   160,   665,   570,   935, -2114,  1156,  1147,
    1185,  1187,  1177,  1189,  1191, -2114, -2114, -2114,     4,   949,
    1212,  1251,   668,    41,    42,    47,    48,   983,   665,  1627,
     943,  1143,   285,  1049,  1153,  1405,   117,  1180,  1005,   452,
    1040,  1050,  1087,  1061,   715,  1035,  1627,  1041,  1046,  1116,
    1129,  1063,  1072,   131,  1627,  1081,   121,  1059,  1357, -2114,
    1356,  1390,  1376,  1388,  1056, -2114,  1305,   743,  1627,  1336,
     815,  1627,  1338,  1146,  1627,  1168, -2114,  1147, -2114,  1453,
    1447, -2114,  1449, -2114,  1627,  1512,   107,  1514,    11,   901,
    1484, -2114,  1485, -2114, -2114,   815,  1366,   724,  1520,  1361,
    1377,  1493,  1510,  1470,  1490,  1495,  1505, -2114,  1114,  1306,
    1419,  1541,  1542,     8,  1516, -2114,  1413,   815,  1270,  1439,
    1627,  1332,  1627, -2114, -2114,  1572,  1576,  1551,  1553, -2114,
   -2114,  1343, -2114,  1592,   987, -2114,   725,  4227,  1633,   725,
     725,  1617, -2114,  1629, -2114,  1630,   630,  1614, -2114, -2114,
    4227,  1640,   198,  1626,  1642, -2114, -2114, -2114,  1660, -2114,
    1607,  2411, -2114, -2114,  1520,  4227,  4227,  4227,  4227,  4227,
    4227, -2114, -2114,  1614, -2114, -2114,  2165, -2114, -2114,   617,
   -2114,  1682, -2114, -2114, -2114, -2114,   228, -2114,   296,  1676,
    1678, -2114,  4227,  4227,  4227,  4227,  4227,  4227,  4227,  4227,
    4227,  4227,  4227,  4227,  4227,  4227,  2006, -2114,  1518, -2114,
    1691, -2114,  1692,  1693,  1694,  1696, -2114, -2114,    35, -2114,
    1697, -2114, -2114, -2114,   669,  1698, -2114,  1707, -2114,  2398,
   -2114,  1210,   945,   945,   945,   945,   945, -2114,   945,   945,
   -2114,   153,   158,  1709,   945,   945,  1713,  1714, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114,   766, -2114, -2114,  1715,  1724,
     503, -2114,  1725,   609, -2114, -2114,   815,  1728,  4227,  1670,
   -2114, -2114,  1685,  1663,  1664, -2114, -2114, -2114, -2114,  4227,
    1700, -2114, -2114, -2114,  4227, -2114, -2114, -2114, -2114, -2114,
     815, -2114, -2114,  1701, -2114,   815,   946, -2114,  1384, -2114,
     815,    97,   815,  1074, -2114, -2114,  1528, -2114, -2114,   845,
   -2114, -2114,  1721, -2114,   743, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114,  1627, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114,  1457,  1463,  1180, -2114,  1705,   815,   815, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114,    28,  1708,  1717,   -17,
     612,  1422,  1627,  1537,  1627,  1718,  1727, -2114,  1730, -2114,
   -2114, -2114,  1190,  1731,   101,  1731,   103,   815,  1474,  1476,
     815,  1482,  1627,  1486,  1627,  1624,  1627,  1742,  1627,  1627,
    1627,  1627,  1627,  1627,  1563,  1627,  1746,  1627,  1627,  1750,
      62, -2114, -2114, -2114, -2114, -2114, -2114,  1627,   918, -2114,
   -2114,  1627, -2114,  1622,   815,  1627, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114,  1785,  1787, -2114,   815,   815,
   -2114, -2114, -2114, -2114, -2114,  1784,  4227, -2114, -2114,  1027,
    1621, -2114, -2114,  1027, -2114, -2114, -2114,  1027,  1520, -2114,
   -2114, -2114, -2114, -2114, -2114,   634,   911, -2114, -2114, -2114,
    1627,  1520, -2114, -2114, -2114,  1348, -2114,  1180, -2114, -2114,
   -2114,   -16,  1517, -2114,  1758,  1627, -2114,  1627,   815, -2114,
     815, -2114, -2114, -2114, -2114, -2114, -2114, -2114,   815, -2114,
    1793, -2114, -2114,  3030, -2114, -2114,   299, -2114, -2114, -2114,
   -2114,  1763,  1796,   484,  3064, -2114,  1675,  1786, -2114, -2114,
    4227, -2114,  4227, -2114, -2114,   643,  3568,  2889,  3193,  3289,
    3430,  3971,  1745,   252,  1747,  4053, -2114, -2114,  1805,  1706,
    1633, -2114,   911, -2114,  1589,  1590,  2485,  2485,  2485,  3206,
    3206,  2485,  2485,  2485,  2485,  2485,   960,   960,  1642,  1642,
   -2114, -2114, -2114, -2114,  1775, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,   814, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,   842, -2114, -2114,
    1822, -2114, -2114, -2114,  1784,  1808, -2114,  1665,  1666,   191,
   -2114, -2114, -2114, -2114,  1220, -2114, -2114, -2114, -2114,  1809,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,   861,   861,   861,
     861,  1829,   861,   861,   202,   945,   861,   945,   861, -2114,
     861,   861, -2114, -2114,   -66, -2114, -2114, -2114, -2114,  1784,
    1026,   665, -2114, -2114,  1830, -2114, -2114,  3817,  1795, -2114,
    1965, -2114, -2114, -2114,   665,  1814, -2114,  1803,  4081, -2114,
    4109, -2114, -2114,  1813,  1172,  1183,   665, -2114,   665, -2114,
     -66, -2114,  1810,  1812, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114,  1823, -2114,  1782,  1816,  1083, -2114,  1919,   878,
     815,   815,  1817, -2114,  1818,  1820,  1627,  1370, -2114, -2114,
    1680,  1570,   815,  1821,  1825,  1627,  1826,  1627,  1827, -2114,
   -2114, -2114, -2114, -2114, -2114,   877, -2114,   815, -2114,   815,
   -2114, -2114, -2114,   815, -2114,   815,  1828,   815,   815,  1832,
     815,  1833,   815,  1836,   743,  1843, -2114,  1844,  1845,  1849,
    1850,  1851,  1852,  1420,  1853, -2114,  1854,  1855, -2114,   815,
    1856,  1267, -2114,  1328, -2114,   815, -2114, -2114, -2114,   815,
   -2114, -2114, -2114,   508, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114,  3064, -2114,  1684, -2114,  1627, -2114, -2114,  1859,  1098,
     937,   442,  1865,  1866, -2114,  1731,  1824,  1862,  1627,   815,
    1627,   -16,  4535, -2114, -2114,  1738, -2114, -2114,  1782,  1841,
   -2114,   725, -2114,   725,  1860, -2114, -2114,  4227,  1890,  1891,
    3512,  2770, -2114, -2114, -2114,  4227, -2114,  4227,  4227,  4227,
    4227, -2114,  2830,  4227,  3145,  4227, -2114,  1848,  4227, -2114,
   -2114, -2114,  1908,  1909,  4227,  1518, -2114,    35, -2114, -2114,
   -2114, -2114,  1906,  1910, -2114, -2114,   630,   574,  1229, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,  1893,  1926,  1928,
    1930,  1931, -2114,  1932,  1933, -2114, -2114,  1925,   743, -2114,
   -2114,   743, -2114,   743,   861,  1940,   861,  1941,  1945,  1946,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  3684, -2114,
    5152,   284,  1900,  1877,  1782, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114,   993, -2114, -2114, -2114,  1934,
   -2114, -2114, -2114,  1904, -2114, -2114,  1804, -2114, -2114,  1911,
   -2114, -2114, -2114,  1180, -2114,  1912,  1880,  1913, -2114, -2114,
   -2114,  1915,   341, -2114,  1916,   683,   815,  1918, -2114, -2114,
    1920, -2114,  1921, -2114,   165, -2114,   251, -2114, -2114,   108,
   -2114, -2114, -2114,  1924,  1927, -2114,  1935, -2114,  1936, -2114,
    1939, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  1943,
   -2114, -2114, -2114,  1944, -2114,  1711, -2114,  1636,  1323,  1007,
    1647,  1801,  1656,  1802,   -42,  1627,  1947,  1627,   231,   815,
   -2114,  1948, -2114,  1784,  1051,   665,   815,  1871, -2114, -2114,
    1953, -2114, -2114, -2114, -2114,   195,  1627, -2114,   159, -2114,
    1722,  1190, -2114,   128,  1954, -2114,  1585,  1171, -2114, -2114,
   -2114, -2114,  1060, -2114, -2114, -2114,  1060,  1838, -2114, -2114,
    1959, -2114, -2114,  1627,   815, -2114, -2114,  1960,   815, -2114,
    1831,  1831,  1583,   -49,  1831, -2114, -2114,  1961, -2114, -2114,
   -2114, -2114,  1862, -2114, -2114,  1981, -2114, -2114, -2114,   430,
   -2114,  4227,  4227,  1971,  4227, -2114, -2114, -2114, -2114,  4227,
    4227,  2003,  1980,  1996,  1982,  2022,  4227, -2114,   670, -2114,
     815, -2114, -2114, -2114, -2114, -2114,  2017,  3064,  2020, -2114,
    4227, -2114,  4227,  2100,  1783,  3540,  4275,  4433,  4461,  4489,
     697,   211,  3064,  1994,   729,   200,  1995,  2056,  4053, -2114,
   -2114,  4533, -2114, -2114,  2037,  2038,  2058,   630,  1614,  2524,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
    2074, -2114,  2076, -2114, -2114, -2114,   284,  2004, -2114,  5152,
   -2114,  2033, -2114,  2068, -2114,  1591,  1637, -2114, -2114, -2114,
   -2114, -2114,  1949, -2114, -2114, -2114,  2009, -2114,    94, -2114,
   -2114,   815, -2114, -2114,  1923,  1723, -2114,     0,  1719,  1735,
     907,  1062, -2114, -2114,  2049,  2050,  2055, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
     199,  1273,  1627,  1627,    -8,  1627,   421,  1520, -2114, -2114,
   -2114,  1819, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114,  1791, -2114, -2114, -2114,   815,   815,  1627, -2114,
    2029,   815, -2114,  2030,   743, -2114, -2114,  2032,   815, -2114,
   -2114,   815,  2034, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
    2039, -2114, -2114, -2114,   561,   366, -2114,  1627, -2114, -2114,
   -2114,  1938, -2114, -2114, -2114, -2114,   815,   815, -2114, -2114,
   -2114,  2069, -2114, -2114, -2114,   815, -2114,  1981,  2097,  4227,
    3734,  2073,  2075,  2509,  4358,  2007,  2313,  4227, -2114, -2114,
   -2114,  4227,  2077,  4227,  1431, -2114,    -9,  2107,  2094,  4633,
    4748, -2114, -2114, -2114, -2114,  2070, -2114, -2114,  1221,  2062,
   -2114, -2114, -2114, -2114, -2114,  1573,  2099,  2099,  1190,  2086,
   -2114, -2114,  1573,  2099,  2099,  2099,  1060,  2088,  4227, -2114,
   -2114, -2114, -2114, -2114,  2106,  4227, -2114,  3371, -2114,  2112,
    4227,  2131,  3686,  3912,  2081, -2114,  2524,  2524, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114,  1113, -2114, -2114, -2114,  2095,   630,  1614, -2114,
   -2114, -2114, -2114,  2071,  1627,  2009, -2114, -2114,   877,   665,
    1868,  2102,  1789,  1914, -2114, -2114, -2114, -2114, -2114, -2114,
     341, -2114, -2114, -2114, -2114,   247,   247,  1180, -2114, -2114,
   -2114, -2114, -2114,  1986,  1874, -2114, -2114, -2114, -2114, -2114,
    1627,  1627,  1782,  2087, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,  2093, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,  2098,   815, -2114,
   -2114, -2114, -2114,  2104, -2114, -2114,  5365,  4227, -2114, -2114,
    2119, -2114,  4844, -2114,  5397,  4227,  5219,  5438, -2114,  5529,
    2121,  2125,  2126,  2138,  2139, -2114,  1180,  2142, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114,  2184,   815,  1349, -2114,  2118, -2114,
     614,   815,  1546,   717, -2114, -2114,  1349,   614,   717,   614,
    2120, -2114,  4780,  2148,  2150,   750,   449,  2151,   781,  2153,
    2154,   578,  2155,   627, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114,  1279, -2114, -2114, -2114,  1180,  1950,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
    1627,   815, -2114, -2114,  1585, -2114, -2114,   800,   808,   -41,
     917,   -26, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114,  2158,  5152,  2105, -2114,   925, -2114,  3064,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,  4227,  4227,  4227,
   -2114,  4227, -2114, -2114,   815, -2114, -2114,   815,  1309,   815,
   -2114,  2099,  2099,  2176, -2114, -2114, -2114, -2114, -2114,  2099,
    2099,  2195, -2114, -2114, -2114, -2114,  2182,  4227, -2114, -2114,
   -2114,  2187,  4227, -2114,  4227,  2214, -2114,  4227, -2114,  1455,
   -2114, -2114, -2114,   665,  1627,  2147,  1118,  1955,   815,   815,
     304, -2114, -2114,  2149,  2175, -2114,  1627, -2114, -2114, -2114,
   -2114,  1967, -2114, -2114, -2114,  -175, -2114, -2114,  1627,   815,
    1627,  2177, -2114,   815,   815,   -53,   815,  1952,   138, -2114,
    2186, -2114,  1788,  1799,  1627,  1627,  1627,  2188,   772, -2114,
      19,   -19,   830, -2114,     7, -2114,  2159,  4844,  5152, -2114,
   -2114,  2165, -2114, -2114,  2230, -2114, -2114, -2114, -2114,   111,
    2190,  2172,  4843,  4942,  5057,  5089, -2114,  2118,   815, -2114,
     815,   815,   815,  1546,  1546, -2114,  2203,  2204,  2206,  2183,
    2208,  2211,  2212,   815,  1997,  1127, -2114,   815,   815,  1985,
    1987,  2013,  2024,   248,  2240, -2114, -2114,  2110,  2014,  2015,
    2025, -2114, -2114, -2114,  1217, -2114,  2103, -2114,  1037, -2114,
   -2114,  1389, -2114,   815,  2223,   815,   815,  2023,  1879,  1627,
    2041,   257,    33,  1972,  1922,   815,  1627,   815,  2010,   233,
    1888,   815,  1887,  1937, -2114,  2262, -2114,   815,  2266, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,   815,
     815, -2114, -2114,   815,   815, -2114, -2114, -2114, -2114, -2114,
       5,   -52,   -22,  1881,  1872,  -133,  1882,  1627,  1878,  2043,
    1885,  2053,  2045,  2051,  2285, -2114,    55,  1180,  2286, -2114,
      55,  2314,  2298,   815, -2114,  1627,   815,  2060,  -122,  1627,
    2089,   293,   -93,  1180,  2016,  1942,   106,  2063,  2064,    61,
    1886,  1883, -2114,  2306, -2114,  1889,  1884,   665,  2317, -2114,
   -2114, -2114,  5150,   829,  1561,  5152,  2318,  4227,  2319,  2322,
    2323,  2324, -2114,  2330,  2341, -2114, -2114, -2114, -2114, -2114,
   -2114,  4227, -2114,  4227, -2114, -2114,  1248, -2114, -2114, -2114,
   -2114,   815,   815,  1627,   815,   815,   815,   815,   815, -2114,
   -2114,  2299,  2329,   815,   815,   815, -2114, -2114,  1238,  2356,
     122,   815,  2356,  1254,   141,  2304, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  1627,  1957,
   -2114,   135,   815,   815, -2114, -2114, -2114, -2114,   770,  1627,
   -2114, -2114, -2114,   815,   815, -2114,  1627, -2114,   815,  1627,
   -2114, -2114, -2114, -2114, -2114,  1929,  1929,  2108, -2114,   667,
     815,   667,  2109,   815,  2114,   815,   815,  2115,  1962, -2114,
    1627,   815,   815,  2205,  1627,   561,  1627,   366, -2114, -2114,
     815, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114,   815,  1627,  1627, -2114,   815,   815,   815, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114,  1103,   815, -2114, -2114,
     815,   815,  1627, -2114,  1627,  1627, -2114, -2114,  1897,  1898,
   -2114, -2114, -2114,  4227, -2114, -2114, -2114, -2114,  5251, -2114,
   -2114, -2114, -2114,   815,   815,  2336,  2325,  1180,  1180, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  2110, -2114,
   -2114, -2114, -2114, -2114, -2114,  2344,  2356,  2356,  2345,  2349,
     749,  1099,  2354,  2356,  2356, -2114,   994, -2114,  1627, -2114,
   -2114, -2114, -2114, -2114,  1998, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114,  1627, -2114, -2114,   815, -2114, -2114, -2114, -2114,
    1929, -2114,   815,  1929,   815, -2114, -2114,   815,  1627, -2114,
   -2114, -2114,   815, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114,  1999, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114,   665,   665,  5150,  2355, -2114, -2114, -2114,  4227,
   -2114, -2114, -2114,  1037,  2358,  2359,  1037,  1037, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  1037,  2360,
    2361, -2114,  2011, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  2337,
   -2114,  1037,  1037, -2114, -2114, -2114,  1037,  1037, -2114,  2362,
    4227, -2114, -2114, -2114, -2114, -2114,  2363, -2114
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       4,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1348,     0,     3,   134,   136,   138,   514,   516,   518,   520,
     524,   526,   528,   582,   591,   593,   595,   597,   599,   601,
     603,   605,   607,   609,   611,   618,   620,   622,   624,   626,
     628,   630,   632,   634,   716,   718,   720,   722,   682,   878,
    1020,  1022,  1024,  1026,  1028,  1030,  1032,  1034,  1204,  1206,
    1268,  1332,  1334,  1336,  1338,  1340,  1342,  1344,  1346,     1,
       2,     0,   384,     6,   382,   383,     0,     0,     0,     0,
       0,     0,     0,   390,   391,     0,   375,   376,   378,   379,
     380,   381,     0,     0,  1302,     0,     0,     5,     7,   140,
     143,   145,   147,   149,   178,   366,   373,     0,   385,     0,
     431,   434,   389,   392,   396,   392,   684,   392,   643,   392,
     396,   392,   865,   392,   396,   392,   396,     0,   396,   392,
    1067,   392,  1153,   392,  1208,   392,   396,   396,  1301,  1324,
    1327,   392,   392,   396,   135,   137,   139,   258,   259,   268,
     188,   189,   264,   277,   262,     0,     0,     0,     0,   278,
       0,     0,     0,   281,   260,   261,   279,   280,   282,   283,
     284,   285,   286,   307,     0,     0,     0,     0,     0,     0,
       0,     0,   642,   715,   853,   856,   855,   852,   854,   857,
     858,   859,   862,   864,   860,   861,   863,  1016,  1017,  1018,
    1019,  1151,  1152,  1202,  1203,  1273,  1274,  1275,  1276,  1277,
    1278,  1279,  1280,  1281,  1282,  1283,  1284,  1285,  1286,  1287,
    1288,  1289,  1290,  1291,  1292,  1293,  1294,  1295,  1296,  1297,
    1298,  1299,  1300,  1380,  1381,    37,    38,    47,    39,    40,
      41,    42,    48,    43,    44,    45,   265,   132,   133,    46,
     263,   272,   305,   306,   333,   304,   308,     0,   309,   636,
     638,   637,     0,    67,    67,     0,     0,     0,     0,   635,
       0,   640,     0,     0,   530,     0,   584,     0,     0,   523,
       0,   523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   614,     0,   613,   616,    67,   880,  1349,     0,  1348,
    1348,     0,     0,  1350,  1345,    16,    15,     0,   179,   141,
     144,   151,   152,   153,   155,   154,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,     0,     0,     0,     0,
       0,     0,    22,   377,    65,    64,     0,     0,   436,   435,
     437,   438,     0,     0,     0,     0,     0,     0,     0,   462,
     725,   685,   644,   866,   887,  1046,  1061,  1068,  1154,  1209,
    1238,  1354,  1367,   890,  1156,     0,   393,     0,   461,     0,
      22,     0,   468,     0,     0,     0,     0,   404,     0,   415,
       0,     0,     0,     0,     0,   816,   817,   724,     0,     0,
       0,     0,     0,   806,   807,     0,     0,     0,     0,    22,
       0,     0,     0,     0,    22,     0,   729,   726,     0,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,   818,
     848,     0,     0,     0,     0,   886,     0,     0,    22,     0,
       0,    22,     0,     0,    22,   893,   897,   415,   898,     0,
       0,   911,     0,  1045,    22,     0,     0,     0,     0,     0,
       0,  1050,     0,  1063,  1060,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1237,     0,     0,
       0,     0,     0,  1257,  1266,  1353,     0,     0,     0,     0,
      22,     0,    22,  1359,  1360,     0,     0,     0,     0,  1366,
    1373,     0,  1370,     0,   258,   277,   258,     0,     0,   258,
     258,     0,   249,     0,    29,     0,     0,     0,    32,    33,
     273,     0,     0,     0,   302,    36,   211,   212,     0,   214,
       0,     0,   127,   127,     0,     0,     0,     0,     0,     0,
       0,   190,   193,   189,   192,   195,     0,    37,    38,   240,
     191,   229,   226,   227,   228,   236,     0,   244,     0,     0,
       0,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   471,     0,   470,
       0,    66,     0,     0,     0,     0,   625,   482,     0,   481,
       0,  1347,   639,   641,   640,     0,   525,     0,   517,     0,
     515,     0,   523,   523,   523,   523,   523,   522,   523,   523,
    1036,   523,   523,     0,   523,   523,     0,     0,   604,   596,
     606,   598,   592,   594,   600,   602,  1320,  1315,  1318,  1316,
    1317,  1319,  1321,  1322,  1323,     0,  1313,   617,     0,     0,
       0,  1341,     0,  1350,  1337,  1339,  1351,     0,     0,     0,
     171,   166,     0,     0,     0,   369,   371,   372,   457,     0,
       0,   432,     9,    11,     0,   433,    18,    20,    19,    21,
       0,    17,  1328,     0,  1326,   439,     0,   447,  1305,  1310,
    1306,     0,     0,     0,  1331,  1330,   386,   888,   889,   392,
    1155,   394,     0,   463,     0,   397,   398,   448,   403,   402,
     401,   399,    22,   464,   413,   417,   465,   466,   690,   649,
     747,     0,     0,     0,   763,     0,     0,     0,   810,   808,
     811,   809,   812,   814,   813,   815,     0,     0,     0,     0,
      22,     0,    22,     0,    22,     0,     0,   764,     0,    23,
      24,    25,     0,    26,     0,    26,     0,     0,     0,     0,
       0,     0,    22,     0,    22,     0,    22,     0,    22,    22,
      22,    22,    22,    22,     0,    22,     0,    22,    22,     0,
       0,   748,   846,   850,   749,   875,   891,    22,    22,   912,
     899,    22,   909,   906,     0,    22,   900,   894,   895,   417,
     892,   914,  1047,  1057,  1056,     0,     0,  1053,     0,     0,
    1058,  1059,  1049,  1048,   411,   171,     0,   422,   423,     0,
       0,   421,   406,     0,   407,   419,   405,     0,     0,  1064,
    1065,  1079,  1163,  1211,  1239,     0,     0,    54,    53,  1253,
      22,     0,  1240,  1241,  1259,     0,  1258,     0,  1262,  1260,
    1261,  1251,  1254,  1264,     0,    22,  1272,    22,     0,  1361,
       0,  1363,  1270,  1356,  1355,  1368,   448,  1371,     0,  1369,
       0,   252,   255,     0,   188,   189,     0,   256,   257,   251,
      28,    30,     0,     0,   274,   322,     0,     0,   323,   213,
       0,   287,     0,   128,   129,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   241,   242,     0,     0,
       0,   266,     0,   267,     0,     0,   299,   297,   295,   292,
     293,   294,   296,   298,   300,   301,   288,   289,   290,   291,
     317,   311,   312,   313,     0,   316,   310,   314,   315,   319,
     320,   321,   475,   476,   477,   479,   480,   478,     0,   473,
     631,   623,   619,   627,   629,   486,   487,     0,   484,   633,
       0,   519,   527,   529,   171,     0,   539,     0,   560,     0,
     541,   540,   545,   546,     0,   559,   561,   531,   538,     0,
     583,   586,   587,   588,   589,   585,   590,    67,    67,    67,
      67,     0,    67,    67,     0,   523,    67,   523,    67,  1021,
      67,    67,  1269,   608,     0,   615,   612,   621,   879,   171,
       0,     0,   884,  1343,     0,  1352,  1333,     0,   167,   171,
       0,   142,   173,   146,     0,     0,   448,     0,     0,   367,
       0,  1329,  1325,     0,   441,   444,     0,  1309,     0,  1308,
       0,  1311,     0,     0,    12,    13,    14,   387,   388,  1062,
     395,   400,   451,   454,   469,     0,     0,   418,   396,   396,
       0,     0,     0,   755,     0,     0,    22,    22,   789,   791,
       0,     0,     0,     0,     0,    22,     0,    22,     0,   805,
     804,   765,    52,    51,   729,     0,   729,     0,   752,     0,
     732,   733,   726,     0,   750,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   788,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,   759,     0,
       0,     0,   851,   396,   901,     0,   904,   903,   902,     0,
     910,   908,   896,     0,  1051,  1052,  1055,  1054,   174,   175,
     420,   176,   430,   424,   409,    22,   410,   408,     0,   396,
     396,   396,     0,     0,  1246,    26,  1255,     0,    22,     0,
      22,  1252,     0,  1244,  1364,  1357,  1271,  1362,   456,  1377,
    1372,   258,   250,   258,     0,    30,   276,     0,     0,     0,
       0,     0,   123,   125,   330,     0,   303,     0,     0,     0,
       0,   332,     0,     0,     0,     0,   194,     0,     0,   230,
     237,   245,     0,     0,     0,     0,   472,     0,   483,   521,
     537,   544,     0,     0,   533,   534,   557,   558,     0,   554,
     555,   556,   550,   548,   549,   532,   547,   542,     0,     0,
       0,     0,   683,     0,     0,  1035,  1044,     0,     0,  1039,
    1042,     0,  1037,     0,    67,     0,    67,     0,     0,     0,
    1314,   883,   882,   881,   885,  1335,     8,   169,     0,   180,
     181,     0,     0,     0,   458,   368,   370,    10,   440,   442,
     443,   445,   446,  1304,  1307,     0,  1303,   374,   452,    67,
     448,   467,   416,     0,   692,   693,     0,   686,   687,     0,
     651,   652,   652,     0,   645,     0,     0,     0,   776,   775,
     774,     0,     0,   734,     0,    22,     0,     0,   797,   796,
       0,   786,     0,   803,     0,    27,     0,   730,   731,     0,
     727,   728,   761,     0,     0,   780,     0,   769,     0,   757,
       0,   758,   772,   792,   771,   770,   802,   773,   793,     0,
     795,   768,   760,     0,   766,     0,   849,     0,     0,     0,
       0,     0,     0,     0,     0,    22,     0,    22,    22,     0,
     822,     0,   877,   171,     0,     0,     0,     0,   871,   867,
       0,   905,   907,   913,  1006,     0,    22,   927,    22,   925,
       0,     0,   917,    22,     0,   931,  1007,     0,   429,   412,
    1066,  1081,     0,  1082,  1073,  1075,     0,     0,  1069,  1070,
       0,  1165,  1166,    22,     0,  1157,  1158,     0,     0,  1210,
    1222,  1222,     0,     0,  1222,  1213,  1214,     0,  1217,  1242,
    1243,  1245,     0,    60,    61,  1247,  1250,  1249,  1248,     0,
    1267,   338,   338,     0,     0,   335,   336,   337,   334,     0,
       0,     0,     0,     0,     0,     0,   338,  1263,     0,  1265,
       0,  1365,  1375,  1379,   253,   254,     0,   275,     0,   324,
       0,   269,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   200,     0,     0,     0,     0,     0,     0,    34,
      35,     0,   474,   485,     0,     0,     0,   551,   552,     0,
     723,   717,   719,   721,  1025,  1023,  1040,  1043,  1038,  1041,
       0,  1027,     0,  1031,  1205,  1207,     0,     0,   184,   182,
     183,     0,   148,     0,  1312,   449,     0,   453,   455,   414,
     448,   688,     0,   691,   448,   646,   670,   647,   674,   648,
     650,     0,   781,   783,     0,     0,   738,     0,     0,     0,
       0,     0,   736,   784,     0,     0,     0,   798,   785,   787,
     754,   753,   751,   779,   778,   762,   777,   756,   794,   767,
       0,    22,    22,    22,     0,    22,     0,     0,   830,   831,
     832,     0,   826,   843,   842,   844,   847,   870,   869,   868,
     872,   873,     0,   876,   448,   930,     0,     0,    22,   918,
       0,     0,   916,     0,     0,   934,   929,   933,     0,   923,
     915,     0,   941,   425,   426,   427,   428,    50,    49,  1115,
    1124,  1072,   448,  1071,     0,     0,  1077,    22,  1080,   448,
    1162,  1159,  1161,  1164,  1224,  1223,     0,     0,    25,  1226,
    1225,  1215,  1229,  1230,  1218,     0,  1212,  1256,     0,     0,
     339,     0,     0,     0,     0,     0,     0,     0,   361,   361,
     352,     0,     0,     0,     0,  1358,     0,     0,     0,     0,
       0,    80,    91,    92,    78,     0,    81,    82,     0,     0,
      85,    86,    89,   130,    87,     0,   104,   104,     0,     0,
      90,   131,     0,   104,   104,   104,     0,     0,     0,   327,
     328,   326,   329,   209,     0,     0,   207,     0,   203,     0,
       0,   201,     0,     0,     0,   318,     0,     0,   553,   579,
     577,   578,   562,   565,   569,   572,   575,   576,   563,   564,
     566,   567,   568,   570,   571,   573,   574,   580,   581,   543,
    1029,  1033,     0,   177,   185,   172,     0,    57,    58,    59,
      55,    56,   450,   712,    22,   670,   668,   653,     0,     0,
     677,     0,     0,     0,   742,   740,   741,   744,   743,   745,
       0,   735,   800,   799,   801,    22,    22,     0,   837,   838,
     839,   840,   841,     0,     0,   833,   827,   828,   829,   845,
      22,    22,  1009,  1013,   920,   921,   919,   994,   922,   994,
     955,   935,   924,  1008,   942,  1122,  1121,  1112,  1128,  1127,
    1135,  1074,  1137,  1138,  1145,  1076,  1078,  1199,     0,  1220,
    1219,  1216,  1227,     0,  1221,    62,     0,   338,   350,   351,
       0,   344,     0,   246,     0,     0,     0,     0,   349,     0,
       0,     0,     0,     0,     0,  1378,     0,     0,    31,   325,
     270,   271,    79,    83,    84,    88,    74,    72,    70,    69,
      71,    73,    68,    75,    97,     0,   114,    99,    95,   105,
     115,     0,     0,   116,   113,   124,   119,   120,   121,   122,
     117,   126,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   243,   535,   536,   168,   170,   150,
     710,   694,   689,   653,     0,   673,   675,   676,     0,   679,
     782,   739,   746,   737,   820,   821,   819,   825,   824,   823,
      22,     0,   836,   874,  1007,  1011,  1015,     0,     0,     0,
     944,     0,  1126,  1110,  1109,  1133,  1143,  1197,  1167,  1160,
    1231,   343,   340,     0,   181,   341,   186,     0,   347,   361,
     362,   363,   364,   361,   365,   346,   345,     0,     0,     0,
     354,     0,  1374,  1376,     0,    93,    77,    76,     0,     0,
      76,   104,   104,     0,   106,   107,   108,   109,   110,   104,
     104,     0,   331,   224,   208,   206,     0,     0,   204,   222,
     202,     0,     0,   220,     0,   218,   217,     0,   215,   695,
     714,   672,   671,     0,    22,     0,     0,     0,     0,     0,
       0,   661,   489,   493,     0,   678,    22,   681,   834,   835,
    1010,     0,   928,   997,   995,   998,   926,   932,    22,     0,
      22,     0,   940,     0,     0,     0,     0,     0,     0,   954,
       0,  1125,     0,     0,    22,    22,    22,     0,     0,  1114,
    1129,  1139,     0,  1201,     0,   348,     0,     0,   181,   196,
     199,     0,   353,   198,   234,   231,   232,   233,   238,     0,
       0,     0,     0,     0,     0,     0,    98,    96,     0,   100,
       0,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   713,     0,     0,     0,
       0,     0,     0,     0,     0,   494,   659,   490,     0,     0,
       0,   654,   658,   662,     0,   663,     0,   660,   495,   669,
     680,     0,  1014,     0,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
       0,     0,     0,     0,   993,     0,   999,     0,     0,   938,
     939,   937,   936,   948,   945,   951,   952,   953,   946,     0,
       0,   949,   943,     0,     0,  1116,  1117,  1118,  1123,  1113,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,  1100,  1102,     0,  1132,     0,     0,     0,  1142,
       0,     0,     0,     0,  1200,    22,     0,     0,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1192,     0,  1236,     0,     0,     0,     0,   187,
     342,   248,   200,     0,     0,   181,     0,     0,     0,     0,
       0,     0,    94,     0,     0,   101,   112,   111,   223,   205,
     221,     0,   219,     0,   216,   696,     0,   699,   700,   698,
     697,     0,     0,    22,     0,     0,     0,     0,     0,   705,
     711,     0,     0,     0,     0,     0,   664,   665,     0,     0,
       0,     0,     0,     0,     0,     0,   963,   964,   965,   966,
     967,   968,   969,   970,   960,  1001,   957,   974,    22,     0,
     992,     0,     0,     0,   987,   981,   982,   983,    22,    22,
     956,   976,   959,     0,     0,   961,    22,   958,     0,    22,
    1012,  1000,   996,   947,   950,  1149,  1149,     0,  1099,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1087,
      22,     0,     0,     0,    22,     0,    22,     0,  1111,  1136,
       0,  1147,  1131,  1130,  1134,  1146,  1141,  1140,  1144,  1173,
    1171,  1168,     0,    22,    22,  1190,     0,     0,     0,  1185,
    1193,  1196,  1195,  1194,  1191,  1172,    22,     0,  1169,  1170,
       0,     0,    22,  1174,    22,    22,  1198,  1228,     0,     0,
    1235,  1232,   197,     0,   235,   239,   247,   359,     0,   356,
     357,   355,   358,     0,     0,     0,     0,     0,     0,   701,
     702,   707,   703,   704,   460,   459,   706,   488,   490,   655,
     656,   657,   666,   667,    63,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   492,     0,   977,    22,   985,
     984,   986,   989,   988,     0,   990,   975,   973,   962,   972,
     978,   971,    22,  1119,  1120,     0,  1106,  1107,  1108,  1095,
    1149,  1096,     0,  1149,     0,  1089,  1085,     0,    22,  1088,
    1090,  1091,     0,  1104,  1101,  1105,  1103,  1148,  1179,  1189,
    1178,  1183,  1184,  1186,     0,  1187,  1182,  1180,  1181,  1175,
    1176,  1177,     0,     0,     0,     0,   103,   102,   210,     0,
     708,   709,   491,   495,     0,     0,   495,   495,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   495,     0,
       0,   980,  1003,  1002,   979,   991,  1150,  1097,  1093,  1098,
    1094,  1084,  1083,  1086,  1092,  1188,  1234,  1233,   360,     0,
     500,   495,   495,   502,   501,   503,   495,   495,  1004,     0,
       0,   498,   499,   496,   497,  1005,     0,   225
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  -333,
    -356,   -77,   212,  -387,  -718, -2114,  -155,  -157,  1443,  1454,
    1456, -2114, -2114, -2114,  -172, -2114, -2114,  -281, -1287,  -738,
    1839, -2114, -2114,  1009, -2113,  -352,  -217,   469,  -901, -2114,
     965,   968,   970, -2114,   971,   751,   478,   493,  -497, -1329,
    -600,   767, -2114, -2114, -2114, -2114,  1917, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  -887, -2114,
   -2114, -2114,  1794,  -914,  -587,  1437, -2114, -2114, -1812,   948,
   -2114,   411,  -188,  1550,   249, -1147, -1802,  2291, -1796, -1794,
    1555,   263,  1963, -2114,  1554, -2114, -2114, -2114, -2114,  -455,
   -2114, -2114, -2114, -1135,  -151, -1149,    -7, -2114, -1370, -1144,
   -1560, -2114, -2114,  -436, -2114,   220, -2114, -2114, -2114,   -25,
     -95, -2114,  -843, -2114,  2021,  1681,   -92,  -532,  -461, -2114,
    -581, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  1199,  -692,
    -821, -2114, -2114, -1846, -2114, -2114, -2114, -2114, -2114,   145,
   -2114,  1258,    24, -2114,  1275, -1432,    85, -2017, -2114, -1398,
   -2114, -2114, -2114, -2114, -2114,  -208, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114,  -209, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,   208,  1895,
   -1137, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  1192,
     592, -2114, -2114, -2114,   741, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114,  1395,   137, -2114, -2114,   731, -2114, -2114,
   -2114,   723, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114,   703, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114,   588, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114,   182, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114,   343,   327, -2114, -2114, -2114, -2114,
     181,   324, -2114, -2114, -2114, -2114,   183,   329, -2056, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114,  -934,   876, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,  1669, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114,  1487,  1522, -2114, -2114, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114,  1203,  1869, -2114, -2114,
   -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114, -2114
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    22,    23,    24,    25,     2,     3,   107,   108,   681,
     694,   376,  1906,  1799,  1086,   524,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,  1609,  2013,
     839,  1742,  1424,  1425,  2405,   347,   592,  1855,  1962,  1674,
    1675,  1676,  1677,  1685,  1678,  1856,  1857,  1858,  1860,  1861,
    1968,  1863,  1679,  1687,  1463,  1464,   893,  1182,  1183,   257,
     258,   259,   109,   660,   110,   111,   112,   113,   336,  1258,
    1019,  1020,  1139,  1140,   821,  1022,   114,   659,  1507,  1508,
    1509,  1935,   260,   561,  2054,   903,   562,   904,   563,   564,
     565,  2058,   566,  2059,   567,   568,  1937,   520,   261,   521,
     262,   263,   883,   264,   265,   266,  1472,  1446,  1641,  1510,
    1825,  1943,   115,   670,   116,   387,  1048,   118,   119,   377,
     388,   389,   482,  1056,   715,  1057,   390,   826,   822,  1388,
    1144,   120,   352,   353,   121,  1052,  1517,  1279,  1053,  1168,
    1169,  1026,  1027,  2249,   122,   123,   124,   707,   391,   590,
     948,   949,   600,   957,   958,  2001,  2251,  2002,  2003,  2265,
    2412,    26,    27,    28,    29,   623,    30,    31,    32,   609,
    1225,  1226,   979,  1729,    33,   611,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,   304,   648,    45,
      46,    47,    48,    49,    50,    51,    52,    53,   272,   605,
     268,   125,  1289,  1058,   126,  1520,  1990,  2094,  1989,  1891,
    1521,    54,    55,    56,    57,   127,  1295,  1059,   128,  1524,
    1895,  2004,  2107,  1894,  1747,  1525,  1527,  1750,  1899,  2007,
    1529,    58,   129,   756,   754,  1304,  1541,  1542,   130,   439,
     440,  1907,  1361,  1121,   783,  1122,   441,   131,  1370,  1123,
     132,    59,   650,   373,   133,   134,   798,   457,   458,   459,
     460,   461,  1133,  1384,  1593,  1590,  1596,  1597,  1919,  2021,
    1385,  1920,  2030,  1386,  2135,  1917,  2014,  2015,  2138,  2416,
    2529,  2503,  1584,  1602,  1783,  1914,  2011,  1916,  1585,    60,
      61,    62,    63,    64,    65,    66,    67,   994,   135,   136,
     472,   137,   699,   138,   139,  1400,  1614,  1615,  1149,   140,
    1612,  2174,  2325,  2327,  2439,  2039,  2038,  1924,  1613,  1610,
    2037,  1922,  1921,  1796,  1611,  1800,  1925,  2178,  2329,  2040,
    1801,  1804,  1926,  2182,  2335,  2041,  1805,  2332,  2433,   374,
     141,  1407,  1150,   142,  1619,  2043,  2203,  2354,  2042,  1928,
    1620,    68,    69,   143,   144,  1151,  1417,  1626,  1418,  1631,
    1634,  1812,  1813,  2044,  2208,  2367,   145,   146,   851,   852,
     493,   494,  1449,  1162,   854,    70,   147,   505,   354,   148,
    1037,  1039,   691,  1042,   645,   646,   149,   150,    71,    72,
      73,    74,    75,    76,    77,    78,   313,   657,   151,  1451,
     506,   152,   153,   513,   866,  1837,  1656,  1453,   867
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     267,   695,   690,   560,   317,   529,   522,   528,   675,   318,
     319,   789,   895,  1445,  1084,  1054,   824,  1632,  1447,   559,
     307,   636,   978,   693,   693,  1448,   527,  1444,  1607,   753,
     755,   709,   710,  1157,   558,   438,   557,  1092,  2017,   456,
     344,   470,   345,   481,   471,  1471,  1473,  1475,  1476,   509,
    1210,   491,   503,  2031,   492,   504,   737,   593,   512,   871,
    2179,   872,  1642,  1012,   877,   878,     4,     5,     6,    82,
    1835,  2309,  2350,   672,    84,    85,  1652,   340,   673,   672,
    2252,   320,   748,   626,   673,   344,  2204,   345,   649,  1826,
     728,   730,   341,   637,   844,  1251,   732,   734,  2175,   495,
     392,  2311,   393,   779,   394,  2351,   442,   674,   443,  1616,
     462,  1445,  2145,   674,   483,  1066,   484,   792,   485,  1568,
     486,   617,  2046,  1448,   379,  1444,   507,   508,   380,   381,
    1748,   606,   510,  1261,  1754,  2055,   383,   749,   750,   672,
     751,  2056,   814,  2057,   673,   685,   672,  2343,  1087,  2409,
    1093,   673,  1088,   672,  1094,  1093,   672,   805,   673,  1552,
     534,   673,   532,   541,   856,   344,  2316,   345,   676,   677,
     678,   679,  2406,   674,   379,  1040,   617,   672,   380,   381,
     674,   617,   673,   344,   384,   345,   383,   674,  2214,   385,
     674,  2413,    96,    97,    98,    99,   100,   101,  2285,   676,
     677,   678,   679,   269,   955,   270,     7,   838,  1235,  2018,
    1700,   674,  1087,  1283,  1214,  1070,  1550,   273,   274,   277,
     278,  1695,     8,   117,  1773,  1236,   305,   269,     1,   270,
     301,   886,  2136,  2146,   384,   356,  2211,   721,  2137,   385,
      79,   602,  1146,   603,   308,   808,  1147,     9,    10,   672,
    2434,   672,   496,  1701,   673,   956,   673,  1041,  1158,   662,
     618,  2215,  1193,   309,  1696,   672,  1237,   302,  1051,   533,
     673,   676,   677,   678,   679,  2284,   154,  1702,  1360,    11,
     497,   696,    12,   674,    13,   674,   809,   676,   677,   678,
     679,  1569,   357,  2484,  2485,    14,  1148,   806,  1087,   674,
    2499,  2500,  1551,   845,   722,   910,  2317,   315,   316,  1153,
    2352,    15,  2407,   995,   155,    16,  2245,  2246,   997,  2286,
      17,    18,  2019,  1015,  1031,  2282,  2246,   708,   838,  1194,
     560,  2414,   846,  1071,  1264,   346,  1062,  1089,   887,  1095,
     271,   847,  1774,  2150,  1095,  2349,   686,   693,  1862,   303,
    2147,  1215,  1033,   619,   455,  1862,  1238,  1038,  2344,  1043,
    1445,  2347,  2246,   522,   271,   522,  2020,  1755,   522,   522,
     683,  1506,  1448,   912,  1444,   607,   910,  1749,   604,  2060,
     911,  2252,   661,  2061,  2508,  1765,   156,  2510,  2353,   729,
     731,  1802,  1067,  1064,  1065,   733,   735,   275,   276,  1870,
    1159,  1089,  2310,  2376,   987,   988,   989,   990,   991,   711,
     992,   993,  2055,   996,   998,   774,  1000,  1001,  2056,   638,
    2057,  1119,   342,  2312,  1096,  2032,  2033,  1099,  1120,  2034,
    2035,  2036,  2313,  1534,   775,  2180,  2287,  1421,  2294,    19,
    1160,  1633,  2181,  1836,  1803,   498,   279,  1932,   913,  1577,
    2307,  1173,  1136,  1137,  2358,  1090,  1091,  1639,  1155,  1977,
    1156,  1130,   639,   640,   641,   642,   643,   644,   778,  2103,
    2362,  1239,  2247,  2176,   752,   693,   693,  1627,  1253,  2177,
    1635,  2247,   530,   594,   595,   671,  1143,  1089,  2029,  1408,
    1143,    82,  2205,  2206,  1143,  1766,    84,    85,  1240,  2207,
    2104,  2359,  1978,   848,   849,   850,  1820,   280,  2330,  1008,
     873,  1767,   620,   511,   741,  2248,   306,  2247,   499,  1090,
    1091,  1409,  1591,   884,  2283,  1166,   706,  1167,   621,   622,
     310,   311,   312,   624,   986,  1170,  1368,  1176,   896,   897,
     898,   899,   900,   901,   688,  2419,  2420,  1598,  1874,   905,
    1876,   689,   314,  1878,   682,  1881,  1883,   337,  1586,  1535,
    2348,  1177,   500,   501,   502,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,  2134,
    1083,   749,   750,   587,   751,   359,  1587,  1373,  1984,  1241,
    2105,  2106,   705,  1573,   625,   558,   379,   557,  1904,  1905,
     380,   381,   742,    20,    21,  1090,  1091,   338,   383,   525,
    2202,   597,  1588,   339,    96,    97,    98,    99,   100,   101,
     588,   738,  1242,  1243,  1486,   343,   746,   743,  1956,  1960,
     672,  1985,  2070,  2071,   612,   673,   360,  1987,   767,  1798,
    2073,  2074,   358,  1595,  1009,   816,   776,   355,   598,   906,
     907,  1017,   676,   677,   678,   679,   384,   473,   613,  1254,
     790,   385,  1028,   793,   674,   523,   796,  1030,  1330,   525,
    1374,  1010,  1262,  1445,  1049,  1375,   803,  1942,  1936,   529,
    1988,   528,   535,   361,  1273,  1448,  1274,  1444,   344,  1944,
     345,  1961,   602,  1011,   603,   908,  1184,  1653,   362,  1743,
     530,   672,   589,  1745,    80,  1536,   673,  1537,  1654,  1538,
    1539,   531,   859,  1540,   861,   542,  1454,  1776,  1455,   614,
    1185,   560,   560,   676,   677,   678,   679,  1296,  1297,   543,
     599,  1956,  1960,   544,  1410,   674,   615,    81,   545,  1307,
     559,   348,   546,   514,   758,  1777,  1778,    82,   515,    83,
    1693,   759,    84,    85,  1317,   558,  1318,   557,  1376,   516,
    1320,   665,  1321,   666,  1323,  1324,   667,  1326,  1411,  1328,
    1228,  1229,  1230,  1231,  1694,  1233,  1234,   517,    86,  1245,
    1339,  1247,  1698,  1248,  1249,  1445,  1343,  1244,   672,  1246,
     547,  1797,  1371,   673,  1969,   669,  1372,  1448,  1807,  1444,
     363,   569,  1497,  1975,   364,  1498,  1699,  1499,   548,  1141,
     676,   677,   678,   679,   349,   350,   351,  1221,   570,  1220,
     526,   527,   674,  1082,   281,   282,  1427,  1976,   526,   527,
    2077,  1082,  1579,   672,  1980,  2079,   549,  2080,   673,    87,
    2082,    88,    89,  1004,    90,  1005,    91,  2049,  2050,   874,
     875,  2159,    92,   283,    93,    94,   365,    95,  1981,   550,
     284,   366,   367,  1377,  2160,   815,   816,   674,   315,   316,
      96,    97,    98,    99,   100,   101,   518,  2183,   519,  2012,
     285,  2373,   286,  1180,   817,  1181,   591,  2016,   824,   818,
     287,  1205,  1782,  1206,   368,   375,   596,  1378,  1445,  1445,
     315,   316,  1072,  1936,   823,   288,  1528,   616,   369,  2184,
    1448,  1448,  1444,  1444,  1379,   601,  1380,   102,   370,  1207,
    1381,  1208,   371,   103,  1055,  1382,  1383,  1412,   608,   104,
     105,   526,   527,  1413,  2048,  1414,   672,   697,   698,  2161,
    1864,   673,   610,  2049,  2050,   874,   875,  2488,  2489,  2490,
    2491,  2492,  1074,  1073,  1076,  1958,  1078,  1290,   676,   677,
     678,   679,  1970,  1287,  1294,  1958,  1288,  1970,   617,   372,
     674,   726,   727,  1546,  1101,   628,  1103,  2051,  1105,   627,
    1107,  1108,  1109,  1110,  1111,  1112,    82,  1114,   629,  1116,
    1117,    84,    85,   647,   584,   585,  2022,   870,   586,  1124,
    1127,  2162,   630,  1128,  2052,   514,  2163,  1131,  1315,   631,
     515,   289,   632,  1580,   749,   750,  1401,   751,  1993,  2185,
     522,   516,   522,   633,  1544,  1629,  1575,  1500,  1369,  1502,
     764,   765,   379,  1581,   634,  1779,   380,   381,   635,   517,
    1291,  2164,   651,  1995,   383,   672,   307,  2165,  2424,   825,
     673,  1252,  1152,   654,  1398,  1405,  1415,  1399,  1406,  1416,
    1630,   529,  1516,   528,   810,   811,  1445,  1164,  1142,  1165,
    1004,  1622,  1514,  2501,   825,  1624,  1578,   655,  1448,   674,
    1444,   527,   656,  1607,  2385,  2520,  2386,  2259,  2523,  2524,
    2186,   379,   384,  2187,   658,   380,   381,   385,  2188,  1402,
    2525,   290,   663,   383,  2189,  1993,   684,  2190,  2191,    96,
      97,    98,    99,   100,   101,  2192,   664,  1655,  1044,  1045,
    1046,   672,  2260,  2531,  2532,   291,   673,   687,  2533,  2534,
    1995,  2436,  2437,  2438,   526,   835,   836,   837,   518,  1760,
     519,  1761,  2193,   676,   677,   678,   679,    82,   815,   816,
    2023,   384,    84,    85,   692,   674,   385,   701,  1790,  1292,
    1293,   702,  1282,   168,  1887,  2194,  1888,   817,   171,   172,
    1457,   672,   818,  1034,  1035,  1563,   673,  1391,  1465,  2024,
    1466,  1467,  1468,  1469,  1511,   700,  1867,   823,  1869,   704,
    1392,  1478,  2261,   676,   677,   678,   679,  1481,  1751,   703,
     749,   750,  2025,   751,   712,   674,   475,   713,  1125,  1083,
     526,   527,  2166,  1082,  2167,  2168,   980,  1269,  1270,  2169,
    2170,  1314,  2171,  1316,   558,   714,   557,  2262,  1271,  1272,
    2172,  2173,  2263,   315,   316,  1608,   716,   106,   717,  1608,
    1216,  1217,  1218,  1219,   474,  2195,   476,   477,  2264,  1487,
    1488,   478,   379,  1784,  1785,   718,   380,   381,  1788,  1126,
    1393,   723,   479,   724,   383,  1792,  2196,   719,  1793,   720,
      96,    97,    98,    99,   100,   101,   725,    82,  1301,  1303,
    1758,  1759,    84,    85,   736,  1843,  1844,  1310,   475,  1312,
     981,   672,   739,  1809,  1810,   757,   673,  2493,  2494,  2495,
    2496,  2497,  1814,  2197,  2198,  2199,  2200,   463,  2201,  2026,
    2027,  2028,   384,   676,   677,   678,   679,   385,   744,   379,
    1846,  1847,  1848,   380,   381,   674,  1345,   740,   476,   477,
     760,   383,  2519,   478,   444,    82,  1849,  1850,  1851,   761,
      84,    85,  1854,   665,   479,   666,  1346,   762,   667,  1854,
     766,   982,  1403,  1603,  1604,  1605,  1606,  1389,  1992,  1741,
     763,  1740,   768,  1956,  1957,   445,   983,   984,   749,   750,
    1426,   751,  1428,  1154,   769,   668,   770,   669,   985,   384,
    1909,  2464,   379,  2536,   385,   745,   380,   381,   672,   771,
     475,  2237,  2238,   673,   383,  2098,  2099,  1897,  1347,   772,
      96,    97,    98,    99,   100,   101,   773,  1362,   781,  1404,
     676,   677,   678,   679,   464,  2256,  2257,   780,  1852,  1853,
    2387,  2388,   674,   672,  1640,  1640,   777,  1644,   673,  1732,
    1348,  1349,  1645,  1646,   782,   478,  2402,  2403,   672,  1640,
     379,   784,   384,   673,   380,   381,   479,   385,  1302,  1952,
    2410,  2411,   383,  1659,   785,  1660,   747,   674,    96,    97,
      98,    99,   100,   101,   815,   816,   786,  1993,  1994,  1363,
     816,  1338,   674,  2226,  2227,  1929,   551,   552,   160,   553,
     554,   555,   379,   817,   465,   787,   380,   381,   818,   788,
     791,  1562,  1995,   794,   383,  1350,  1364,  1885,  1886,  1351,
     384,   795,  2083,   819,   800,   385,  1083,   815,   816,   820,
     556,  2005,   652,   653,  2084,   672,   797,  1545,   446,  2085,
     673,   558,  1955,   557,   292,   801,   817,   802,  1963,  1608,
     804,   818,   807,   480,  2086,   812,   813,   676,   677,   678,
     679,   827,   384,   825,   829,   828,   819,   385,   831,   674,
    1768,  1769,   820,   293,  1996,  1997,  1394,  1395,  1998,  1999,
    1396,   830,  1830,  1831,  2000,  1397,  1832,  1570,   832,  1572,
    1574,  1833,  1834,   833,   294,   840,   295,   296,  2009,  2049,
    2050,   874,   875,   834,  1846,  1847,  1848,   841,  1589,  1352,
    1592,   672,   842,   843,   853,  1599,   673,   855,  1353,  1354,
    1849,  1850,  1851,   749,   750,  1355,  1628,   858,   345,  1356,
     857,   -66,   -66,  2051,   -66,  1621,  1964,  1965,  1966,  1967,
    1357,  2066,   860,   862,  1854,   674,  1854,   863,  1358,   864,
    1359,   865,  1816,   868,   879,  2087,   297,   298,   299,   300,
    1824,  2095,  2101,   869,  1827,   672,  1829,   880,   881,   882,
     673,   551,   552,   874,   875,   554,   555,  1737,  1738,   888,
    1739,   466,   467,   468,   469,   693,  2102,   676,   677,   678,
     679,  1896,   885,   447,   448,   449,   450,   680,   889,   674,
     586,  1872,  1852,  1853,   890,   556,  2140,   942,   943,   944,
    2143,  2144,   909,  2148,   914,  2151,   915,   950,   951,   952,
     953,   451,   954,   959,   961,  1365,  1366,  1367,   452,   945,
     946,   453,   947,   962,   454,   999,  2088,  2089,  2090,  1002,
    1003,  1006,  1018,  2091,   551,   552,   874,   875,   554,   555,
    1007,  1013,  2092,  2093,  1016,  2222,  1023,  2223,  2224,  2225,
    1024,  1025,  1036,  1047,  1050,  1083,  1083,  1060,  1075,  2053,
    2235,  1029,  1032,  1061,  2239,  2240,  1063,  1077,  1198,  1068,
     558,   558,   557,   557,  1097,    82,  1098,  1085,  1069,  1079,
      84,    85,  1100,  1770,  1771,  1772,  1102,  1775,  1080,  1104,
    2274,  1081,  2276,  2277,  2266,  2267,  2268,  2269,  2270,  2271,
    2272,  2273,  2290,  1106,  2292,   487,  2295,  1115,  2297,  1113,
    1786,  1118,  1129,  1134,  2301,  1135,  2355,  1138,  1145,  1163,
    1640,  1171,   845,  1174,  1175,  1178,  2303,  2304,  1939,  1179,
    2305,  2306,  1192,  1197,  1195,  1202,  1203,  1204,  1209,  1806,
    1661,  1211,  1227,  1212,  1213,  1232,  1255,  1263,  1268,  1662,
    1663,  1664,  1665,  2331,  1666,  1667,  1668,  2331,  1257,  1669,
    2339,  1670,  1671,  2341,  1265,  2370,  1278,  1672,  1680,  1280,
    1306,  1276,  1681,  1277,  1305,  1387,  2363,  1281,  1298,  1299,
     379,  1300,  1308,  1422,   380,   381,  1309,  1311,  1313,  1322,
    1423,  1456,   383,  1325,  1327,  2389,  2390,  1329,    96,    97,
      98,    99,   100,   101,  1331,  1332,  1333,  2399,  2400,  2401,
    1334,  1335,  1336,  1337,  1340,  1341,  1342,  1344,   693,   693,
    1390,  2392,  2393,  2394,  2395,  2396,  1419,  1420,  1450,  1452,
     693,   693,   693,  1458,  1459,  1477,  1479,  1480,  2408,  1484,
     384,  1489,  1490,  1485,  1491,   385,  1492,  1493,  1494,  1495,
    2062,  2063,  2064,  1496,  2065,   488,  1501,  1503,  2421,  2422,
    2423,  1504,  1505,  1512,  1513,  1519,  1892,  1531,  1522,  1515,
    2427,  2428,  1523,  1530,  1532,  2430,  1533,  1543,    82,  1547,
    1567,  1548,  1549,    84,    85,  1553,  1561,  2440,  1554,  1566,
    2443,  1560,  2445,  2446,   489,  1565,  1555,  1556,  2450,  2451,
    1557,  1594,  1912,  1913,  1558,  1559,  1564,  2457,  1284,  1576,
    2480,  2481,  1582,  1608,  1583,  1600,  1571,  1601,  1617,  2458,
    1618,  1623,  1636,  2461,  2462,  2463,  1638,  1625,   572,   573,
     574,   575,   576,  1643,  2466,  2053,  2053,  2467,  2468,  2502,
    1647,  2111,  1648,  1650,   577,   578,   579,   580,   581,   582,
     583,   584,   585,  1260,  2212,   586,  2112,   490,  1649,  1651,
    2476,  2477,  1657,  1658,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   930,   330,   331,   332,   333,   334,   335,
     931,  1697,  1703,   379,  1704,  1706,  1707,   380,   381,  1708,
    1730,  1285,  1731,  1733,  1735,   383,  1736,  1746,  1781,  1780,
    1756,    96,    97,    98,    99,   100,   101,   932,  1753,   933,
    1762,  1763,  2507,  1752,  1744,  1757,  1764,  1787,  1789,  2509,
    1791,  2511,  1794,  1822,  2512,  1815,  1408,  1795,  1808,  2514,
    2516,  2517,  2008,   934,  1818,  1838,  1819,  1839,  1828,  1845,
    1842,   935,   936,   384,   937,   938,  1859,  1865,   385,  1871,
    1873,  1879,   939,   940,   941,    82,  1877,  1661,  1889,  1890,
      84,    85,  1898,  1900,  1901,  1993,  1662,  1663,  1664,  1665,
    1884,  1666,  1667,  1668,  1911,  1915,  1669,  1902,  1670,  1671,
    1910,  1923,  1933,  1947,  1672,   378,  1927,  1948,  1949,  1673,
    1995,   157,  1930,   158,   159,   160,   161,   162,   163,  1950,
     164,  1951,  1286,  1953,  1954,  1959,  1971,   165,   166,   902,
    2113,  1973,   167,  1974,  1979,  1982,  2096,  1983,  1986,  2045,
    2378,  2072,  2047,  2075,   168,   169,  2076,   170,  2110,   171,
     172,  2078,  2114,   173,  2081,  2097,  2109,  2108,  2142,  2115,
    2139,  2006,  2141,  2100,  2116,  2117,  2118,  2152,  2209,  2158,
    2213,  2119,  2153,  2216,  2120,  2121,  2155,  2156,  2157,  2217,
     379,  2149,  2122,  2154,   380,   381,  2228,  2229,   382,  2230,
    2231,  2232,   383,  2233,  2241,  2234,  2242,  2236,    96,    97,
      98,    99,   100,   101,   174,   175,   536,   537,   538,   539,
     176,   177,  2243,   178,   179,   180,   181,   182,   183,   184,
    2244,  2250,  2278,  2253,  2254,   185,   186,   187,  1993,  2258,
     188,  2275,  2123,  2298,  2255,  2279,   189,  2281,  2288,  2293,
     384,  2124,  2296,  2300,   190,   385,   191,  2302,  2315,  2289,
    2314,  2318,  2320,  2323,   572,   573,   574,   575,   576,  2324,
    2125,  2280,  2299,  2321,  2322,  2326,  2328,  2334,  2291,  1802,
     577,   578,   579,   580,   581,   582,   583,   584,   585,  2338,
    2342,   586,  2356,  2360,  2361,  2346,  2126,  2366,  2357,  2127,
    2128,  2129,  2365,  2364,   386,  2383,  2474,  2130,  2371,  2377,
    2379,  2369,  2131,  2380,  2381,  2382,  2384,  2368,  2397,  2319,
    2398,  2404,  2132,  2415,  2418,  2452,  2472,  2473,   192,  2478,
    2133,  1823,  2432,  2444,  2447,  2483,  2486,  2340,  2435,  2442,
    2487,  2345,  2479,  2448,   963,  2498,  2518,  2505,  2515,  2521,
    2522,  2526,  2527,  2535,  2530,  2528,  2537,  1222,   526,   835,
     836,   837,   572,   573,   574,   575,   576,  2068,  1223,  1682,
    1224,  1637,  1683,  1866,  1684,  1686,   193,  2069,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   168,   977,   586,
    2067,  1868,   171,   172,  1021,  2391,  1259,  1734,  2210,  1199,
     894,   540,  2374,  1482,   891,  1200,  1201,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,  2375,   799,  1518,
    1132,   876,  1483,  2482,  1526,  1991,  1893,  1319,   892,  1908,
    2417,  1903,  1918,  2441,   204,   205,   -67,   -67,   -67,   960,
    2425,  2426,  2010,  2308,  2333,  2337,  2454,  1811,  2429,  2336,
    2456,  2431,   -67,   -67,   -67,   -67,   -67,   582,   583,   584,
     585,  1161,  1014,   586,     0,   206,  1250,  1275,     0,     0,
       0,     0,  2449,     0,     0,     0,  2453,     0,  2455,   964,
     816,     0,     0,     0,     0,     0,     0,     0,   207,   208,
     209,   210,     0,     0,   965,  2459,  2460,     0,   966,     0,
       0,   967,   968,     0,     0,     0,   969,     0,  2465,     0,
       0,     0,     0,  1709,  2469,     0,  2470,  2471,  1710,  1711,
       0,     0,     0,     0,     0,   970,     0,     0,     0,   571,
       0,     0,     0,     0,   572,   573,   574,   575,   576,     0,
       0,   971,   972,   973,     0,   974,     0,   975,   976,     0,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
     157,   586,   158,   159,   160,   161,   162,   163,     0,   164,
    2504,     0,     0,   211,   212,     0,   165,   166,     0,     0,
       0,   167,     0,     0,  2506,     0,     0,   213,   214,     0,
       0,     0,     0,   168,   169,     0,   170,     0,   171,   172,
    2513,     0,   173,     0,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,     0,     0,     0,     0,  1712,  1713,  1714,  1715,
    1716,  1717,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   243,   244,   174,   175,   536,   537,   538,   539,   176,
     177,     0,   178,   179,   180,   181,   182,   183,   184,     0,
       0,     0,   192,     0,   185,   186,   187,     0,     0,   188,
       0,     0,     0,     0,     0,   189,     0,     0,     0,     0,
       0,     0,     0,   190,     0,   191,     0,     0,     0,     0,
       0,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,
    1727,  1728,     0,     0,     0,     0,     0,     0,     0,     0,
     193,   572,   573,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,   586,     0,
       0,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,     0,  1461,     0,     0,     0,   192,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   204,   205,
       0,     0,     0,     0,     0,     0,   157,  1462,   158,   159,
     160,   161,   162,   163,     0,   164,     0,     0,     0,     0,
       0,     0,   165,   166,  1470,     0,     0,   167,     0,   206,
       0,     0,     0,     0,     0,   193,     0,     0,     0,   168,
     169,     0,   170,     0,   171,   172,     0,     0,   173,     0,
       0,     0,   207,   208,   209,   210,     0,     0,     0,     0,
     572,   573,   574,   575,   576,     0,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,   586,     0,     0,
       0,     0,     0,   204,   205,     0,     0,     0,     0,   174,
     175,     0,     0,     0,     0,   176,   177,     0,   178,   179,
     180,   181,   182,   183,   184,     0,     0,     0,     0,     0,
     185,   186,   187,     0,   206,   188,  1187,     0,     0,     0,
       0,   189,     0,     0,     0,     0,     0,   211,   212,   190,
       0,   191,     0,     0,     0,     0,     0,   207,   208,   209,
     210,   213,   214,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,     0,     0,     0,     0,
       0,   572,   573,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,   192,     0,   243,   244,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,   586,     0,
       0,     0,   211,   212,     0,   572,   573,   574,   575,   576,
       0,     0,     0,  1172,     0,     0,   213,   214,     0,     0,
       0,   577,   578,   579,   580,   581,   582,   583,   584,   585,
       0,   193,   586,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   204,
     205,   157,     0,   158,   159,   160,   161,   162,   163,     0,
     164,     0,     0,     0,     0,     0,     0,   165,   166,  1474,
       0,     0,   167,     0,     0,     0,     0,     0,     0,     0,
     206,     0,     0,     0,   168,   169,     0,   170,     0,   171,
     172,     0,     0,   173,   572,   573,   574,   575,   576,     0,
       0,     0,     0,   207,   208,   209,   210,   572,   573,   574,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,   586,     0,   577,   578,   579,   580,   581,   582,   583,
     584,   585,     0,     0,   586,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,     0,     0,     0,     0,
     176,   177,     0,   178,   179,   180,   181,   182,   183,   184,
    1188,     0,     0,     0,     0,   185,   186,   187,     0,     0,
     188,     0,     0,     0,     0,     0,   189,     0,     0,     0,
       0,     0,     0,     0,   190,     0,   191,     0,   211,   212,
     572,   573,   574,   575,   576,     0,     0,     0,     0,     0,
       0,     0,   213,   214,     0,     0,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,   586,     0,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1189,     0,   192,     0,
       0,     0,     0,     0,     0,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   157,     0,   158,
     159,   160,   161,   162,   163,     0,   164,     0,     0,     0,
       0,     0,     0,   165,   166,  1875,     0,     0,   167,     0,
       0,     0,     0,     0,     0,     0,   193,     0,     0,     0,
     168,   169,     0,   170,     0,   171,   172,     0,     0,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   572,   573,   574,   575,   576,     0,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,   586,     0,
       0,     0,     0,     0,   204,   205,     0,     0,     0,     0,
     174,   175,     0,     0,     0,     0,   176,   177,     0,   178,
     179,   180,   181,   182,   183,   184,     0,     0,     0,     0,
       0,   185,   186,   187,     0,   206,   188,  1190,     0,     0,
       0,     0,   189,     0,     0,     0,     0,     0,     0,     0,
     190,     0,   191,   572,   573,   574,   575,   576,   207,   208,
     209,   210,     0,     0,     0,     0,     0,     0,     0,   577,
     578,   579,   580,   581,   582,   583,   584,   585,     0,     0,
     586,   572,   573,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,   586,   572,
     573,   574,   575,   576,     0,     0,     0,     0,     0,  1460,
       0,     0,     0,     0,   192,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,   586,     0,     0,     0,
       0,     0,     0,   211,   212,     0,     0,  1688,     0,     0,
       0,  1186,     0,     0,     0,     0,     0,   213,   214,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   193,     0,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,     0,     0,     0,     0,     0,     0,
       0,   243,   244,     0,     0,     0,     0,     0,     0,     0,
     204,   205,   157,     0,   158,   159,   160,   161,   162,   163,
       0,   164,     0,     0,     0,     0,     0,     0,   165,   166,
    1880,     0,     0,   167,     0,     0,     0,     0,     0,     0,
       0,   206,     0,     0,     0,   168,   169,     0,   170,     0,
     171,   172,     0,     0,   173,   572,   573,   574,   575,   576,
       0,     0,     0,     0,   207,   208,   209,   210,     0,     0,
       0,   577,   578,   579,   580,   581,   582,   583,   584,   585,
       0,     0,   586,   321,   322,   323,   324,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,   334,   335,     0,
       0,     0,     0,     0,     0,   174,   175,     0,     0,     0,
       0,   176,   177,     0,   178,   179,   180,   181,   182,   183,
     184,  1817,     0,     0,     0,     0,   185,   186,   187,     0,
       0,   188,     0,     0,     0,     0,     0,   189,   572,   573,
     574,   575,   576,     0,     0,   190,     0,   191,     0,   211,
     212,     0,     0,     0,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   213,   214,   586,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1256,     0,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   192,
       0,     0,     0,     0,     0,     0,     0,   243,   244,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   157,     0,
     158,   159,   160,   161,   162,   163,     0,   164,     0,     0,
       0,     0,     0,     0,   165,   166,  1882,     0,     0,   167,
       0,     0,     0,     0,     0,     0,     0,   193,     0,     0,
       0,   168,   169,     0,   170,     0,   171,   172,     0,     0,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   572,   573,   574,   575,   576,     0,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   577,   578,
     579,   580,   581,   582,   583,   584,   585,     0,     0,   586,
       0,     0,     0,     0,     0,   204,   205,     0,     0,     0,
       0,   174,   175,     0,  1191,     0,     0,   176,   177,     0,
     178,   179,   180,   181,   182,   183,   184,     0,     0,     0,
       0,     0,   185,   186,   187,     0,   206,   188,     0,     0,
       0,     0,     0,   189,     0,     0,     0,     0,     0,     0,
       0,   190,     0,   191,   572,   573,   574,   575,   576,   207,
     208,   209,   210,     0,     0,     0,     0,     0,     0,     0,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,   586,   572,   573,   574,   575,   576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1196,     0,   577,   578,
     579,   580,   581,   582,   583,   584,   585,     0,     0,   586,
     572,   573,   574,   575,   576,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1266,   192,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,   586,     0,     0,
       0,     0,     0,     0,   211,   212,     0,     0,     0,     0,
       0,     0,  1267,     0,     0,     0,     0,     0,   213,   214,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   193,     0,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,     0,     0,     0,     0,     0,
       0,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   204,   205,   157,     0,   158,   159,   160,   161,   162,
     163,     0,   164,     0,     0,     0,     0,     0,     0,   165,
     166,     0,     0,     0,   167,     0,     0,     0,     0,     0,
       0,     0,   206,     0,     0,     0,   168,   169,     0,   170,
       0,   171,   172,     0,     0,   173,   572,   573,   574,   575,
     576,     0,     0,     0,     0,   207,   208,   209,   210,     0,
       0,     0,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,   586,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1689,     0,
       0,     0,     0,     0,     0,     0,   174,   175,     0,     0,
       0,     0,   176,   177,     0,   178,   179,   180,   181,   182,
     183,   184,     0,     0,     0,     0,     0,   185,   186,   187,
       0,     0,   188,     0,     0,     0,     0,     0,   189,   572,
     573,   574,   575,   576,     0,     0,   190,     0,   191,     0,
     211,   212,     0,     0,     0,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   213,   214,   586,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1821,
       0,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,     0,
       0,     0,     0,     0,   572,   573,   574,   575,   576,     0,
     192,     0,     0,     0,     0,     0,     0,     0,   243,   244,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,   586,   572,   573,   574,   575,   576,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1690,     0,   577,   578,
     579,   580,   581,   582,   583,   584,   585,     0,   193,   586,
     572,   573,   574,   575,   576,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1691,     0,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,   586,     0,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,     0,
       0,     0,  1692,     0,   572,   573,   574,   575,   576,     0,
       0,     0,     0,     0,     0,     0,   204,   205,  1429,     0,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,   586,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   169,  1705,   206,     0,     0,
       0,     0,     0,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     207,   208,   209,   210,  1430,     0,  1431,  1432,  1433,  1434,
    1435,  1436,  1437,  1438,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1439,     0,     0,  1440,   572,   573,   574,   575,   576,     0,
     176,   177,     0,   178,   179,   180,   181,   182,  1441,     0,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,   586,     0,     0,     0,     0,     0,     0,     0,     0,
    1442,     0,  1443,     0,     0,     0,  1840,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   213,
     214,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,     0,     0,     0,     0,   192,   572,
     573,   574,   575,   576,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   243,   244,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,   586,     0,     0,     0,
       0,   572,   573,   574,   575,   576,     0,     0,     0,     0,
       0,  1841,     0,     0,     0,     0,   193,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,   586,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1972,     0,     0,     0,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,     0,     0,     0,
       0,     0,     0,     0,   572,   573,   574,   575,   576,     0,
       0,     0,     0,     0,   204,   205,     0,  1429,     0,     0,
     577,   578,   579,   580,   581,   582,   583,   584,   585,     0,
       0,   586,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   169,   206,  2218,     0,     0,     0,
       0,     0,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   207,   208,
     209,   210,  1934,     0,     0,  1431,  1432,  1433,  1434,  1435,
    1436,  1437,  1438,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1439,
       0,     0,  1440,   572,   573,   574,   575,   576,     0,   176,
     177,     0,   178,   179,   180,   181,   182,  1441,     0,   577,
     578,   579,   580,   581,   582,   583,   584,   585,     0,     0,
     586,     0,     0,     0,     0,     0,     0,     0,     0,  1442,
       0,  1443,     0,     0,     0,  2219,     0,     0,     0,     0,
       0,     0,     0,   211,   212,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   213,   214,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,     0,     0,     0,     0,     0,   192,   572,   573,
     574,   575,   576,     0,     0,     0,     0,     0,     0,     0,
       0,   243,   244,     0,   577,   578,   579,   580,   581,   582,
     583,   584,   585,     0,     0,   586,     0,     0,     0,     0,
     572,   573,   574,   575,   576,     0,     0,     0,     0,     0,
    2220,     0,     0,     0,     0,   193,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,   586,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2221,     0,     0,     0,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,     0,     0,     0,
       0,   572,   573,   574,   575,   576,     0,     0,     0,     0,
       0,     0,     0,   204,   205,  1429,     0,   577,   578,   579,
     580,   581,   582,   583,   584,   585,     0,     0,   586,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   169,  2372,   206,     0,     0,     0,     0,     0,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   207,   208,   209,
     210,     0,     0,  1431,  1432,  1433,  1434,  1435,  1436,  1437,
    1438,     0,  1940,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1439,     0,     0,
    1440,     0,   572,   573,   574,   575,   576,   176,   177,   169,
     178,   179,   180,   181,   182,  1441,     0,   173,   577,   578,
     579,   580,   581,   582,   583,   584,   585,     0,     0,   586,
       0,     0,     0,     0,     0,     0,     0,  1442,     0,  1443,
       0,     0,     0,     0,  2475,     0,     0,     0,     0,     0,
       0,     0,   211,   212,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   213,   214,     0,     0,
       0,     0,     0,     0,   176,   177,     0,   178,   179,   180,
     181,   182,  1941,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,     0,     0,     0,     0,   192,   572,   573,   574,   575,
     576,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     243,   244,   577,   578,   579,   580,   581,   582,   583,   584,
     585,     0,     0,   586,     0,     0,     0,     0,   572,   573,
     574,   575,   576,     0,     0,     0,  1931,     0,     0,     0,
       0,     0,     0,   193,   577,   578,   579,   580,   581,   582,
     583,   584,   585,     0,     0,   586,     0,     0,     0,     0,
       0,     0,   192,     0,     0,     0,     0,     0,  1938,   572,
     573,   574,   575,   576,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   577,   578,   579,   580,   581,
     582,   583,   584,   585,     0,     0,   586,     0,     0,     0,
       0,   204,   205,     0,     0,     0,     0,     0,     0,  1945,
     193,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   206,     0,     0,     0,     0,     0,     0,     0,
       0,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,     0,     0,     0,   207,   208,   209,   210,     0,
     572,   573,   574,   575,   576,     0,     0,     0,   204,   205,
       0,     0,     0,     0,     0,     0,   577,   578,   579,   580,
     581,   582,   583,   584,   585,     0,     0,   586,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   206,
    1946,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   207,   208,   209,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,     0,
       0,     0,   395,   396,     0,     0,     0,   211,   212,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   243,   244,
       0,   213,   214,     0,     0,     0,     0,   397,     0,     0,
       0,     0,     0,     0,     0,   398,     0,     0,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   399,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   243,   244,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   379,     0,     0,     0,   380,   381,     0,   400,
     401,     0,     0,     0,   383,   402,     0,     0,     0,     0,
     403,   404,   405,   406,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   407,     0,     0,   408,   409,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   384,     0,     0,     0,     0,   385,     0,     0,
       0,     0,     0,     0,     0,     0,   410,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   413,     0,     0,     0,
       0,     0,   414,     0,     0,     0,     0,     0,     0,   415,
     416,     0,   417,     0,     0,     0,     0,   418,     0,   419,
       0,   420,   421,     0,     0,   422,   423,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   424,   425,     0,     0,     0,     0,   426,   427,     0,
       0,     0,     0,     0,     0,   428,     0,     0,     0,   429,
       0,     0,   430,   431,     0,   432,     0,   433,     0,     0,
       0,   434,   435,     0,   436,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   437
};

static const yytype_int16 yycheck[] =
{
       7,   357,   354,   191,    81,   162,   157,   162,   341,    86,
      87,   447,   544,  1162,   752,   707,   477,    66,  1162,   191,
      25,    87,   609,   356,   357,  1162,    21,  1162,    23,   416,
     417,   383,   384,    49,   191,   130,   191,   755,    79,   134,
      23,   136,    25,   138,   136,  1192,  1193,  1194,  1195,    79,
     964,   146,   147,    79,   146,   147,   408,   274,   153,   514,
      79,   516,  1432,   650,   519,   520,     3,     4,     5,    49,
      79,   123,   165,    18,    54,    55,  1446,   193,    23,    18,
    2097,    88,   415,   291,    23,    23,    79,    25,   305,  1649,
      49,    49,   208,   159,    86,  1009,    49,    49,    79,    79,
     125,   123,   127,   436,   129,   198,   131,    52,   133,  1396,
     135,  1260,   165,    52,   139,    87,   141,   450,   143,   161,
     145,    23,  1934,  1260,   154,  1260,   151,   152,   158,   159,
      36,     6,   162,  1020,   134,  1937,   166,    20,    21,    18,
      23,  1937,   475,  1937,    23,    25,    18,   269,    47,  2262,
      47,    23,    51,    18,    51,    47,    18,    50,    23,    51,
     167,    23,    33,   170,   497,    23,   299,    25,    40,    41,
      42,    43,    50,    52,   154,    78,    23,    18,   158,   159,
      52,    23,    23,    23,   214,    25,   166,    52,    77,   219,
      52,    50,   172,   173,   174,   175,   176,   177,   165,    40,
      41,    42,    43,    23,   169,    25,   143,   488,     6,   250,
      10,    52,    47,  1056,    23,   232,    51,     9,    10,    11,
      12,    10,   159,     3,   232,    23,    18,    23,     7,    25,
      41,    33,   407,   286,   214,   473,  2048,   233,   413,   219,
       0,    23,   823,    25,   249,   234,   827,   184,   185,    18,
    2306,    18,   232,    53,    23,   220,    23,   160,   274,   336,
     162,   150,    10,   268,    53,    18,    64,    78,   704,   140,
      23,    40,    41,    42,    43,  2121,     6,    77,  1121,   216,
     260,   358,   219,    52,   221,    52,   275,    40,    41,    42,
      43,   333,   530,  2406,  2407,   232,   828,   190,    47,    52,
    2413,  2414,    51,   295,   300,    77,   439,    23,    24,   841,
     403,   248,   190,   160,     6,   252,    68,    69,   160,   286,
     257,   258,   363,   656,   680,    68,    69,   167,   609,    77,
     518,   190,   324,   350,  1026,   193,   723,   236,   140,   236,
     160,   333,   350,   205,   236,  2191,   226,   680,  1677,   160,
     403,   160,   685,   255,   134,  1684,   154,   690,   480,   692,
    1509,    68,    69,   514,   160,   516,   407,   367,   519,   520,
     346,  1258,  1509,    77,  1509,   250,    77,   283,   160,  1939,
     152,  2398,    98,  1943,  2440,   186,     6,  2443,   481,   348,
     348,    25,   364,   726,   727,   348,   348,   217,   218,  1686,
     416,   236,   454,  2215,   612,   613,   614,   615,   616,   385,
     618,   619,  2214,   621,   622,   284,   624,   625,  2214,   485,
    2214,   359,   538,   445,   757,   451,   452,   760,   780,   455,
     456,   457,   454,    92,   303,   454,   403,  1155,   205,   376,
     456,   490,   461,   452,    78,   425,     6,  1817,   152,  1363,
     445,   152,   808,   809,   348,   354,   355,    27,   845,    10,
     847,   794,   528,   529,   530,   531,   532,   533,   347,   165,
     409,   269,   224,   454,   357,   808,   809,  1411,  1010,   460,
    1414,   224,    52,   275,   276,   340,   819,   236,  1920,    47,
     823,    49,   485,   486,   827,   296,    54,    55,   296,   492,
     196,   395,    53,   495,   496,   497,  1643,   184,   453,     6,
     517,   312,   414,   543,   229,   267,   252,   224,   498,   354,
     355,    79,   363,   530,   267,   858,   381,   860,   430,   431,
     535,   536,   537,   194,   611,   868,  1123,    53,   545,   546,
     547,   548,   549,   550,   527,   410,   411,   419,  1695,   556,
    1697,   534,     6,  1700,   342,  1702,  1703,    52,   363,   218,
     267,    77,   542,   543,   544,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,  2011,
     752,    20,    21,    41,    23,   161,   391,    79,    10,   387,
     286,   287,   380,   362,   255,   752,   154,   752,   351,   352,
     158,   159,   317,   540,   541,   354,   355,    52,   166,    35,
    2042,    41,   417,   155,   172,   173,   174,   175,   176,   177,
      78,   409,   420,   421,    50,   178,   414,   342,    14,    15,
      18,    53,  1961,  1962,   170,    23,   212,    10,   426,    78,
    1969,  1970,   168,  1381,   141,   142,   434,   184,    78,    32,
      33,   658,    40,    41,    42,    43,   214,    78,   194,  1011,
     448,   219,   669,   451,    52,    35,   454,   674,  1104,    35,
     162,   168,  1024,  1822,   699,   167,   464,  1826,  1822,   836,
      53,   836,    18,   259,  1036,  1822,  1038,  1822,    23,  1826,
      25,    77,    23,   190,    25,    78,    53,    27,   274,  1520,
      52,    18,   160,  1524,     6,   364,    23,   366,    38,   368,
     369,   140,   500,   372,   502,    78,  1171,   296,  1173,   255,
      77,   909,   910,    40,    41,    42,    43,  1060,  1061,    78,
     160,    14,    15,    52,   292,    52,   272,    39,    52,  1072,
     912,   156,    52,    18,   292,   324,   325,    49,    23,    51,
      53,   299,    54,    55,  1087,   912,  1089,   912,   250,    34,
    1093,    18,  1095,    20,  1097,  1098,    23,  1100,   326,  1102,
     987,   988,   989,   990,    77,   992,   993,    52,    80,   996,
    1113,   998,    53,  1000,  1001,  1934,  1119,   995,    18,   997,
      52,  1612,  1125,    23,    77,    52,  1129,  1934,  1619,  1934,
     376,   234,  1238,    53,   380,  1241,    77,  1243,    52,   816,
      40,    41,    42,    43,   229,   230,   231,   974,   234,   974,
      20,    21,    52,    23,   193,   194,  1159,    77,    20,    21,
    1977,    23,  1364,    18,    53,  1982,    52,  1984,    23,   141,
    1987,   143,   144,    77,   146,    79,   148,    18,    19,    20,
      21,    79,   154,   222,   156,   157,   432,   159,    77,    52,
     229,   437,   438,   355,    92,   141,   142,    52,    23,    24,
     172,   173,   174,   175,   176,   177,   151,    47,   153,    79,
     249,    52,   251,   890,   160,   892,    25,    79,  1349,   165,
     259,    77,  1584,    79,   470,    50,     6,   389,  2047,  2048,
      23,    24,   290,  2047,   180,   274,  1293,   288,   484,    79,
    2047,  2048,  2047,  2048,   406,     6,   408,   219,   494,    77,
     412,    79,   498,   225,   712,   417,   418,   485,     6,   231,
     232,    20,    21,   491,     9,   493,    18,   381,   382,   167,
    1678,    23,     6,    18,    19,    20,    21,   198,   199,   200,
     201,   202,   740,   341,   742,  1856,   744,    79,    40,    41,
      42,    43,  1863,  1058,  1059,  1866,  1058,  1868,    23,   545,
      52,   303,   304,  1306,   762,     6,   764,    52,   766,   160,
     768,   769,   770,   771,   772,   773,    49,   775,     6,   777,
     778,    54,    55,    18,    34,    35,    79,    10,    38,   787,
     788,   229,     6,   791,    79,    18,   234,   795,  1085,     6,
      23,   380,     6,  1365,    20,    21,    79,    23,   188,   189,
    1171,    34,  1173,     6,   341,  1412,  1359,  1244,  1123,  1246,
     315,   316,   154,  1366,     6,  1567,   158,   159,     6,    52,
     162,   269,     6,   213,   166,    18,    25,   275,   278,    23,
      23,    25,   840,     6,  1149,  1150,  1151,  1149,  1150,  1151,
    1412,  1218,  1279,  1218,   163,   164,  2215,   855,    41,   857,
      77,  1404,    79,    79,    23,  1408,    25,     6,  2215,    52,
    2215,    21,   473,    23,  2231,  2483,  2233,    50,  2486,  2487,
     260,   154,   214,   263,    27,   158,   159,   219,   268,   162,
    2498,   470,    23,   166,   274,   188,    51,   277,   278,   172,
     173,   174,   175,   176,   177,   285,    23,  1450,    44,    45,
      46,    18,    85,  2521,  2522,   494,    23,    51,  2526,  2527,
     213,   464,   465,   466,    20,    21,    22,    23,   151,    77,
     153,    79,   312,    40,    41,    42,    43,    49,   141,   142,
     233,   214,    54,    55,   233,    52,   219,    23,  1594,   281,
     282,    50,    79,    49,    51,   335,    53,   160,    54,    55,
    1177,    18,   165,   227,   228,   168,    23,    79,  1185,   262,
    1187,  1188,  1189,  1190,  1261,   471,  1683,   180,  1685,   155,
      92,  1198,   155,    40,    41,    42,    43,  1204,  1531,    78,
      20,    21,   285,    23,   269,    52,   123,    51,   290,  1381,
      20,    21,   440,    23,   442,   443,     6,    45,    46,   447,
     448,  1084,   450,  1086,  1381,    78,  1381,   190,    45,    46,
     458,   459,   195,    23,    24,  1392,    51,   539,    51,  1396,
      20,    21,    22,    23,    79,   415,   163,   164,   211,    20,
      21,   168,   154,  1586,  1587,    78,   158,   159,  1591,   341,
     162,   312,   179,    51,   166,  1598,   436,    78,  1601,    78,
     172,   173,   174,   175,   176,   177,    25,    49,  1066,  1067,
     373,   374,    54,    55,   301,    64,    65,  1075,   123,  1077,
      80,    18,   349,  1626,  1627,   290,    23,   198,   199,   200,
     201,   202,  1635,   473,   474,   475,   476,    79,   478,   392,
     393,   394,   214,    40,    41,    42,    43,   219,   269,   154,
      11,    12,    13,   158,   159,    52,    59,   184,   163,   164,
     290,   166,  2479,   168,    48,    49,    27,    28,    29,   289,
      54,    55,  1675,    18,   179,    20,    79,   260,    23,  1682,
     315,   141,   415,   182,   183,   184,   185,  1145,    79,  1516,
     299,  1516,   321,    14,    15,    79,   156,   157,    20,    21,
    1158,    23,  1160,    25,   328,    50,   260,    52,   168,   214,
    1767,   278,   154,  2530,   219,   232,   158,   159,    18,   260,
     123,   264,   265,    23,   166,   277,   278,  1749,   131,   336,
     172,   173,   174,   175,   176,   177,   334,    79,    51,   472,
      40,    41,    42,    43,   186,   198,   199,   358,   109,   110,
     172,   173,    52,    18,  1431,  1432,   345,  1434,    23,  1506,
     163,   164,  1439,  1440,    78,   168,   198,   199,    18,  1446,
     154,    51,   214,    23,   158,   159,   179,   219,    78,  1836,
     196,   197,   166,  1460,    78,  1462,    51,    52,   172,   173,
     174,   175,   176,   177,   141,   142,    78,   188,   189,   141,
     142,    51,    52,  2073,  2074,  1808,    18,    19,    20,    21,
      22,    23,   154,   160,   256,   429,   158,   159,   165,   184,
     154,   168,   213,   155,   166,   228,   168,  1706,  1707,   232,
     214,   355,    47,   180,    51,   219,  1678,   141,   142,   186,
      52,  1898,   309,   310,    59,    18,   348,  1305,   232,    64,
      23,  1678,  1855,  1678,   141,    78,   160,    78,  1861,  1686,
      18,   165,    18,   368,    79,    51,    51,    40,    41,    42,
      43,   180,   214,    23,    51,   168,   180,   219,    78,    52,
     277,   278,   186,   170,   275,   276,   458,   459,   279,   280,
     462,    51,   131,   132,   285,   467,   135,  1355,    78,  1357,
    1358,   140,   141,    78,   191,   269,   193,   194,  1911,    18,
      19,    20,    21,    78,    11,    12,    13,   168,  1376,   322,
    1378,    18,    51,    51,    78,  1383,    23,   184,   331,   332,
      27,    28,    29,    20,    21,   338,    23,   168,    25,   342,
     340,    20,    21,    52,    23,  1403,    70,    71,    72,    73,
     353,  1954,   290,    51,  1957,    52,  1959,    51,   361,    78,
     363,    78,  1639,   290,    17,   180,   253,   254,   255,   256,
    1647,  1993,  1998,    51,  1651,    18,  1653,    18,    18,    35,
      23,    18,    19,    20,    21,    22,    23,    20,    21,    33,
      23,   433,   434,   435,   436,  1998,  1999,    40,    41,    42,
      43,  1748,    32,   387,   388,   389,   390,   180,    18,    52,
      38,  1688,   109,   110,    77,    52,  2019,   169,   170,   171,
    2023,  2024,    10,  2026,    18,  2028,    18,     6,     6,     6,
       6,   415,     6,     6,     6,   377,   378,   379,   422,   191,
     192,   425,   194,     6,   428,     6,   261,   262,   263,     6,
       6,     6,    52,   268,    18,    19,    20,    21,    22,    23,
       6,     6,   277,   278,     6,  2068,    51,  2070,  2071,  2072,
      77,    77,   358,   215,    23,  1917,  1918,   290,   326,  1937,
    2083,    51,    51,   290,  2087,  2088,    51,   220,    52,    51,
    1917,  1918,  1917,  1918,   290,    49,   290,    36,    51,    51,
      54,    55,   290,  1561,  1562,  1563,   290,  1565,    51,   155,
    2113,    51,  2115,  2116,   395,   396,   397,   398,   399,   400,
     401,   402,  2125,    51,  2127,    79,  2129,    51,  2131,   236,
    1588,    51,   180,    18,  2137,    18,  2193,    23,   187,    51,
    1817,    18,   295,    50,    18,   140,  2149,  2150,  1825,    33,
    2153,  2154,    77,    18,    77,   236,   236,    52,     6,  1617,
      47,    23,    23,   168,   168,     6,     6,    23,    25,    56,
      57,    58,    59,  2176,    61,    62,    63,  2180,    53,    66,
    2183,    68,    69,  2186,    51,  2207,    33,    74,    75,    77,
     290,    51,    79,    51,   184,   181,  2199,    51,    51,    51,
     154,    51,    51,    49,   158,   159,    51,    51,    51,    51,
      18,    21,   166,    51,    51,  2241,  2242,    51,   172,   173,
     174,   175,   176,   177,    51,    51,    51,  2253,  2254,  2255,
      51,    51,    51,    51,    51,    51,    51,    51,  2241,  2242,
      51,  2244,  2245,  2246,  2247,  2248,    51,    51,   180,    78,
    2253,  2254,  2255,    33,    33,    77,    18,    18,  2261,    23,
     214,    38,     6,    23,     6,   219,     6,     6,     6,     6,
    1947,  1948,  1949,    18,  1951,   229,     6,     6,  2281,  2282,
    2283,     6,     6,    53,    77,    51,  1744,    77,   154,    25,
    2293,  2294,    51,    51,    51,  2298,    51,    51,    49,    51,
     168,    51,    51,    54,    55,    51,   340,  2310,    51,   323,
    2313,   270,  2315,  2316,   268,   184,    51,    51,  2321,  2322,
      51,   269,  1780,  1781,    51,    51,   349,  2330,    79,    51,
    2387,  2388,   131,  2160,    51,    51,    59,   422,   170,  2342,
      51,    51,    51,  2346,  2347,  2348,    35,   186,    11,    12,
      13,    14,    15,    52,  2357,  2213,  2214,  2360,  2361,  2416,
      27,    64,    52,    51,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    78,  2051,    38,    79,   331,    52,    27,
    2383,  2384,    35,    33,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    57,    99,   100,   101,   102,   103,   104,
      64,    77,    77,   154,    18,    38,    38,   158,   159,    21,
       6,   162,     6,    79,    51,   166,    18,    78,   297,   270,
     371,   172,   173,   174,   175,   176,   177,    91,   375,    93,
      51,    51,  2435,   180,   155,   370,    51,    78,    78,  2442,
      78,  2444,    78,   106,  2447,    18,    47,    78,   180,  2452,
    2472,  2473,  1910,   117,    51,    18,    51,    33,    51,    67,
      60,   125,   126,   214,   128,   129,    37,    51,   219,    51,
      34,    10,   136,   137,   138,    49,    34,    47,    53,    78,
      54,    55,   284,    51,   365,   188,    56,    57,    58,    59,
      79,    61,    62,    63,   290,    78,    66,   253,    68,    69,
     184,    78,    53,    52,    74,    79,    78,    52,    52,    79,
     213,    16,    78,    18,    19,    20,    21,    22,    23,    51,
      25,    52,   273,    51,    10,    77,    76,    32,    33,    34,
     233,    53,    37,    53,    53,    52,  1994,    53,    53,    51,
    2217,    35,   107,    18,    49,    50,    34,    52,  2006,    54,
      55,    34,   255,    58,    10,    78,    51,    78,    51,   262,
    2018,   281,  2020,   278,   267,   268,   269,    51,    79,    51,
      10,   274,   454,    53,   277,   278,  2034,  2035,  2036,    77,
     154,   299,   285,   454,   158,   159,    53,    53,   162,    53,
      77,    53,   166,    52,   279,    53,   279,   270,   172,   173,
     174,   175,   176,   177,   109,   110,   111,   112,   113,   114,
     115,   116,   269,   118,   119,   120,   121,   122,   123,   124,
     266,    51,   269,   279,   279,   130,   131,   132,   188,   196,
     135,    78,   335,   416,   279,   426,   141,   266,   336,   299,
     214,   344,   424,    51,   149,   219,   151,    51,   446,   397,
     439,   439,   444,   270,    11,    12,    13,    14,    15,   284,
     363,  2119,   395,   290,   449,   284,    51,    51,  2126,    25,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    51,
     290,    38,   336,   290,   290,   266,   389,    51,   416,   392,
     393,   394,   479,   477,   268,    35,  2373,   400,    51,    51,
      51,   487,   405,    51,    51,    51,    35,   488,    79,  2167,
      51,    25,   415,    79,   427,   180,   489,   489,   223,    53,
     423,    78,   463,   279,   279,    51,    51,  2185,   290,   290,
      51,  2189,    77,   441,     6,    51,    51,   409,   409,    51,
      51,    51,    51,    51,    77,   404,    53,   974,    20,    21,
      22,    23,    11,    12,    13,    14,    15,  1958,   974,  1464,
     974,  1422,  1464,  1682,  1464,  1464,   271,  1959,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    49,   609,    38,
    1957,  1684,    54,    55,   660,  2243,  1019,  1509,  2047,   909,
     543,   170,  2213,  1205,    53,   910,   912,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,  2214,   457,  1280,
     799,   518,  1207,  2398,  1292,  1893,  1745,  1092,    77,  1766,
    2278,  1760,  1789,  2311,   329,   330,    11,    12,    13,   604,
    2288,  2289,  1914,  2160,  2177,  2181,  2325,  1631,  2296,  2180,
    2327,  2299,    27,    28,    29,    30,    31,    32,    33,    34,
      35,   852,   653,    38,    -1,   360,  1004,  1040,    -1,    -1,
      -1,    -1,  2320,    -1,    -1,    -1,  2324,    -1,  2326,   141,
     142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   383,   384,
     385,   386,    -1,    -1,   156,  2343,  2344,    -1,   160,    -1,
      -1,   163,   164,    -1,    -1,    -1,   168,    -1,  2356,    -1,
      -1,    -1,    -1,    49,  2362,    -1,  2364,  2365,    54,    55,
      -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,
      -1,   203,   204,   205,    -1,   207,    -1,   209,   210,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      16,    38,    18,    19,    20,    21,    22,    23,    -1,    25,
    2418,    -1,    -1,   468,   469,    -1,    32,    33,    -1,    -1,
      -1,    37,    -1,    -1,  2432,    -1,    -1,   482,   483,    -1,
      -1,    -1,    -1,    49,    50,    -1,    52,    -1,    54,    55,
    2448,    -1,    58,    -1,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   546,   547,   109,   110,   111,   112,   113,   114,   115,
     116,    -1,   118,   119,   120,   121,   122,   123,   124,    -1,
      -1,    -1,   223,    -1,   130,   131,   132,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,   151,    -1,    -1,    -1,    -1,
      -1,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     271,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,    -1,    53,    -1,    -1,    -1,   223,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   329,   330,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    77,    18,    19,
      20,    21,    22,    23,    -1,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    33,    34,    -1,    -1,    37,    -1,   360,
      -1,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,    49,
      50,    -1,    52,    -1,    54,    55,    -1,    -1,    58,    -1,
      -1,    -1,   383,   384,   385,   386,    -1,    -1,    -1,    -1,
      11,    12,    13,    14,    15,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    -1,   329,   330,    -1,    -1,    -1,    -1,   109,
     110,    -1,    -1,    -1,    -1,   115,   116,    -1,   118,   119,
     120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,
     130,   131,   132,    -1,   360,   135,    77,    -1,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,   468,   469,   149,
      -1,   151,    -1,    -1,    -1,    -1,    -1,   383,   384,   385,
     386,   482,   483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,    -1,    -1,    -1,    -1,
      -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   223,    -1,   546,   547,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    -1,
      -1,    -1,   468,   469,    -1,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    53,    -1,    -1,   482,   483,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,   271,    38,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,    -1,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     546,   547,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   329,
     330,    16,    -1,    18,    19,    20,    21,    22,    23,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,    34,
      -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     360,    -1,    -1,    -1,    49,    50,    -1,    52,    -1,    54,
      55,    -1,    -1,    58,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,   383,   384,   385,   386,    11,    12,    13,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    -1,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,    -1,    -1,    -1,
     115,   116,    -1,   118,   119,   120,   121,   122,   123,   124,
      77,    -1,    -1,    -1,    -1,   130,   131,   132,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,   151,    -1,   468,   469,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   482,   483,    -1,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,   223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   546,   547,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    33,    34,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,
      49,    50,    -1,    52,    -1,    54,    55,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    11,    12,    13,    14,    15,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,   329,   330,    -1,    -1,    -1,    -1,
     109,   110,    -1,    -1,    -1,    -1,   115,   116,    -1,   118,
     119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
      -1,   130,   131,   132,    -1,   360,   135,    77,    -1,    -1,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,   151,    11,    12,    13,    14,    15,   383,   384,
     385,   386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      38,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    -1,   223,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,   468,   469,    -1,    -1,    77,    -1,    -1,
      -1,    53,    -1,    -1,    -1,    -1,    -1,   482,   483,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   271,    -1,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,    -1,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   546,   547,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     329,   330,    16,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,
      34,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   360,    -1,    -1,    -1,    49,    50,    -1,    52,    -1,
      54,    55,    -1,    -1,    58,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,   383,   384,   385,   386,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    38,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,    -1,    -1,
      -1,   115,   116,    -1,   118,   119,   120,   121,   122,   123,
     124,    77,    -1,    -1,    -1,    -1,   130,   131,   132,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,   141,    11,    12,
      13,    14,    15,    -1,    -1,   149,    -1,   151,    -1,   468,
     469,    -1,    -1,    -1,    27,    28,    29,    30,    31,    32,
      33,    34,    35,   482,   483,    38,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   546,   547,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    33,    34,    -1,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   271,    -1,    -1,
      -1,    49,    50,    -1,    52,    -1,    54,    55,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    11,    12,    13,    14,    15,    -1,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,   329,   330,    -1,    -1,    -1,
      -1,   109,   110,    -1,    53,    -1,    -1,   115,   116,    -1,
     118,   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,
      -1,    -1,   130,   131,   132,    -1,   360,   135,    -1,    -1,
      -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,   151,    11,    12,    13,    14,    15,   383,
     384,   385,   386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    53,    -1,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    38,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    53,   223,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    -1,   468,   469,    -1,    -1,    -1,    -1,
      -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,   482,   483,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   271,    -1,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,    -1,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   546,   547,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   329,   330,    16,    -1,    18,    19,    20,    21,    22,
      23,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      33,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   360,    -1,    -1,    -1,    49,    50,    -1,    52,
      -1,    54,    55,    -1,    -1,    58,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,   383,   384,   385,   386,    -1,
      -1,    -1,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,    -1,
      -1,    -1,   115,   116,    -1,   118,   119,   120,   121,   122,
     123,   124,    -1,    -1,    -1,    -1,    -1,   130,   131,   132,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,   141,    11,
      12,    13,    14,    15,    -1,    -1,   149,    -1,   151,    -1,
     468,   469,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,   482,   483,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,    -1,
      -1,    -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,
     223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   546,   547,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    53,    -1,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,   271,    38,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    53,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
      -1,    -1,    53,    -1,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   329,   330,    23,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    53,   360,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     383,   384,   385,   386,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,    -1,    -1,   108,    11,    12,    13,    14,    15,    -1,
     115,   116,    -1,   118,   119,   120,   121,   122,   123,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     145,    -1,   147,    -1,    -1,    -1,    53,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   468,   469,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   482,
     483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,    -1,    -1,    -1,    -1,   223,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   546,   547,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    53,    -1,    -1,    -1,    -1,   271,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    53,    -1,    -1,    -1,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,   329,   330,    -1,    23,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    50,   360,    53,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   383,   384,
     385,   386,    78,    -1,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
      -1,    -1,   108,    11,    12,    13,    14,    15,    -1,   115,
     116,    -1,   118,   119,   120,   121,   122,   123,    -1,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,
      -1,   147,    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   468,   469,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   482,   483,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,    -1,    -1,    -1,    -1,    -1,   223,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   546,   547,    -1,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      53,    -1,    -1,    -1,    -1,   271,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    53,    -1,    -1,    -1,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,    -1,    -1,    -1,    -1,
      -1,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   329,   330,    23,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    53,   360,    -1,    -1,    -1,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   383,   384,   385,
     386,    -1,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,
     108,    -1,    11,    12,    13,    14,    15,   115,   116,    50,
     118,   119,   120,   121,   122,   123,    -1,    58,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,   147,
      -1,    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   468,   469,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   482,   483,    -1,    -1,
      -1,    -1,    -1,    -1,   115,   116,    -1,   118,   119,   120,
     121,   122,   123,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,    -1,    -1,    -1,    -1,   223,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     546,   547,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    38,    -1,    -1,    -1,    -1,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,   271,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,
      -1,    -1,   223,    -1,    -1,    -1,    -1,    -1,    51,    11,
      12,    13,    14,    15,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,    -1,
      -1,   329,   330,    -1,    -1,    -1,    -1,    -1,    -1,    51,
     271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,    -1,    -1,    -1,    -1,   383,   384,   385,   386,    -1,
      11,    12,    13,    14,    15,    -1,    -1,    -1,   329,   330,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,
      51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   383,   384,   385,   386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     468,   469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   482,   483,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,    -1,
      -1,    -1,    54,    55,    -1,    -1,    -1,   468,   469,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   546,   547,
      -1,   482,   483,    -1,    -1,    -1,    -1,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   546,   547,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   154,    -1,    -1,    -1,   158,   159,    -1,   161,
     162,    -1,    -1,    -1,   166,   167,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   185,    -1,    -1,   188,   189,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   214,    -1,    -1,    -1,    -1,   219,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,    -1,
     232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   258,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   268,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,   281,
     282,    -1,   284,    -1,    -1,    -1,    -1,   289,    -1,   291,
      -1,   293,   294,    -1,    -1,   297,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   313,   314,    -1,    -1,    -1,    -1,   319,   320,    -1,
      -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,   331,
      -1,    -1,   334,   335,    -1,   337,    -1,   339,    -1,    -1,
      -1,   343,   344,    -1,   346,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   356
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,   553,   554,     3,     4,     5,   143,   159,   184,
     185,   216,   219,   221,   232,   248,   252,   257,   258,   376,
     540,   541,   549,   550,   551,   552,   709,   710,   711,   712,
     714,   715,   716,   722,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   759,   760,   761,   762,   779,   799,
     837,   838,   839,   840,   841,   842,   843,   844,   899,   900,
     923,   936,   937,   938,   939,   940,   941,   942,   943,     0,
       6,    39,    49,    51,    54,    55,    80,   141,   143,   144,
     146,   148,   154,   156,   157,   159,   172,   173,   174,   175,
     176,   177,   219,   225,   231,   232,   539,   555,   556,   610,
     612,   613,   614,   615,   624,   660,   662,   663,   665,   666,
     679,   682,   692,   693,   694,   749,   752,   763,   766,   780,
     786,   795,   798,   802,   803,   846,   847,   849,   851,   852,
     857,   888,   891,   901,   902,   914,   915,   924,   927,   934,
     935,   946,   949,   950,     6,     6,     6,    16,    18,    19,
      20,    21,    22,    23,    25,    32,    33,    37,    49,    50,
      52,    54,    55,    58,   109,   110,   115,   116,   118,   119,
     120,   121,   122,   123,   124,   130,   131,   132,   135,   141,
     149,   151,   223,   271,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   329,   330,   360,   383,   384,   385,
     386,   468,   469,   482,   483,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   546,   547,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   607,   608,   609,
     630,   646,   648,   649,   651,   652,   653,   654,   748,    23,
      25,   160,   746,   746,   746,   217,   218,   746,   746,     6,
     184,   193,   194,   222,   229,   249,   251,   259,   274,   380,
     470,   494,   141,   170,   191,   193,   194,   253,   254,   255,
     256,    41,    78,   160,   735,   746,   252,    25,   249,   268,
     535,   536,   537,   944,     6,    23,    24,   559,   559,   559,
     654,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      99,   100,   101,   102,   103,   104,   616,    52,    52,   155,
     193,   208,   538,   178,    23,    25,   193,   583,   156,   229,
     230,   231,   680,   681,   926,   184,   473,   530,   168,   161,
     212,   259,   274,   376,   380,   432,   437,   438,   470,   484,
     494,   498,   545,   801,   887,    50,   559,   667,    79,   154,
     158,   159,   162,   166,   214,   219,   268,   663,   668,   669,
     674,   696,   667,   667,   667,    54,    55,    79,    87,   118,
     161,   162,   167,   172,   173,   174,   175,   185,   188,   189,
     228,   232,   258,   268,   274,   281,   282,   284,   289,   291,
     293,   294,   297,   298,   313,   314,   319,   320,   327,   331,
     334,   335,   337,   339,   343,   344,   346,   356,   668,   787,
     788,   794,   667,   667,    48,    79,   232,   387,   388,   389,
     390,   415,   422,   425,   428,   663,   668,   805,   806,   807,
     808,   809,   667,    79,   186,   256,   433,   434,   435,   436,
     668,   674,   848,    78,    79,   123,   163,   164,   168,   179,
     368,   668,   670,   667,   667,   667,   667,    79,   229,   268,
     331,   668,   674,   918,   919,    79,   232,   260,   425,   498,
     542,   543,   544,   668,   674,   925,   948,   667,   667,    79,
     162,   543,   668,   951,    18,    23,    34,    52,   151,   153,
     645,   647,   652,    35,   563,    35,    20,    21,   564,   565,
      52,   140,    33,   140,   654,    18,   111,   112,   113,   114,
     635,   654,    78,    78,    52,    52,    52,    52,    52,    52,
      52,    18,    19,    21,    22,    23,    52,   564,   565,   572,
     630,   631,   634,   636,   637,   638,   640,   642,   643,   234,
     234,     6,    11,    12,    13,    14,    15,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    38,    41,    78,   160,
     697,    25,   584,   584,   746,   746,     6,    41,    78,   160,
     700,     6,    23,    25,   160,   747,     6,   250,     6,   717,
       6,   723,   170,   194,   255,   272,   288,    23,   162,   255,
     414,   430,   431,   713,   194,   255,   713,   160,     6,     6,
       6,     6,     6,     6,     6,     6,    87,   159,   485,   528,
     529,   530,   531,   532,   533,   932,   933,    18,   736,   584,
     800,     6,   944,   944,     6,     6,   473,   945,    27,   625,
     611,    98,   559,    23,    23,    18,    20,    23,    50,    52,
     661,   697,    18,    23,    52,   557,    40,    41,    42,    43,
     180,   557,   560,   700,    51,    25,   226,    51,   527,   534,
     583,   930,   233,   557,   558,   558,   559,   381,   382,   850,
     471,    23,    50,    78,   155,   560,   697,   695,   167,   583,
     583,   700,   269,    51,    78,   672,    51,    51,    78,    78,
      78,   233,   300,   312,    51,    25,   303,   304,    49,   348,
      49,   348,    49,   348,    49,   348,   301,   583,   560,   349,
     184,   229,   317,   342,   269,   232,   560,    51,   557,    20,
      21,    23,   357,   561,   782,   561,   781,   290,   292,   299,
     290,   289,   260,   299,   315,   316,   315,   560,   321,   328,
     260,   260,   336,   334,   284,   303,   560,   345,   347,   557,
     358,    51,    78,   792,    51,    78,    78,   429,   184,   661,
     560,   154,   557,   560,   155,   355,   560,   348,   804,   672,
      51,    78,    78,   560,    18,    50,   190,    18,   234,   275,
     163,   164,    51,    51,   557,   141,   142,   160,   165,   180,
     186,   622,   676,   180,   676,    23,   675,   180,   168,    51,
      51,    78,    78,    78,    78,    21,    22,    23,   575,   578,
     269,   168,    51,    51,    86,   295,   324,   333,   495,   496,
     497,   916,   917,    78,   922,   184,   557,   340,   168,   560,
     290,   560,    51,    51,    78,    78,   952,   956,   290,    51,
      10,   647,   647,   654,    20,    21,   640,   647,   647,    17,
      18,    18,    35,   650,   654,    32,    33,   140,    33,    18,
      77,    53,    77,   604,   604,   675,   654,   654,   654,   654,
     654,   654,    34,   633,   635,   654,    32,    33,    78,    10,
      77,   152,    77,   152,    18,    18,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
      57,    64,    91,    93,   117,   125,   126,   128,   129,   136,
     137,   138,   169,   170,   171,   191,   192,   194,   698,   699,
       6,     6,     6,     6,     6,   169,   220,   701,   702,     6,
     747,     6,     6,     6,   141,   156,   160,   163,   164,   168,
     187,   203,   204,   205,   207,   209,   210,   578,   622,   720,
       6,    80,   141,   156,   157,   168,   559,   713,   713,   713,
     713,   713,   713,   713,   845,   160,   713,   160,   713,     6,
     713,   713,     6,     6,    77,    79,     6,     6,     6,   141,
     168,   190,   622,     6,   945,   557,     6,   654,    52,   618,
     619,   620,   623,    51,    77,    77,   689,   690,   654,    51,
     654,   558,    51,   557,   227,   228,   358,   928,   557,   929,
      78,   160,   931,   557,    44,    45,    46,   215,   664,   667,
      23,   661,   683,   686,   687,   560,   671,   673,   751,   765,
     290,   290,   561,    51,   557,   557,    87,   364,    51,    51,
     232,   350,   290,   341,   560,   326,   560,   220,   560,    51,
      51,    51,    23,   572,   577,    36,   562,    47,    51,   236,
     354,   355,   562,    47,    51,   236,   557,   290,   290,   557,
     290,   560,   290,   560,   155,   560,    51,   560,   560,   560,
     560,   560,   560,   236,   560,    51,   560,   560,    51,   359,
     583,   791,   793,   797,   560,   290,   341,   560,   560,   180,
     557,   560,   673,   810,    18,    18,   558,   558,    23,   620,
     621,   654,    41,   557,   678,   187,   678,   678,   675,   856,
     890,   903,   560,   675,    25,   561,   561,    49,   274,   416,
     456,   916,   921,    51,   560,   560,   557,   557,   687,   688,
     557,    18,    53,   152,    50,    18,    53,    77,   140,    33,
     654,   654,   605,   606,    53,    77,    53,    77,    77,    77,
      77,    53,    77,    10,    77,    77,    53,    18,    52,   631,
     638,   642,   236,   236,    52,    77,    79,    77,    79,     6,
     621,    23,   168,   168,    23,   160,    20,    21,    22,    23,
     564,   565,   566,   567,   568,   718,   719,    23,   584,   584,
     584,   584,     6,   584,   584,     6,    23,    64,   154,   269,
     296,   387,   420,   421,   713,   584,   713,   584,   584,   584,
     933,   621,    25,   675,   583,     6,    51,    53,   617,   623,
      78,   616,   583,    23,   687,    51,    53,    53,    25,    45,
      46,    45,    46,   583,   583,   932,    51,    51,    33,   685,
      77,    51,    79,   670,    79,   162,   273,   668,   674,   750,
      79,   162,   281,   282,   668,   764,   557,   557,    51,    51,
      51,   560,    78,   560,   783,   184,   290,   557,    51,    51,
     560,    51,   560,    51,   782,   559,   782,   557,   557,   781,
     557,   557,    51,   557,   557,    51,   557,    51,   557,    51,
     661,    51,    51,    51,    51,    51,    51,    51,    51,   557,
      51,    51,    51,   557,    51,    59,    79,   131,   163,   164,
     228,   232,   322,   331,   332,   338,   342,   353,   361,   363,
     670,   790,    79,   141,   168,   377,   378,   379,   622,   668,
     796,   557,   557,    79,   162,   167,   250,   355,   389,   406,
     408,   412,   417,   418,   811,   818,   821,   181,   677,   560,
      51,    79,    92,   162,   458,   459,   462,   467,   668,   674,
     853,    79,   162,   415,   472,   668,   674,   889,    47,    79,
     292,   326,   485,   491,   493,   668,   674,   904,   906,    51,
      51,   562,    49,    18,   580,   581,   560,   557,   560,    23,
      79,    81,    82,    83,    84,    85,    86,    87,    88,   105,
     108,   123,   145,   147,   651,   653,   655,   657,   748,   920,
     180,   947,    78,   955,   647,   647,    21,   654,    33,    33,
      77,    53,    77,   602,   603,   654,   654,   654,   654,   654,
      34,   633,   654,   633,    34,   633,   633,    77,   654,    18,
      18,   654,   699,   702,    23,    23,    50,    20,    21,    38,
       6,     6,     6,     6,     6,     6,    18,   661,   661,   661,
     584,     6,   584,     6,     6,     6,   616,   626,   627,   628,
     657,   559,    53,    77,    79,    25,   584,   684,   686,    51,
     753,   758,   154,    51,   767,   773,   767,   774,   561,   778,
      51,    77,    51,    51,    92,   218,   364,   366,   368,   369,
     372,   784,   785,    51,   341,   560,   557,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
     270,   340,   168,   168,   349,   184,   323,   168,   161,   333,
     560,    59,   560,   362,   560,   557,    51,   621,    25,   675,
     583,   557,   131,    51,   830,   836,   363,   391,   417,   560,
     813,   363,   560,   812,   269,   577,   814,   815,   419,   560,
      51,   422,   831,   182,   183,   184,   185,    23,   565,   576,
     867,   872,   858,   866,   854,   855,   576,   170,    51,   892,
     898,   560,   557,    51,   557,   186,   905,   905,    23,   561,
     583,   907,    66,   490,   908,   905,    51,   581,    35,    27,
     654,   656,   656,    52,   654,   654,   654,    27,    52,    52,
      51,    27,   656,    27,    38,   557,   954,    35,    33,   654,
     654,    47,    56,    57,    58,    59,    61,    62,    63,    66,
      68,    69,    74,    79,   587,   588,   589,   590,   592,   600,
      75,    79,   588,   589,   590,   591,   592,   601,    77,    53,
      53,    53,    53,    53,    77,    10,    53,    77,    53,    77,
      10,    53,    77,    77,    18,    53,    38,    38,    21,    49,
      54,    55,   172,   173,   174,   175,   176,   177,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   721,
       6,     6,   559,    79,   627,    51,    18,    20,    21,    23,
     564,   565,   579,   688,   155,   688,    78,   772,    36,   283,
     775,   557,   180,   375,   134,   367,   371,   370,   373,   374,
      77,    79,    51,    51,    51,   186,   296,   312,   277,   278,
     560,   560,   560,   232,   350,   560,   296,   324,   325,   675,
     270,   297,   687,   832,   557,   557,   560,    78,   557,    78,
     661,    78,   557,   557,    78,    78,   871,   688,    78,   561,
     873,   878,    25,    78,   879,   884,   560,   688,   180,   557,
     557,   906,   909,   910,   557,    18,   654,    77,    51,    51,
     748,    51,   106,    78,   654,   658,   658,   654,    51,   654,
     131,   132,   135,   140,   141,    79,   452,   953,    18,    33,
      53,    53,    60,    64,    65,    67,    11,    12,    13,    27,
      28,    29,   109,   110,   557,   585,   593,   594,   595,    37,
     596,   597,   597,   599,   577,    51,   593,   596,   599,   596,
     576,    51,   654,    34,   633,    34,   633,    34,   633,    10,
      34,   633,    34,   633,    79,   721,   721,    51,    53,    53,
      78,   757,   560,   772,   771,   768,   559,   583,   284,   776,
      51,   365,   253,   785,   351,   352,   560,   789,   789,   561,
     184,   290,   560,   560,   833,    78,   835,   823,   823,   816,
     819,   870,   869,    78,   865,   874,   880,    78,   897,   557,
      78,    51,   656,    53,    78,   629,   657,   644,    51,   654,
      23,   123,   653,   659,   748,    51,    51,    52,    52,    52,
      51,    52,   561,    51,    10,   557,    14,    15,   586,    77,
      15,    77,   586,   557,    70,    71,    72,    73,   598,    77,
     586,    76,    53,    53,    53,    53,    77,    10,    53,    53,
      53,    77,    52,    53,    10,    53,    53,    10,    53,   756,
     754,   768,    79,   188,   189,   213,   275,   276,   279,   280,
     285,   703,   705,   706,   769,   561,   281,   777,   560,   557,
     831,   834,    79,   577,   824,   825,    79,    79,   250,   363,
     407,   817,    79,   233,   262,   285,   392,   393,   394,   703,
     820,    79,   451,   452,   455,   456,   457,   868,   864,   863,
     877,   883,   896,   893,   911,    51,   626,   107,     9,    18,
      19,    52,    79,   630,   632,   634,   636,   637,   639,   641,
     658,   658,   654,   654,   654,   654,   557,   595,   585,   594,
     597,   597,    35,   597,   597,    18,    34,   633,    34,   633,
     633,    10,   633,    47,    59,    64,    79,   180,   261,   262,
     263,   268,   277,   278,   755,   583,   560,    78,   277,   278,
     278,   558,   557,   165,   196,   286,   287,   770,    78,    51,
     560,    64,    79,   233,   255,   262,   267,   268,   269,   274,
     277,   278,   285,   335,   344,   363,   389,   392,   393,   394,
     400,   405,   415,   423,   703,   822,   407,   413,   826,   560,
     557,   560,    51,   557,   557,   165,   286,   403,   557,   299,
     205,   557,    51,   454,   454,   560,   560,   560,    51,    79,
      92,   167,   229,   234,   269,   275,   440,   442,   443,   447,
     448,   450,   458,   459,   859,    79,   454,   460,   875,    79,
     454,   461,   881,    47,    79,   189,   260,   263,   268,   274,
     277,   278,   285,   312,   335,   415,   436,   473,   474,   475,
     476,   478,   703,   894,    79,   485,   486,   492,   912,    79,
     629,   626,   654,    10,    77,   150,    53,    77,    53,    53,
      53,    53,   557,   557,   557,   557,   598,   598,    53,    53,
      53,    77,    53,    52,    53,   557,   270,   264,   265,   557,
     557,   279,   279,   269,   266,    68,    69,   224,   267,   691,
      51,   704,   705,   279,   279,   279,   198,   199,   196,    50,
      85,   155,   190,   195,   211,   707,   395,   396,   397,   398,
     399,   400,   401,   402,   557,    78,   557,   557,   269,   426,
     560,   266,    68,   267,   691,   165,   286,   403,   336,   397,
     557,   560,   557,   299,   205,   557,   424,   557,   416,   395,
      51,   557,    51,   557,   557,   557,   557,   445,   872,   123,
     454,   123,   445,   454,   439,   446,   299,   439,   439,   560,
     444,   290,   449,   270,   284,   860,   284,   861,    51,   876,
     453,   557,   885,   873,    51,   882,   885,   879,    51,   557,
     560,   557,   290,   269,   480,   560,   266,    68,   267,   691,
     165,   198,   403,   481,   895,   561,   336,   416,   348,   395,
     290,   290,   409,   557,   477,   479,    51,   913,   488,   487,
     583,    51,    53,    52,   632,   639,   626,    51,   654,    51,
      51,    51,    51,    35,    35,   633,   633,   172,   173,   558,
     558,   560,   557,   557,   557,   557,   557,    79,    51,   558,
     558,   558,   198,   199,    25,   582,    50,   190,   557,   582,
     196,   197,   708,    50,   190,    79,   827,   560,   427,   410,
     411,   557,   557,   557,   278,   560,   560,   557,   557,   560,
     557,   560,   463,   886,   886,   290,   464,   465,   466,   862,
     557,   862,   290,   557,   279,   557,   557,   279,   441,   560,
     557,   557,   180,   560,   878,   560,   884,   557,   557,   560,
     560,   557,   557,   557,   278,   560,   557,   557,   557,   560,
     560,   560,   489,   489,   654,    53,   557,   557,    53,    77,
     561,   561,   704,    51,   582,   582,    51,    51,   198,   199,
     200,   201,   202,   198,   199,   200,   201,   202,    51,   582,
     582,    79,   561,   829,   560,   409,   560,   557,   886,   557,
     886,   557,   557,   560,   557,   409,   583,   583,    51,   633,
     707,    51,    51,   707,   707,   707,    51,    51,   404,   828,
      77,   707,   707,   707,   707,    51,   633,    53
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   548,   553,   553,   554,   554,   555,   555,   556,   557,
     557,   557,   558,   558,   558,   559,   559,   560,   560,   560,
     560,   560,   560,   561,   561,   561,   562,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   572,   573,
     573,   574,   574,   575,   575,   575,   575,   575,   575,   576,
     576,   577,   577,   578,   578,   579,   579,   579,   579,   579,
     580,   581,   581,   582,   583,   583,   584,   584,   585,   585,
     585,   585,   585,   585,   585,   585,   586,   586,   587,   587,
     587,   587,   587,   587,   587,   587,   587,   588,   589,   590,
     591,   592,   592,   593,   593,   593,   593,   594,   594,   595,
     595,   596,   596,   596,   597,   597,   598,   598,   598,   598,
     599,   599,   599,   600,   600,   600,   600,   601,   601,   601,
     601,   601,   601,   602,   602,   603,   603,   604,   605,   606,
     607,   608,   609,   609,   549,   550,   549,   551,   549,   552,
     555,   611,   610,   555,   612,   555,   613,   555,   614,   555,
     615,   616,   616,   616,   616,   616,   616,   616,   616,   616,
     616,   616,   616,   616,   616,   616,   616,   617,   617,   618,
     618,   619,   619,   620,   621,   621,   622,   623,   555,   625,
     624,   626,   626,   627,   628,   628,   629,   629,   630,   630,
     631,   631,   631,   631,   631,   631,   632,   632,   632,   632,
     633,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   635,   635,   635,   635,   636,   636,   636,   637,   637,
     637,   637,   637,   637,   637,   637,   638,   638,   638,   638,
     638,   639,   639,   639,   639,   639,   640,   640,   641,   641,
     642,   642,   642,   642,   643,   643,   644,   644,   644,   645,
     645,   646,   647,   647,   647,   647,   647,   647,   647,   648,
     648,   648,   648,   648,   648,   648,   648,   648,   648,   649,
     649,   649,   649,   650,   650,   650,   651,   652,   653,   653,
     653,   653,   653,   653,   653,   653,   653,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   654,   654,   654,   655,   655,   655,   655,   656,   656,
     656,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   658,   659,   659,   659,   659,   555,   660,   660,   661,
     661,   661,   661,   555,   662,   663,   663,   663,   663,   663,
     663,   663,   663,   663,   663,   555,   664,   664,   665,   555,
     666,   666,   667,   667,   667,   667,   668,   668,   668,   668,
     668,   668,   668,   668,   669,   670,   670,   670,   670,   670,
     670,   670,   670,   671,   671,   672,   672,   673,   674,   675,
     676,   676,   676,   676,   677,   677,   677,   677,   677,   678,
     678,   555,   679,   679,   555,   680,   680,   680,   680,   681,
     681,   681,   681,   681,   681,   681,   681,   682,   683,   684,
     684,   685,   685,   686,   687,   687,   688,   689,   690,   691,
     691,   692,   693,   694,   694,   694,   694,   694,   695,   696,
     697,   697,   697,   698,   698,   699,   699,   699,   699,   699,
     699,   700,   700,   700,   701,   701,   702,   702,   703,   703,
     704,   704,   705,   705,   706,   707,   707,   707,   707,   707,
     707,   707,   707,   707,   708,   708,   708,   708,   708,   708,
     708,   708,   708,   708,   549,   709,   549,   710,   549,   711,
     549,   712,   713,   713,   549,   714,   549,   715,   549,   716,
     717,   717,   717,   717,   717,   717,   717,   717,   717,   717,
     717,   717,   717,   717,   717,   717,   717,   718,   718,   718,
     718,   718,   718,   718,   718,   719,   719,   719,   719,   720,
     720,   720,   721,   721,   721,   721,   721,   721,   721,   721,
     721,   721,   721,   721,   721,   721,   721,   721,   721,   721,
     721,   721,   549,   722,   723,   723,   723,   723,   723,   723,
     723,   549,   724,   549,   725,   549,   726,   549,   727,   549,
     728,   549,   729,   549,   730,   549,   731,   549,   732,   549,
     733,   549,   734,   735,   735,   735,   736,   736,   549,   737,
     549,   738,   549,   739,   549,   740,   549,   741,   549,   742,
     549,   743,   549,   744,   549,   745,   746,   746,   746,   747,
     747,   747,   748,   692,   763,   764,   764,   764,   764,   765,
     765,   766,   767,   768,   769,   769,   769,   769,   769,   769,
     769,   769,   770,   770,   770,   770,   770,   770,   771,   771,
     772,   772,   773,   774,   775,   775,   775,   776,   776,   777,
     777,   778,   549,   779,   692,   749,   750,   750,   750,   750,
     751,   751,   752,   753,   754,   755,   755,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     756,   756,   757,   757,   758,   748,   549,   759,   549,   760,
     549,   761,   549,   762,   692,   780,   781,   781,   781,   782,
     782,   782,   782,   782,   783,   783,   784,   784,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   788,   789,
     789,   789,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   791,   791,   792,   792,
     793,   794,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   748,   748,   692,   795,   796,   796,   796,
     796,   796,   796,   796,   796,   797,   797,   798,   549,   799,
     800,   800,   800,   800,   800,   800,   692,   801,   801,   801,
     802,   803,   803,   804,   804,   805,   806,   807,   807,   807,
     807,   807,   807,   807,   807,   807,   807,   807,   807,   807,
     807,   807,   808,   809,   810,   810,   811,   811,   811,   811,
     811,   811,   811,   811,   811,   812,   811,   813,   811,   811,
     811,   811,   814,   814,   815,   816,   816,   817,   817,   817,
     818,   818,   819,   819,   820,   820,   820,   820,   820,   820,
     820,   820,   820,   820,   820,   821,   822,   822,   822,   822,
     822,   822,   822,   822,   822,   822,   822,   822,   822,   822,
     822,   822,   822,   822,   822,   822,   822,   822,   822,   822,
     822,   822,   822,   822,   822,   822,   822,   822,   822,   822,
     822,   822,   822,   822,   823,   823,   824,   825,   826,   826,
     826,   827,   827,   828,   828,   829,   830,   831,   831,   833,
     832,   834,   834,   835,   835,   836,   748,   748,   748,   748,
     549,   837,   549,   838,   549,   839,   549,   840,   549,   841,
     549,   842,   549,   843,   549,   844,   845,   845,   845,   845,
     845,   845,   845,   845,   845,   692,   846,   847,   847,   847,
     848,   848,   848,   848,   848,   848,   848,   848,   848,   848,
     692,   850,   849,   851,   851,   851,   851,   692,   852,   853,
     853,   853,   853,   854,   853,   855,   853,   853,   853,   856,
     856,   857,   858,   859,   859,   859,   859,   859,   859,   859,
     859,   859,   859,   859,   859,   859,   859,   859,   859,   859,
     860,   859,   861,   859,   859,   859,   862,   862,   862,   863,
     864,   864,   865,   865,   866,   867,   868,   868,   868,   868,
     868,   869,   870,   870,   871,   871,   872,   873,   874,   875,
     875,   875,   876,   877,   877,   878,   878,   879,   880,   881,
     881,   881,   882,   883,   883,   884,   884,   885,   885,   886,
     886,   748,   748,   692,   887,   887,   888,   889,   889,   889,
     889,   889,   889,   890,   890,   891,   892,   893,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   895,   895,   895,   895,   896,   896,   897,
     897,   898,   748,   748,   549,   899,   549,   900,   692,   901,
     902,   903,   903,   904,   904,   904,   904,   904,   904,   904,
     904,   904,   905,   905,   906,   907,   907,   908,   908,   909,
     910,   911,   911,   912,   912,   912,   913,   692,   914,   915,
     915,   915,   915,   915,   915,   916,   916,   916,   916,   916,
     916,   917,   917,   918,   919,   919,   919,   919,   919,   919,
     919,   919,   919,   920,   921,   921,   922,   922,   549,   923,
     924,   925,   925,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   748,   748,   748,   748,   748,   748,   748,   748,   748,
     748,   555,   926,   927,   928,   928,   929,   929,   930,   930,
     930,   931,   931,   932,   932,   933,   933,   933,   933,   933,
     933,   933,   933,   933,   555,   934,   934,   555,   935,   935,
     935,   935,   549,   936,   549,   937,   549,   938,   549,   939,
     549,   940,   549,   941,   549,   942,   549,   943,   944,   944,
     945,   945,   945,   692,   946,   924,   924,   947,   947,   948,
     948,   948,   948,   948,   948,   948,   692,   949,   950,   950,
     951,   951,   951,   952,   953,   954,   954,   955,   955,   956,
     748,   748
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     1,     5,     1,
       3,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     0,     2,     2,     2,
       3,     7,     2,     2,     5,     5,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     2,     2,     1,     1,     1,     2,     1,
       1,     1,     1,     2,     4,     1,     3,     1,     3,     1,
       3,     4,     6,     6,     0,     1,     1,     1,     1,     1,
       2,     4,     4,     2,     2,     2,     2,     2,     4,     2,
       2,     2,     2,     0,     3,     0,     3,     0,     0,     0,
       6,     6,     1,     1,     1,     2,     1,     2,     1,     2,
       1,     0,     4,     1,     2,     1,     4,     1,     6,     1,
       8,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     0,     4,     2,
       5,     0,     4,     1,     1,     1,     2,     4,     1,     0,
       5,     0,     1,     1,     1,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     3,     1,     1,
       1,     5,     7,     5,     7,     9,     7,     5,     7,     5,
      11,     1,     1,     2,     1,     7,     9,     7,     7,     9,
       7,     9,     7,     9,     7,    15,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     3,     1,     3,     1,     3,
       1,     2,     2,     6,     1,     3,     0,     4,     3,     1,
       3,     3,     2,     4,     4,     2,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     1,     3,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     4,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     6,     3,
       3,     3,     3,     3,     5,     7,     6,     6,     6,     6,
       4,     8,     4,     1,     1,     1,     1,     1,     0,     1,
       3,     4,     6,     4,     3,     4,     4,     4,     5,     3,
       3,     3,     2,     5,     4,     7,     7,     7,     7,     7,
       9,     0,     1,     1,     1,     1,     1,     4,     5,     1,
       3,     1,     1,     1,     5,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     4,     1,
       1,     1,     0,     1,     2,     3,     0,     2,     2,     2,
       3,     2,     2,     2,     1,     2,     2,     2,     3,     3,
       3,     2,     4,     0,     3,     0,     3,     0,     3,     1,
       2,     1,     1,     1,     0,     2,     2,     2,     2,     2,
       1,     1,     3,     3,     1,     1,     1,     1,     1,     2,
       4,     3,     4,     4,     3,     4,     4,     3,     0,     1,
       2,     0,     1,     3,     1,     3,     1,     0,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     5,     0,     3,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     4,     1,
       0,     3,     4,     1,     2,     0,     5,     5,     5,     5,
       4,     4,     4,     4,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     3,     1,     3,     1,     4,
       1,     5,     1,     0,     1,     3,     1,     4,     1,     4,
       0,     2,     3,     3,     3,     6,     6,     3,     2,     2,
       2,     2,     3,     5,     3,     2,     2,     1,     1,     1,
       1,     2,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     0,     2,     2,     2,     2,     2,
       2,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     4,     1,
       3,     1,     4,     1,     1,     3,     0,     1,     1,     4,
       1,     4,     1,     4,     1,     3,     1,     4,     1,     4,
       1,     4,     1,     4,     1,     2,     1,     1,     1,     1,
       0,     1,     1,     1,     2,     1,     2,     2,     2,     0,
       3,     5,     0,     0,     2,     4,     4,     4,     2,     2,
       2,     1,     1,     1,     2,     2,     3,     3,     0,     3,
       0,     3,     4,     3,     0,     2,     2,     0,     2,     0,
       2,     4,     1,     5,     1,     2,     1,     1,     2,     4,
       0,     3,     5,     0,     0,     0,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     2,     3,     3,     4,     4,
       0,     3,     0,     3,     4,     1,     1,     6,     1,     6,
       1,     6,     1,     6,     2,     2,     0,     3,     3,     0,
       3,     3,     2,     2,     1,     3,     1,     3,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       4,     6,     4,     6,     6,     4,     6,     5,     5,     4,
       5,     5,     6,     3,     3,     4,     5,     6,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     6,     6,     6,
       5,     6,     8,     6,     6,     6,     5,     6,     4,     4,
       4,     4,     5,     5,     6,     5,     5,     5,     6,     7,
       7,     7,     5,     5,     4,     4,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     4,     4,     4,     2,     3,     3,     3,
       2,     2,     2,     3,     5,     5,     4,     3,     3,     3,
       3,     3,     2,     2,     2,     3,     0,     3,     0,     3,
       0,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     2,
       2,     1,     2,     2,     4,     0,     3,     5,     1,     4,
       0,     3,     3,     3,     2,     3,     2,     1,     2,     2,
       2,     3,     3,     0,     1,     2,     3,     1,     1,     2,
       2,     3,     3,     3,     3,     4,     2,     4,     3,     2,
       3,     1,     2,     4,     0,     3,     2,     1,     2,     3,
       3,     3,     3,     2,     3,     0,     5,     0,     5,     2,
       2,     1,     4,     1,     1,     0,     3,     2,     2,     2,
       5,     2,     0,     3,     0,     2,     2,     3,     2,     2,
       3,     2,     2,     2,     1,     3,     2,     2,     2,     2,
       2,     2,     3,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     2,     3,     2,     3,     3,     4,
       4,     2,     2,     2,     3,     3,     3,     2,     3,     3,
       3,     4,     2,     1,     0,     2,     3,     1,     0,     1,
       2,     0,     2,     0,     1,     3,     0,     0,     2,     0,
       3,     0,     3,     0,     3,     3,     1,     1,     1,     1,
       1,     4,     1,     6,     1,     6,     1,     6,     1,     7,
       1,     6,     1,     7,     1,     5,     0,     2,     3,     2,
       3,     3,     2,     3,     2,     2,     2,     3,     3,     3,
       1,     3,     3,     2,     3,     3,     2,     2,     2,     2,
       2,     0,     4,     2,     3,     3,     5,     1,     2,     1,
       1,     2,     2,     0,     3,     0,     3,     2,     3,     0,
       3,     5,     0,     4,     4,     3,     4,     2,     3,     3,
       3,     3,     4,     4,     4,     3,     3,     4,     4,     2,
       0,     3,     0,     3,     3,     3,     1,     1,     1,     0,
       0,     3,     0,     3,     4,     1,     2,     2,     2,     4,
       4,     0,     0,     3,     0,     3,     3,     1,     0,     0,
       2,     2,     0,     0,     3,     1,     5,     1,     0,     0,
       2,     2,     0,     0,     3,     1,     5,     1,     2,     0,
       2,     1,     1,     1,     1,     2,     2,     1,     1,     2,
       4,     2,     2,     0,     3,     5,     0,     0,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     4,     3,
       2,     2,     1,     1,     1,     1,     1,     0,     3,     0,
       3,     4,     1,     1,     1,     6,     1,     6,     1,     2,
       5,     0,     3,     1,     1,     2,     3,     1,     2,     3,
       3,     3,     0,     1,     2,     1,     1,     2,     6,     0,
       0,     0,     3,     4,     4,     2,     0,     2,     2,     3,
       3,     3,     5,     5,     4,     3,     2,     3,     3,     3,
       3,     1,     2,     2,     2,     3,     5,     1,     2,     2,
       2,     2,     2,     1,     0,     2,     0,     3,     1,     4,
       3,     3,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     2,     0,     0,     2,     2,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     3,     1,     3,     4,
       3,     3,     1,     4,     1,     5,     1,     3,     1,     3,
       1,     3,     1,     4,     1,     2,     1,     3,     0,     1,
       0,     1,     2,     2,     2,     3,     3,     0,     2,     1,
       1,     2,     3,     2,     3,     4,     2,     2,     3,     3,
       1,     2,     3,     0,     2,     0,     3,     0,     3,     3,
       1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          goto yyexhaustedlab;                                          \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      YY_LAC_ESTABLISH;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 2: /* config: conf_entries END  */
#line 132 "conf/confbase.Y"
                         { return 0; }
#line 6169 "obj/conf/cf-parse.tab.c"
    break;

  case 3: /* config: CLI_MARKER cli_cmd  */
#line 133 "conf/confbase.Y"
                      { return 0; }
#line 6175 "obj/conf/cf-parse.tab.c"
    break;

  case 8: /* definition: DEFINE symbol '=' term ';'  */
#line 149 "conf/confbase.Y"
                              {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     if (f_eval(f_linearize((yyvsp[-1].x)), cfg_mem, val) > F_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val, val);
   }
#line 6185 "obj/conf/cf-parse.tab.c"
    break;

  case 10: /* expr: '(' term ')'  */
#line 158 "conf/confbase.Y"
                { (yyval.i) = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 6191 "obj/conf/cf-parse.tab.c"
    break;

  case 11: /* expr: CF_SYM_KNOWN  */
#line 159 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number constant expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 6199 "obj/conf/cf-parse.tab.c"
    break;

  case 12: /* expr_us: expr S  */
#line 165 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) S_; }
#line 6205 "obj/conf/cf-parse.tab.c"
    break;

  case 13: /* expr_us: expr MS  */
#line 166 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) MS_; }
#line 6211 "obj/conf/cf-parse.tab.c"
    break;

  case 14: /* expr_us: expr US  */
#line 167 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) US_; }
#line 6217 "obj/conf/cf-parse.tab.c"
    break;

  case 17: /* bool: expr  */
#line 175 "conf/confbase.Y"
        { (yyval.i) = !!(yyvsp[0].i); }
#line 6223 "obj/conf/cf-parse.tab.c"
    break;

  case 18: /* bool: ON  */
#line 176 "conf/confbase.Y"
      { (yyval.i) = 1; }
#line 6229 "obj/conf/cf-parse.tab.c"
    break;

  case 19: /* bool: YES  */
#line 177 "conf/confbase.Y"
       { (yyval.i) = 1; }
#line 6235 "obj/conf/cf-parse.tab.c"
    break;

  case 20: /* bool: OFF  */
#line 178 "conf/confbase.Y"
       { (yyval.i) = 0; }
#line 6241 "obj/conf/cf-parse.tab.c"
    break;

  case 21: /* bool: NO  */
#line 179 "conf/confbase.Y"
      { (yyval.i) = 0; }
#line 6247 "obj/conf/cf-parse.tab.c"
    break;

  case 22: /* bool: %empty  */
#line 180 "conf/confbase.Y"
                                 { (yyval.i) = 1; }
#line 6253 "obj/conf/cf-parse.tab.c"
    break;

  case 23: /* ipa: IP4  */
#line 187 "conf/confbase.Y"
       { (yyval.a) = ipa_from_ip4((yyvsp[0].ip4)); }
#line 6259 "obj/conf/cf-parse.tab.c"
    break;

  case 24: /* ipa: IP6  */
#line 188 "conf/confbase.Y"
       { (yyval.a) = ipa_from_ip6((yyvsp[0].ip6)); }
#line 6265 "obj/conf/cf-parse.tab.c"
    break;

  case 25: /* ipa: CF_SYM_KNOWN  */
#line 189 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address constant expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).ip;
   }
#line 6274 "obj/conf/cf-parse.tab.c"
    break;

  case 26: /* ipa_scope: %empty  */
#line 196 "conf/confbase.Y"
               { (yyval.iface) = NULL; }
#line 6280 "obj/conf/cf-parse.tab.c"
    break;

  case 27: /* ipa_scope: '%' symbol  */
#line 197 "conf/confbase.Y"
              { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6286 "obj/conf/cf-parse.tab.c"
    break;

  case 28: /* pxlen4: '/' NUM  */
#line 204 "conf/confbase.Y"
           {
     if ((yyvsp[0].i) > IP4_MAX_PREFIX_LENGTH) cf_error("Invalid prefix length %u", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 6295 "obj/conf/cf-parse.tab.c"
    break;

  case 29: /* net_ip4_: IP4 pxlen4  */
#line 211 "conf/confbase.Y"
{
  net_fill_ip4(&((yyval.net)), (yyvsp[-1].ip4), (yyvsp[0].i));

  net_addr_ip4 *n = (void *) &((yyval.net));
  if (!net_validate_ip4(n))
    cf_error("Invalid IPv4 prefix %I4/%d, maybe you wanted %I4/%d",
	     n->prefix, n->pxlen, ip4_and(n->prefix, ip4_mkmask(n->pxlen)), n->pxlen);
}
#line 6308 "obj/conf/cf-parse.tab.c"
    break;

  case 30: /* net_ip6_: IP6 '/' NUM  */
#line 221 "conf/confbase.Y"
{
  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  net_fill_ip6(&((yyval.net)), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6 *n = (void *) &((yyval.net));
  if (!net_validate_ip6(n))
    cf_error("Invalid IPv6 prefix %I6/%d, maybe you wanted %I6/%d",
	     n->prefix, n->pxlen, ip6_and(n->prefix, ip6_mkmask(n->pxlen)), n->pxlen);
}
#line 6324 "obj/conf/cf-parse.tab.c"
    break;

  case 31: /* net_ip6_sadr_: IP6 '/' NUM FROM IP6 '/' NUM  */
#line 234 "conf/confbase.Y"
{
  if ((yyvsp[-4].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[-4].i));

  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
  net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-6].ip6), (yyvsp[-4].i), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6_sadr *n = (void *) (yyval.net_ptr);
  if (!net_validate_ip6_sadr(n))
    cf_error("Invalid SADR IPv6 prefix %I6/%d from %I6/%d, maybe you wanted %I6/%d from %I6/%d",
	     n->dst_prefix, n->dst_pxlen, n->src_prefix, n->src_pxlen,
	     ip6_and(n->dst_prefix, ip6_mkmask(n->dst_pxlen)), n->dst_pxlen,
	     ip6_and(n->src_prefix, ip6_mkmask(n->src_pxlen)), n->src_pxlen);
}
#line 6346 "obj/conf/cf-parse.tab.c"
    break;

  case 32: /* net_vpn4_: VPN_RD net_ip4_  */
#line 253 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
  net_fill_vpn4((yyval.net_ptr), net4_prefix(&(yyvsp[0].net)), net4_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 6355 "obj/conf/cf-parse.tab.c"
    break;

  case 33: /* net_vpn6_: VPN_RD net_ip6_  */
#line 259 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
  net_fill_vpn6((yyval.net_ptr), net6_prefix(&(yyvsp[0].net)), net6_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 6364 "obj/conf/cf-parse.tab.c"
    break;

  case 34: /* net_roa4_: net_ip4_ MAX NUM AS NUM  */
#line 265 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa4));
  net_fill_roa4((yyval.net_ptr), net4_prefix(&(yyvsp[-4].net)), net4_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net4_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP4_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 6375 "obj/conf/cf-parse.tab.c"
    break;

  case 35: /* net_roa6_: net_ip6_ MAX NUM AS NUM  */
#line 273 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_roa6((yyval.net_ptr), net6_prefix(&(yyvsp[-4].net)), net6_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net6_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 6386 "obj/conf/cf-parse.tab.c"
    break;

  case 36: /* net_mpls_: MPLS NUM  */
#line 281 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_mpls((yyval.net_ptr), (yyvsp[0].i));
}
#line 6395 "obj/conf/cf-parse.tab.c"
    break;

  case 43: /* net_: net_ip_  */
#line 291 "conf/confbase.Y"
           { (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length); net_copy((yyval.net_ptr), &((yyvsp[0].net))); }
#line 6401 "obj/conf/cf-parse.tab.c"
    break;

  case 50: /* net_ip6: CF_SYM_KNOWN  */
#line 304 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[0].s)).net->type != NET_IP6))
       cf_error("IPv6 network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 6411 "obj/conf/cf-parse.tab.c"
    break;

  case 52: /* net_ip: CF_SYM_KNOWN  */
#line 313 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || !net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       cf_error("IP network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 6421 "obj/conf/cf-parse.tab.c"
    break;

  case 54: /* net_any: CF_SYM_KNOWN  */
#line 322 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET))
       cf_error("Network constant expected");
     (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
   }
#line 6431 "obj/conf/cf-parse.tab.c"
    break;

  case 57: /* net_or_ipa: IP4  */
#line 332 "conf/confbase.Y"
       { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 6437 "obj/conf/cf-parse.tab.c"
    break;

  case 58: /* net_or_ipa: IP6  */
#line 333 "conf/confbase.Y"
       { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 6443 "obj/conf/cf-parse.tab.c"
    break;

  case 59: /* net_or_ipa: CF_SYM_KNOWN  */
#line 334 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       net_fill_ip_host(&((yyval.net)), SYM_VAL((yyvsp[0].s)).ip);
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
     else
       cf_error("IP address or network constant expected");
   }
#line 6456 "obj/conf/cf-parse.tab.c"
    break;

  case 60: /* label_stack_start: NUM  */
#line 345 "conf/confbase.Y"
{
  (yyval.mls) = cfg_allocz(sizeof(mpls_label_stack));
  (yyval.mls)->len = 1;
  (yyval.mls)->stack[0] = (yyvsp[0].i);
}
#line 6466 "obj/conf/cf-parse.tab.c"
    break;

  case 62: /* label_stack: label_stack '/' NUM  */
#line 353 "conf/confbase.Y"
                        {
    if ((yyvsp[-2].mls)->len >= MPLS_MAX_LABEL_STACK)
      cf_error("Too many labels in stack");
    (yyvsp[-2].mls)->stack[(yyvsp[-2].mls)->len++] = (yyvsp[0].i);
    (yyval.mls) = (yyvsp[-2].mls);
  }
#line 6477 "obj/conf/cf-parse.tab.c"
    break;

  case 63: /* time: TEXT  */
#line 362 "conf/confbase.Y"
        {
     (yyval.time) = tm_parse_time((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date/time");
   }
#line 6487 "obj/conf/cf-parse.tab.c"
    break;

  case 65: /* text: CF_SYM_KNOWN  */
#line 371 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String constant expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 6496 "obj/conf/cf-parse.tab.c"
    break;

  case 67: /* opttext: %empty  */
#line 379 "conf/confbase.Y"
               { (yyval.t) = NULL; }
#line 6502 "obj/conf/cf-parse.tab.c"
    break;

  case 68: /* flow_num_op: TRUE  */
#line 37 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_TRUE; }
#line 6508 "obj/conf/cf-parse.tab.c"
    break;

  case 69: /* flow_num_op: '='  */
#line 38 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_EQ;  }
#line 6514 "obj/conf/cf-parse.tab.c"
    break;

  case 70: /* flow_num_op: NEQ  */
#line 39 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_NEQ; }
#line 6520 "obj/conf/cf-parse.tab.c"
    break;

  case 71: /* flow_num_op: '<'  */
#line 40 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_LT;  }
#line 6526 "obj/conf/cf-parse.tab.c"
    break;

  case 72: /* flow_num_op: LEQ  */
#line 41 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_LEQ; }
#line 6532 "obj/conf/cf-parse.tab.c"
    break;

  case 73: /* flow_num_op: '>'  */
#line 42 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_GT;  }
#line 6538 "obj/conf/cf-parse.tab.c"
    break;

  case 74: /* flow_num_op: GEQ  */
#line 43 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_GEQ; }
#line 6544 "obj/conf/cf-parse.tab.c"
    break;

  case 75: /* flow_num_op: FALSE  */
#line 44 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_FALSE; }
#line 6550 "obj/conf/cf-parse.tab.c"
    break;

  case 76: /* flow_logic_op: OR  */
#line 48 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_OR; }
#line 6556 "obj/conf/cf-parse.tab.c"
    break;

  case 77: /* flow_logic_op: AND  */
#line 49 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_AND; }
#line 6562 "obj/conf/cf-parse.tab.c"
    break;

  case 78: /* flow_num_type_: PROTO  */
#line 53 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_IP_PROTOCOL; }
#line 6568 "obj/conf/cf-parse.tab.c"
    break;

  case 79: /* flow_num_type_: NEXT HEADER  */
#line 54 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_NEXT_HEADER; }
#line 6574 "obj/conf/cf-parse.tab.c"
    break;

  case 80: /* flow_num_type_: PORT  */
#line 55 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_PORT; }
#line 6580 "obj/conf/cf-parse.tab.c"
    break;

  case 81: /* flow_num_type_: DPORT  */
#line 56 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DST_PORT; }
#line 6586 "obj/conf/cf-parse.tab.c"
    break;

  case 82: /* flow_num_type_: SPORT  */
#line 57 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_SRC_PORT; }
#line 6592 "obj/conf/cf-parse.tab.c"
    break;

  case 83: /* flow_num_type_: ICMP TYPE  */
#line 58 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_ICMP_TYPE; }
#line 6598 "obj/conf/cf-parse.tab.c"
    break;

  case 84: /* flow_num_type_: ICMP CODE  */
#line 59 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_ICMP_CODE; }
#line 6604 "obj/conf/cf-parse.tab.c"
    break;

  case 85: /* flow_num_type_: LENGTH  */
#line 60 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_PACKET_LENGTH; }
#line 6610 "obj/conf/cf-parse.tab.c"
    break;

  case 86: /* flow_num_type_: DSCP  */
#line 61 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DSCP; }
#line 6616 "obj/conf/cf-parse.tab.c"
    break;

  case 87: /* flow_num_type: flow_num_type_  */
#line 64 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, (yyvsp[0].i32)); }
#line 6622 "obj/conf/cf-parse.tab.c"
    break;

  case 88: /* flow_flag_type: TCP FLAGS  */
#line 65 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_TCP_FLAGS); }
#line 6628 "obj/conf/cf-parse.tab.c"
    break;

  case 89: /* flow_frag_type: FRAGMENT  */
#line 66 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_FRAGMENT); }
#line 6634 "obj/conf/cf-parse.tab.c"
    break;

  case 90: /* flow_label_type: LABEL  */
#line 67 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_LABEL); }
#line 6640 "obj/conf/cf-parse.tab.c"
    break;

  case 91: /* flow_srcdst: DST  */
#line 70 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DST_PREFIX; }
#line 6646 "obj/conf/cf-parse.tab.c"
    break;

  case 92: /* flow_srcdst: SRC  */
#line 71 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_SRC_PREFIX; }
#line 6652 "obj/conf/cf-parse.tab.c"
    break;

  case 93: /* flow_num_opts: flow_num_op expr  */
#line 75 "conf/flowspec.Y"
                    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 6661 "obj/conf/cf-parse.tab.c"
    break;

  case 94: /* flow_num_opts: flow_num_opts flow_logic_op flow_num_op expr  */
#line 79 "conf/flowspec.Y"
                                                {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-2].i32) | (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 6670 "obj/conf/cf-parse.tab.c"
    break;

  case 97: /* flow_num_opt_ext_expr: expr  */
#line 88 "conf/flowspec.Y"
        {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_EQ, (yyvsp[0].i));
   }
#line 6679 "obj/conf/cf-parse.tab.c"
    break;

  case 98: /* flow_num_opt_ext_expr: expr DDOT expr  */
#line 92 "conf/flowspec.Y"
                  {
     flow_check_cf_value_length(this_flow, (yyvsp[-2].i));
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_GEQ, (yyvsp[-2].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_AND | FLOW_OP_LEQ, (yyvsp[0].i));
   }
#line 6690 "obj/conf/cf-parse.tab.c"
    break;

  case 101: /* flow_bmk_opts: flow_neg expr '/' expr  */
#line 106 "conf/flowspec.Y"
                          {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 6699 "obj/conf/cf-parse.tab.c"
    break;

  case 102: /* flow_bmk_opts: flow_bmk_opts flow_logic_op flow_neg expr '/' expr  */
#line 110 "conf/flowspec.Y"
                                                      {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-4].i32) | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 6708 "obj/conf/cf-parse.tab.c"
    break;

  case 103: /* flow_bmk_opts: flow_bmk_opts ',' flow_neg expr '/' expr  */
#line 114 "conf/flowspec.Y"
                                            {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, 0x40 | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i)); /* AND */
   }
#line 6717 "obj/conf/cf-parse.tab.c"
    break;

  case 104: /* flow_neg: %empty  */
#line 121 "conf/flowspec.Y"
                { (yyval.i32) = 0x00; }
#line 6723 "obj/conf/cf-parse.tab.c"
    break;

  case 105: /* flow_neg: '!'  */
#line 122 "conf/flowspec.Y"
                { (yyval.i32) = 0x02; }
#line 6729 "obj/conf/cf-parse.tab.c"
    break;

  case 106: /* flow_frag_val: DONT_FRAGMENT  */
#line 126 "conf/flowspec.Y"
                  { (yyval.i32) = 1; }
#line 6735 "obj/conf/cf-parse.tab.c"
    break;

  case 107: /* flow_frag_val: IS_FRAGMENT  */
#line 127 "conf/flowspec.Y"
                  { (yyval.i32) = 2; }
#line 6741 "obj/conf/cf-parse.tab.c"
    break;

  case 108: /* flow_frag_val: FIRST_FRAGMENT  */
#line 128 "conf/flowspec.Y"
                  { (yyval.i32) = 4; }
#line 6747 "obj/conf/cf-parse.tab.c"
    break;

  case 109: /* flow_frag_val: LAST_FRAGMENT  */
#line 129 "conf/flowspec.Y"
                  { (yyval.i32) = 8; }
#line 6753 "obj/conf/cf-parse.tab.c"
    break;

  case 110: /* flow_frag_opts: flow_neg flow_frag_val  */
#line 133 "conf/flowspec.Y"
                          {
     flow_builder_add_val_mask(this_flow, 0, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 6761 "obj/conf/cf-parse.tab.c"
    break;

  case 111: /* flow_frag_opts: flow_frag_opts flow_logic_op flow_neg flow_frag_val  */
#line 136 "conf/flowspec.Y"
                                                       {
     flow_builder_add_val_mask(this_flow, (yyvsp[-2].i32), ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 6769 "obj/conf/cf-parse.tab.c"
    break;

  case 112: /* flow_frag_opts: flow_frag_opts ',' flow_neg flow_frag_val  */
#line 139 "conf/flowspec.Y"
                                             {
     flow_builder_add_val_mask(this_flow, 0x40, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32)); /* AND */
   }
#line 6777 "obj/conf/cf-parse.tab.c"
    break;

  case 113: /* flow4_item: flow_srcdst net_ip  */
#line 145 "conf/flowspec.Y"
                      {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder4_add_pfx(this_flow, (net_addr_ip4 *) &((yyvsp[0].net)));
   }
#line 6786 "obj/conf/cf-parse.tab.c"
    break;

  case 117: /* flow6_item: flow_srcdst net_ip6  */
#line 155 "conf/flowspec.Y"
                       {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[0].net)), 0);
   }
#line 6795 "obj/conf/cf-parse.tab.c"
    break;

  case 118: /* flow6_item: flow_srcdst net_ip6 OFFSET NUM  */
#line 159 "conf/flowspec.Y"
                                  {
     if ((yyvsp[0].i) > (yyvsp[-2].net).pxlen)
       cf_error("Prefix offset is higher than prefix length");
     flow_builder_set_type(this_flow, (yyvsp[-3].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[-2].net)), (yyvsp[0].i));
   }
#line 6806 "obj/conf/cf-parse.tab.c"
    break;

  case 127: /* flow_builder_init: %empty  */
#line 182 "conf/flowspec.Y"
{
  if (this_flow == NULL)
    this_flow = flow_builder_init(&root_pool);
  else
    flow_builder_clear(this_flow);
}
#line 6817 "obj/conf/cf-parse.tab.c"
    break;

  case 128: /* flow_builder_set_ipv4: %empty  */
#line 189 "conf/flowspec.Y"
                       { this_flow->ipv6 = 0; }
#line 6823 "obj/conf/cf-parse.tab.c"
    break;

  case 129: /* flow_builder_set_ipv6: %empty  */
#line 190 "conf/flowspec.Y"
                       { this_flow->ipv6 = 1; }
#line 6829 "obj/conf/cf-parse.tab.c"
    break;

  case 130: /* net_flow4_: FLOW4 '{' flow_builder_init flow_builder_set_ipv4 flow4_opts '}'  */
#line 193 "conf/flowspec.Y"
{
  (yyval.net_ptr) = (net_addr *) flow_builder4_finalize(this_flow, cfg_mem);
  flow4_validate_cf((net_addr_flow4 *) (yyval.net_ptr));
}
#line 6838 "obj/conf/cf-parse.tab.c"
    break;

  case 131: /* net_flow6_: FLOW6 '{' flow_builder_init flow_builder_set_ipv6 flow6_opts '}'  */
#line 199 "conf/flowspec.Y"
{
  (yyval.net_ptr) = (net_addr *) flow_builder6_finalize(this_flow, cfg_mem);
  flow6_validate_cf((net_addr_flow6 *) (yyval.net_ptr));
}
#line 6847 "obj/conf/cf-parse.tab.c"
    break;

  case 141: /* $@1: %empty  */
#line 470 "filter/config.Y"
                 { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, filter, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 6853 "obj/conf/cf-parse.tab.c"
    break;

  case 142: /* filter_def: FILTER symbol $@1 filter_body  */
#line 471 "filter/config.Y"
                 {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .sym = (yyvsp[-2].s), .root = (yyvsp[0].fl) };
     (yyvsp[-2].s)->filter = f;

     cf_pop_scope();
   }
#line 6865 "obj/conf/cf-parse.tab.c"
    break;

  case 144: /* filter_eval: EVAL term  */
#line 482 "filter/config.Y"
             { f_eval_int(f_linearize((yyvsp[0].x))); }
#line 6871 "obj/conf/cf-parse.tab.c"
    break;

  case 146: /* custom_attr: ATTRIBUTE type symbol ';'  */
#line 486 "filter/config.Y"
                                       {
  cf_define_symbol((yyvsp[-1].s), SYM_ATTRIBUTE, attribute, ca_lookup(new_config->pool, (yyvsp[-1].s)->name, (yyvsp[-2].i))->fda);
}
#line 6879 "obj/conf/cf-parse.tab.c"
    break;

  case 148: /* bt_test_suite: BT_TEST_SUITE '(' CF_SYM_KNOWN ',' text ')'  */
#line 492 "filter/config.Y"
                                             {
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-3].s)->function;
  t->fn_name = (yyvsp[-3].s)->name;
  t->dsc = (yyvsp[-1].t);

  add_tail(&new_config->tests, &t->n);
 }
#line 6893 "obj/conf/cf-parse.tab.c"
    break;

  case 150: /* bt_test_same: BT_TEST_SAME '(' CF_SYM_KNOWN ',' CF_SYM_KNOWN ',' NUM ')'  */
#line 505 "filter/config.Y"
                                                            {
  cf_assert_symbol((yyvsp[-5].s), SYM_FUNCTION);
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-5].s)->function;
  t->cmp = (yyvsp[-3].s)->function;
  t->result = (yyvsp[-1].i);
  t->fn_name = (yyvsp[-5].s)->name;
  t->dsc = (yyvsp[-3].s)->name;
  add_tail(&new_config->tests, &t->n);
 }
#line 6909 "obj/conf/cf-parse.tab.c"
    break;

  case 151: /* type: INT  */
#line 519 "filter/config.Y"
       { (yyval.i) = T_INT; }
#line 6915 "obj/conf/cf-parse.tab.c"
    break;

  case 152: /* type: BOOL  */
#line 520 "filter/config.Y"
        { (yyval.i) = T_BOOL; }
#line 6921 "obj/conf/cf-parse.tab.c"
    break;

  case 153: /* type: IP  */
#line 521 "filter/config.Y"
      { (yyval.i) = T_IP; }
#line 6927 "obj/conf/cf-parse.tab.c"
    break;

  case 154: /* type: RD  */
#line 522 "filter/config.Y"
      { (yyval.i) = T_RD; }
#line 6933 "obj/conf/cf-parse.tab.c"
    break;

  case 155: /* type: PREFIX  */
#line 523 "filter/config.Y"
          { (yyval.i) = T_NET; }
#line 6939 "obj/conf/cf-parse.tab.c"
    break;

  case 156: /* type: PAIR  */
#line 524 "filter/config.Y"
        { (yyval.i) = T_PAIR; }
#line 6945 "obj/conf/cf-parse.tab.c"
    break;

  case 157: /* type: QUAD  */
#line 525 "filter/config.Y"
        { (yyval.i) = T_QUAD; }
#line 6951 "obj/conf/cf-parse.tab.c"
    break;

  case 158: /* type: EC  */
#line 526 "filter/config.Y"
      { (yyval.i) = T_EC; }
#line 6957 "obj/conf/cf-parse.tab.c"
    break;

  case 159: /* type: LC  */
#line 527 "filter/config.Y"
      { (yyval.i) = T_LC; }
#line 6963 "obj/conf/cf-parse.tab.c"
    break;

  case 160: /* type: STRING  */
#line 528 "filter/config.Y"
          { (yyval.i) = T_STRING; }
#line 6969 "obj/conf/cf-parse.tab.c"
    break;

  case 161: /* type: BGPMASK  */
#line 529 "filter/config.Y"
           { (yyval.i) = T_PATH_MASK; }
#line 6975 "obj/conf/cf-parse.tab.c"
    break;

  case 162: /* type: BGPPATH  */
#line 530 "filter/config.Y"
           { (yyval.i) = T_PATH; }
#line 6981 "obj/conf/cf-parse.tab.c"
    break;

  case 163: /* type: CLIST  */
#line 531 "filter/config.Y"
         { (yyval.i) = T_CLIST; }
#line 6987 "obj/conf/cf-parse.tab.c"
    break;

  case 164: /* type: ECLIST  */
#line 532 "filter/config.Y"
          { (yyval.i) = T_ECLIST; }
#line 6993 "obj/conf/cf-parse.tab.c"
    break;

  case 165: /* type: LCLIST  */
#line 533 "filter/config.Y"
          { (yyval.i) = T_LCLIST; }
#line 6999 "obj/conf/cf-parse.tab.c"
    break;

  case 166: /* type: type SET  */
#line 534 "filter/config.Y"
            {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_RD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_NET:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 7024 "obj/conf/cf-parse.tab.c"
    break;

  case 168: /* function_argsn: function_argsn type symbol ';'  */
#line 558 "filter/config.Y"
                                  {
     if ((yyvsp[-1].s)->scope->slots >= 0xfe) cf_error("Too many declarations, at most 255 allowed");
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
   }
#line 7033 "obj/conf/cf-parse.tab.c"
    break;

  case 169: /* function_args: '(' ')'  */
#line 565 "filter/config.Y"
           { (yyval.i) = 0; }
#line 7039 "obj/conf/cf-parse.tab.c"
    break;

  case 170: /* function_args: '(' function_argsn type symbol ')'  */
#line 566 "filter/config.Y"
                                      {
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
     (yyval.i) = (yyvsp[-1].s)->scope->slots;
   }
#line 7048 "obj/conf/cf-parse.tab.c"
    break;

  case 171: /* function_vars: %empty  */
#line 573 "filter/config.Y"
               { (yyval.i) = 0; }
#line 7054 "obj/conf/cf-parse.tab.c"
    break;

  case 172: /* function_vars: function_vars type symbol ';'  */
#line 574 "filter/config.Y"
                                 {
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
     (yyval.i) = (yyvsp[-3].i) + 1;
   }
#line 7063 "obj/conf/cf-parse.tab.c"
    break;

  case 174: /* filter: CF_SYM_KNOWN  */
#line 583 "filter/config.Y"
                {
     cf_assert_symbol((yyvsp[0].s), SYM_FILTER);
     (yyval.f) = (yyvsp[0].s)->filter;
   }
#line 7072 "obj/conf/cf-parse.tab.c"
    break;

  case 175: /* filter: filter_body  */
#line 587 "filter/config.Y"
               {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .root = (yyvsp[0].fl) };
     (yyval.f) = f;
   }
#line 7082 "obj/conf/cf-parse.tab.c"
    break;

  case 176: /* where_filter: WHERE term  */
#line 595 "filter/config.Y"
              {
     /* Construct 'IF term THEN { ACCEPT; } ELSE { REJECT; }' */
     (yyval.f) = f_new_where((yyvsp[0].x));
   }
#line 7091 "obj/conf/cf-parse.tab.c"
    break;

  case 177: /* function_body: function_vars '{' cmds '}'  */
#line 602 "filter/config.Y"
                              {
     (yyval.fl) = f_linearize((yyvsp[-1].x));
     (yyval.fl)->vars = (yyvsp[-3].i);
   }
#line 7100 "obj/conf/cf-parse.tab.c"
    break;

  case 179: /* $@2: %empty  */
#line 610 "filter/config.Y"
                   { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, function, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 7109 "obj/conf/cf-parse.tab.c"
    break;

  case 180: /* function_def: FUNCTION symbol $@2 function_args function_body  */
#line 613 "filter/config.Y"
                                 {
     DBG("Definition of function %s with %u args and %u local vars.\n", (yyvsp[-3].s)->name, (yyvsp[-1].i), (yyvsp[0].fl)->vars);
     (yyvsp[0].fl)->args = (yyvsp[-1].i);
     (yyvsp[-3].s)->function = (yyvsp[0].fl);
     cf_pop_scope();
   }
#line 7120 "obj/conf/cf-parse.tab.c"
    break;

  case 181: /* cmds: %empty  */
#line 623 "filter/config.Y"
                  { (yyval.x) = NULL; }
#line 7126 "obj/conf/cf-parse.tab.c"
    break;

  case 182: /* cmds: cmds_int  */
#line 624 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].xp).begin; }
#line 7132 "obj/conf/cf-parse.tab.c"
    break;

  case 183: /* cmd_prep: cmd  */
#line 627 "filter/config.Y"
              {
  (yyval.xp).begin = (yyval.xp).end = (yyvsp[0].x);
  if ((yyvsp[0].x))
    while ((yyval.xp).end->next)
      (yyval.xp).end = (yyval.xp).end->next;
}
#line 7143 "obj/conf/cf-parse.tab.c"
    break;

  case 185: /* cmds_int: cmds_int cmd_prep  */
#line 636 "filter/config.Y"
                     {
  if (!(yyvsp[-1].xp).begin)
    (yyval.xp) = (yyvsp[0].xp);
  else if (!(yyvsp[0].xp).begin)
    (yyval.xp) = (yyvsp[-1].xp);
  else {
    (yyval.xp).begin = (yyvsp[-1].xp).begin;
    (yyval.xp).end = (yyvsp[0].xp).end;
    (yyvsp[-1].xp).end->next = (yyvsp[0].xp).begin;
  }
 }
#line 7159 "obj/conf/cf-parse.tab.c"
    break;

  case 186: /* block: cmd  */
#line 650 "filter/config.Y"
       {
     (yyval.x)=(yyvsp[0].x);
   }
#line 7167 "obj/conf/cf-parse.tab.c"
    break;

  case 187: /* block: '{' cmds '}'  */
#line 653 "filter/config.Y"
                {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 7175 "obj/conf/cf-parse.tab.c"
    break;

  case 188: /* fipa: IP4  */
#line 662 "filter/config.Y"
                          { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip4((yyvsp[0].ip4)); }
#line 7181 "obj/conf/cf-parse.tab.c"
    break;

  case 189: /* fipa: IP6  */
#line 663 "filter/config.Y"
                          { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip6((yyvsp[0].ip6)); }
#line 7187 "obj/conf/cf-parse.tab.c"
    break;

  case 190: /* set_atom: NUM  */
#line 676 "filter/config.Y"
          { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 7193 "obj/conf/cf-parse.tab.c"
    break;

  case 191: /* set_atom: fipa  */
#line 677 "filter/config.Y"
          { (yyval.v) = (yyvsp[0].v); }
#line 7199 "obj/conf/cf-parse.tab.c"
    break;

  case 192: /* set_atom: VPN_RD  */
#line 678 "filter/config.Y"
          { (yyval.v).type = T_RD; (yyval.v).val.ec = (yyvsp[0].i64); }
#line 7205 "obj/conf/cf-parse.tab.c"
    break;

  case 193: /* set_atom: ENUM  */
#line 679 "filter/config.Y"
          { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 7211 "obj/conf/cf-parse.tab.c"
    break;

  case 194: /* set_atom: '(' term ')'  */
#line 680 "filter/config.Y"
                {
     if (f_eval(f_linearize((yyvsp[-1].x)), cfg_mem, &((yyval.v))) > F_RETURN) cf_error("Runtime error");
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 7220 "obj/conf/cf-parse.tab.c"
    break;

  case 195: /* set_atom: CF_SYM_KNOWN  */
#line 684 "filter/config.Y"
                {
     cf_assert_symbol((yyvsp[0].s), SYM_CONSTANT);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(yyvsp[0].s)->val;
   }
#line 7230 "obj/conf/cf-parse.tab.c"
    break;

  case 196: /* switch_atom: NUM  */
#line 692 "filter/config.Y"
         { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 7236 "obj/conf/cf-parse.tab.c"
    break;

  case 197: /* switch_atom: '(' term ')'  */
#line 693 "filter/config.Y"
                { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 7242 "obj/conf/cf-parse.tab.c"
    break;

  case 198: /* switch_atom: fipa  */
#line 694 "filter/config.Y"
         { (yyval.v) = (yyvsp[0].v); }
#line 7248 "obj/conf/cf-parse.tab.c"
    break;

  case 199: /* switch_atom: ENUM  */
#line 695 "filter/config.Y"
         { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 7254 "obj/conf/cf-parse.tab.c"
    break;

  case 200: /* cnum: term  */
#line 699 "filter/config.Y"
        { (yyval.i32) = f_eval_int(f_linearize((yyvsp[0].x))); }
#line 7260 "obj/conf/cf-parse.tab.c"
    break;

  case 201: /* pair_item: '(' cnum ',' cnum ')'  */
#line 702 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7266 "obj/conf/cf-parse.tab.c"
    break;

  case 202: /* pair_item: '(' cnum ',' cnum DDOT cnum ')'  */
#line 703 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7272 "obj/conf/cf-parse.tab.c"
    break;

  case 203: /* pair_item: '(' cnum ',' '*' ')'  */
#line 704 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 7278 "obj/conf/cf-parse.tab.c"
    break;

  case 204: /* pair_item: '(' cnum DDOT cnum ',' cnum ')'  */
#line 705 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7284 "obj/conf/cf-parse.tab.c"
    break;

  case 205: /* pair_item: '(' cnum DDOT cnum ',' cnum DDOT cnum ')'  */
#line 706 "filter/config.Y"
                                             { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7290 "obj/conf/cf-parse.tab.c"
    break;

  case 206: /* pair_item: '(' cnum DDOT cnum ',' '*' ')'  */
#line 707 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 7296 "obj/conf/cf-parse.tab.c"
    break;

  case 207: /* pair_item: '(' '*' ',' cnum ')'  */
#line 708 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7302 "obj/conf/cf-parse.tab.c"
    break;

  case 208: /* pair_item: '(' '*' ',' cnum DDOT cnum ')'  */
#line 709 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7308 "obj/conf/cf-parse.tab.c"
    break;

  case 209: /* pair_item: '(' '*' ',' '*' ')'  */
#line 710 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 7314 "obj/conf/cf-parse.tab.c"
    break;

  case 210: /* pair_item: '(' cnum ',' cnum ')' DDOT '(' cnum ',' cnum ')'  */
#line 712 "filter/config.Y"
   { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 7320 "obj/conf/cf-parse.tab.c"
    break;

  case 211: /* ec_kind: RT  */
#line 716 "filter/config.Y"
      { (yyval.ecs) = EC_RT; }
#line 7326 "obj/conf/cf-parse.tab.c"
    break;

  case 212: /* ec_kind: RO  */
#line 717 "filter/config.Y"
      { (yyval.ecs) = EC_RO; }
#line 7332 "obj/conf/cf-parse.tab.c"
    break;

  case 213: /* ec_kind: UNKNOWN NUM  */
#line 718 "filter/config.Y"
               { (yyval.ecs) = (yyvsp[0].i); }
#line 7338 "obj/conf/cf-parse.tab.c"
    break;

  case 214: /* ec_kind: GENERIC  */
#line 719 "filter/config.Y"
           { (yyval.ecs) = EC_GENERIC; }
#line 7344 "obj/conf/cf-parse.tab.c"
    break;

  case 215: /* ec_item: '(' ec_kind ',' cnum ',' cnum ')'  */
#line 723 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7350 "obj/conf/cf-parse.tab.c"
    break;

  case 216: /* ec_item: '(' ec_kind ',' cnum ',' cnum DDOT cnum ')'  */
#line 724 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-7].ecs), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7356 "obj/conf/cf-parse.tab.c"
    break;

  case 217: /* ec_item: '(' ec_kind ',' cnum ',' '*' ')'  */
#line 725 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 7362 "obj/conf/cf-parse.tab.c"
    break;

  case 218: /* lc_item: '(' cnum ',' cnum ',' cnum ')'  */
#line 729 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7368 "obj/conf/cf-parse.tab.c"
    break;

  case 219: /* lc_item: '(' cnum ',' cnum ',' cnum DDOT cnum ')'  */
#line 730 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7374 "obj/conf/cf-parse.tab.c"
    break;

  case 220: /* lc_item: '(' cnum ',' cnum ',' '*' ')'  */
#line 731 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 7380 "obj/conf/cf-parse.tab.c"
    break;

  case 221: /* lc_item: '(' cnum ',' cnum DDOT cnum ',' '*' ')'  */
#line 732 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 7386 "obj/conf/cf-parse.tab.c"
    break;

  case 222: /* lc_item: '(' cnum ',' '*' ',' '*' ')'  */
#line 733 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 7392 "obj/conf/cf-parse.tab.c"
    break;

  case 223: /* lc_item: '(' cnum DDOT cnum ',' '*' ',' '*' ')'  */
#line 734 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 7398 "obj/conf/cf-parse.tab.c"
    break;

  case 224: /* lc_item: '(' '*' ',' '*' ',' '*' ')'  */
#line 735 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 7404 "obj/conf/cf-parse.tab.c"
    break;

  case 225: /* lc_item: '(' cnum ',' cnum ',' cnum ')' DDOT '(' cnum ',' cnum ',' cnum ')'  */
#line 737 "filter/config.Y"
   { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 7410 "obj/conf/cf-parse.tab.c"
    break;

  case 229: /* set_item: set_atom  */
#line 744 "filter/config.Y"
            { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 7416 "obj/conf/cf-parse.tab.c"
    break;

  case 230: /* set_item: set_atom DDOT set_atom  */
#line 745 "filter/config.Y"
                          { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 7422 "obj/conf/cf-parse.tab.c"
    break;

  case 234: /* switch_item: switch_atom  */
#line 752 "filter/config.Y"
               { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 7428 "obj/conf/cf-parse.tab.c"
    break;

  case 235: /* switch_item: switch_atom DDOT switch_atom  */
#line 753 "filter/config.Y"
                                { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 7434 "obj/conf/cf-parse.tab.c"
    break;

  case 237: /* set_items: set_items ',' set_item  */
#line 758 "filter/config.Y"
                          { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 7440 "obj/conf/cf-parse.tab.c"
    break;

  case 239: /* switch_items: switch_items ',' switch_item  */
#line 763 "filter/config.Y"
                                { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 7446 "obj/conf/cf-parse.tab.c"
    break;

  case 240: /* fprefix: net_ip_  */
#line 767 "filter/config.Y"
                { (yyval.px).net = (yyvsp[0].net); (yyval.px).lo = (yyvsp[0].net).pxlen; (yyval.px).hi = (yyvsp[0].net).pxlen; }
#line 7452 "obj/conf/cf-parse.tab.c"
    break;

  case 241: /* fprefix: net_ip_ '+'  */
#line 768 "filter/config.Y"
                { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = (yyvsp[-1].net).pxlen; (yyval.px).hi = net_max_prefix_length[(yyvsp[-1].net).type]; }
#line 7458 "obj/conf/cf-parse.tab.c"
    break;

  case 242: /* fprefix: net_ip_ '-'  */
#line 769 "filter/config.Y"
                { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = 0; (yyval.px).hi = (yyvsp[-1].net).pxlen; }
#line 7464 "obj/conf/cf-parse.tab.c"
    break;

  case 243: /* fprefix: net_ip_ '{' NUM ',' NUM '}'  */
#line 770 "filter/config.Y"
                               {
     (yyval.px).net = (yyvsp[-5].net); (yyval.px).lo = (yyvsp[-3].i); (yyval.px).hi = (yyvsp[-1].i);
     if (((yyvsp[-3].i) > (yyvsp[-1].i)) || ((yyvsp[-1].i) > net_max_prefix_length[(yyvsp[-5].net).type]))
       cf_error("Invalid prefix pattern range: {%u, %u}", (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 7474 "obj/conf/cf-parse.tab.c"
    break;

  case 244: /* fprefix_set: fprefix  */
#line 778 "filter/config.Y"
           { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi); }
#line 7480 "obj/conf/cf-parse.tab.c"
    break;

  case 245: /* fprefix_set: fprefix_set ',' fprefix  */
#line 779 "filter/config.Y"
                           { (yyval.trie) = (yyvsp[-2].trie); trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi); }
#line 7486 "obj/conf/cf-parse.tab.c"
    break;

  case 246: /* switch_body: %empty  */
#line 782 "filter/config.Y"
                         { (yyval.e) = NULL; }
#line 7492 "obj/conf/cf-parse.tab.c"
    break;

  case 247: /* switch_body: switch_body switch_items ':' cmds  */
#line 783 "filter/config.Y"
                                      {
     /* Fill data fields */
     struct f_tree *t;
     struct f_line *line = f_linearize((yyvsp[0].x));
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = line;
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 7505 "obj/conf/cf-parse.tab.c"
    break;

  case 248: /* switch_body: switch_body ELSECOL cmds  */
#line 791 "filter/config.Y"
                            {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = f_linearize((yyvsp[0].x));
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 7517 "obj/conf/cf-parse.tab.c"
    break;

  case 249: /* bgp_path_expr: symbol_value  */
#line 801 "filter/config.Y"
                { (yyval.x) = (yyvsp[0].x); }
#line 7523 "obj/conf/cf-parse.tab.c"
    break;

  case 250: /* bgp_path_expr: '(' term ')'  */
#line 802 "filter/config.Y"
                { (yyval.x) = (yyvsp[-1].x); }
#line 7529 "obj/conf/cf-parse.tab.c"
    break;

  case 251: /* bgp_path: PO bgp_path_tail PC  */
#line 806 "filter/config.Y"
                         { (yyval.x) = (yyvsp[-1].x); }
#line 7535 "obj/conf/cf-parse.tab.c"
    break;

  case 252: /* bgp_path_tail: NUM bgp_path_tail  */
#line 810 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .asn = (yyvsp[-1].i), .kind = PM_ASN, }, }); (yyval.x)->next = (yyvsp[0].x);  }
#line 7541 "obj/conf/cf-parse.tab.c"
    break;

  case 253: /* bgp_path_tail: NUM DDOT NUM bgp_path_tail  */
#line 811 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .from = (yyvsp[-3].i), .to = (yyvsp[-1].i), .kind = PM_ASN_RANGE }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7547 "obj/conf/cf-parse.tab.c"
    break;

  case 254: /* bgp_path_tail: '[' set_items ']' bgp_path_tail  */
#line 812 "filter/config.Y"
                                   {
   if ((yyvsp[-2].e)->from.type != T_INT) cf_error("Only integer sets allowed in path mask");
   (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .set = build_tree((yyvsp[-2].e)), .kind = PM_ASN_SET }, }); (yyval.x)->next = (yyvsp[0].x);
 }
#line 7556 "obj/conf/cf-parse.tab.c"
    break;

  case 255: /* bgp_path_tail: '*' bgp_path_tail  */
#line 816 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_ASTERISK }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7562 "obj/conf/cf-parse.tab.c"
    break;

  case 256: /* bgp_path_tail: '?' bgp_path_tail  */
#line 817 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_QUESTION }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7568 "obj/conf/cf-parse.tab.c"
    break;

  case 257: /* bgp_path_tail: bgp_path_expr bgp_path_tail  */
#line 818 "filter/config.Y"
                                { (yyval.x) = (yyvsp[-1].x); (yyval.x)->next = (yyvsp[0].x); }
#line 7574 "obj/conf/cf-parse.tab.c"
    break;

  case 258: /* bgp_path_tail: %empty  */
#line 819 "filter/config.Y"
                                { (yyval.x) = NULL; }
#line 7580 "obj/conf/cf-parse.tab.c"
    break;

  case 259: /* constant: NUM  */
#line 823 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_INT, .val.i = (yyvsp[0].i), }); }
#line 7586 "obj/conf/cf-parse.tab.c"
    break;

  case 260: /* constant: TRUE  */
#line 824 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 1, }); }
#line 7592 "obj/conf/cf-parse.tab.c"
    break;

  case 261: /* constant: FALSE  */
#line 825 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 0, }); }
#line 7598 "obj/conf/cf-parse.tab.c"
    break;

  case 262: /* constant: TEXT  */
#line 826 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_STRING, .val.s = (yyvsp[0].t), }); }
#line 7604 "obj/conf/cf-parse.tab.c"
    break;

  case 263: /* constant: fipa  */
#line 827 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (yyvsp[0].v)); }
#line 7610 "obj/conf/cf-parse.tab.c"
    break;

  case 264: /* constant: VPN_RD  */
#line 828 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_RD, .val.ec = (yyvsp[0].i64), }); }
#line 7616 "obj/conf/cf-parse.tab.c"
    break;

  case 265: /* constant: net_  */
#line 829 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_NET, .val.net = (yyvsp[0].net_ptr), }); }
#line 7622 "obj/conf/cf-parse.tab.c"
    break;

  case 266: /* constant: '[' set_items ']'  */
#line 830 "filter/config.Y"
                     {
     DBG( "We've got a set here..." );
     (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_SET, .val.t = build_tree((yyvsp[-1].e)), });
     DBG( "ook\n" );
 }
#line 7632 "obj/conf/cf-parse.tab.c"
    break;

  case 267: /* constant: '[' fprefix_set ']'  */
#line 835 "filter/config.Y"
                       { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PREFIX_SET, .val.ti = (yyvsp[-1].trie), }); }
#line 7638 "obj/conf/cf-parse.tab.c"
    break;

  case 268: /* constant: ENUM  */
#line 836 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = (yyvsp[0].i) >> 16, .val.i = (yyvsp[0].i) & 0xffff, }); }
#line 7644 "obj/conf/cf-parse.tab.c"
    break;

  case 269: /* constructor: '(' term ',' term ')'  */
#line 840 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_PAIR_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7650 "obj/conf/cf-parse.tab.c"
    break;

  case 270: /* constructor: '(' ec_kind ',' term ',' term ')'  */
#line 841 "filter/config.Y"
                                     { (yyval.x) = f_new_inst(FI_EC_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].ecs)); }
#line 7656 "obj/conf/cf-parse.tab.c"
    break;

  case 271: /* constructor: '(' term ',' term ',' term ')'  */
#line 842 "filter/config.Y"
                                  { (yyval.x) = f_new_inst(FI_LC_CONSTRUCT, (yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7662 "obj/conf/cf-parse.tab.c"
    break;

  case 272: /* constructor: bgp_path  */
#line 843 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_PATHMASK_CONSTRUCT, (yyvsp[0].x)); }
#line 7668 "obj/conf/cf-parse.tab.c"
    break;

  case 273: /* var_list: %empty  */
#line 848 "filter/config.Y"
                      { (yyval.x) = NULL; }
#line 7674 "obj/conf/cf-parse.tab.c"
    break;

  case 274: /* var_list: term  */
#line 849 "filter/config.Y"
        { (yyval.x) = (yyvsp[0].x); }
#line 7680 "obj/conf/cf-parse.tab.c"
    break;

  case 275: /* var_list: var_list ',' term  */
#line 850 "filter/config.Y"
                     { (yyval.x) = (yyvsp[0].x); (yyval.x)->next = (yyvsp[-2].x); }
#line 7686 "obj/conf/cf-parse.tab.c"
    break;

  case 276: /* function_call: CF_SYM_KNOWN '(' var_list ')'  */
#line 853 "filter/config.Y"
                                 {
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");

     struct f_inst *fc = f_new_inst(FI_CALL, (yyvsp[-3].s));
     uint args = 0;
     while ((yyvsp[-1].x)) {
       args++;
       struct f_inst *tmp = (yyvsp[-1].x)->next;
       (yyvsp[-1].x)->next = fc;

       fc = (yyvsp[-1].x);
       (yyvsp[-1].x) = tmp;
     }

     if (args != (yyvsp[-3].s)->function->args)
       cf_error("Function call '%s' got %u arguments, need %u arguments.",
	   (yyvsp[-3].s)->name, args, (yyvsp[-3].s)->function->args);

     (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_VOID });
     (yyval.x)->next = fc;
   }
#line 7713 "obj/conf/cf-parse.tab.c"
    break;

  case 277: /* symbol_value: CF_SYM_KNOWN  */
#line 878 "filter/config.Y"
  {
    switch ((yyvsp[0].s)->class) {
      case SYM_CONSTANT_RANGE:
	(yyval.x) = f_new_inst(FI_CONSTANT, *((yyvsp[0].s)->val));
	break;
      case SYM_VARIABLE_RANGE:
	(yyval.x) = f_new_inst(FI_VAR_GET, (yyvsp[0].s));
	break;
      case SYM_ATTRIBUTE:
	(yyval.x) = f_new_inst(FI_EA_GET, *(yyvsp[0].s)->attribute);
	break;
      default:
	cf_error("Can't get value of symbol %s", (yyvsp[0].s)->name);
    }
  }
#line 7733 "obj/conf/cf-parse.tab.c"
    break;

  case 278: /* static_attr: FROM  */
#line 896 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	0); }
#line 7739 "obj/conf/cf-parse.tab.c"
    break;

  case 279: /* static_attr: GW  */
#line 897 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	0); }
#line 7745 "obj/conf/cf-parse.tab.c"
    break;

  case 280: /* static_attr: NET  */
#line 898 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_NET,	  SA_NET,	1); }
#line 7751 "obj/conf/cf-parse.tab.c"
    break;

  case 281: /* static_attr: PROTO  */
#line 899 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	1); }
#line 7757 "obj/conf/cf-parse.tab.c"
    break;

  case 282: /* static_attr: SOURCE  */
#line 900 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	1); }
#line 7763 "obj/conf/cf-parse.tab.c"
    break;

  case 283: /* static_attr: SCOPE  */
#line 901 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	0); }
#line 7769 "obj/conf/cf-parse.tab.c"
    break;

  case 284: /* static_attr: DEST  */
#line 902 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	0); }
#line 7775 "obj/conf/cf-parse.tab.c"
    break;

  case 285: /* static_attr: IFNAME  */
#line 903 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	0); }
#line 7781 "obj/conf/cf-parse.tab.c"
    break;

  case 286: /* static_attr: IFINDEX  */
#line 904 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	1); }
#line 7787 "obj/conf/cf-parse.tab.c"
    break;

  case 287: /* term: '(' term ')'  */
#line 908 "filter/config.Y"
                        { (yyval.x) = (yyvsp[-1].x); }
#line 7793 "obj/conf/cf-parse.tab.c"
    break;

  case 288: /* term: term '+' term  */
#line 909 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_ADD, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7799 "obj/conf/cf-parse.tab.c"
    break;

  case 289: /* term: term '-' term  */
#line 910 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_SUBTRACT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7805 "obj/conf/cf-parse.tab.c"
    break;

  case 290: /* term: term '*' term  */
#line 911 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_MULTIPLY, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7811 "obj/conf/cf-parse.tab.c"
    break;

  case 291: /* term: term '/' term  */
#line 912 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_DIVIDE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7817 "obj/conf/cf-parse.tab.c"
    break;

  case 292: /* term: term AND term  */
#line 913 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_AND, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7823 "obj/conf/cf-parse.tab.c"
    break;

  case 293: /* term: term OR term  */
#line 914 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_OR, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7829 "obj/conf/cf-parse.tab.c"
    break;

  case 294: /* term: term '=' term  */
#line 915 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_EQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7835 "obj/conf/cf-parse.tab.c"
    break;

  case 295: /* term: term NEQ term  */
#line 916 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NEQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7841 "obj/conf/cf-parse.tab.c"
    break;

  case 296: /* term: term '<' term  */
#line 917 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7847 "obj/conf/cf-parse.tab.c"
    break;

  case 297: /* term: term LEQ term  */
#line 918 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7853 "obj/conf/cf-parse.tab.c"
    break;

  case 298: /* term: term '>' term  */
#line 919 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LT, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 7859 "obj/conf/cf-parse.tab.c"
    break;

  case 299: /* term: term GEQ term  */
#line 920 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 7865 "obj/conf/cf-parse.tab.c"
    break;

  case 300: /* term: term '~' term  */
#line 921 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7871 "obj/conf/cf-parse.tab.c"
    break;

  case 301: /* term: term NMA term  */
#line 922 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NOT_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7877 "obj/conf/cf-parse.tab.c"
    break;

  case 302: /* term: '!' term  */
#line 923 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NOT, (yyvsp[0].x)); }
#line 7883 "obj/conf/cf-parse.tab.c"
    break;

  case 303: /* term: DEFINED '(' term ')'  */
#line 924 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_DEFINED, (yyvsp[-1].x)); }
#line 7889 "obj/conf/cf-parse.tab.c"
    break;

  case 304: /* term: symbol_value  */
#line 926 "filter/config.Y"
                  { (yyval.x) = (yyvsp[0].x); }
#line 7895 "obj/conf/cf-parse.tab.c"
    break;

  case 305: /* term: constant  */
#line 927 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].x); }
#line 7901 "obj/conf/cf-parse.tab.c"
    break;

  case 306: /* term: constructor  */
#line 928 "filter/config.Y"
               { (yyval.x) = (yyvsp[0].x); }
#line 7907 "obj/conf/cf-parse.tab.c"
    break;

  case 307: /* term: PREFERENCE  */
#line 930 "filter/config.Y"
              { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 7913 "obj/conf/cf-parse.tab.c"
    break;

  case 308: /* term: static_attr  */
#line 932 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 7919 "obj/conf/cf-parse.tab.c"
    break;

  case 309: /* term: dynamic_attr  */
#line 934 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_EA_GET, (yyvsp[0].fda)); }
#line 7925 "obj/conf/cf-parse.tab.c"
    break;

  case 310: /* term: term '.' IS_V4  */
#line 936 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_IS_V4, (yyvsp[-2].x)); }
#line 7931 "obj/conf/cf-parse.tab.c"
    break;

  case 311: /* term: term '.' TYPE  */
#line 937 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_TYPE, (yyvsp[-2].x)); }
#line 7937 "obj/conf/cf-parse.tab.c"
    break;

  case 312: /* term: term '.' IP  */
#line 938 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_IP, (yyvsp[-2].x)); }
#line 7943 "obj/conf/cf-parse.tab.c"
    break;

  case 313: /* term: term '.' RD  */
#line 939 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_ROUTE_DISTINGUISHER, (yyvsp[-2].x)); }
#line 7949 "obj/conf/cf-parse.tab.c"
    break;

  case 314: /* term: term '.' LEN  */
#line 940 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_LENGTH, (yyvsp[-2].x)); }
#line 7955 "obj/conf/cf-parse.tab.c"
    break;

  case 315: /* term: term '.' MAXLEN  */
#line 941 "filter/config.Y"
                   { (yyval.x) = f_new_inst(FI_ROA_MAXLEN, (yyvsp[-2].x)); }
#line 7961 "obj/conf/cf-parse.tab.c"
    break;

  case 316: /* term: term '.' ASN  */
#line 942 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_ROA_ASN, (yyvsp[-2].x)); }
#line 7967 "obj/conf/cf-parse.tab.c"
    break;

  case 317: /* term: term '.' SRC  */
#line 943 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_SADR_SRC, (yyvsp[-2].x)); }
#line 7973 "obj/conf/cf-parse.tab.c"
    break;

  case 318: /* term: term '.' MASK '(' term ')'  */
#line 944 "filter/config.Y"
                              { (yyval.x) = f_new_inst(FI_IP_MASK, (yyvsp[-5].x), (yyvsp[-1].x)); }
#line 7979 "obj/conf/cf-parse.tab.c"
    break;

  case 319: /* term: term '.' FIRST  */
#line 945 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST, (yyvsp[-2].x)); }
#line 7985 "obj/conf/cf-parse.tab.c"
    break;

  case 320: /* term: term '.' LAST  */
#line 946 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_AS_PATH_LAST, (yyvsp[-2].x)); }
#line 7991 "obj/conf/cf-parse.tab.c"
    break;

  case 321: /* term: term '.' LAST_NONAGGREGATED  */
#line 947 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG, (yyvsp[-2].x)); }
#line 7997 "obj/conf/cf-parse.tab.c"
    break;

  case 322: /* term: '+' EMPTY '+'  */
#line 957 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_path); }
#line 8003 "obj/conf/cf-parse.tab.c"
    break;

  case 323: /* term: '-' EMPTY '-'  */
#line 958 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_clist); }
#line 8009 "obj/conf/cf-parse.tab.c"
    break;

  case 324: /* term: '-' '-' EMPTY '-' '-'  */
#line 959 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_eclist); }
#line 8015 "obj/conf/cf-parse.tab.c"
    break;

  case 325: /* term: '-' '-' '-' EMPTY '-' '-' '-'  */
#line 960 "filter/config.Y"
                                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_lclist); }
#line 8021 "obj/conf/cf-parse.tab.c"
    break;

  case 326: /* term: PREPEND '(' term ',' term ')'  */
#line 961 "filter/config.Y"
                                 { (yyval.x) = f_new_inst(FI_PATH_PREPEND, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8027 "obj/conf/cf-parse.tab.c"
    break;

  case 327: /* term: ADD '(' term ',' term ')'  */
#line 962 "filter/config.Y"
                             { (yyval.x) = f_new_inst(FI_CLIST_ADD, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8033 "obj/conf/cf-parse.tab.c"
    break;

  case 328: /* term: DELETE '(' term ',' term ')'  */
#line 963 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CLIST_DEL, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8039 "obj/conf/cf-parse.tab.c"
    break;

  case 329: /* term: FILTER '(' term ',' term ')'  */
#line 964 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CLIST_FILTER, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8045 "obj/conf/cf-parse.tab.c"
    break;

  case 330: /* term: ROA_CHECK '(' rtable ')'  */
#line 966 "filter/config.Y"
                            { (yyval.x) = f_new_inst(FI_ROA_CHECK_IMPLICIT, (yyvsp[-1].r)); }
#line 8051 "obj/conf/cf-parse.tab.c"
    break;

  case 331: /* term: ROA_CHECK '(' rtable ',' term ',' term ')'  */
#line 967 "filter/config.Y"
                                              { (yyval.x) = f_new_inst(FI_ROA_CHECK_EXPLICIT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].r)); }
#line 8057 "obj/conf/cf-parse.tab.c"
    break;

  case 332: /* term: FORMAT '(' term ')'  */
#line 969 "filter/config.Y"
                       {  (yyval.x) = f_new_inst(FI_FORMAT, (yyvsp[-1].x)); }
#line 8063 "obj/conf/cf-parse.tab.c"
    break;

  case 334: /* break_command: QUITBIRD  */
#line 977 "filter/config.Y"
            { (yyval.fret) = F_QUITBIRD; }
#line 8069 "obj/conf/cf-parse.tab.c"
    break;

  case 335: /* break_command: ACCEPT  */
#line 978 "filter/config.Y"
          { (yyval.fret) = F_ACCEPT; }
#line 8075 "obj/conf/cf-parse.tab.c"
    break;

  case 336: /* break_command: REJECT  */
#line 979 "filter/config.Y"
          { (yyval.fret) = F_REJECT; }
#line 8081 "obj/conf/cf-parse.tab.c"
    break;

  case 337: /* break_command: ERROR  */
#line 980 "filter/config.Y"
         { (yyval.fret) = F_ERROR; }
#line 8087 "obj/conf/cf-parse.tab.c"
    break;

  case 338: /* print_list: %empty  */
#line 983 "filter/config.Y"
                        { (yyval.x) = NULL; }
#line 8093 "obj/conf/cf-parse.tab.c"
    break;

  case 339: /* print_list: term  */
#line 984 "filter/config.Y"
        { (yyval.x) = (yyvsp[0].x); }
#line 8099 "obj/conf/cf-parse.tab.c"
    break;

  case 340: /* print_list: term ',' print_list  */
#line 985 "filter/config.Y"
                       {
     ASSERT((yyvsp[-2].x));
     ASSERT((yyvsp[-2].x)->next == NULL);
     (yyvsp[-2].x)->next = (yyvsp[0].x);
     (yyval.x) = (yyvsp[-2].x);
   }
#line 8110 "obj/conf/cf-parse.tab.c"
    break;

  case 341: /* cmd: IF term THEN block  */
#line 994 "filter/config.Y"
                      {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-2].x), (yyvsp[0].x), NULL);
   }
#line 8118 "obj/conf/cf-parse.tab.c"
    break;

  case 342: /* cmd: IF term THEN block ELSE block  */
#line 997 "filter/config.Y"
                                 {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-4].x), (yyvsp[-2].x), (yyvsp[0].x));
   }
#line 8126 "obj/conf/cf-parse.tab.c"
    break;

  case 343: /* cmd: CF_SYM_KNOWN '=' term ';'  */
#line 1000 "filter/config.Y"
                             {
     switch ((yyvsp[-3].s)->class) {
       case SYM_VARIABLE_RANGE:
	 (yyval.x) = f_new_inst(FI_VAR_SET, (yyvsp[-1].x), (yyvsp[-3].s));
	 break;
       case SYM_ATTRIBUTE:
	 (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), *(yyvsp[-3].s)->attribute);
	 break;
       default:
	 cf_error("Can't assign to symbol %s", (yyvsp[-3].s)->name);
     }
   }
#line 8143 "obj/conf/cf-parse.tab.c"
    break;

  case 344: /* cmd: RETURN term ';'  */
#line 1012 "filter/config.Y"
                   {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN, (yyvsp[-1].x));
   }
#line 8152 "obj/conf/cf-parse.tab.c"
    break;

  case 345: /* cmd: dynamic_attr '=' term ';'  */
#line 1016 "filter/config.Y"
                             {
     (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), (yyvsp[-3].fda));
   }
#line 8160 "obj/conf/cf-parse.tab.c"
    break;

  case 346: /* cmd: static_attr '=' term ';'  */
#line 1019 "filter/config.Y"
                            {
     if ((yyvsp[-3].fsa).readonly)
       cf_error( "This static attribute is read-only.");
     (yyval.x) = f_new_inst(FI_RTA_SET, (yyvsp[-1].x), (yyvsp[-3].fsa));
   }
#line 8170 "obj/conf/cf-parse.tab.c"
    break;

  case 347: /* cmd: PREFERENCE '=' term ';'  */
#line 1024 "filter/config.Y"
                           {
     (yyval.x) = f_new_inst(FI_PREF_SET, (yyvsp[-1].x));
   }
#line 8178 "obj/conf/cf-parse.tab.c"
    break;

  case 348: /* cmd: UNSET '(' dynamic_attr ')' ';'  */
#line 1027 "filter/config.Y"
                                  {
     (yyval.x) = f_new_inst(FI_EA_UNSET, (yyvsp[-2].fda));
   }
#line 8186 "obj/conf/cf-parse.tab.c"
    break;

  case 349: /* cmd: break_command print_list ';'  */
#line 1030 "filter/config.Y"
                                {
    struct f_inst *breaker = f_new_inst(FI_DIE, (yyvsp[-2].fret));
    if ((yyvsp[-1].x)) {
      struct f_inst *printer = f_new_inst(FI_PRINT, (yyvsp[-1].x));
      struct f_inst *flusher = f_new_inst(FI_FLUSH);
      printer->next = flusher;
      flusher->next = breaker;
      (yyval.x) = printer;
    } else
      (yyval.x) = breaker;
   }
#line 8202 "obj/conf/cf-parse.tab.c"
    break;

  case 350: /* cmd: PRINT print_list ';'  */
#line 1041 "filter/config.Y"
                        {
    (yyval.x) = f_new_inst(FI_PRINT, (yyvsp[-1].x));
    (yyval.x)->next = f_new_inst(FI_FLUSH);
   }
#line 8211 "obj/conf/cf-parse.tab.c"
    break;

  case 351: /* cmd: PRINTN print_list ';'  */
#line 1045 "filter/config.Y"
                         {
    (yyval.x) = f_new_inst(FI_PRINT, (yyvsp[-1].x));
   }
#line 8219 "obj/conf/cf-parse.tab.c"
    break;

  case 352: /* cmd: function_call ';'  */
#line 1048 "filter/config.Y"
                     { (yyval.x) = f_new_inst(FI_DROP_RESULT, (yyvsp[-1].x)); }
#line 8225 "obj/conf/cf-parse.tab.c"
    break;

  case 353: /* cmd: CASE term '{' switch_body '}'  */
#line 1049 "filter/config.Y"
                                 {
      (yyval.x) = f_new_inst(FI_SWITCH, (yyvsp[-3].x), build_tree((yyvsp[-1].e)));
   }
#line 8233 "obj/conf/cf-parse.tab.c"
    break;

  case 354: /* cmd: dynamic_attr '.' EMPTY ';'  */
#line 1053 "filter/config.Y"
                              { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 8239 "obj/conf/cf-parse.tab.c"
    break;

  case 355: /* cmd: dynamic_attr '.' PREPEND '(' term ')' ';'  */
#line 1054 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8245 "obj/conf/cf-parse.tab.c"
    break;

  case 356: /* cmd: dynamic_attr '.' ADD '(' term ')' ';'  */
#line 1055 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_ADD, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8251 "obj/conf/cf-parse.tab.c"
    break;

  case 357: /* cmd: dynamic_attr '.' DELETE '(' term ')' ';'  */
#line 1056 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_DEL, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8257 "obj/conf/cf-parse.tab.c"
    break;

  case 358: /* cmd: dynamic_attr '.' FILTER '(' term ')' ';'  */
#line 1057 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_FILTER, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8263 "obj/conf/cf-parse.tab.c"
    break;

  case 359: /* cmd: BT_ASSERT '(' get_cf_position term get_cf_position ')' ';'  */
#line 1058 "filter/config.Y"
                                                              { (yyval.x) = assert_done((yyvsp[-3].x), (yyvsp[-4].t) + 1, (yyvsp[-2].t) - 1); }
#line 8269 "obj/conf/cf-parse.tab.c"
    break;

  case 360: /* cmd: BT_CHECK_ASSIGN '(' get_cf_position lvalue get_cf_position ',' term ')' ';'  */
#line 1059 "filter/config.Y"
                                                                               { (yyval.x) = assert_assign(&(yyvsp[-5].flv), (yyvsp[-2].x), (yyvsp[-6].t) + 1, (yyvsp[-4].t) - 1); }
#line 8275 "obj/conf/cf-parse.tab.c"
    break;

  case 361: /* get_cf_position: %empty  */
#line 1063 "filter/config.Y"
{
  (yyval.t) = cf_text;
}
#line 8283 "obj/conf/cf-parse.tab.c"
    break;

  case 362: /* lvalue: CF_SYM_KNOWN  */
#line 1068 "filter/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_VARIABLE); (yyval.flv) = (struct f_lval) { .type = F_LVAL_VARIABLE, .sym = (yyvsp[0].s) }; }
#line 8289 "obj/conf/cf-parse.tab.c"
    break;

  case 363: /* lvalue: PREFERENCE  */
#line 1069 "filter/config.Y"
              { (yyval.flv) = (struct f_lval) { .type = F_LVAL_PREFERENCE }; }
#line 8295 "obj/conf/cf-parse.tab.c"
    break;

  case 364: /* lvalue: static_attr  */
#line 1070 "filter/config.Y"
               { (yyval.flv) = (struct f_lval) { .type = F_LVAL_SA, .sa = (yyvsp[0].fsa) }; }
#line 8301 "obj/conf/cf-parse.tab.c"
    break;

  case 365: /* lvalue: dynamic_attr  */
#line 1071 "filter/config.Y"
                { (yyval.flv) = (struct f_lval) { .type = F_LVAL_EA, .da = (yyvsp[0].fda) }; }
#line 8307 "obj/conf/cf-parse.tab.c"
    break;

  case 367: /* rtrid: ROUTER ID idval ';'  */
#line 109 "nest/config.Y"
                       { new_config->router_id = (yyvsp[-1].i32); }
#line 8313 "obj/conf/cf-parse.tab.c"
    break;

  case 368: /* rtrid: ROUTER ID FROM iface_patt ';'  */
#line 110 "nest/config.Y"
                                 { new_config->router_id_from = this_ipatt; }
#line 8319 "obj/conf/cf-parse.tab.c"
    break;

  case 369: /* idval: NUM  */
#line 114 "nest/config.Y"
       { (yyval.i32) = (yyvsp[0].i); }
#line 8325 "obj/conf/cf-parse.tab.c"
    break;

  case 370: /* idval: '(' term ')'  */
#line 115 "nest/config.Y"
                { (yyval.i32) = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 8331 "obj/conf/cf-parse.tab.c"
    break;

  case 371: /* idval: IP4  */
#line 116 "nest/config.Y"
       { (yyval.i32) = ip4_to_u32((yyvsp[0].ip4)); }
#line 8337 "obj/conf/cf-parse.tab.c"
    break;

  case 372: /* idval: CF_SYM_KNOWN  */
#line 117 "nest/config.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP)) && ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).ip);
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 8350 "obj/conf/cf-parse.tab.c"
    break;

  case 374: /* gr_opts: GRACEFUL RESTART WAIT expr ';'  */
#line 129 "nest/config.Y"
                                        { new_config->gr_wait = (yyvsp[-1].i); }
#line 8356 "obj/conf/cf-parse.tab.c"
    break;

  case 375: /* net_type: IPV4  */
#line 135 "nest/config.Y"
        { (yyval.i) = NET_IP4; }
#line 8362 "obj/conf/cf-parse.tab.c"
    break;

  case 376: /* net_type: IPV6  */
#line 136 "nest/config.Y"
        { (yyval.i) = NET_IP6; }
#line 8368 "obj/conf/cf-parse.tab.c"
    break;

  case 377: /* net_type: IPV6 SADR  */
#line 137 "nest/config.Y"
             { (yyval.i) = NET_IP6_SADR; }
#line 8374 "obj/conf/cf-parse.tab.c"
    break;

  case 378: /* net_type: VPN4  */
#line 138 "nest/config.Y"
        { (yyval.i) = NET_VPN4; }
#line 8380 "obj/conf/cf-parse.tab.c"
    break;

  case 379: /* net_type: VPN6  */
#line 139 "nest/config.Y"
        { (yyval.i) = NET_VPN6; }
#line 8386 "obj/conf/cf-parse.tab.c"
    break;

  case 380: /* net_type: ROA4  */
#line 140 "nest/config.Y"
        { (yyval.i) = NET_ROA4; }
#line 8392 "obj/conf/cf-parse.tab.c"
    break;

  case 381: /* net_type: ROA6  */
#line 141 "nest/config.Y"
        { (yyval.i) = NET_ROA6; }
#line 8398 "obj/conf/cf-parse.tab.c"
    break;

  case 382: /* net_type: FLOW4  */
#line 142 "nest/config.Y"
        { (yyval.i) = NET_FLOW4; }
#line 8404 "obj/conf/cf-parse.tab.c"
    break;

  case 383: /* net_type: FLOW6  */
#line 143 "nest/config.Y"
        { (yyval.i) = NET_FLOW6; }
#line 8410 "obj/conf/cf-parse.tab.c"
    break;

  case 384: /* net_type: MPLS  */
#line 144 "nest/config.Y"
        { (yyval.i) = NET_MPLS; }
#line 8416 "obj/conf/cf-parse.tab.c"
    break;

  case 386: /* table_sorted: %empty  */
#line 155 "nest/config.Y"
          { (yyval.i) = 0; }
#line 8422 "obj/conf/cf-parse.tab.c"
    break;

  case 387: /* table_sorted: SORTED  */
#line 156 "nest/config.Y"
          { (yyval.i) = 1; }
#line 8428 "obj/conf/cf-parse.tab.c"
    break;

  case 388: /* table: net_type TABLE symbol table_sorted  */
#line 159 "nest/config.Y"
                                          {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s), (yyvsp[-3].i));
   cf->sorted = (yyvsp[0].i);
   }
#line 8438 "obj/conf/cf-parse.tab.c"
    break;

  case 389: /* conf: proto  */
#line 169 "nest/config.Y"
            { proto_postconfig(); }
#line 8444 "obj/conf/cf-parse.tab.c"
    break;

  case 390: /* proto_start: PROTOCOL  */
#line 172 "nest/config.Y"
            { (yyval.i) = SYM_PROTO; }
#line 8450 "obj/conf/cf-parse.tab.c"
    break;

  case 391: /* proto_start: TEMPLATE  */
#line 173 "nest/config.Y"
            { (yyval.i) = SYM_TEMPLATE; }
#line 8456 "obj/conf/cf-parse.tab.c"
    break;

  case 392: /* proto_name: %empty  */
#line 177 "nest/config.Y"
               {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;
     }
#line 8467 "obj/conf/cf-parse.tab.c"
    break;

  case 393: /* proto_name: symbol  */
#line 183 "nest/config.Y"
          {
     cf_define_symbol((yyvsp[0].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 8476 "obj/conf/cf-parse.tab.c"
    break;

  case 394: /* proto_name: FROM CF_SYM_KNOWN  */
#line 187 "nest/config.Y"
                     {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 8491 "obj/conf/cf-parse.tab.c"
    break;

  case 395: /* proto_name: symbol FROM CF_SYM_KNOWN  */
#line 197 "nest/config.Y"
                            {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 8504 "obj/conf/cf-parse.tab.c"
    break;

  case 397: /* proto_item: DISABLED bool  */
#line 209 "nest/config.Y"
                 { this_proto->disabled = (yyvsp[0].i); }
#line 8510 "obj/conf/cf-parse.tab.c"
    break;

  case 398: /* proto_item: DEBUG debug_mask  */
#line 210 "nest/config.Y"
                    { this_proto->debug = (yyvsp[0].i); }
#line 8516 "obj/conf/cf-parse.tab.c"
    break;

  case 399: /* proto_item: MRTDUMP mrtdump_mask  */
#line 211 "nest/config.Y"
                        { this_proto->mrtdump = (yyvsp[0].i); }
#line 8522 "obj/conf/cf-parse.tab.c"
    break;

  case 400: /* proto_item: ROUTER ID idval  */
#line 212 "nest/config.Y"
                   { this_proto->router_id = (yyvsp[0].i32); }
#line 8528 "obj/conf/cf-parse.tab.c"
    break;

  case 401: /* proto_item: DESCRIPTION text  */
#line 213 "nest/config.Y"
                    { this_proto->dsc = (yyvsp[0].t); }
#line 8534 "obj/conf/cf-parse.tab.c"
    break;

  case 402: /* proto_item: VRF text  */
#line 214 "nest/config.Y"
            { this_proto->vrf = if_get_by_name((yyvsp[0].t)); this_proto->vrf_set = 1; }
#line 8540 "obj/conf/cf-parse.tab.c"
    break;

  case 403: /* proto_item: VRF DEFAULT  */
#line 215 "nest/config.Y"
               { this_proto->vrf = NULL; this_proto->vrf_set = 1; }
#line 8546 "obj/conf/cf-parse.tab.c"
    break;

  case 404: /* channel_start: net_type  */
#line 220 "nest/config.Y"
{
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[0].i)], (yyvsp[0].i), this_proto);
}
#line 8554 "obj/conf/cf-parse.tab.c"
    break;

  case 405: /* channel_item: TABLE rtable  */
#line 225 "nest/config.Y"
                {
     if (this_channel->net_type && ((yyvsp[0].r)->addr_type != this_channel->net_type))
       cf_error("Incompatible table type");
     this_channel->table = (yyvsp[0].r);
   }
#line 8564 "obj/conf/cf-parse.tab.c"
    break;

  case 406: /* channel_item: IMPORT imexport  */
#line 230 "nest/config.Y"
                   { this_channel->in_filter = (yyvsp[0].f); }
#line 8570 "obj/conf/cf-parse.tab.c"
    break;

  case 407: /* channel_item: EXPORT imexport  */
#line 231 "nest/config.Y"
                   { this_channel->out_filter = (yyvsp[0].f); }
#line 8576 "obj/conf/cf-parse.tab.c"
    break;

  case 408: /* channel_item: RECEIVE LIMIT limit_spec  */
#line 232 "nest/config.Y"
                            { this_channel->rx_limit = (yyvsp[0].cl); }
#line 8582 "obj/conf/cf-parse.tab.c"
    break;

  case 409: /* channel_item: IMPORT LIMIT limit_spec  */
#line 233 "nest/config.Y"
                           { this_channel->in_limit = (yyvsp[0].cl); }
#line 8588 "obj/conf/cf-parse.tab.c"
    break;

  case 410: /* channel_item: EXPORT LIMIT limit_spec  */
#line 234 "nest/config.Y"
                           { this_channel->out_limit = (yyvsp[0].cl); }
#line 8594 "obj/conf/cf-parse.tab.c"
    break;

  case 411: /* channel_item: PREFERENCE expr  */
#line 235 "nest/config.Y"
                   { this_channel->preference = (yyvsp[0].i); check_u16((yyvsp[0].i)); }
#line 8600 "obj/conf/cf-parse.tab.c"
    break;

  case 412: /* channel_item: IMPORT KEEP FILTERED bool  */
#line 236 "nest/config.Y"
                             { this_channel->in_keep_filtered = (yyvsp[0].i); }
#line 8606 "obj/conf/cf-parse.tab.c"
    break;

  case 417: /* channel_end: %empty  */
#line 250 "nest/config.Y"
{
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 8617 "obj/conf/cf-parse.tab.c"
    break;

  case 419: /* rtable: CF_SYM_KNOWN  */
#line 260 "nest/config.Y"
                     { cf_assert_symbol((yyvsp[0].s), SYM_TABLE); (yyval.r) = (yyvsp[0].s)->table; }
#line 8623 "obj/conf/cf-parse.tab.c"
    break;

  case 420: /* imexport: FILTER filter  */
#line 263 "nest/config.Y"
                 { (yyval.f) = (yyvsp[0].f); }
#line 8629 "obj/conf/cf-parse.tab.c"
    break;

  case 422: /* imexport: ALL  */
#line 265 "nest/config.Y"
       { (yyval.f) = FILTER_ACCEPT; }
#line 8635 "obj/conf/cf-parse.tab.c"
    break;

  case 423: /* imexport: NONE  */
#line 266 "nest/config.Y"
        { (yyval.f) = FILTER_REJECT; }
#line 8641 "obj/conf/cf-parse.tab.c"
    break;

  case 424: /* limit_action: %empty  */
#line 270 "nest/config.Y"
                 { (yyval.i) = PLA_DISABLE; }
#line 8647 "obj/conf/cf-parse.tab.c"
    break;

  case 425: /* limit_action: ACTION WARN  */
#line 271 "nest/config.Y"
               { (yyval.i) = PLA_WARN; }
#line 8653 "obj/conf/cf-parse.tab.c"
    break;

  case 426: /* limit_action: ACTION BLOCK  */
#line 272 "nest/config.Y"
                { (yyval.i) = PLA_BLOCK; }
#line 8659 "obj/conf/cf-parse.tab.c"
    break;

  case 427: /* limit_action: ACTION RESTART  */
#line 273 "nest/config.Y"
                  { (yyval.i) = PLA_RESTART; }
#line 8665 "obj/conf/cf-parse.tab.c"
    break;

  case 428: /* limit_action: ACTION DISABLE  */
#line 274 "nest/config.Y"
                  { (yyval.i) = PLA_DISABLE; }
#line 8671 "obj/conf/cf-parse.tab.c"
    break;

  case 429: /* limit_spec: expr limit_action  */
#line 278 "nest/config.Y"
                     { (yyval.cl) = (struct channel_limit){ .limit = (yyvsp[-1].i), (yyval.cl).action = (yyvsp[0].i) }; }
#line 8677 "obj/conf/cf-parse.tab.c"
    break;

  case 430: /* limit_spec: OFF  */
#line 279 "nest/config.Y"
       { (yyval.cl) = (struct channel_limit){}; }
#line 8683 "obj/conf/cf-parse.tab.c"
    break;

  case 432: /* debug_default: DEBUG PROTOCOLS debug_mask  */
#line 286 "nest/config.Y"
                              { new_config->proto_default_debug = (yyvsp[0].i); }
#line 8689 "obj/conf/cf-parse.tab.c"
    break;

  case 433: /* debug_default: DEBUG COMMANDS expr  */
#line 287 "nest/config.Y"
                       { new_config->cli_debug = (yyvsp[0].i); }
#line 8695 "obj/conf/cf-parse.tab.c"
    break;

  case 435: /* timeformat_which: ROUTE  */
#line 295 "nest/config.Y"
         { (yyval.tf) = &new_config->tf_route; }
#line 8701 "obj/conf/cf-parse.tab.c"
    break;

  case 436: /* timeformat_which: PROTOCOL  */
#line 296 "nest/config.Y"
            { (yyval.tf) = &new_config->tf_proto; }
#line 8707 "obj/conf/cf-parse.tab.c"
    break;

  case 437: /* timeformat_which: BASE  */
#line 297 "nest/config.Y"
        { (yyval.tf) = &new_config->tf_base; }
#line 8713 "obj/conf/cf-parse.tab.c"
    break;

  case 438: /* timeformat_which: LOG  */
#line 298 "nest/config.Y"
       { (yyval.tf) = &new_config->tf_log; }
#line 8719 "obj/conf/cf-parse.tab.c"
    break;

  case 439: /* timeformat_spec: timeformat_which TEXT  */
#line 302 "nest/config.Y"
                         { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 8725 "obj/conf/cf-parse.tab.c"
    break;

  case 440: /* timeformat_spec: timeformat_which TEXT expr TEXT  */
#line 303 "nest/config.Y"
                                   { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (s64) (yyvsp[-1].i) S_}; }
#line 8731 "obj/conf/cf-parse.tab.c"
    break;

  case 441: /* timeformat_spec: timeformat_which ISO SHORT  */
#line 304 "nest/config.Y"
                                 { *(yyvsp[-2].tf) = TM_ISO_SHORT_S; }
#line 8737 "obj/conf/cf-parse.tab.c"
    break;

  case 442: /* timeformat_spec: timeformat_which ISO SHORT MS  */
#line 305 "nest/config.Y"
                                 { *(yyvsp[-3].tf) = TM_ISO_SHORT_MS; }
#line 8743 "obj/conf/cf-parse.tab.c"
    break;

  case 443: /* timeformat_spec: timeformat_which ISO SHORT US  */
#line 306 "nest/config.Y"
                                 { *(yyvsp[-3].tf) = TM_ISO_SHORT_US; }
#line 8749 "obj/conf/cf-parse.tab.c"
    break;

  case 444: /* timeformat_spec: timeformat_which ISO LONG  */
#line 307 "nest/config.Y"
                                { *(yyvsp[-2].tf) = TM_ISO_LONG_S; }
#line 8755 "obj/conf/cf-parse.tab.c"
    break;

  case 445: /* timeformat_spec: timeformat_which ISO LONG MS  */
#line 308 "nest/config.Y"
                                { *(yyvsp[-3].tf) = TM_ISO_LONG_MS; }
#line 8761 "obj/conf/cf-parse.tab.c"
    break;

  case 446: /* timeformat_spec: timeformat_which ISO LONG US  */
#line 309 "nest/config.Y"
                                { *(yyvsp[-3].tf) = TM_ISO_LONG_US; }
#line 8767 "obj/conf/cf-parse.tab.c"
    break;

  case 448: /* iface_patt_node_init: %empty  */
#line 320 "nest/config.Y"
               {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 8777 "obj/conf/cf-parse.tab.c"
    break;

  case 449: /* iface_patt_node_body: TEXT  */
#line 328 "nest/config.Y"
        { this_ipn->pattern = (yyvsp[0].t); /* this_ipn->prefix stays zero */ }
#line 8783 "obj/conf/cf-parse.tab.c"
    break;

  case 450: /* iface_patt_node_body: opttext net_or_ipa  */
#line 329 "nest/config.Y"
                      { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].net); }
#line 8789 "obj/conf/cf-parse.tab.c"
    break;

  case 451: /* iface_negate: %empty  */
#line 333 "nest/config.Y"
       { this_ipn->positive = 1; }
#line 8795 "obj/conf/cf-parse.tab.c"
    break;

  case 452: /* iface_negate: '-'  */
#line 334 "nest/config.Y"
       { this_ipn->positive = 0; }
#line 8801 "obj/conf/cf-parse.tab.c"
    break;

  case 456: /* iface_patt_list_nopx: iface_patt_list  */
#line 348 "nest/config.Y"
                                      { iface_patt_check(); }
#line 8807 "obj/conf/cf-parse.tab.c"
    break;

  case 457: /* iface_patt_init: %empty  */
#line 350 "nest/config.Y"
                 {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 8817 "obj/conf/cf-parse.tab.c"
    break;

  case 459: /* tos: CLASS expr  */
#line 362 "nest/config.Y"
              { (yyval.i) = (yyvsp[0].i) & 0xfc;        if ((yyvsp[0].i) > 255) cf_error("TX class must be in range 0-255"); }
#line 8823 "obj/conf/cf-parse.tab.c"
    break;

  case 460: /* tos: DSCP expr  */
#line 363 "nest/config.Y"
              { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if ((yyvsp[0].i) > 63)  cf_error("TX DSCP must be in range 0-63"); }
#line 8829 "obj/conf/cf-parse.tab.c"
    break;

  case 462: /* dev_proto_start: proto_start DIRECT  */
#line 370 "nest/config.Y"
                                    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 8838 "obj/conf/cf-parse.tab.c"
    break;

  case 467: /* dev_proto: dev_proto CHECK LINK bool ';'  */
#line 381 "nest/config.Y"
                                 { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 8844 "obj/conf/cf-parse.tab.c"
    break;

  case 468: /* dev_iface_init: %empty  */
#line 385 "nest/config.Y"
               {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 8854 "obj/conf/cf-parse.tab.c"
    break;

  case 470: /* debug_mask: ALL  */
#line 399 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 8860 "obj/conf/cf-parse.tab.c"
    break;

  case 471: /* debug_mask: OFF  */
#line 400 "nest/config.Y"
       { (yyval.i) = 0; }
#line 8866 "obj/conf/cf-parse.tab.c"
    break;

  case 472: /* debug_mask: '{' debug_list '}'  */
#line 401 "nest/config.Y"
                      { (yyval.i) = (yyvsp[-1].i); }
#line 8872 "obj/conf/cf-parse.tab.c"
    break;

  case 474: /* debug_list: debug_list ',' debug_flag  */
#line 406 "nest/config.Y"
                             { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 8878 "obj/conf/cf-parse.tab.c"
    break;

  case 475: /* debug_flag: STATES  */
#line 410 "nest/config.Y"
                { (yyval.i) = D_STATES; }
#line 8884 "obj/conf/cf-parse.tab.c"
    break;

  case 476: /* debug_flag: ROUTES  */
#line 411 "nest/config.Y"
                { (yyval.i) = D_ROUTES; }
#line 8890 "obj/conf/cf-parse.tab.c"
    break;

  case 477: /* debug_flag: FILTERS  */
#line 412 "nest/config.Y"
                { (yyval.i) = D_FILTERS; }
#line 8896 "obj/conf/cf-parse.tab.c"
    break;

  case 478: /* debug_flag: INTERFACES  */
#line 413 "nest/config.Y"
                { (yyval.i) = D_IFACES; }
#line 8902 "obj/conf/cf-parse.tab.c"
    break;

  case 479: /* debug_flag: EVENTS  */
#line 414 "nest/config.Y"
                { (yyval.i) = D_EVENTS; }
#line 8908 "obj/conf/cf-parse.tab.c"
    break;

  case 480: /* debug_flag: PACKETS  */
#line 415 "nest/config.Y"
                { (yyval.i) = D_PACKETS; }
#line 8914 "obj/conf/cf-parse.tab.c"
    break;

  case 481: /* mrtdump_mask: ALL  */
#line 421 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 8920 "obj/conf/cf-parse.tab.c"
    break;

  case 482: /* mrtdump_mask: OFF  */
#line 422 "nest/config.Y"
       { (yyval.i) = 0; }
#line 8926 "obj/conf/cf-parse.tab.c"
    break;

  case 483: /* mrtdump_mask: '{' mrtdump_list '}'  */
#line 423 "nest/config.Y"
                        { (yyval.i) = (yyvsp[-1].i); }
#line 8932 "obj/conf/cf-parse.tab.c"
    break;

  case 485: /* mrtdump_list: mrtdump_list ',' mrtdump_flag  */
#line 428 "nest/config.Y"
                                 { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 8938 "obj/conf/cf-parse.tab.c"
    break;

  case 486: /* mrtdump_flag: STATES  */
#line 432 "nest/config.Y"
                { (yyval.i) = MD_STATES; }
#line 8944 "obj/conf/cf-parse.tab.c"
    break;

  case 487: /* mrtdump_flag: MESSAGES  */
#line 433 "nest/config.Y"
                { (yyval.i) = MD_MESSAGES; }
#line 8950 "obj/conf/cf-parse.tab.c"
    break;

  case 494: /* password_item_begin: PASSWORD text  */
#line 454 "nest/config.Y"
                 {
     if (!this_p_list) {
	this_p_list = cfg_alloc(sizeof(list));
	init_list(this_p_list);
	password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 8972 "obj/conf/cf-parse.tab.c"
    break;

  case 495: /* password_item_params: %empty  */
#line 474 "nest/config.Y"
               { }
#line 8978 "obj/conf/cf-parse.tab.c"
    break;

  case 496: /* password_item_params: GENERATE FROM time ';' password_item_params  */
#line 475 "nest/config.Y"
                                               { this_p_item->genfrom = (yyvsp[-2].time); }
#line 8984 "obj/conf/cf-parse.tab.c"
    break;

  case 497: /* password_item_params: GENERATE TO time ';' password_item_params  */
#line 476 "nest/config.Y"
                                             { this_p_item->gento = (yyvsp[-2].time); }
#line 8990 "obj/conf/cf-parse.tab.c"
    break;

  case 498: /* password_item_params: ACCEPT FROM time ';' password_item_params  */
#line 477 "nest/config.Y"
                                             { this_p_item->accfrom = (yyvsp[-2].time); }
#line 8996 "obj/conf/cf-parse.tab.c"
    break;

  case 499: /* password_item_params: ACCEPT TO time ';' password_item_params  */
#line 478 "nest/config.Y"
                                           { this_p_item->accto = (yyvsp[-2].time); }
#line 9002 "obj/conf/cf-parse.tab.c"
    break;

  case 500: /* password_item_params: FROM time ';' password_item_params  */
#line 479 "nest/config.Y"
                                      { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 9008 "obj/conf/cf-parse.tab.c"
    break;

  case 501: /* password_item_params: TO time ';' password_item_params  */
#line 480 "nest/config.Y"
                                    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 9014 "obj/conf/cf-parse.tab.c"
    break;

  case 502: /* password_item_params: ID expr ';' password_item_params  */
#line 481 "nest/config.Y"
                                    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 9020 "obj/conf/cf-parse.tab.c"
    break;

  case 503: /* password_item_params: ALGORITHM password_algorithm ';' password_item_params  */
#line 482 "nest/config.Y"
                                                         { this_p_item->alg = (yyvsp[-2].i); }
#line 9026 "obj/conf/cf-parse.tab.c"
    break;

  case 504: /* password_algorithm: KEYED MD5  */
#line 486 "nest/config.Y"
                { (yyval.i) = ALG_MD5; }
#line 9032 "obj/conf/cf-parse.tab.c"
    break;

  case 505: /* password_algorithm: KEYED SHA1  */
#line 487 "nest/config.Y"
                { (yyval.i) = ALG_SHA1; }
#line 9038 "obj/conf/cf-parse.tab.c"
    break;

  case 506: /* password_algorithm: KEYED SHA256  */
#line 488 "nest/config.Y"
                { (yyval.i) = ALG_SHA256; }
#line 9044 "obj/conf/cf-parse.tab.c"
    break;

  case 507: /* password_algorithm: KEYED SHA384  */
#line 489 "nest/config.Y"
                { (yyval.i) = ALG_SHA384; }
#line 9050 "obj/conf/cf-parse.tab.c"
    break;

  case 508: /* password_algorithm: KEYED SHA512  */
#line 490 "nest/config.Y"
                { (yyval.i) = ALG_SHA512; }
#line 9056 "obj/conf/cf-parse.tab.c"
    break;

  case 509: /* password_algorithm: HMAC MD5  */
#line 491 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_MD5; }
#line 9062 "obj/conf/cf-parse.tab.c"
    break;

  case 510: /* password_algorithm: HMAC SHA1  */
#line 492 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA1; }
#line 9068 "obj/conf/cf-parse.tab.c"
    break;

  case 511: /* password_algorithm: HMAC SHA256  */
#line 493 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA256; }
#line 9074 "obj/conf/cf-parse.tab.c"
    break;

  case 512: /* password_algorithm: HMAC SHA384  */
#line 494 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA384; }
#line 9080 "obj/conf/cf-parse.tab.c"
    break;

  case 513: /* password_algorithm: HMAC SHA512  */
#line 495 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA512; }
#line 9086 "obj/conf/cf-parse.tab.c"
    break;

  case 515: /* cmd_SHOW_STATUS: SHOW STATUS END  */
#line 502 "nest/config.Y"
{ cmd_show_status(); }
#line 9092 "obj/conf/cf-parse.tab.c"
    break;

  case 517: /* cmd_SHOW_MEMORY: SHOW MEMORY END  */
#line 505 "nest/config.Y"
{ cmd_show_memory(); }
#line 9098 "obj/conf/cf-parse.tab.c"
    break;

  case 519: /* cmd_SHOW_PROTOCOLS: SHOW PROTOCOLS proto_patt2 END  */
#line 508 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 9104 "obj/conf/cf-parse.tab.c"
    break;

  case 521: /* cmd_SHOW_PROTOCOLS_ALL: SHOW PROTOCOLS ALL proto_patt2 END  */
#line 511 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 9110 "obj/conf/cf-parse.tab.c"
    break;

  case 522: /* optproto: CF_SYM_KNOWN  */
#line 514 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.s) = (yyvsp[0].s); }
#line 9116 "obj/conf/cf-parse.tab.c"
    break;

  case 523: /* optproto: %empty  */
#line 515 "nest/config.Y"
               { (yyval.s) = NULL; }
#line 9122 "obj/conf/cf-parse.tab.c"
    break;

  case 525: /* cmd_SHOW_INTERFACES: SHOW INTERFACES END  */
#line 519 "nest/config.Y"
{ if_show(); }
#line 9128 "obj/conf/cf-parse.tab.c"
    break;

  case 527: /* cmd_SHOW_INTERFACES_SUMMARY: SHOW INTERFACES SUMMARY END  */
#line 522 "nest/config.Y"
{ if_show_summary(); }
#line 9134 "obj/conf/cf-parse.tab.c"
    break;

  case 529: /* cmd_SHOW_ROUTE: SHOW ROUTE r_args END  */
#line 526 "nest/config.Y"
{ rt_show((yyvsp[-1].ra)); }
#line 9140 "obj/conf/cf-parse.tab.c"
    break;

  case 530: /* r_args: %empty  */
#line 529 "nest/config.Y"
               {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     init_list(&((yyval.ra)->tables));
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->running_on_config = new_config->fallback;
   }
#line 9151 "obj/conf/cf-parse.tab.c"
    break;

  case 531: /* r_args: r_args net_any  */
#line 535 "nest/config.Y"
                  {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
   }
#line 9161 "obj/conf/cf-parse.tab.c"
    break;

  case 532: /* r_args: r_args FOR r_args_for  */
#line 540 "nest/config.Y"
                         {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->show_for = 1;
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
   }
#line 9172 "obj/conf/cf-parse.tab.c"
    break;

  case 533: /* r_args: r_args TABLE CF_SYM_KNOWN  */
#line 546 "nest/config.Y"
                             {
     cf_assert_symbol((yyvsp[0].s), SYM_TABLE);
     (yyval.ra) = (yyvsp[-2].ra);
     rt_show_add_table((yyval.ra), (yyvsp[0].s)->table->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9183 "obj/conf/cf-parse.tab.c"
    break;

  case 534: /* r_args: r_args TABLE ALL  */
#line 552 "nest/config.Y"
                    {
     struct rtable_config *t;
     (yyval.ra) = (yyvsp[-2].ra);
     WALK_LIST(t, config->tables)
       rt_show_add_table((yyval.ra), t->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_ALL;
   }
#line 9195 "obj/conf/cf-parse.tab.c"
    break;

  case 535: /* r_args: r_args IMPORT TABLE CF_SYM_KNOWN '.' r_args_channel  */
#line 559 "nest/config.Y"
                                                       {
     cf_assert_symbol((yyvsp[-2].s), SYM_PROTO);
     (yyval.ra) = (yyvsp[-5].ra);
     struct proto_config *cf = (yyvsp[-2].s)->proto;
     if (!cf->proto) cf_error("%s is not a protocol", (yyvsp[-2].s)->name);
     struct channel *c = proto_find_channel_by_name(cf->proto, (yyvsp[0].t));
     if (!c) cf_error("Channel %s.%s not found", (yyvsp[-2].s)->name, (yyvsp[0].t));
     if (!c->in_table) cf_error("No import table in channel %s.%s", (yyvsp[-2].s)->name, (yyvsp[0].t));
     rt_show_add_table((yyval.ra), c->in_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9211 "obj/conf/cf-parse.tab.c"
    break;

  case 536: /* r_args: r_args EXPORT TABLE CF_SYM_KNOWN '.' r_args_channel  */
#line 570 "nest/config.Y"
                                                       {
     cf_assert_symbol((yyvsp[-2].s), SYM_PROTO);
     (yyval.ra) = (yyvsp[-5].ra);
     struct proto_config *cf = (yyvsp[-2].s)->proto;
     if (!cf->proto) cf_error("%s is not a protocol", (yyvsp[-2].s)->name);
     struct channel *c = proto_find_channel_by_name(cf->proto, (yyvsp[0].t));
     if (!c) cf_error("Channel %s.%s not found", (yyvsp[-2].s)->name, (yyvsp[0].t));
     if (!c->out_table) cf_error("No export table in channel %s.%s", (yyvsp[-2].s)->name, (yyvsp[0].t));
     rt_show_add_table((yyval.ra), c->out_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9227 "obj/conf/cf-parse.tab.c"
    break;

  case 537: /* r_args: r_args FILTER filter  */
#line 581 "nest/config.Y"
                        {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 9237 "obj/conf/cf-parse.tab.c"
    break;

  case 538: /* r_args: r_args where_filter  */
#line 586 "nest/config.Y"
                       {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 9247 "obj/conf/cf-parse.tab.c"
    break;

  case 539: /* r_args: r_args ALL  */
#line 591 "nest/config.Y"
              {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 9256 "obj/conf/cf-parse.tab.c"
    break;

  case 540: /* r_args: r_args PRIMARY  */
#line 595 "nest/config.Y"
                  {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 9265 "obj/conf/cf-parse.tab.c"
    break;

  case 541: /* r_args: r_args FILTERED  */
#line 599 "nest/config.Y"
                   {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 9274 "obj/conf/cf-parse.tab.c"
    break;

  case 542: /* r_args: r_args export_mode CF_SYM_KNOWN  */
#line 603 "nest/config.Y"
                                   {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9289 "obj/conf/cf-parse.tab.c"
    break;

  case 543: /* r_args: r_args export_mode CF_SYM_KNOWN '.' r_args_channel  */
#line 613 "nest/config.Y"
                                                      {
     cf_assert_symbol((yyvsp[-2].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[-2].s)->proto;
     (yyval.ra) = (yyvsp[-4].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[-2].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-3].i);
     (yyval.ra)->export_channel = proto_find_channel_by_name(c->proto, (yyvsp[0].t));
     if (!(yyval.ra)->export_channel) cf_error("Export channel not found");
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9305 "obj/conf/cf-parse.tab.c"
    break;

  case 544: /* r_args: r_args PROTOCOL CF_SYM_KNOWN  */
#line 624 "nest/config.Y"
                                {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9319 "obj/conf/cf-parse.tab.c"
    break;

  case 545: /* r_args: r_args STATS  */
#line 633 "nest/config.Y"
                {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 9328 "obj/conf/cf-parse.tab.c"
    break;

  case 546: /* r_args: r_args COUNT  */
#line 637 "nest/config.Y"
                {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 9337 "obj/conf/cf-parse.tab.c"
    break;

  case 547: /* r_args_for: r_args_for_val  */
#line 644 "nest/config.Y"
                 {
    (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length);
    net_copy((yyval.net_ptr), &(yyvsp[0].net));
  }
#line 9346 "obj/conf/cf-parse.tab.c"
    break;

  case 551: /* r_args_for: VPN_RD IP4  */
#line 651 "nest/config.Y"
              {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
    net_fill_vpn4((yyval.net_ptr), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 9355 "obj/conf/cf-parse.tab.c"
    break;

  case 552: /* r_args_for: VPN_RD IP6  */
#line 655 "nest/config.Y"
              {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
    net_fill_vpn6((yyval.net_ptr), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 9364 "obj/conf/cf-parse.tab.c"
    break;

  case 553: /* r_args_for: IP6 FROM IP6  */
#line 659 "nest/config.Y"
                {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
    net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-2].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH);
  }
#line 9373 "obj/conf/cf-parse.tab.c"
    break;

  case 554: /* r_args_for: CF_SYM_KNOWN  */
#line 663 "nest/config.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
     {
       (yyval.net_ptr) = cfg_alloc(ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip) ? sizeof(net_addr_ip4) : sizeof(net_addr_ip6));
       net_fill_ip_host((yyval.net_ptr), SYM_VAL((yyvsp[0].s)).ip);
     }
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_type_match(SYM_VAL((yyvsp[0].s)).net, NB_IP | NB_VPN))
       (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
     else
       cf_error("IP address or network constant expected");
   }
#line 9389 "obj/conf/cf-parse.tab.c"
    break;

  case 557: /* r_args_for_val: IP4  */
#line 679 "nest/config.Y"
       { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 9395 "obj/conf/cf-parse.tab.c"
    break;

  case 558: /* r_args_for_val: IP6  */
#line 680 "nest/config.Y"
       { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 9401 "obj/conf/cf-parse.tab.c"
    break;

  case 559: /* export_mode: PREEXPORT  */
#line 683 "nest/config.Y"
                { (yyval.i) = RSEM_PREEXPORT; }
#line 9407 "obj/conf/cf-parse.tab.c"
    break;

  case 560: /* export_mode: EXPORT  */
#line 684 "nest/config.Y"
                { (yyval.i) = RSEM_EXPORT; }
#line 9413 "obj/conf/cf-parse.tab.c"
    break;

  case 561: /* export_mode: NOEXPORT  */
#line 685 "nest/config.Y"
                { (yyval.i) = RSEM_NOEXPORT; }
#line 9419 "obj/conf/cf-parse.tab.c"
    break;

  case 562: /* r_args_channel: IPV4  */
#line 690 "nest/config.Y"
                { (yyval.t) = "ipv4"; }
#line 9425 "obj/conf/cf-parse.tab.c"
    break;

  case 563: /* r_args_channel: IPV4_MC  */
#line 691 "nest/config.Y"
                { (yyval.t) = "ipv4-mc"; }
#line 9431 "obj/conf/cf-parse.tab.c"
    break;

  case 564: /* r_args_channel: IPV4_MPLS  */
#line 692 "nest/config.Y"
                { (yyval.t) = "ipv4-mpls"; }
#line 9437 "obj/conf/cf-parse.tab.c"
    break;

  case 565: /* r_args_channel: IPV6  */
#line 693 "nest/config.Y"
                { (yyval.t) = "ipv6"; }
#line 9443 "obj/conf/cf-parse.tab.c"
    break;

  case 566: /* r_args_channel: IPV6_MC  */
#line 694 "nest/config.Y"
                { (yyval.t) = "ipv6-mc"; }
#line 9449 "obj/conf/cf-parse.tab.c"
    break;

  case 567: /* r_args_channel: IPV6_MPLS  */
#line 695 "nest/config.Y"
                { (yyval.t) = "ipv6-mpls"; }
#line 9455 "obj/conf/cf-parse.tab.c"
    break;

  case 568: /* r_args_channel: IPV6_SADR  */
#line 696 "nest/config.Y"
                { (yyval.t) = "ipv6-sadr"; }
#line 9461 "obj/conf/cf-parse.tab.c"
    break;

  case 569: /* r_args_channel: VPN4  */
#line 697 "nest/config.Y"
                { (yyval.t) = "vpn4"; }
#line 9467 "obj/conf/cf-parse.tab.c"
    break;

  case 570: /* r_args_channel: VPN4_MC  */
#line 698 "nest/config.Y"
                { (yyval.t) = "vpn4-mc"; }
#line 9473 "obj/conf/cf-parse.tab.c"
    break;

  case 571: /* r_args_channel: VPN4_MPLS  */
#line 699 "nest/config.Y"
                { (yyval.t) = "vpn4-mpls"; }
#line 9479 "obj/conf/cf-parse.tab.c"
    break;

  case 572: /* r_args_channel: VPN6  */
#line 700 "nest/config.Y"
                { (yyval.t) = "vpn6"; }
#line 9485 "obj/conf/cf-parse.tab.c"
    break;

  case 573: /* r_args_channel: VPN6_MC  */
#line 701 "nest/config.Y"
                { (yyval.t) = "vpn6-mc"; }
#line 9491 "obj/conf/cf-parse.tab.c"
    break;

  case 574: /* r_args_channel: VPN6_MPLS  */
#line 702 "nest/config.Y"
                { (yyval.t) = "vpn6-mpls"; }
#line 9497 "obj/conf/cf-parse.tab.c"
    break;

  case 575: /* r_args_channel: ROA4  */
#line 703 "nest/config.Y"
                { (yyval.t) = "roa4"; }
#line 9503 "obj/conf/cf-parse.tab.c"
    break;

  case 576: /* r_args_channel: ROA6  */
#line 704 "nest/config.Y"
                { (yyval.t) = "roa6"; }
#line 9509 "obj/conf/cf-parse.tab.c"
    break;

  case 577: /* r_args_channel: FLOW4  */
#line 705 "nest/config.Y"
                { (yyval.t) = "flow4"; }
#line 9515 "obj/conf/cf-parse.tab.c"
    break;

  case 578: /* r_args_channel: FLOW6  */
#line 706 "nest/config.Y"
                { (yyval.t) = "flow6"; }
#line 9521 "obj/conf/cf-parse.tab.c"
    break;

  case 579: /* r_args_channel: MPLS  */
#line 707 "nest/config.Y"
                { (yyval.t) = "mpls"; }
#line 9527 "obj/conf/cf-parse.tab.c"
    break;

  case 580: /* r_args_channel: PRI  */
#line 708 "nest/config.Y"
                { (yyval.t) = "pri"; }
#line 9533 "obj/conf/cf-parse.tab.c"
    break;

  case 581: /* r_args_channel: SEC  */
#line 709 "nest/config.Y"
                { (yyval.t) = "sec"; }
#line 9539 "obj/conf/cf-parse.tab.c"
    break;

  case 583: /* cmd_SHOW_SYMBOLS: SHOW SYMBOLS sym_args END  */
#line 714 "nest/config.Y"
{ cmd_show_symbols((yyvsp[-1].sd)); }
#line 9545 "obj/conf/cf-parse.tab.c"
    break;

  case 584: /* sym_args: %empty  */
#line 717 "nest/config.Y"
               {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 9553 "obj/conf/cf-parse.tab.c"
    break;

  case 585: /* sym_args: sym_args TABLE  */
#line 720 "nest/config.Y"
                  { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 9559 "obj/conf/cf-parse.tab.c"
    break;

  case 586: /* sym_args: sym_args FUNCTION  */
#line 721 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 9565 "obj/conf/cf-parse.tab.c"
    break;

  case 587: /* sym_args: sym_args FILTER  */
#line 722 "nest/config.Y"
                   { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 9571 "obj/conf/cf-parse.tab.c"
    break;

  case 588: /* sym_args: sym_args PROTOCOL  */
#line 723 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 9577 "obj/conf/cf-parse.tab.c"
    break;

  case 589: /* sym_args: sym_args TEMPLATE  */
#line 724 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 9583 "obj/conf/cf-parse.tab.c"
    break;

  case 590: /* sym_args: sym_args symbol  */
#line 725 "nest/config.Y"
                   { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 9589 "obj/conf/cf-parse.tab.c"
    break;

  case 592: /* cmd_DUMP_RESOURCES: DUMP RESOURCES END  */
#line 731 "nest/config.Y"
{ rdump(&root_pool); cli_msg(0, ""); }
#line 9595 "obj/conf/cf-parse.tab.c"
    break;

  case 594: /* cmd_DUMP_SOCKETS: DUMP SOCKETS END  */
#line 733 "nest/config.Y"
{ sk_dump_all(); cli_msg(0, ""); }
#line 9601 "obj/conf/cf-parse.tab.c"
    break;

  case 596: /* cmd_DUMP_EVENTS: DUMP EVENTS END  */
#line 735 "nest/config.Y"
{ io_log_dump(); cli_msg(0, ""); }
#line 9607 "obj/conf/cf-parse.tab.c"
    break;

  case 598: /* cmd_DUMP_INTERFACES: DUMP INTERFACES END  */
#line 737 "nest/config.Y"
{ if_dump_all(); cli_msg(0, ""); }
#line 9613 "obj/conf/cf-parse.tab.c"
    break;

  case 600: /* cmd_DUMP_NEIGHBORS: DUMP NEIGHBORS END  */
#line 739 "nest/config.Y"
{ neigh_dump_all(); cli_msg(0, ""); }
#line 9619 "obj/conf/cf-parse.tab.c"
    break;

  case 602: /* cmd_DUMP_ATTRIBUTES: DUMP ATTRIBUTES END  */
#line 741 "nest/config.Y"
{ rta_dump_all(); cli_msg(0, ""); }
#line 9625 "obj/conf/cf-parse.tab.c"
    break;

  case 604: /* cmd_DUMP_ROUTES: DUMP ROUTES END  */
#line 743 "nest/config.Y"
{ rt_dump_all(); cli_msg(0, ""); }
#line 9631 "obj/conf/cf-parse.tab.c"
    break;

  case 606: /* cmd_DUMP_PROTOCOLS: DUMP PROTOCOLS END  */
#line 745 "nest/config.Y"
{ protos_dump_all(); cli_msg(0, ""); }
#line 9637 "obj/conf/cf-parse.tab.c"
    break;

  case 608: /* cmd_DUMP_FILTER_ALL: DUMP FILTER ALL END  */
#line 747 "nest/config.Y"
{ filters_dump_all(); cli_msg(0, ""); }
#line 9643 "obj/conf/cf-parse.tab.c"
    break;

  case 610: /* cmd_EVAL: EVAL term END  */
#line 750 "nest/config.Y"
{ cmd_eval(f_linearize((yyvsp[-1].x))); }
#line 9649 "obj/conf/cf-parse.tab.c"
    break;

  case 612: /* cmd_ECHO: ECHO echo_mask echo_size END  */
#line 753 "nest/config.Y"
                                       {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 9658 "obj/conf/cf-parse.tab.c"
    break;

  case 613: /* echo_mask: ALL  */
#line 759 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 9664 "obj/conf/cf-parse.tab.c"
    break;

  case 614: /* echo_mask: OFF  */
#line 760 "nest/config.Y"
       { (yyval.i) = 0; }
#line 9670 "obj/conf/cf-parse.tab.c"
    break;

  case 615: /* echo_mask: '{' log_mask_list '}'  */
#line 761 "nest/config.Y"
                         { (yyval.i) = (yyvsp[-1].i); }
#line 9676 "obj/conf/cf-parse.tab.c"
    break;

  case 616: /* echo_size: %empty  */
#line 765 "nest/config.Y"
               { (yyval.i) = 4096; }
#line 9682 "obj/conf/cf-parse.tab.c"
    break;

  case 617: /* echo_size: NUM  */
#line 766 "nest/config.Y"
       {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 9691 "obj/conf/cf-parse.tab.c"
    break;

  case 619: /* cmd_DISABLE: DISABLE proto_patt opttext END  */
#line 773 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9697 "obj/conf/cf-parse.tab.c"
    break;

  case 621: /* cmd_ENABLE: ENABLE proto_patt opttext END  */
#line 775 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9703 "obj/conf/cf-parse.tab.c"
    break;

  case 623: /* cmd_RESTART: RESTART proto_patt opttext END  */
#line 777 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9709 "obj/conf/cf-parse.tab.c"
    break;

  case 625: /* cmd_RELOAD: RELOAD proto_patt END  */
#line 779 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 9715 "obj/conf/cf-parse.tab.c"
    break;

  case 627: /* cmd_RELOAD_IN: RELOAD IN proto_patt END  */
#line 781 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 9721 "obj/conf/cf-parse.tab.c"
    break;

  case 629: /* cmd_RELOAD_OUT: RELOAD OUT proto_patt END  */
#line 783 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 9727 "obj/conf/cf-parse.tab.c"
    break;

  case 631: /* cmd_DEBUG: DEBUG proto_patt debug_mask END  */
#line 787 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 9733 "obj/conf/cf-parse.tab.c"
    break;

  case 633: /* cmd_MRTDUMP: MRTDUMP proto_patt mrtdump_mask END  */
#line 791 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 9739 "obj/conf/cf-parse.tab.c"
    break;

  case 635: /* cmd_RESTRICT: RESTRICT END  */
#line 794 "nest/config.Y"
{ this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 9745 "obj/conf/cf-parse.tab.c"
    break;

  case 636: /* proto_patt: CF_SYM_KNOWN  */
#line 797 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 9751 "obj/conf/cf-parse.tab.c"
    break;

  case 637: /* proto_patt: ALL  */
#line 798 "nest/config.Y"
        { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 9757 "obj/conf/cf-parse.tab.c"
    break;

  case 638: /* proto_patt: TEXT  */
#line 799 "nest/config.Y"
        { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 9763 "obj/conf/cf-parse.tab.c"
    break;

  case 639: /* proto_patt2: CF_SYM_KNOWN  */
#line 803 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 9769 "obj/conf/cf-parse.tab.c"
    break;

  case 640: /* proto_patt2: %empty  */
#line 804 "nest/config.Y"
        { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 9775 "obj/conf/cf-parse.tab.c"
    break;

  case 641: /* proto_patt2: TEXT  */
#line 805 "nest/config.Y"
        { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 9781 "obj/conf/cf-parse.tab.c"
    break;

  case 642: /* dynamic_attr: IGP_METRIC  */
#line 808 "nest/config.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 9787 "obj/conf/cf-parse.tab.c"
    break;

  case 644: /* bfd_proto_start: proto_start BFD  */
#line 37 "proto/bfd/config.Y"
{
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);
}
#line 9797 "obj/conf/cf-parse.tab.c"
    break;

  case 652: /* bfd_iface_start: %empty  */
#line 60 "proto/bfd/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 9814 "obj/conf/cf-parse.tab.c"
    break;

  case 653: /* bfd_iface_finish: %empty  */
#line 74 "proto/bfd/config.Y"
{
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 9837 "obj/conf/cf-parse.tab.c"
    break;

  case 654: /* bfd_iface_item: INTERVAL expr_us  */
#line 94 "proto/bfd/config.Y"
                    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 9843 "obj/conf/cf-parse.tab.c"
    break;

  case 655: /* bfd_iface_item: MIN RX INTERVAL expr_us  */
#line 95 "proto/bfd/config.Y"
                           { BFD_IFACE->min_rx_int = (yyvsp[0].time); }
#line 9849 "obj/conf/cf-parse.tab.c"
    break;

  case 656: /* bfd_iface_item: MIN TX INTERVAL expr_us  */
#line 96 "proto/bfd/config.Y"
                           { BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 9855 "obj/conf/cf-parse.tab.c"
    break;

  case 657: /* bfd_iface_item: IDLE TX INTERVAL expr_us  */
#line 97 "proto/bfd/config.Y"
                            { BFD_IFACE->idle_tx_int = (yyvsp[0].time); }
#line 9861 "obj/conf/cf-parse.tab.c"
    break;

  case 658: /* bfd_iface_item: MULTIPLIER expr  */
#line 98 "proto/bfd/config.Y"
                   { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 9867 "obj/conf/cf-parse.tab.c"
    break;

  case 659: /* bfd_iface_item: PASSIVE bool  */
#line 99 "proto/bfd/config.Y"
                { BFD_IFACE->passive = (yyvsp[0].i); }
#line 9873 "obj/conf/cf-parse.tab.c"
    break;

  case 660: /* bfd_iface_item: AUTHENTICATION bfd_auth_type  */
#line 100 "proto/bfd/config.Y"
                                { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 9879 "obj/conf/cf-parse.tab.c"
    break;

  case 661: /* bfd_iface_item: password_list  */
#line 101 "proto/bfd/config.Y"
                 {}
#line 9885 "obj/conf/cf-parse.tab.c"
    break;

  case 662: /* bfd_auth_type: NONE  */
#line 105 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_NONE; }
#line 9891 "obj/conf/cf-parse.tab.c"
    break;

  case 663: /* bfd_auth_type: SIMPLE  */
#line 106 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 9897 "obj/conf/cf-parse.tab.c"
    break;

  case 664: /* bfd_auth_type: KEYED MD5  */
#line 107 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 9903 "obj/conf/cf-parse.tab.c"
    break;

  case 665: /* bfd_auth_type: KEYED SHA1  */
#line 108 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 9909 "obj/conf/cf-parse.tab.c"
    break;

  case 666: /* bfd_auth_type: METICULOUS KEYED MD5  */
#line 109 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 9915 "obj/conf/cf-parse.tab.c"
    break;

  case 667: /* bfd_auth_type: METICULOUS KEYED SHA1  */
#line 110 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 9921 "obj/conf/cf-parse.tab.c"
    break;

  case 673: /* bfd_multihop: bfd_iface_start bfd_iface_opt_list bfd_iface_finish  */
#line 128 "proto/bfd/config.Y"
{ BFD_CFG->multihop = BFD_IFACE; }
#line 9927 "obj/conf/cf-parse.tab.c"
    break;

  case 674: /* bfd_neigh_iface: %empty  */
#line 132 "proto/bfd/config.Y"
               { (yyval.iface) = NULL; }
#line 9933 "obj/conf/cf-parse.tab.c"
    break;

  case 675: /* bfd_neigh_iface: '%' symbol  */
#line 133 "proto/bfd/config.Y"
              { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 9939 "obj/conf/cf-parse.tab.c"
    break;

  case 676: /* bfd_neigh_iface: DEV text  */
#line 134 "proto/bfd/config.Y"
            { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 9945 "obj/conf/cf-parse.tab.c"
    break;

  case 677: /* bfd_neigh_local: %empty  */
#line 138 "proto/bfd/config.Y"
               { (yyval.a) = IPA_NONE; }
#line 9951 "obj/conf/cf-parse.tab.c"
    break;

  case 678: /* bfd_neigh_local: LOCAL ipa  */
#line 139 "proto/bfd/config.Y"
             { (yyval.a) = (yyvsp[0].a); }
#line 9957 "obj/conf/cf-parse.tab.c"
    break;

  case 679: /* bfd_neigh_multihop: %empty  */
#line 143 "proto/bfd/config.Y"
               { (yyval.i) = 0; }
#line 9963 "obj/conf/cf-parse.tab.c"
    break;

  case 680: /* bfd_neigh_multihop: MULTIHOP bool  */
#line 144 "proto/bfd/config.Y"
                 { (yyval.i) = (yyvsp[0].i); }
#line 9969 "obj/conf/cf-parse.tab.c"
    break;

  case 681: /* bfd_neighbor: ipa bfd_neigh_iface bfd_neigh_local bfd_neigh_multihop  */
#line 148 "proto/bfd/config.Y"
{
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 9989 "obj/conf/cf-parse.tab.c"
    break;

  case 683: /* cmd_SHOW_BFD_SESSIONS: SHOW BFD SESSIONS optproto END  */
#line 167 "proto/bfd/config.Y"
{ bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 9995 "obj/conf/cf-parse.tab.c"
    break;

  case 685: /* babel_proto_start: proto_start BABEL  */
#line 35 "proto/babel/config.Y"
{
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
  BABEL_CFG->hold_time = 1 S_;
}
#line 10005 "obj/conf/cf-parse.tab.c"
    break;

  case 689: /* babel_proto_item: RANDOMIZE ROUTER ID bool  */
#line 45 "proto/babel/config.Y"
                            { BABEL_CFG->randomize_router_id = (yyvsp[0].i); }
#line 10011 "obj/conf/cf-parse.tab.c"
    break;

  case 693: /* babel_iface_start: %empty  */
#line 58 "proto/babel/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->limit = BABEL_HELLO_LIMIT;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 10027 "obj/conf/cf-parse.tab.c"
    break;

  case 694: /* babel_iface_finish: %empty  */
#line 72 "proto/babel/config.Y"
{
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);

  BABEL_CFG->hold_time = MAX_(BABEL_CFG->hold_time, BABEL_IFACE->update_interval*BABEL_HOLD_TIME_FACTOR);
}
#line 10055 "obj/conf/cf-parse.tab.c"
    break;

  case 696: /* babel_iface_item: PORT expr  */
#line 98 "proto/babel/config.Y"
             { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10061 "obj/conf/cf-parse.tab.c"
    break;

  case 697: /* babel_iface_item: RXCOST expr  */
#line 99 "proto/babel/config.Y"
               { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 10067 "obj/conf/cf-parse.tab.c"
    break;

  case 698: /* babel_iface_item: LIMIT expr  */
#line 100 "proto/babel/config.Y"
              { BABEL_IFACE->limit = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>16)) cf_error("Limit must be in range 1-16"); }
#line 10073 "obj/conf/cf-parse.tab.c"
    break;

  case 699: /* babel_iface_item: TYPE WIRED  */
#line 101 "proto/babel/config.Y"
              { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 10079 "obj/conf/cf-parse.tab.c"
    break;

  case 700: /* babel_iface_item: TYPE WIRELESS  */
#line 102 "proto/babel/config.Y"
                 { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 10085 "obj/conf/cf-parse.tab.c"
    break;

  case 701: /* babel_iface_item: HELLO INTERVAL expr_us  */
#line 103 "proto/babel/config.Y"
                          { BABEL_IFACE->hello_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Hello interval must be in range 10 ms - 655 s"); }
#line 10091 "obj/conf/cf-parse.tab.c"
    break;

  case 702: /* babel_iface_item: UPDATE INTERVAL expr_us  */
#line 104 "proto/babel/config.Y"
                           { BABEL_IFACE->update_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Update interval must be in range 10 ms - 655 s"); }
#line 10097 "obj/conf/cf-parse.tab.c"
    break;

  case 703: /* babel_iface_item: RX BUFFER expr  */
#line 105 "proto/babel/config.Y"
                  { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 10103 "obj/conf/cf-parse.tab.c"
    break;

  case 704: /* babel_iface_item: TX LENGTH expr  */
#line 106 "proto/babel/config.Y"
                  { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 10109 "obj/conf/cf-parse.tab.c"
    break;

  case 705: /* babel_iface_item: TX tos  */
#line 107 "proto/babel/config.Y"
          { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 10115 "obj/conf/cf-parse.tab.c"
    break;

  case 706: /* babel_iface_item: TX PRIORITY expr  */
#line 108 "proto/babel/config.Y"
                    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 10121 "obj/conf/cf-parse.tab.c"
    break;

  case 707: /* babel_iface_item: CHECK LINK bool  */
#line 109 "proto/babel/config.Y"
                   { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 10127 "obj/conf/cf-parse.tab.c"
    break;

  case 708: /* babel_iface_item: NEXT HOP IPV4 ipa  */
#line 110 "proto/babel/config.Y"
                     { BABEL_IFACE->next_hop_ip4 = (yyvsp[0].a); if (!ipa_is_ip4((yyvsp[0].a))) cf_error("Must be an IPv4 address"); }
#line 10133 "obj/conf/cf-parse.tab.c"
    break;

  case 709: /* babel_iface_item: NEXT HOP IPV6 ipa  */
#line 111 "proto/babel/config.Y"
                     { BABEL_IFACE->next_hop_ip6 = (yyvsp[0].a); if (!ipa_is_ip6((yyvsp[0].a))) cf_error("Must be an IPv6 address"); }
#line 10139 "obj/conf/cf-parse.tab.c"
    break;

  case 715: /* dynamic_attr: BABEL_METRIC  */
#line 128 "proto/babel/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_BABEL_METRIC); }
#line 10145 "obj/conf/cf-parse.tab.c"
    break;

  case 717: /* cmd_SHOW_BABEL_INTERFACES: SHOW BABEL INTERFACES optproto opttext END  */
#line 133 "proto/babel/config.Y"
{ babel_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 10151 "obj/conf/cf-parse.tab.c"
    break;

  case 719: /* cmd_SHOW_BABEL_NEIGHBORS: SHOW BABEL NEIGHBORS optproto opttext END  */
#line 136 "proto/babel/config.Y"
{ babel_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 10157 "obj/conf/cf-parse.tab.c"
    break;

  case 721: /* cmd_SHOW_BABEL_ENTRIES: SHOW BABEL ENTRIES optproto opttext END  */
#line 139 "proto/babel/config.Y"
{ babel_show_entries(proto_get_named((yyvsp[-2].s), &proto_babel)); }
#line 10163 "obj/conf/cf-parse.tab.c"
    break;

  case 723: /* cmd_SHOW_BABEL_ROUTES: SHOW BABEL ROUTES optproto opttext END  */
#line 142 "proto/babel/config.Y"
{ babel_show_routes(proto_get_named((yyvsp[-2].s), &proto_babel)); }
#line 10169 "obj/conf/cf-parse.tab.c"
    break;

  case 725: /* bgp_proto_start: proto_start BGP  */
#line 48 "proto/bgp/config.Y"
                                 {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->local_port = BGP_PORT;
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
     BGP_CFG->dynamic_name = "dynbgp";
     BGP_CFG->check_link = -1;
   }
#line 10201 "obj/conf/cf-parse.tab.c"
    break;

  case 727: /* bgp_loc_opts: bgp_loc_opts PORT expr  */
#line 79 "proto/bgp/config.Y"
                          { BGP_CFG->local_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10207 "obj/conf/cf-parse.tab.c"
    break;

  case 728: /* bgp_loc_opts: bgp_loc_opts AS expr  */
#line 80 "proto/bgp/config.Y"
                        { BGP_CFG->local_as = (yyvsp[0].i); }
#line 10213 "obj/conf/cf-parse.tab.c"
    break;

  case 730: /* bgp_nbr_opts: bgp_nbr_opts PORT expr  */
#line 85 "proto/bgp/config.Y"
                          { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10219 "obj/conf/cf-parse.tab.c"
    break;

  case 731: /* bgp_nbr_opts: bgp_nbr_opts AS expr  */
#line 86 "proto/bgp/config.Y"
                        { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 10225 "obj/conf/cf-parse.tab.c"
    break;

  case 732: /* bgp_nbr_opts: bgp_nbr_opts INTERNAL  */
#line 87 "proto/bgp/config.Y"
                         { BGP_CFG->peer_type = BGP_PT_INTERNAL; }
#line 10231 "obj/conf/cf-parse.tab.c"
    break;

  case 733: /* bgp_nbr_opts: bgp_nbr_opts EXTERNAL  */
#line 88 "proto/bgp/config.Y"
                         { BGP_CFG->peer_type = BGP_PT_EXTERNAL; }
#line 10237 "obj/conf/cf-parse.tab.c"
    break;

  case 734: /* bgp_cease_mask: bool  */
#line 93 "proto/bgp/config.Y"
        { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 10243 "obj/conf/cf-parse.tab.c"
    break;

  case 735: /* bgp_cease_mask: '{' bgp_cease_list '}'  */
#line 94 "proto/bgp/config.Y"
                          { (yyval.i) = (yyvsp[-1].i); }
#line 10249 "obj/conf/cf-parse.tab.c"
    break;

  case 737: /* bgp_cease_list: bgp_cease_list ',' bgp_cease_flag  */
#line 99 "proto/bgp/config.Y"
                                     { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 10255 "obj/conf/cf-parse.tab.c"
    break;

  case 738: /* bgp_cease_flag: CEASE  */
#line 103 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 0; }
#line 10261 "obj/conf/cf-parse.tab.c"
    break;

  case 739: /* bgp_cease_flag: PREFIX LIMIT HIT  */
#line 104 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 1; }
#line 10267 "obj/conf/cf-parse.tab.c"
    break;

  case 740: /* bgp_cease_flag: ADMINISTRATIVE SHUTDOWN  */
#line 105 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 2; }
#line 10273 "obj/conf/cf-parse.tab.c"
    break;

  case 741: /* bgp_cease_flag: PEER DECONFIGURED  */
#line 106 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 3; }
#line 10279 "obj/conf/cf-parse.tab.c"
    break;

  case 742: /* bgp_cease_flag: ADMINISTRATIVE RESET  */
#line 107 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 4; }
#line 10285 "obj/conf/cf-parse.tab.c"
    break;

  case 743: /* bgp_cease_flag: CONNECTION REJECTED  */
#line 108 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 5; }
#line 10291 "obj/conf/cf-parse.tab.c"
    break;

  case 744: /* bgp_cease_flag: CONFIGURATION CHANGE  */
#line 109 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 6; }
#line 10297 "obj/conf/cf-parse.tab.c"
    break;

  case 745: /* bgp_cease_flag: CONNECTION COLLISION  */
#line 110 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 7; }
#line 10303 "obj/conf/cf-parse.tab.c"
    break;

  case 746: /* bgp_cease_flag: OUT OF RESOURCES  */
#line 111 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 8; }
#line 10309 "obj/conf/cf-parse.tab.c"
    break;

  case 751: /* bgp_proto: bgp_proto LOCAL ipa ipa_scope bgp_loc_opts ';'  */
#line 119 "proto/bgp/config.Y"
                                                  {
     BGP_CFG->local_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 10318 "obj/conf/cf-parse.tab.c"
    break;

  case 753: /* bgp_proto: bgp_proto NEIGHBOR ipa ipa_scope bgp_nbr_opts ';'  */
#line 124 "proto/bgp/config.Y"
                                                     {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 10329 "obj/conf/cf-parse.tab.c"
    break;

  case 754: /* bgp_proto: bgp_proto NEIGHBOR RANGE net_ip bgp_nbr_opts ';'  */
#line 130 "proto/bgp/config.Y"
                                                    {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     net_addr *n = cfg_alloc((yyvsp[-2].net).length);
     net_copy(n, &((yyvsp[-2].net)));
     BGP_CFG->remote_range = n;
   }
#line 10341 "obj/conf/cf-parse.tab.c"
    break;

  case 755: /* bgp_proto: bgp_proto INTERFACE TEXT ';'  */
#line 137 "proto/bgp/config.Y"
                                { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 10347 "obj/conf/cf-parse.tab.c"
    break;

  case 756: /* bgp_proto: bgp_proto RR CLUSTER ID idval ';'  */
#line 138 "proto/bgp/config.Y"
                                     { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 10353 "obj/conf/cf-parse.tab.c"
    break;

  case 757: /* bgp_proto: bgp_proto RR CLIENT bool ';'  */
#line 139 "proto/bgp/config.Y"
                                { BGP_CFG->rr_client = (yyvsp[-1].i); }
#line 10359 "obj/conf/cf-parse.tab.c"
    break;

  case 758: /* bgp_proto: bgp_proto RS CLIENT bool ';'  */
#line 140 "proto/bgp/config.Y"
                                { BGP_CFG->rs_client = (yyvsp[-1].i); }
#line 10365 "obj/conf/cf-parse.tab.c"
    break;

  case 759: /* bgp_proto: bgp_proto CONFEDERATION expr ';'  */
#line 141 "proto/bgp/config.Y"
                                    { BGP_CFG->confederation = (yyvsp[-1].i); }
#line 10371 "obj/conf/cf-parse.tab.c"
    break;

  case 760: /* bgp_proto: bgp_proto CONFEDERATION MEMBER bool ';'  */
#line 142 "proto/bgp/config.Y"
                                           { BGP_CFG->confederation_member = (yyvsp[-1].i); }
#line 10377 "obj/conf/cf-parse.tab.c"
    break;

  case 761: /* bgp_proto: bgp_proto HOLD TIME expr ';'  */
#line 143 "proto/bgp/config.Y"
                                { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 10383 "obj/conf/cf-parse.tab.c"
    break;

  case 762: /* bgp_proto: bgp_proto STARTUP HOLD TIME expr ';'  */
#line 144 "proto/bgp/config.Y"
                                        { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 10389 "obj/conf/cf-parse.tab.c"
    break;

  case 763: /* bgp_proto: bgp_proto DIRECT ';'  */
#line 145 "proto/bgp/config.Y"
                        { BGP_CFG->multihop = 0; }
#line 10395 "obj/conf/cf-parse.tab.c"
    break;

  case 764: /* bgp_proto: bgp_proto MULTIHOP ';'  */
#line 146 "proto/bgp/config.Y"
                          { BGP_CFG->multihop = 64; }
#line 10401 "obj/conf/cf-parse.tab.c"
    break;

  case 765: /* bgp_proto: bgp_proto MULTIHOP expr ';'  */
#line 147 "proto/bgp/config.Y"
                               { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 10407 "obj/conf/cf-parse.tab.c"
    break;

  case 766: /* bgp_proto: bgp_proto DYNAMIC NAME text ';'  */
#line 148 "proto/bgp/config.Y"
                                   {
     if (strchr((yyvsp[-1].t), '%')) cf_error("Forbidden character '%%' in dynamic name");
     if (strlen((yyvsp[-1].t)) > (SYM_MAX_LEN - 16)) cf_error("Dynamic name too long");
     BGP_CFG->dynamic_name = (yyvsp[-1].t);
   }
#line 10417 "obj/conf/cf-parse.tab.c"
    break;

  case 767: /* bgp_proto: bgp_proto DYNAMIC NAME DIGITS expr ';'  */
#line 153 "proto/bgp/config.Y"
                                          { BGP_CFG->dynamic_name_digits = (yyvsp[-1].i); if ((yyvsp[-1].i)>10) cf_error("Dynamic name digits must be at most 10"); }
#line 10423 "obj/conf/cf-parse.tab.c"
    break;

  case 768: /* bgp_proto: bgp_proto STRICT BIND bool ';'  */
#line 154 "proto/bgp/config.Y"
                                  { BGP_CFG->strict_bind = (yyvsp[-1].i); }
#line 10429 "obj/conf/cf-parse.tab.c"
    break;

  case 769: /* bgp_proto: bgp_proto PATH METRIC bool ';'  */
#line 155 "proto/bgp/config.Y"
                                  { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 10435 "obj/conf/cf-parse.tab.c"
    break;

  case 770: /* bgp_proto: bgp_proto MED METRIC bool ';'  */
#line 156 "proto/bgp/config.Y"
                                 { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 10441 "obj/conf/cf-parse.tab.c"
    break;

  case 771: /* bgp_proto: bgp_proto IGP METRIC bool ';'  */
#line 157 "proto/bgp/config.Y"
                                 { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 10447 "obj/conf/cf-parse.tab.c"
    break;

  case 772: /* bgp_proto: bgp_proto PREFER OLDER bool ';'  */
#line 158 "proto/bgp/config.Y"
                                   { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 10453 "obj/conf/cf-parse.tab.c"
    break;

  case 773: /* bgp_proto: bgp_proto DETERMINISTIC MED bool ';'  */
#line 159 "proto/bgp/config.Y"
                                        { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 10459 "obj/conf/cf-parse.tab.c"
    break;

  case 774: /* bgp_proto: bgp_proto DEFAULT BGP_MED expr ';'  */
#line 160 "proto/bgp/config.Y"
                                      { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 10465 "obj/conf/cf-parse.tab.c"
    break;

  case 775: /* bgp_proto: bgp_proto DEFAULT BGP_LOCAL_PREF expr ';'  */
#line 161 "proto/bgp/config.Y"
                                             { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 10471 "obj/conf/cf-parse.tab.c"
    break;

  case 776: /* bgp_proto: bgp_proto SOURCE ADDRESS ipa ';'  */
#line 162 "proto/bgp/config.Y"
                                    { BGP_CFG->local_ip = (yyvsp[-1].a); }
#line 10477 "obj/conf/cf-parse.tab.c"
    break;

  case 777: /* bgp_proto: bgp_proto START DELAY TIME expr ';'  */
#line 163 "proto/bgp/config.Y"
                                       { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 10483 "obj/conf/cf-parse.tab.c"
    break;

  case 778: /* bgp_proto: bgp_proto CONNECT DELAY TIME expr ';'  */
#line 164 "proto/bgp/config.Y"
                                         { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 10489 "obj/conf/cf-parse.tab.c"
    break;

  case 779: /* bgp_proto: bgp_proto CONNECT RETRY TIME expr ';'  */
#line 165 "proto/bgp/config.Y"
                                         { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 10495 "obj/conf/cf-parse.tab.c"
    break;

  case 780: /* bgp_proto: bgp_proto KEEPALIVE TIME expr ';'  */
#line 166 "proto/bgp/config.Y"
                                     { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 10501 "obj/conf/cf-parse.tab.c"
    break;

  case 781: /* bgp_proto: bgp_proto ERROR FORGET TIME expr ';'  */
#line 167 "proto/bgp/config.Y"
                                        { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 10507 "obj/conf/cf-parse.tab.c"
    break;

  case 782: /* bgp_proto: bgp_proto ERROR WAIT TIME expr ',' expr ';'  */
#line 168 "proto/bgp/config.Y"
                                               { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 10513 "obj/conf/cf-parse.tab.c"
    break;

  case 783: /* bgp_proto: bgp_proto DISABLE AFTER ERROR bool ';'  */
#line 169 "proto/bgp/config.Y"
                                          { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 10519 "obj/conf/cf-parse.tab.c"
    break;

  case 784: /* bgp_proto: bgp_proto DISABLE AFTER CEASE bgp_cease_mask ';'  */
#line 170 "proto/bgp/config.Y"
                                                    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 10525 "obj/conf/cf-parse.tab.c"
    break;

  case 785: /* bgp_proto: bgp_proto ENABLE ROUTE REFRESH bool ';'  */
#line 171 "proto/bgp/config.Y"
                                           { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 10531 "obj/conf/cf-parse.tab.c"
    break;

  case 786: /* bgp_proto: bgp_proto ENABLE AS4 bool ';'  */
#line 172 "proto/bgp/config.Y"
                                 { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 10537 "obj/conf/cf-parse.tab.c"
    break;

  case 787: /* bgp_proto: bgp_proto ENABLE EXTENDED MESSAGES bool ';'  */
#line 173 "proto/bgp/config.Y"
                                               { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 10543 "obj/conf/cf-parse.tab.c"
    break;

  case 788: /* bgp_proto: bgp_proto CAPABILITIES bool ';'  */
#line 174 "proto/bgp/config.Y"
                                   { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 10549 "obj/conf/cf-parse.tab.c"
    break;

  case 789: /* bgp_proto: bgp_proto PASSWORD text ';'  */
#line 175 "proto/bgp/config.Y"
                               { BGP_CFG->password = (yyvsp[-1].t); }
#line 10555 "obj/conf/cf-parse.tab.c"
    break;

  case 790: /* bgp_proto: bgp_proto SETKEY bool ';'  */
#line 176 "proto/bgp/config.Y"
                             { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 10561 "obj/conf/cf-parse.tab.c"
    break;

  case 791: /* bgp_proto: bgp_proto PASSIVE bool ';'  */
#line 177 "proto/bgp/config.Y"
                              { BGP_CFG->passive = (yyvsp[-1].i); }
#line 10567 "obj/conf/cf-parse.tab.c"
    break;

  case 792: /* bgp_proto: bgp_proto INTERPRET COMMUNITIES bool ';'  */
#line 178 "proto/bgp/config.Y"
                                            { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 10573 "obj/conf/cf-parse.tab.c"
    break;

  case 793: /* bgp_proto: bgp_proto ALLOW LOCAL AS ';'  */
#line 179 "proto/bgp/config.Y"
                                { BGP_CFG->allow_local_as = -1; }
#line 10579 "obj/conf/cf-parse.tab.c"
    break;

  case 794: /* bgp_proto: bgp_proto ALLOW LOCAL AS expr ';'  */
#line 180 "proto/bgp/config.Y"
                                     { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 10585 "obj/conf/cf-parse.tab.c"
    break;

  case 795: /* bgp_proto: bgp_proto ALLOW BGP_LOCAL_PREF bool ';'  */
#line 181 "proto/bgp/config.Y"
                                           { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 10591 "obj/conf/cf-parse.tab.c"
    break;

  case 796: /* bgp_proto: bgp_proto GRACEFUL RESTART bool ';'  */
#line 182 "proto/bgp/config.Y"
                                       { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 10597 "obj/conf/cf-parse.tab.c"
    break;

  case 797: /* bgp_proto: bgp_proto GRACEFUL RESTART AWARE ';'  */
#line 183 "proto/bgp/config.Y"
                                        { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 10603 "obj/conf/cf-parse.tab.c"
    break;

  case 798: /* bgp_proto: bgp_proto GRACEFUL RESTART TIME expr ';'  */
#line 184 "proto/bgp/config.Y"
                                            { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 10609 "obj/conf/cf-parse.tab.c"
    break;

  case 799: /* bgp_proto: bgp_proto LONG LIVED GRACEFUL RESTART bool ';'  */
#line 185 "proto/bgp/config.Y"
                                                  { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 10615 "obj/conf/cf-parse.tab.c"
    break;

  case 800: /* bgp_proto: bgp_proto LONG LIVED GRACEFUL RESTART AWARE ';'  */
#line 186 "proto/bgp/config.Y"
                                                   { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 10621 "obj/conf/cf-parse.tab.c"
    break;

  case 801: /* bgp_proto: bgp_proto LONG LIVED STALE TIME expr ';'  */
#line 187 "proto/bgp/config.Y"
                                            { BGP_CFG->llgr_time = (yyvsp[-1].i); }
#line 10627 "obj/conf/cf-parse.tab.c"
    break;

  case 802: /* bgp_proto: bgp_proto TTL SECURITY bool ';'  */
#line 188 "proto/bgp/config.Y"
                                   { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 10633 "obj/conf/cf-parse.tab.c"
    break;

  case 803: /* bgp_proto: bgp_proto CHECK LINK bool ';'  */
#line 189 "proto/bgp/config.Y"
                                 { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 10639 "obj/conf/cf-parse.tab.c"
    break;

  case 804: /* bgp_proto: bgp_proto BFD bool ';'  */
#line 190 "proto/bgp/config.Y"
                          { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 10645 "obj/conf/cf-parse.tab.c"
    break;

  case 805: /* bgp_proto: bgp_proto BFD GRACEFUL ';'  */
#line 191 "proto/bgp/config.Y"
                              { BGP_CFG->bfd = BGP_BFD_GRACEFUL; cf_check_bfd(1); }
#line 10651 "obj/conf/cf-parse.tab.c"
    break;

  case 806: /* bgp_afi: IPV4  */
#line 195 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4; }
#line 10657 "obj/conf/cf-parse.tab.c"
    break;

  case 807: /* bgp_afi: IPV6  */
#line 196 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6; }
#line 10663 "obj/conf/cf-parse.tab.c"
    break;

  case 808: /* bgp_afi: IPV4 MULTICAST  */
#line 197 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4_MC; }
#line 10669 "obj/conf/cf-parse.tab.c"
    break;

  case 809: /* bgp_afi: IPV6 MULTICAST  */
#line 198 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6_MC; }
#line 10675 "obj/conf/cf-parse.tab.c"
    break;

  case 810: /* bgp_afi: IPV4 MPLS  */
#line 199 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4_MPLS; }
#line 10681 "obj/conf/cf-parse.tab.c"
    break;

  case 811: /* bgp_afi: IPV6 MPLS  */
#line 200 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6_MPLS; }
#line 10687 "obj/conf/cf-parse.tab.c"
    break;

  case 812: /* bgp_afi: VPN4 MPLS  */
#line 201 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN4_MPLS; }
#line 10693 "obj/conf/cf-parse.tab.c"
    break;

  case 813: /* bgp_afi: VPN6 MPLS  */
#line 202 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN6_MPLS; }
#line 10699 "obj/conf/cf-parse.tab.c"
    break;

  case 814: /* bgp_afi: VPN4 MULTICAST  */
#line 203 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN4_MC; }
#line 10705 "obj/conf/cf-parse.tab.c"
    break;

  case 815: /* bgp_afi: VPN6 MULTICAST  */
#line 204 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN6_MC; }
#line 10711 "obj/conf/cf-parse.tab.c"
    break;

  case 816: /* bgp_afi: FLOW4  */
#line 205 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_FLOW4; }
#line 10717 "obj/conf/cf-parse.tab.c"
    break;

  case 817: /* bgp_afi: FLOW6  */
#line 206 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_FLOW6; }
#line 10723 "obj/conf/cf-parse.tab.c"
    break;

  case 818: /* bgp_channel_start: bgp_afi  */
#line 210 "proto/bgp/config.Y"
{
  const struct bgp_af_desc *desc = bgp_get_af_desc((yyvsp[0].i32));

  if (!desc)
    cf_error("Unknown AFI/SAFI");

  this_channel = channel_config_get(&channel_bgp, desc->name, desc->net, this_proto);

  /* New channel */
  if (!BGP_CC->desc)
  {
    BGP_CC->c.in_filter = FILTER_UNDEF;
    BGP_CC->c.out_filter = FILTER_UNDEF;
    BGP_CC->c.ra_mode = RA_UNDEF;
    BGP_CC->afi = (yyvsp[0].i32);
    BGP_CC->desc = desc;
    BGP_CC->next_hop_keep = 0xff; /* undefined */
    BGP_CC->gr_able = 0xff;	/* undefined */
    BGP_CC->llgr_able = 0xff;	/* undefined */
    BGP_CC->llgr_time = ~0U;	/* undefined */
    BGP_CC->aigp = 0xff;	/* undefined */
  }
}
#line 10751 "obj/conf/cf-parse.tab.c"
    break;

  case 819: /* bgp_nh: bool  */
#line 235 "proto/bgp/config.Y"
        { (yyval.i) = (yyvsp[0].i); }
#line 10757 "obj/conf/cf-parse.tab.c"
    break;

  case 820: /* bgp_nh: IBGP  */
#line 236 "proto/bgp/config.Y"
        { (yyval.i) = NH_IBGP; }
#line 10763 "obj/conf/cf-parse.tab.c"
    break;

  case 821: /* bgp_nh: EBGP  */
#line 237 "proto/bgp/config.Y"
        { (yyval.i) = NH_EBGP; }
#line 10769 "obj/conf/cf-parse.tab.c"
    break;

  case 823: /* bgp_channel_item: NEXT HOP ADDRESS ipa  */
#line 241 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_addr = (yyvsp[0].a); }
#line 10775 "obj/conf/cf-parse.tab.c"
    break;

  case 824: /* bgp_channel_item: NEXT HOP SELF bgp_nh  */
#line 242 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_self = (yyvsp[0].i); }
#line 10781 "obj/conf/cf-parse.tab.c"
    break;

  case 825: /* bgp_channel_item: NEXT HOP KEEP bgp_nh  */
#line 243 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_keep = (yyvsp[0].i); }
#line 10787 "obj/conf/cf-parse.tab.c"
    break;

  case 826: /* bgp_channel_item: MANDATORY bool  */
#line 244 "proto/bgp/config.Y"
                  { BGP_CC->mandatory = (yyvsp[0].i); }
#line 10793 "obj/conf/cf-parse.tab.c"
    break;

  case 827: /* bgp_channel_item: MISSING LLADDR SELF  */
#line 245 "proto/bgp/config.Y"
                       { BGP_CC->missing_lladdr = MLL_SELF; }
#line 10799 "obj/conf/cf-parse.tab.c"
    break;

  case 828: /* bgp_channel_item: MISSING LLADDR DROP  */
#line 246 "proto/bgp/config.Y"
                       { BGP_CC->missing_lladdr = MLL_DROP; }
#line 10805 "obj/conf/cf-parse.tab.c"
    break;

  case 829: /* bgp_channel_item: MISSING LLADDR IGNORE  */
#line 247 "proto/bgp/config.Y"
                         { BGP_CC->missing_lladdr = MLL_IGNORE; }
#line 10811 "obj/conf/cf-parse.tab.c"
    break;

  case 830: /* bgp_channel_item: GATEWAY DIRECT  */
#line 248 "proto/bgp/config.Y"
                  { BGP_CC->gw_mode = GW_DIRECT; }
#line 10817 "obj/conf/cf-parse.tab.c"
    break;

  case 831: /* bgp_channel_item: GATEWAY RECURSIVE  */
#line 249 "proto/bgp/config.Y"
                     { BGP_CC->gw_mode = GW_RECURSIVE; }
#line 10823 "obj/conf/cf-parse.tab.c"
    break;

  case 832: /* bgp_channel_item: SECONDARY bool  */
#line 250 "proto/bgp/config.Y"
                  { BGP_CC->secondary = (yyvsp[0].i); }
#line 10829 "obj/conf/cf-parse.tab.c"
    break;

  case 833: /* bgp_channel_item: GRACEFUL RESTART bool  */
#line 251 "proto/bgp/config.Y"
                         { BGP_CC->gr_able = (yyvsp[0].i); }
#line 10835 "obj/conf/cf-parse.tab.c"
    break;

  case 834: /* bgp_channel_item: LONG LIVED GRACEFUL RESTART bool  */
#line 252 "proto/bgp/config.Y"
                                    { BGP_CC->llgr_able = (yyvsp[0].i); }
#line 10841 "obj/conf/cf-parse.tab.c"
    break;

  case 835: /* bgp_channel_item: LONG LIVED STALE TIME expr  */
#line 253 "proto/bgp/config.Y"
                              { BGP_CC->llgr_time = (yyvsp[0].i); }
#line 10847 "obj/conf/cf-parse.tab.c"
    break;

  case 836: /* bgp_channel_item: EXTENDED NEXT HOP bool  */
#line 254 "proto/bgp/config.Y"
                          { BGP_CC->ext_next_hop = (yyvsp[0].i); }
#line 10853 "obj/conf/cf-parse.tab.c"
    break;

  case 837: /* bgp_channel_item: ADD PATHS RX  */
#line 255 "proto/bgp/config.Y"
                { BGP_CC->add_path = BGP_ADD_PATH_RX; }
#line 10859 "obj/conf/cf-parse.tab.c"
    break;

  case 838: /* bgp_channel_item: ADD PATHS TX  */
#line 256 "proto/bgp/config.Y"
                { BGP_CC->add_path = BGP_ADD_PATH_TX; }
#line 10865 "obj/conf/cf-parse.tab.c"
    break;

  case 839: /* bgp_channel_item: ADD PATHS bool  */
#line 257 "proto/bgp/config.Y"
                  { BGP_CC->add_path = (yyvsp[0].i) ? BGP_ADD_PATH_FULL : 0; }
#line 10871 "obj/conf/cf-parse.tab.c"
    break;

  case 840: /* bgp_channel_item: IMPORT TABLE bool  */
#line 258 "proto/bgp/config.Y"
                     { BGP_CC->import_table = (yyvsp[0].i); }
#line 10877 "obj/conf/cf-parse.tab.c"
    break;

  case 841: /* bgp_channel_item: EXPORT TABLE bool  */
#line 259 "proto/bgp/config.Y"
                     { BGP_CC->export_table = (yyvsp[0].i); }
#line 10883 "obj/conf/cf-parse.tab.c"
    break;

  case 842: /* bgp_channel_item: AIGP bool  */
#line 260 "proto/bgp/config.Y"
             { BGP_CC->aigp = (yyvsp[0].i); BGP_CC->aigp_originate = 0; }
#line 10889 "obj/conf/cf-parse.tab.c"
    break;

  case 843: /* bgp_channel_item: AIGP ORIGINATE  */
#line 261 "proto/bgp/config.Y"
                  { BGP_CC->aigp = 1; BGP_CC->aigp_originate = 1; }
#line 10895 "obj/conf/cf-parse.tab.c"
    break;

  case 844: /* bgp_channel_item: COST expr  */
#line 262 "proto/bgp/config.Y"
             { BGP_CC->cost = (yyvsp[0].i); if ((yyvsp[0].i) < 1) cf_error("Cost must be positive"); }
#line 10901 "obj/conf/cf-parse.tab.c"
    break;

  case 845: /* bgp_channel_item: IGP TABLE rtable  */
#line 263 "proto/bgp/config.Y"
                    {
    if (BGP_CC->desc->no_igp)
      cf_error("IGP table not allowed here");

    if ((yyvsp[0].r)->addr_type == NET_IP4)
      BGP_CC->igp_table_ip4 = (yyvsp[0].r);
    else if ((yyvsp[0].r)->addr_type == NET_IP6)
      BGP_CC->igp_table_ip6 = (yyvsp[0].r);
    else
      cf_error("Mismatched IGP table type");
   }
#line 10917 "obj/conf/cf-parse.tab.c"
    break;

  case 850: /* bgp_channel_end: %empty  */
#line 287 "proto/bgp/config.Y"
{
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 10928 "obj/conf/cf-parse.tab.c"
    break;

  case 852: /* dynamic_attr: BGP_ORIGIN  */
#line 298 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(PROTOCOL_BGP, BA_ORIGIN)); }
#line 10934 "obj/conf/cf-parse.tab.c"
    break;

  case 853: /* dynamic_attr: BGP_PATH  */
#line 300 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(PROTOCOL_BGP, BA_AS_PATH)); }
#line 10940 "obj/conf/cf-parse.tab.c"
    break;

  case 854: /* dynamic_attr: BGP_NEXT_HOP  */
#line 302 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(PROTOCOL_BGP, BA_NEXT_HOP)); }
#line 10946 "obj/conf/cf-parse.tab.c"
    break;

  case 855: /* dynamic_attr: BGP_MED  */
#line 304 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_MULTI_EXIT_DISC)); }
#line 10952 "obj/conf/cf-parse.tab.c"
    break;

  case 856: /* dynamic_attr: BGP_LOCAL_PREF  */
#line 306 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_LOCAL_PREF)); }
#line 10958 "obj/conf/cf-parse.tab.c"
    break;

  case 857: /* dynamic_attr: BGP_ATOMIC_AGGR  */
#line 308 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_ATOMIC_AGGR)); }
#line 10964 "obj/conf/cf-parse.tab.c"
    break;

  case 858: /* dynamic_attr: BGP_AGGREGATOR  */
#line 310 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AGGREGATOR)); }
#line 10970 "obj/conf/cf-parse.tab.c"
    break;

  case 859: /* dynamic_attr: BGP_COMMUNITY  */
#line 312 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_COMMUNITY)); }
#line 10976 "obj/conf/cf-parse.tab.c"
    break;

  case 860: /* dynamic_attr: BGP_ORIGINATOR_ID  */
#line 314 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(PROTOCOL_BGP, BA_ORIGINATOR_ID)); }
#line 10982 "obj/conf/cf-parse.tab.c"
    break;

  case 861: /* dynamic_attr: BGP_CLUSTER_LIST  */
#line 316 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_CLUSTER_LIST)); }
#line 10988 "obj/conf/cf-parse.tab.c"
    break;

  case 862: /* dynamic_attr: BGP_EXT_COMMUNITY  */
#line 318 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(PROTOCOL_BGP, BA_EXT_COMMUNITY)); }
#line 10994 "obj/conf/cf-parse.tab.c"
    break;

  case 863: /* dynamic_attr: BGP_AIGP  */
#line 320 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AIGP)); }
#line 11000 "obj/conf/cf-parse.tab.c"
    break;

  case 864: /* dynamic_attr: BGP_LARGE_COMMUNITY  */
#line 322 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(PROTOCOL_BGP, BA_LARGE_COMMUNITY)); }
#line 11006 "obj/conf/cf-parse.tab.c"
    break;

  case 866: /* mrt_proto_start: proto_start MRT  */
#line 29 "proto/mrt/config.Y"
{
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 11014 "obj/conf/cf-parse.tab.c"
    break;

  case 868: /* mrt_proto_item: TABLE rtable  */
#line 35 "proto/mrt/config.Y"
                        { MRT_CFG->table_cf = (yyvsp[0].r); }
#line 11020 "obj/conf/cf-parse.tab.c"
    break;

  case 869: /* mrt_proto_item: TABLE TEXT  */
#line 36 "proto/mrt/config.Y"
                        { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 11026 "obj/conf/cf-parse.tab.c"
    break;

  case 870: /* mrt_proto_item: FILTER filter  */
#line 37 "proto/mrt/config.Y"
                        { MRT_CFG->filter = (yyvsp[0].f); }
#line 11032 "obj/conf/cf-parse.tab.c"
    break;

  case 871: /* mrt_proto_item: where_filter  */
#line 38 "proto/mrt/config.Y"
                        { MRT_CFG->filter = (yyvsp[0].f); }
#line 11038 "obj/conf/cf-parse.tab.c"
    break;

  case 872: /* mrt_proto_item: FILENAME text  */
#line 39 "proto/mrt/config.Y"
                        { MRT_CFG->filename = (yyvsp[0].t); }
#line 11044 "obj/conf/cf-parse.tab.c"
    break;

  case 873: /* mrt_proto_item: PERIOD expr  */
#line 40 "proto/mrt/config.Y"
                        { MRT_CFG->period = (yyvsp[0].i); }
#line 11050 "obj/conf/cf-parse.tab.c"
    break;

  case 874: /* mrt_proto_item: ALWAYS ADD PATH bool  */
#line 41 "proto/mrt/config.Y"
                        { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 11056 "obj/conf/cf-parse.tab.c"
    break;

  case 877: /* mrt_proto: mrt_proto_start proto_name '{' mrt_proto_opts '}'  */
#line 50 "proto/mrt/config.Y"
                                                     { mrt_check_config(this_proto); }
#line 11062 "obj/conf/cf-parse.tab.c"
    break;

  case 879: /* cmd_MRT_DUMP: MRT DUMP mrt_dump_args END  */
#line 54 "proto/mrt/config.Y"
{ mrt_dump_cmd((yyvsp[-1].md)); }
#line 11068 "obj/conf/cf-parse.tab.c"
    break;

  case 880: /* mrt_dump_args: %empty  */
#line 57 "proto/mrt/config.Y"
               { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 11074 "obj/conf/cf-parse.tab.c"
    break;

  case 881: /* mrt_dump_args: mrt_dump_args TABLE rtable  */
#line 58 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 11080 "obj/conf/cf-parse.tab.c"
    break;

  case 882: /* mrt_dump_args: mrt_dump_args TABLE TEXT  */
#line 59 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 11086 "obj/conf/cf-parse.tab.c"
    break;

  case 883: /* mrt_dump_args: mrt_dump_args FILTER filter  */
#line 60 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 11092 "obj/conf/cf-parse.tab.c"
    break;

  case 884: /* mrt_dump_args: mrt_dump_args where_filter  */
#line 61 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 11098 "obj/conf/cf-parse.tab.c"
    break;

  case 885: /* mrt_dump_args: mrt_dump_args TO text  */
#line 62 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 11104 "obj/conf/cf-parse.tab.c"
    break;

  case 886: /* proto: ospf_proto '}'  */
#line 211 "proto/ospf/config.Y"
                      { ospf_proto_finish(); }
#line 11110 "obj/conf/cf-parse.tab.c"
    break;

  case 887: /* ospf_variant: OSPF  */
#line 214 "proto/ospf/config.Y"
           { (yyval.i) = 1; }
#line 11116 "obj/conf/cf-parse.tab.c"
    break;

  case 888: /* ospf_variant: OSPF V2  */
#line 215 "proto/ospf/config.Y"
           { (yyval.i) = 1; }
#line 11122 "obj/conf/cf-parse.tab.c"
    break;

  case 889: /* ospf_variant: OSPF V3  */
#line 216 "proto/ospf/config.Y"
           { (yyval.i) = 0; }
#line 11128 "obj/conf/cf-parse.tab.c"
    break;

  case 890: /* ospf_proto_start: proto_start ospf_variant  */
#line 220 "proto/ospf/config.Y"
{
  this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : 0;

  init_list(&OSPF_CFG->area_list);
  init_list(&OSPF_CFG->vlink_list);
  OSPF_CFG->ecmp = rt_default_ecmp;
  OSPF_CFG->tick = OSPF_DEFAULT_TICK;
  OSPF_CFG->ospf2 = (yyvsp[0].i);
  OSPF_CFG->af_ext = !(yyvsp[0].i);
  OSPF_CFG->gr_mode = OSPF_GR_AWARE;
  OSPF_CFG->gr_time = OSPF_DEFAULT_GR_TIME;
}
#line 11146 "obj/conf/cf-parse.tab.c"
    break;

  case 893: /* ospf_af_mc: %empty  */
#line 240 "proto/ospf/config.Y"
             { (yyval.i) = 0; }
#line 11152 "obj/conf/cf-parse.tab.c"
    break;

  case 894: /* ospf_af_mc: MULTICAST  */
#line 241 "proto/ospf/config.Y"
             { (yyval.i) = 1; }
#line 11158 "obj/conf/cf-parse.tab.c"
    break;

  case 895: /* ospf_channel_start: net_type ospf_af_mc  */
#line 246 "proto/ospf/config.Y"
{
  /* TODO: change name for multicast channels */
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[-1].i)], (yyvsp[-1].i), this_proto);

  /* Save the multicast flag */
  if (this_channel == proto_cf_main_channel(this_proto))
    OSPF_CFG->af_mc = (yyvsp[0].i);
}
#line 11171 "obj/conf/cf-parse.tab.c"
    break;

  case 898: /* ospf_proto_item: ospf_channel  */
#line 259 "proto/ospf/config.Y"
                { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 11177 "obj/conf/cf-parse.tab.c"
    break;

  case 899: /* ospf_proto_item: RFC1583COMPAT bool  */
#line 260 "proto/ospf/config.Y"
                      { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 11183 "obj/conf/cf-parse.tab.c"
    break;

  case 900: /* ospf_proto_item: RFC5838 bool  */
#line 261 "proto/ospf/config.Y"
                { OSPF_CFG->af_ext = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("RFC5838 option requires OSPFv3"); }
#line 11189 "obj/conf/cf-parse.tab.c"
    break;

  case 901: /* ospf_proto_item: VPN PE bool  */
#line 262 "proto/ospf/config.Y"
               { OSPF_CFG->vpn_pe = (yyvsp[0].i); }
#line 11195 "obj/conf/cf-parse.tab.c"
    break;

  case 902: /* ospf_proto_item: STUB ROUTER bool  */
#line 263 "proto/ospf/config.Y"
                    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 11201 "obj/conf/cf-parse.tab.c"
    break;

  case 903: /* ospf_proto_item: GRACEFUL RESTART bool  */
#line 264 "proto/ospf/config.Y"
                         { OSPF_CFG->gr_mode = (yyvsp[0].i); }
#line 11207 "obj/conf/cf-parse.tab.c"
    break;

  case 904: /* ospf_proto_item: GRACEFUL RESTART AWARE  */
#line 265 "proto/ospf/config.Y"
                          { OSPF_CFG->gr_mode = OSPF_GR_AWARE; }
#line 11213 "obj/conf/cf-parse.tab.c"
    break;

  case 905: /* ospf_proto_item: GRACEFUL RESTART TIME expr  */
#line 266 "proto/ospf/config.Y"
                              { OSPF_CFG->gr_time = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 1800)) cf_error("Graceful restart time must be in range 1-1800"); }
#line 11219 "obj/conf/cf-parse.tab.c"
    break;

  case 906: /* ospf_proto_item: ECMP bool  */
#line 267 "proto/ospf/config.Y"
             { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 11225 "obj/conf/cf-parse.tab.c"
    break;

  case 907: /* ospf_proto_item: ECMP bool LIMIT expr  */
#line 268 "proto/ospf/config.Y"
                        { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 11231 "obj/conf/cf-parse.tab.c"
    break;

  case 908: /* ospf_proto_item: MERGE EXTERNAL bool  */
#line 269 "proto/ospf/config.Y"
                       { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 11237 "obj/conf/cf-parse.tab.c"
    break;

  case 909: /* ospf_proto_item: TICK expr  */
#line 270 "proto/ospf/config.Y"
             { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i) <= 0) cf_error("Tick must be greater than zero"); }
#line 11243 "obj/conf/cf-parse.tab.c"
    break;

  case 910: /* ospf_proto_item: INSTANCE ID expr  */
#line 271 "proto/ospf/config.Y"
                    { OSPF_CFG->instance_id = (yyvsp[0].i); OSPF_CFG->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 11249 "obj/conf/cf-parse.tab.c"
    break;

  case 912: /* ospf_area_start: AREA idval  */
#line 275 "proto/ospf/config.Y"
                            {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 11267 "obj/conf/cf-parse.tab.c"
    break;

  case 913: /* ospf_area: ospf_area_start '{' ospf_area_opts '}'  */
#line 290 "proto/ospf/config.Y"
                                                  { ospf_area_finish(); }
#line 11273 "obj/conf/cf-parse.tab.c"
    break;

  case 916: /* ospf_area_item: STUB bool  */
#line 299 "proto/ospf/config.Y"
             { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 11279 "obj/conf/cf-parse.tab.c"
    break;

  case 917: /* ospf_area_item: NSSA  */
#line 300 "proto/ospf/config.Y"
        { this_area->type = OPT_N; }
#line 11285 "obj/conf/cf-parse.tab.c"
    break;

  case 918: /* ospf_area_item: SUMMARY bool  */
#line 301 "proto/ospf/config.Y"
                { this_area->summary = (yyvsp[0].i); }
#line 11291 "obj/conf/cf-parse.tab.c"
    break;

  case 919: /* ospf_area_item: DEFAULT NSSA bool  */
#line 302 "proto/ospf/config.Y"
                     { this_area->default_nssa = (yyvsp[0].i); }
#line 11297 "obj/conf/cf-parse.tab.c"
    break;

  case 920: /* ospf_area_item: DEFAULT COST expr  */
#line 303 "proto/ospf/config.Y"
                     { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 11303 "obj/conf/cf-parse.tab.c"
    break;

  case 921: /* ospf_area_item: DEFAULT COST2 expr  */
#line 304 "proto/ospf/config.Y"
                      { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 11309 "obj/conf/cf-parse.tab.c"
    break;

  case 922: /* ospf_area_item: STUB COST expr  */
#line 305 "proto/ospf/config.Y"
                  { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 11315 "obj/conf/cf-parse.tab.c"
    break;

  case 923: /* ospf_area_item: TRANSLATOR bool  */
#line 306 "proto/ospf/config.Y"
                   { this_area->translator = (yyvsp[0].i); }
#line 11321 "obj/conf/cf-parse.tab.c"
    break;

  case 924: /* ospf_area_item: TRANSLATOR STABILITY expr  */
#line 307 "proto/ospf/config.Y"
                             { this_area->transint = (yyvsp[0].i); }
#line 11327 "obj/conf/cf-parse.tab.c"
    break;

  case 925: /* $@3: %empty  */
#line 308 "proto/ospf/config.Y"
            { this_nets = &this_area->net_list; }
#line 11333 "obj/conf/cf-parse.tab.c"
    break;

  case 927: /* $@4: %empty  */
#line 309 "proto/ospf/config.Y"
            { this_nets = &this_area->enet_list; }
#line 11339 "obj/conf/cf-parse.tab.c"
    break;

  case 934: /* ospf_stubnet_start: net_ip  */
#line 321 "proto/ospf/config.Y"
          {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->prefix = (yyvsp[0].net);
     this_stubnet->cost = COST_D;
   }
#line 11350 "obj/conf/cf-parse.tab.c"
    break;

  case 937: /* ospf_stubnet_item: HIDDEN bool  */
#line 335 "proto/ospf/config.Y"
               { this_stubnet->hidden = (yyvsp[0].i); }
#line 11356 "obj/conf/cf-parse.tab.c"
    break;

  case 938: /* ospf_stubnet_item: SUMMARY bool  */
#line 336 "proto/ospf/config.Y"
                { this_stubnet->summary = (yyvsp[0].i); }
#line 11362 "obj/conf/cf-parse.tab.c"
    break;

  case 939: /* ospf_stubnet_item: COST expr  */
#line 337 "proto/ospf/config.Y"
             { this_stubnet->cost = (yyvsp[0].i); }
#line 11368 "obj/conf/cf-parse.tab.c"
    break;

  case 940: /* ospf_vlink: ospf_vlink_start ospf_instance_id '{' ospf_vlink_opts '}'  */
#line 341 "proto/ospf/config.Y"
                                                             { ospf_iface_finish(); }
#line 11374 "obj/conf/cf-parse.tab.c"
    break;

  case 941: /* ospf_vlink: ospf_vlink_start ospf_instance_id  */
#line 342 "proto/ospf/config.Y"
                                     { ospf_iface_finish(); }
#line 11380 "obj/conf/cf-parse.tab.c"
    break;

  case 945: /* ospf_vlink_item: HELLO expr  */
#line 351 "proto/ospf/config.Y"
              { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 11386 "obj/conf/cf-parse.tab.c"
    break;

  case 946: /* ospf_vlink_item: RETRANSMIT expr  */
#line 352 "proto/ospf/config.Y"
                   { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 11392 "obj/conf/cf-parse.tab.c"
    break;

  case 947: /* ospf_vlink_item: TRANSMIT DELAY expr  */
#line 353 "proto/ospf/config.Y"
                       { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 11398 "obj/conf/cf-parse.tab.c"
    break;

  case 948: /* ospf_vlink_item: WAIT expr  */
#line 354 "proto/ospf/config.Y"
             { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 11404 "obj/conf/cf-parse.tab.c"
    break;

  case 949: /* ospf_vlink_item: DEAD expr  */
#line 355 "proto/ospf/config.Y"
             { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 11410 "obj/conf/cf-parse.tab.c"
    break;

  case 950: /* ospf_vlink_item: DEAD COUNT expr  */
#line 356 "proto/ospf/config.Y"
                   { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 11416 "obj/conf/cf-parse.tab.c"
    break;

  case 951: /* ospf_vlink_item: AUTHENTICATION NONE  */
#line 357 "proto/ospf/config.Y"
                       { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 11422 "obj/conf/cf-parse.tab.c"
    break;

  case 952: /* ospf_vlink_item: AUTHENTICATION SIMPLE  */
#line 358 "proto/ospf/config.Y"
                         { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 11428 "obj/conf/cf-parse.tab.c"
    break;

  case 953: /* ospf_vlink_item: AUTHENTICATION CRYPTOGRAPHIC  */
#line 359 "proto/ospf/config.Y"
                                { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 11434 "obj/conf/cf-parse.tab.c"
    break;

  case 955: /* ospf_vlink_start: VIRTUAL LINK idval  */
#line 364 "proto/ospf/config.Y"
 {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 11454 "obj/conf/cf-parse.tab.c"
    break;

  case 956: /* ospf_iface_item: COST expr  */
#line 382 "proto/ospf/config.Y"
             { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 11460 "obj/conf/cf-parse.tab.c"
    break;

  case 957: /* ospf_iface_item: HELLO expr  */
#line 383 "proto/ospf/config.Y"
              { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 11466 "obj/conf/cf-parse.tab.c"
    break;

  case 958: /* ospf_iface_item: POLL expr  */
#line 384 "proto/ospf/config.Y"
             { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 11472 "obj/conf/cf-parse.tab.c"
    break;

  case 959: /* ospf_iface_item: RETRANSMIT expr  */
#line 385 "proto/ospf/config.Y"
                   { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 11478 "obj/conf/cf-parse.tab.c"
    break;

  case 960: /* ospf_iface_item: WAIT expr  */
#line 386 "proto/ospf/config.Y"
             { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 11484 "obj/conf/cf-parse.tab.c"
    break;

  case 961: /* ospf_iface_item: DEAD expr  */
#line 387 "proto/ospf/config.Y"
             { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 11490 "obj/conf/cf-parse.tab.c"
    break;

  case 962: /* ospf_iface_item: DEAD COUNT expr  */
#line 388 "proto/ospf/config.Y"
                   { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 11496 "obj/conf/cf-parse.tab.c"
    break;

  case 963: /* ospf_iface_item: TYPE BROADCAST  */
#line 389 "proto/ospf/config.Y"
                  { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 11502 "obj/conf/cf-parse.tab.c"
    break;

  case 964: /* ospf_iface_item: TYPE BCAST  */
#line 390 "proto/ospf/config.Y"
              { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 11508 "obj/conf/cf-parse.tab.c"
    break;

  case 965: /* ospf_iface_item: TYPE NONBROADCAST  */
#line 391 "proto/ospf/config.Y"
                     { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 11514 "obj/conf/cf-parse.tab.c"
    break;

  case 966: /* ospf_iface_item: TYPE NBMA  */
#line 392 "proto/ospf/config.Y"
             { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 11520 "obj/conf/cf-parse.tab.c"
    break;

  case 967: /* ospf_iface_item: TYPE POINTOPOINT  */
#line 393 "proto/ospf/config.Y"
                    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 11526 "obj/conf/cf-parse.tab.c"
    break;

  case 968: /* ospf_iface_item: TYPE PTP  */
#line 394 "proto/ospf/config.Y"
            { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 11532 "obj/conf/cf-parse.tab.c"
    break;

  case 969: /* ospf_iface_item: TYPE POINTOMULTIPOINT  */
#line 395 "proto/ospf/config.Y"
                         { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 11538 "obj/conf/cf-parse.tab.c"
    break;

  case 970: /* ospf_iface_item: TYPE PTMP  */
#line 396 "proto/ospf/config.Y"
             { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 11544 "obj/conf/cf-parse.tab.c"
    break;

  case 971: /* ospf_iface_item: REAL BROADCAST bool  */
#line 397 "proto/ospf/config.Y"
                       { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 11550 "obj/conf/cf-parse.tab.c"
    break;

  case 972: /* ospf_iface_item: PTP NETMASK bool  */
#line 398 "proto/ospf/config.Y"
                    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 11556 "obj/conf/cf-parse.tab.c"
    break;

  case 973: /* ospf_iface_item: TRANSMIT DELAY expr  */
#line 399 "proto/ospf/config.Y"
                       { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 11562 "obj/conf/cf-parse.tab.c"
    break;

  case 974: /* ospf_iface_item: PRIORITY expr  */
#line 400 "proto/ospf/config.Y"
                 { OSPF_PATT->priority = (yyvsp[0].i) ; if ((yyvsp[0].i)>255) cf_error("Priority must be in range 0-255"); }
#line 11568 "obj/conf/cf-parse.tab.c"
    break;

  case 975: /* ospf_iface_item: STRICT NONBROADCAST bool  */
#line 401 "proto/ospf/config.Y"
                            { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 11574 "obj/conf/cf-parse.tab.c"
    break;

  case 976: /* ospf_iface_item: STUB bool  */
#line 402 "proto/ospf/config.Y"
             { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 11580 "obj/conf/cf-parse.tab.c"
    break;

  case 977: /* ospf_iface_item: CHECK LINK bool  */
#line 403 "proto/ospf/config.Y"
                   { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 11586 "obj/conf/cf-parse.tab.c"
    break;

  case 978: /* ospf_iface_item: ECMP WEIGHT expr  */
#line 404 "proto/ospf/config.Y"
                    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 11592 "obj/conf/cf-parse.tab.c"
    break;

  case 979: /* ospf_iface_item: LINK LSA SUPPRESSION bool  */
#line 405 "proto/ospf/config.Y"
                             { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 11598 "obj/conf/cf-parse.tab.c"
    break;

  case 981: /* ospf_iface_item: AUTHENTICATION NONE  */
#line 407 "proto/ospf/config.Y"
                       { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 11604 "obj/conf/cf-parse.tab.c"
    break;

  case 982: /* ospf_iface_item: AUTHENTICATION SIMPLE  */
#line 408 "proto/ospf/config.Y"
                         { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 11610 "obj/conf/cf-parse.tab.c"
    break;

  case 983: /* ospf_iface_item: AUTHENTICATION CRYPTOGRAPHIC  */
#line 409 "proto/ospf/config.Y"
                                { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 11616 "obj/conf/cf-parse.tab.c"
    break;

  case 984: /* ospf_iface_item: RX BUFFER NORMAL  */
#line 410 "proto/ospf/config.Y"
                    { OSPF_PATT->rx_buffer = 0; }
#line 11622 "obj/conf/cf-parse.tab.c"
    break;

  case 985: /* ospf_iface_item: RX BUFFER LARGE  */
#line 411 "proto/ospf/config.Y"
                   { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 11628 "obj/conf/cf-parse.tab.c"
    break;

  case 986: /* ospf_iface_item: RX BUFFER expr  */
#line 412 "proto/ospf/config.Y"
                  { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 11634 "obj/conf/cf-parse.tab.c"
    break;

  case 987: /* ospf_iface_item: TX tos  */
#line 413 "proto/ospf/config.Y"
          { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 11640 "obj/conf/cf-parse.tab.c"
    break;

  case 988: /* ospf_iface_item: TX PRIORITY expr  */
#line 414 "proto/ospf/config.Y"
                    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 11646 "obj/conf/cf-parse.tab.c"
    break;

  case 989: /* ospf_iface_item: TX LENGTH expr  */
#line 415 "proto/ospf/config.Y"
                  { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 11652 "obj/conf/cf-parse.tab.c"
    break;

  case 990: /* ospf_iface_item: TTL SECURITY bool  */
#line 416 "proto/ospf/config.Y"
                     { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 11658 "obj/conf/cf-parse.tab.c"
    break;

  case 991: /* ospf_iface_item: TTL SECURITY TX ONLY  */
#line 417 "proto/ospf/config.Y"
                        { OSPF_PATT->ttl_security = 2; }
#line 11664 "obj/conf/cf-parse.tab.c"
    break;

  case 992: /* ospf_iface_item: BFD bool  */
#line 418 "proto/ospf/config.Y"
            { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 11670 "obj/conf/cf-parse.tab.c"
    break;

  case 997: /* pref_base: net_ip  */
#line 430 "proto/ospf/config.Y"
 {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->prefix = (yyvsp[0].net);
 }
#line 11680 "obj/conf/cf-parse.tab.c"
    break;

  case 999: /* pref_opt: HIDDEN  */
#line 439 "proto/ospf/config.Y"
          { this_pref->hidden = 1; }
#line 11686 "obj/conf/cf-parse.tab.c"
    break;

  case 1000: /* pref_opt: TAG expr  */
#line 440 "proto/ospf/config.Y"
            { this_pref->tag = (yyvsp[0].i); }
#line 11692 "obj/conf/cf-parse.tab.c"
    break;

  case 1003: /* nbma_eligible: %empty  */
#line 449 "proto/ospf/config.Y"
             { (yyval.i) = 0; }
#line 11698 "obj/conf/cf-parse.tab.c"
    break;

  case 1004: /* nbma_eligible: ELIGIBLE  */
#line 450 "proto/ospf/config.Y"
            { (yyval.i) = 1; }
#line 11704 "obj/conf/cf-parse.tab.c"
    break;

  case 1005: /* nbma_item: ipa nbma_eligible ';'  */
#line 454 "proto/ospf/config.Y"
 {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 11715 "obj/conf/cf-parse.tab.c"
    break;

  case 1006: /* ospf_iface_start: %empty  */
#line 463 "proto/ospf/config.Y"
 {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->check_link = 1;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 11739 "obj/conf/cf-parse.tab.c"
    break;

  case 1008: /* ospf_instance_id: INSTANCE expr  */
#line 486 "proto/ospf/config.Y"
                 { OSPF_PATT->instance_id = (yyvsp[0].i); OSPF_PATT->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 11745 "obj/conf/cf-parse.tab.c"
    break;

  case 1009: /* $@5: %empty  */
#line 490 "proto/ospf/config.Y"
                   { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 11751 "obj/conf/cf-parse.tab.c"
    break;

  case 1015: /* ospf_iface: ospf_iface_start ospf_iface_patt_list ospf_iface_opt_list  */
#line 504 "proto/ospf/config.Y"
                                                            { ospf_iface_finish(); }
#line 11757 "obj/conf/cf-parse.tab.c"
    break;

  case 1016: /* dynamic_attr: OSPF_METRIC1  */
#line 507 "proto/ospf/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC1); }
#line 11763 "obj/conf/cf-parse.tab.c"
    break;

  case 1017: /* dynamic_attr: OSPF_METRIC2  */
#line 508 "proto/ospf/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC2); }
#line 11769 "obj/conf/cf-parse.tab.c"
    break;

  case 1018: /* dynamic_attr: OSPF_TAG  */
#line 509 "proto/ospf/config.Y"
                       { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_TAG); }
#line 11775 "obj/conf/cf-parse.tab.c"
    break;

  case 1019: /* dynamic_attr: OSPF_ROUTER_ID  */
#line 510 "proto/ospf/config.Y"
                             { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 11781 "obj/conf/cf-parse.tab.c"
    break;

  case 1021: /* cmd_SHOW_OSPF: SHOW OSPF optproto END  */
#line 514 "proto/ospf/config.Y"
{ ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 11787 "obj/conf/cf-parse.tab.c"
    break;

  case 1023: /* cmd_SHOW_OSPF_NEIGHBORS: SHOW OSPF NEIGHBORS optproto opttext END  */
#line 517 "proto/ospf/config.Y"
{ ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 11793 "obj/conf/cf-parse.tab.c"
    break;

  case 1025: /* cmd_SHOW_OSPF_INTERFACE: SHOW OSPF INTERFACE optproto opttext END  */
#line 520 "proto/ospf/config.Y"
{ ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 11799 "obj/conf/cf-parse.tab.c"
    break;

  case 1027: /* cmd_SHOW_OSPF_TOPOLOGY: SHOW OSPF TOPOLOGY optproto opttext END  */
#line 525 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 11805 "obj/conf/cf-parse.tab.c"
    break;

  case 1029: /* cmd_SHOW_OSPF_TOPOLOGY_ALL: SHOW OSPF TOPOLOGY ALL optproto opttext END  */
#line 528 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 11811 "obj/conf/cf-parse.tab.c"
    break;

  case 1031: /* cmd_SHOW_OSPF_STATE: SHOW OSPF STATE optproto opttext END  */
#line 533 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 11817 "obj/conf/cf-parse.tab.c"
    break;

  case 1033: /* cmd_SHOW_OSPF_STATE_ALL: SHOW OSPF STATE ALL optproto opttext END  */
#line 536 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 11823 "obj/conf/cf-parse.tab.c"
    break;

  case 1035: /* cmd_SHOW_OSPF_LSADB: SHOW OSPF LSADB lsadb_args END  */
#line 540 "proto/ospf/config.Y"
{
  if (!(yyvsp[-1].ld)->proto)
    (yyvsp[-1].ld)->proto = (struct ospf_proto *) proto_get_named(NULL, &proto_ospf);

  ospf_sh_lsadb((yyvsp[-1].ld));
}
#line 11834 "obj/conf/cf-parse.tab.c"
    break;

  case 1036: /* lsadb_args: %empty  */
#line 548 "proto/ospf/config.Y"
               {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 11842 "obj/conf/cf-parse.tab.c"
    break;

  case 1037: /* lsadb_args: lsadb_args GLOBAL  */
#line 551 "proto/ospf/config.Y"
                     { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 11848 "obj/conf/cf-parse.tab.c"
    break;

  case 1038: /* lsadb_args: lsadb_args AREA idval  */
#line 552 "proto/ospf/config.Y"
                         { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 11854 "obj/conf/cf-parse.tab.c"
    break;

  case 1039: /* lsadb_args: lsadb_args LINK  */
#line 553 "proto/ospf/config.Y"
                   { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 11860 "obj/conf/cf-parse.tab.c"
    break;

  case 1040: /* lsadb_args: lsadb_args TYPE NUM  */
#line 554 "proto/ospf/config.Y"
                       { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 11866 "obj/conf/cf-parse.tab.c"
    break;

  case 1041: /* lsadb_args: lsadb_args LSID idval  */
#line 555 "proto/ospf/config.Y"
                         { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 11872 "obj/conf/cf-parse.tab.c"
    break;

  case 1042: /* lsadb_args: lsadb_args SELF  */
#line 556 "proto/ospf/config.Y"
                   { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 11878 "obj/conf/cf-parse.tab.c"
    break;

  case 1043: /* lsadb_args: lsadb_args ROUTER idval  */
#line 557 "proto/ospf/config.Y"
                           { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 11884 "obj/conf/cf-parse.tab.c"
    break;

  case 1044: /* lsadb_args: lsadb_args CF_SYM_KNOWN  */
#line 558 "proto/ospf/config.Y"
                           { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->proto = (struct ospf_proto *) proto_get_named((yyvsp[0].s), &proto_ospf); }
#line 11890 "obj/conf/cf-parse.tab.c"
    break;

  case 1046: /* perf_proto_start: proto_start PERF  */
#line 27 "proto/perf/config.Y"
{
  this_proto = proto_config_new(&proto_perf, (yyvsp[-1].i));
  PERF_CFG->from = 10;
  PERF_CFG->to = 20;
  PERF_CFG->repeat = 4;
  PERF_CFG->threshold_max = 500 MS_;
  PERF_CFG->threshold_min = 1 MS_;
  PERF_CFG->attrs_per_rte = 0;
  PERF_CFG->keep = 0;
  PERF_CFG->mode = PERF_MODE_IMPORT;
}
#line 11906 "obj/conf/cf-parse.tab.c"
    break;

  case 1050: /* perf_proto_item: proto_channel  */
#line 46 "proto/perf/config.Y"
                 { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 11912 "obj/conf/cf-parse.tab.c"
    break;

  case 1051: /* perf_proto_item: EXP FROM NUM  */
#line 47 "proto/perf/config.Y"
                { PERF_CFG->from = (yyvsp[0].i); }
#line 11918 "obj/conf/cf-parse.tab.c"
    break;

  case 1052: /* perf_proto_item: EXP TO NUM  */
#line 48 "proto/perf/config.Y"
              { PERF_CFG->to = (yyvsp[0].i); }
#line 11924 "obj/conf/cf-parse.tab.c"
    break;

  case 1053: /* perf_proto_item: REPEAT NUM  */
#line 49 "proto/perf/config.Y"
              { PERF_CFG->repeat = (yyvsp[0].i); }
#line 11930 "obj/conf/cf-parse.tab.c"
    break;

  case 1054: /* perf_proto_item: THRESHOLD MIN expr_us  */
#line 50 "proto/perf/config.Y"
                         { PERF_CFG->threshold_min = (yyvsp[0].time); }
#line 11936 "obj/conf/cf-parse.tab.c"
    break;

  case 1055: /* perf_proto_item: THRESHOLD MAX expr_us  */
#line 51 "proto/perf/config.Y"
                         { PERF_CFG->threshold_max = (yyvsp[0].time); }
#line 11942 "obj/conf/cf-parse.tab.c"
    break;

  case 1056: /* perf_proto_item: ATTRIBUTES NUM  */
#line 52 "proto/perf/config.Y"
                  { PERF_CFG->attrs_per_rte = (yyvsp[0].i); }
#line 11948 "obj/conf/cf-parse.tab.c"
    break;

  case 1057: /* perf_proto_item: KEEP bool  */
#line 53 "proto/perf/config.Y"
             { PERF_CFG->keep = (yyvsp[0].i); }
#line 11954 "obj/conf/cf-parse.tab.c"
    break;

  case 1058: /* perf_proto_item: MODE IMPORT  */
#line 54 "proto/perf/config.Y"
               { PERF_CFG->mode = PERF_MODE_IMPORT; }
#line 11960 "obj/conf/cf-parse.tab.c"
    break;

  case 1059: /* perf_proto_item: MODE EXPORT  */
#line 55 "proto/perf/config.Y"
               { PERF_CFG->mode = PERF_MODE_EXPORT; }
#line 11966 "obj/conf/cf-parse.tab.c"
    break;

  case 1060: /* proto: pipe_proto '}'  */
#line 23 "proto/pipe/config.Y"
                      { this_channel = NULL; }
#line 11972 "obj/conf/cf-parse.tab.c"
    break;

  case 1061: /* $@6: %empty  */
#line 26 "proto/pipe/config.Y"
{
  this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
}
#line 11980 "obj/conf/cf-parse.tab.c"
    break;

  case 1062: /* pipe_proto_start: proto_start PIPE $@6 proto_name  */
#line 30 "proto/pipe/config.Y"
{
  this_channel = proto_cf_main_channel(this_proto);
  if (!this_channel) {
    this_channel = channel_config_new(NULL, NULL, 0, this_proto);
    this_channel->in_filter = FILTER_ACCEPT;
    this_channel->out_filter = FILTER_ACCEPT;
  }
}
#line 11993 "obj/conf/cf-parse.tab.c"
    break;

  case 1066: /* pipe_proto: pipe_proto PEER TABLE rtable ';'  */
#line 43 "proto/pipe/config.Y"
                                    { PIPE_CFG->peer = (yyvsp[-1].r); }
#line 11999 "obj/conf/cf-parse.tab.c"
    break;

  case 1068: /* radv_proto_start: proto_start RADV  */
#line 47 "proto/radv/config.Y"
{
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));

  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 12012 "obj/conf/cf-parse.tab.c"
    break;

  case 1072: /* radv_proto_item: PREFIX radv_prefix  */
#line 60 "proto/radv/config.Y"
                      { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 12018 "obj/conf/cf-parse.tab.c"
    break;

  case 1073: /* $@7: %empty  */
#line 61 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12024 "obj/conf/cf-parse.tab.c"
    break;

  case 1074: /* radv_proto_item: RDNSS $@7 radv_rdnss  */
#line 61 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 12030 "obj/conf/cf-parse.tab.c"
    break;

  case 1075: /* $@8: %empty  */
#line 62 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12036 "obj/conf/cf-parse.tab.c"
    break;

  case 1076: /* radv_proto_item: DNSSL $@8 radv_dnssl  */
#line 62 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 12042 "obj/conf/cf-parse.tab.c"
    break;

  case 1077: /* radv_proto_item: TRIGGER net_ip6  */
#line 63 "proto/radv/config.Y"
                   { RADV_CFG->trigger = (yyvsp[0].net); }
#line 12048 "obj/conf/cf-parse.tab.c"
    break;

  case 1078: /* radv_proto_item: PROPAGATE ROUTES bool  */
#line 64 "proto/radv/config.Y"
                         { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 12054 "obj/conf/cf-parse.tab.c"
    break;

  case 1082: /* radv_iface_start: %empty  */
#line 77 "proto/radv/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = (u32) -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = (u32) -1;
  RADV_IFACE->route_linger_time = (u32) -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = (u32) -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = (u32) -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 12080 "obj/conf/cf-parse.tab.c"
    break;

  case 1083: /* radv_iface_item: MIN RA INTERVAL expr  */
#line 100 "proto/radv/config.Y"
                        { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 12086 "obj/conf/cf-parse.tab.c"
    break;

  case 1084: /* radv_iface_item: MAX RA INTERVAL expr  */
#line 101 "proto/radv/config.Y"
                        { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 12092 "obj/conf/cf-parse.tab.c"
    break;

  case 1085: /* radv_iface_item: MIN DELAY expr  */
#line 102 "proto/radv/config.Y"
                  { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 12098 "obj/conf/cf-parse.tab.c"
    break;

  case 1086: /* radv_iface_item: SOLICITED RA UNICAST bool  */
#line 103 "proto/radv/config.Y"
                             { RADV_IFACE->solicited_ra_unicast = (yyvsp[0].i); }
#line 12104 "obj/conf/cf-parse.tab.c"
    break;

  case 1087: /* radv_iface_item: MANAGED bool  */
#line 104 "proto/radv/config.Y"
                { RADV_IFACE->managed = (yyvsp[0].i); }
#line 12110 "obj/conf/cf-parse.tab.c"
    break;

  case 1088: /* radv_iface_item: OTHER CONFIG bool  */
#line 105 "proto/radv/config.Y"
                     { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 12116 "obj/conf/cf-parse.tab.c"
    break;

  case 1089: /* radv_iface_item: LINK MTU expr  */
#line 106 "proto/radv/config.Y"
                 { RADV_IFACE->link_mtu = (yyvsp[0].i); }
#line 12122 "obj/conf/cf-parse.tab.c"
    break;

  case 1090: /* radv_iface_item: REACHABLE TIME expr  */
#line 107 "proto/radv/config.Y"
                       { RADV_IFACE->reachable_time = (yyvsp[0].i); if ((yyvsp[0].i) > 3600000) cf_error("Reachable time must be in range 0-3600000"); }
#line 12128 "obj/conf/cf-parse.tab.c"
    break;

  case 1091: /* radv_iface_item: RETRANS TIMER expr  */
#line 108 "proto/radv/config.Y"
                      { RADV_IFACE->retrans_timer = (yyvsp[0].i); }
#line 12134 "obj/conf/cf-parse.tab.c"
    break;

  case 1092: /* radv_iface_item: CURRENT HOP LIMIT expr  */
#line 109 "proto/radv/config.Y"
                          { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if ((yyvsp[0].i) > 255) cf_error("Current hop limit must be in range 0-255"); }
#line 12140 "obj/conf/cf-parse.tab.c"
    break;

  case 1093: /* radv_iface_item: DEFAULT LIFETIME expr radv_sensitive  */
#line 110 "proto/radv/config.Y"
                                        {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) > 9000)  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12150 "obj/conf/cf-parse.tab.c"
    break;

  case 1094: /* radv_iface_item: ROUTE LIFETIME expr radv_sensitive  */
#line 115 "proto/radv/config.Y"
                                      {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12159 "obj/conf/cf-parse.tab.c"
    break;

  case 1095: /* radv_iface_item: DEFAULT PREFERENCE radv_preference  */
#line 119 "proto/radv/config.Y"
                                      { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 12165 "obj/conf/cf-parse.tab.c"
    break;

  case 1096: /* radv_iface_item: ROUTE PREFERENCE radv_preference  */
#line 120 "proto/radv/config.Y"
                                    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 12171 "obj/conf/cf-parse.tab.c"
    break;

  case 1097: /* radv_iface_item: PREFIX LINGER TIME expr  */
#line 121 "proto/radv/config.Y"
                           { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 12177 "obj/conf/cf-parse.tab.c"
    break;

  case 1098: /* radv_iface_item: ROUTE LINGER TIME expr  */
#line 122 "proto/radv/config.Y"
                          { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 12183 "obj/conf/cf-parse.tab.c"
    break;

  case 1099: /* radv_iface_item: PREFIX radv_prefix  */
#line 123 "proto/radv/config.Y"
                      { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 12189 "obj/conf/cf-parse.tab.c"
    break;

  case 1100: /* $@9: %empty  */
#line 124 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12195 "obj/conf/cf-parse.tab.c"
    break;

  case 1101: /* radv_iface_item: RDNSS $@9 radv_rdnss  */
#line 124 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 12201 "obj/conf/cf-parse.tab.c"
    break;

  case 1102: /* $@10: %empty  */
#line 125 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12207 "obj/conf/cf-parse.tab.c"
    break;

  case 1103: /* radv_iface_item: DNSSL $@10 radv_dnssl  */
#line 125 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 12213 "obj/conf/cf-parse.tab.c"
    break;

  case 1104: /* radv_iface_item: RDNSS LOCAL bool  */
#line 126 "proto/radv/config.Y"
                    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 12219 "obj/conf/cf-parse.tab.c"
    break;

  case 1105: /* radv_iface_item: DNSSL LOCAL bool  */
#line 127 "proto/radv/config.Y"
                    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 12225 "obj/conf/cf-parse.tab.c"
    break;

  case 1106: /* radv_preference: LOW  */
#line 131 "proto/radv/config.Y"
       { (yyval.i) = RA_PREF_LOW; }
#line 12231 "obj/conf/cf-parse.tab.c"
    break;

  case 1107: /* radv_preference: MEDIUM  */
#line 132 "proto/radv/config.Y"
          { (yyval.i) = RA_PREF_MEDIUM; }
#line 12237 "obj/conf/cf-parse.tab.c"
    break;

  case 1108: /* radv_preference: HIGH  */
#line 133 "proto/radv/config.Y"
        { (yyval.i) = RA_PREF_HIGH; }
#line 12243 "obj/conf/cf-parse.tab.c"
    break;

  case 1109: /* radv_iface_finish: %empty  */
#line 136 "proto/radv/config.Y"
{
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval");

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 12284 "obj/conf/cf-parse.tab.c"
    break;

  case 1115: /* radv_prefix_start: net_ip6  */
#line 189 "proto/radv/config.Y"
{
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = *(net_addr_ip6 *) &((yyvsp[0].net));

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 12298 "obj/conf/cf-parse.tab.c"
    break;

  case 1116: /* radv_prefix_item: SKIP bool  */
#line 200 "proto/radv/config.Y"
             { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 12304 "obj/conf/cf-parse.tab.c"
    break;

  case 1117: /* radv_prefix_item: ONLINK bool  */
#line 201 "proto/radv/config.Y"
               { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 12310 "obj/conf/cf-parse.tab.c"
    break;

  case 1118: /* radv_prefix_item: AUTONOMOUS bool  */
#line 202 "proto/radv/config.Y"
                   { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 12316 "obj/conf/cf-parse.tab.c"
    break;

  case 1119: /* radv_prefix_item: VALID LIFETIME expr radv_sensitive  */
#line 203 "proto/radv/config.Y"
                                      {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12325 "obj/conf/cf-parse.tab.c"
    break;

  case 1120: /* radv_prefix_item: PREFERRED LIFETIME expr radv_sensitive  */
#line 207 "proto/radv/config.Y"
                                          {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12334 "obj/conf/cf-parse.tab.c"
    break;

  case 1121: /* radv_prefix_finish: %empty  */
#line 214 "proto/radv/config.Y"
{
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 12346 "obj/conf/cf-parse.tab.c"
    break;

  case 1127: /* radv_rdnss_node: ipa  */
#line 238 "proto/radv/config.Y"
{
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12358 "obj/conf/cf-parse.tab.c"
    break;

  case 1128: /* radv_rdnss_start: %empty  */
#line 247 "proto/radv/config.Y"
{
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12367 "obj/conf/cf-parse.tab.c"
    break;

  case 1131: /* radv_rdnss_item: LIFETIME radv_mult  */
#line 254 "proto/radv/config.Y"
                      { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 12373 "obj/conf/cf-parse.tab.c"
    break;

  case 1132: /* radv_rdnss_finish: %empty  */
#line 258 "proto/radv/config.Y"
{
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 12389 "obj/conf/cf-parse.tab.c"
    break;

  case 1137: /* radv_dnssl_node: TEXT  */
#line 282 "proto/radv/config.Y"
{
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 12404 "obj/conf/cf-parse.tab.c"
    break;

  case 1138: /* radv_dnssl_start: %empty  */
#line 294 "proto/radv/config.Y"
{
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12413 "obj/conf/cf-parse.tab.c"
    break;

  case 1141: /* radv_dnssl_item: LIFETIME radv_mult  */
#line 301 "proto/radv/config.Y"
                      { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 12419 "obj/conf/cf-parse.tab.c"
    break;

  case 1142: /* radv_dnssl_finish: %empty  */
#line 305 "proto/radv/config.Y"
{
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 12435 "obj/conf/cf-parse.tab.c"
    break;

  case 1147: /* radv_mult: expr  */
#line 329 "proto/radv/config.Y"
        { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 12441 "obj/conf/cf-parse.tab.c"
    break;

  case 1148: /* radv_mult: MULT expr  */
#line 330 "proto/radv/config.Y"
             { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 12447 "obj/conf/cf-parse.tab.c"
    break;

  case 1149: /* radv_sensitive: %empty  */
#line 334 "proto/radv/config.Y"
               { (yyval.i) = (uint) -1; }
#line 12453 "obj/conf/cf-parse.tab.c"
    break;

  case 1150: /* radv_sensitive: SENSITIVE bool  */
#line 335 "proto/radv/config.Y"
                  { (yyval.i) = (yyvsp[0].i); }
#line 12459 "obj/conf/cf-parse.tab.c"
    break;

  case 1151: /* dynamic_attr: RA_PREFERENCE  */
#line 338 "proto/radv/config.Y"
                            { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 12465 "obj/conf/cf-parse.tab.c"
    break;

  case 1152: /* dynamic_attr: RA_LIFETIME  */
#line 339 "proto/radv/config.Y"
                          { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 12471 "obj/conf/cf-parse.tab.c"
    break;

  case 1154: /* rip_variant: RIP  */
#line 48 "proto/rip/config.Y"
          { (yyval.i) = 1; }
#line 12477 "obj/conf/cf-parse.tab.c"
    break;

  case 1155: /* rip_variant: RIP NG  */
#line 49 "proto/rip/config.Y"
          { (yyval.i) = 0; }
#line 12483 "obj/conf/cf-parse.tab.c"
    break;

  case 1156: /* rip_proto_start: proto_start rip_variant  */
#line 53 "proto/rip/config.Y"
{
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : NET_IP6;

  init_list(&RIP_CFG->patt_list);
  RIP_CFG->rip2 = (yyvsp[0].i);
  RIP_CFG->ecmp = rt_default_ecmp;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;
  RIP_CFG->min_timeout_time = 60 S_;
  RIP_CFG->max_garbage_time = 60 S_;
}
#line 12499 "obj/conf/cf-parse.tab.c"
    break;

  case 1159: /* rip_proto_item: ECMP bool  */
#line 68 "proto/rip/config.Y"
                        { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 12505 "obj/conf/cf-parse.tab.c"
    break;

  case 1160: /* rip_proto_item: ECMP bool LIMIT expr  */
#line 69 "proto/rip/config.Y"
                        { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 12511 "obj/conf/cf-parse.tab.c"
    break;

  case 1161: /* rip_proto_item: INFINITY expr  */
#line 70 "proto/rip/config.Y"
                        { RIP_CFG->infinity = (yyvsp[0].i); }
#line 12517 "obj/conf/cf-parse.tab.c"
    break;

  case 1166: /* rip_iface_start: %empty  */
#line 84 "proto/rip/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->check_link = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 12544 "obj/conf/cf-parse.tab.c"
    break;

  case 1167: /* rip_iface_finish: %empty  */
#line 108 "proto/rip/config.Y"
{
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 12577 "obj/conf/cf-parse.tab.c"
    break;

  case 1168: /* rip_iface_item: METRIC expr  */
#line 138 "proto/rip/config.Y"
                        { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 12583 "obj/conf/cf-parse.tab.c"
    break;

  case 1169: /* rip_iface_item: MODE MULTICAST  */
#line 139 "proto/rip/config.Y"
                        { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 12589 "obj/conf/cf-parse.tab.c"
    break;

  case 1170: /* rip_iface_item: MODE BROADCAST  */
#line 140 "proto/rip/config.Y"
                        { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 12595 "obj/conf/cf-parse.tab.c"
    break;

  case 1171: /* rip_iface_item: PASSIVE bool  */
#line 141 "proto/rip/config.Y"
                        { RIP_IFACE->passive = (yyvsp[0].i); }
#line 12601 "obj/conf/cf-parse.tab.c"
    break;

  case 1172: /* rip_iface_item: ADDRESS ipa  */
#line 142 "proto/rip/config.Y"
                        { RIP_IFACE->address = (yyvsp[0].a); if (ipa_is_ip4((yyvsp[0].a)) != rip_cfg_is_v2()) cf_error("IP address version mismatch"); }
#line 12607 "obj/conf/cf-parse.tab.c"
    break;

  case 1173: /* rip_iface_item: PORT expr  */
#line 143 "proto/rip/config.Y"
                        { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 12613 "obj/conf/cf-parse.tab.c"
    break;

  case 1174: /* rip_iface_item: VERSION expr  */
#line 144 "proto/rip/config.Y"
                        { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 12622 "obj/conf/cf-parse.tab.c"
    break;

  case 1175: /* rip_iface_item: VERSION ONLY bool  */
#line 148 "proto/rip/config.Y"
                        { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 12628 "obj/conf/cf-parse.tab.c"
    break;

  case 1176: /* rip_iface_item: SPLIT HORIZON bool  */
#line 149 "proto/rip/config.Y"
                        { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 12634 "obj/conf/cf-parse.tab.c"
    break;

  case 1177: /* rip_iface_item: POISON REVERSE bool  */
#line 150 "proto/rip/config.Y"
                        { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 12640 "obj/conf/cf-parse.tab.c"
    break;

  case 1178: /* rip_iface_item: CHECK ZERO bool  */
#line 151 "proto/rip/config.Y"
                        { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 12646 "obj/conf/cf-parse.tab.c"
    break;

  case 1179: /* rip_iface_item: UPDATE TIME expr  */
#line 152 "proto/rip/config.Y"
                        { RIP_IFACE->update_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 12652 "obj/conf/cf-parse.tab.c"
    break;

  case 1180: /* rip_iface_item: TIMEOUT TIME expr  */
#line 153 "proto/rip/config.Y"
                        { RIP_IFACE->timeout_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 12658 "obj/conf/cf-parse.tab.c"
    break;

  case 1181: /* rip_iface_item: GARBAGE TIME expr  */
#line 154 "proto/rip/config.Y"
                        { RIP_IFACE->garbage_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 12664 "obj/conf/cf-parse.tab.c"
    break;

  case 1182: /* rip_iface_item: ECMP WEIGHT expr  */
#line 155 "proto/rip/config.Y"
                        { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 12670 "obj/conf/cf-parse.tab.c"
    break;

  case 1183: /* rip_iface_item: RX BUFFER expr  */
#line 156 "proto/rip/config.Y"
                        { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 12676 "obj/conf/cf-parse.tab.c"
    break;

  case 1184: /* rip_iface_item: TX LENGTH expr  */
#line 157 "proto/rip/config.Y"
                        { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 12682 "obj/conf/cf-parse.tab.c"
    break;

  case 1185: /* rip_iface_item: TX tos  */
#line 158 "proto/rip/config.Y"
                        { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 12688 "obj/conf/cf-parse.tab.c"
    break;

  case 1186: /* rip_iface_item: TX PRIORITY expr  */
#line 159 "proto/rip/config.Y"
                        { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 12694 "obj/conf/cf-parse.tab.c"
    break;

  case 1187: /* rip_iface_item: TTL SECURITY bool  */
#line 160 "proto/rip/config.Y"
                        { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 12700 "obj/conf/cf-parse.tab.c"
    break;

  case 1188: /* rip_iface_item: TTL SECURITY TX ONLY  */
#line 161 "proto/rip/config.Y"
                        { RIP_IFACE->ttl_security = 2; }
#line 12706 "obj/conf/cf-parse.tab.c"
    break;

  case 1189: /* rip_iface_item: CHECK LINK bool  */
#line 162 "proto/rip/config.Y"
                        { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 12712 "obj/conf/cf-parse.tab.c"
    break;

  case 1190: /* rip_iface_item: BFD bool  */
#line 163 "proto/rip/config.Y"
                        { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 12718 "obj/conf/cf-parse.tab.c"
    break;

  case 1191: /* rip_iface_item: AUTHENTICATION rip_auth  */
#line 164 "proto/rip/config.Y"
                           { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 12724 "obj/conf/cf-parse.tab.c"
    break;

  case 1192: /* rip_iface_item: password_list  */
#line 165 "proto/rip/config.Y"
                        { rip_check_auth(); }
#line 12730 "obj/conf/cf-parse.tab.c"
    break;

  case 1193: /* rip_auth: NONE  */
#line 169 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_NONE; }
#line 12736 "obj/conf/cf-parse.tab.c"
    break;

  case 1194: /* rip_auth: PLAINTEXT  */
#line 170 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_PLAIN; }
#line 12742 "obj/conf/cf-parse.tab.c"
    break;

  case 1195: /* rip_auth: CRYPTOGRAPHIC  */
#line 171 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 12748 "obj/conf/cf-parse.tab.c"
    break;

  case 1196: /* rip_auth: MD5  */
#line 172 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 12754 "obj/conf/cf-parse.tab.c"
    break;

  case 1202: /* dynamic_attr: RIP_METRIC  */
#line 189 "proto/rip/config.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_METRIC); }
#line 12760 "obj/conf/cf-parse.tab.c"
    break;

  case 1203: /* dynamic_attr: RIP_TAG  */
#line 190 "proto/rip/config.Y"
                      { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_TAG); }
#line 12766 "obj/conf/cf-parse.tab.c"
    break;

  case 1205: /* cmd_SHOW_RIP_INTERFACES: SHOW RIP INTERFACES optproto opttext END  */
#line 195 "proto/rip/config.Y"
{ rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 12772 "obj/conf/cf-parse.tab.c"
    break;

  case 1207: /* cmd_SHOW_RIP_NEIGHBORS: SHOW RIP NEIGHBORS optproto opttext END  */
#line 198 "proto/rip/config.Y"
{ rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 12778 "obj/conf/cf-parse.tab.c"
    break;

  case 1209: /* rpki_proto_start: proto_start RPKI  */
#line 43 "proto/rpki/config.Y"
                                   {
  this_proto = proto_config_new(&proto_rpki, (yyvsp[-1].i));
  RPKI_CFG->retry_interval = RPKI_RETRY_INTERVAL;
  RPKI_CFG->refresh_interval = RPKI_REFRESH_INTERVAL;
  RPKI_CFG->expire_interval = RPKI_EXPIRE_INTERVAL;
}
#line 12789 "obj/conf/cf-parse.tab.c"
    break;

  case 1210: /* rpki_proto: rpki_proto_start proto_name '{' rpki_proto_opts '}'  */
#line 50 "proto/rpki/config.Y"
                                                                { rpki_check_config(RPKI_CFG); }
#line 12795 "obj/conf/cf-parse.tab.c"
    break;

  case 1219: /* rpki_proto_item: REFRESH rpki_keep_interval expr  */
#line 64 "proto/rpki/config.Y"
                                   {
     if (rpki_check_refresh_interval((yyvsp[0].i)))
       cf_error(rpki_check_refresh_interval((yyvsp[0].i)));
     RPKI_CFG->refresh_interval = (yyvsp[0].i);
     RPKI_CFG->keep_refresh_interval = (yyvsp[-1].i);
   }
#line 12806 "obj/conf/cf-parse.tab.c"
    break;

  case 1220: /* rpki_proto_item: RETRY rpki_keep_interval expr  */
#line 70 "proto/rpki/config.Y"
                                 {
     if (rpki_check_retry_interval((yyvsp[0].i)))
       cf_error(rpki_check_retry_interval((yyvsp[0].i)));
     RPKI_CFG->retry_interval = (yyvsp[0].i);
     RPKI_CFG->keep_retry_interval = (yyvsp[-1].i);
   }
#line 12817 "obj/conf/cf-parse.tab.c"
    break;

  case 1221: /* rpki_proto_item: EXPIRE rpki_keep_interval expr  */
#line 76 "proto/rpki/config.Y"
                                  {
     if (rpki_check_expire_interval((yyvsp[0].i)))
       cf_error(rpki_check_expire_interval((yyvsp[0].i)));
     RPKI_CFG->expire_interval = (yyvsp[0].i);
     RPKI_CFG->keep_expire_interval = (yyvsp[-1].i);
   }
#line 12828 "obj/conf/cf-parse.tab.c"
    break;

  case 1222: /* rpki_keep_interval: %empty  */
#line 85 "proto/rpki/config.Y"
             { (yyval.i) = 0; }
#line 12834 "obj/conf/cf-parse.tab.c"
    break;

  case 1223: /* rpki_keep_interval: KEEP  */
#line 86 "proto/rpki/config.Y"
        { (yyval.i) = 1; }
#line 12840 "obj/conf/cf-parse.tab.c"
    break;

  case 1224: /* rpki_proto_item_port: PORT expr  */
#line 89 "proto/rpki/config.Y"
                                { check_u16((yyvsp[0].i)); RPKI_CFG->port = (yyvsp[0].i); }
#line 12846 "obj/conf/cf-parse.tab.c"
    break;

  case 1225: /* rpki_cache_addr: text  */
#line 92 "proto/rpki/config.Y"
        {
     rpki_check_unused_hostname();
     RPKI_CFG->hostname = (yyvsp[0].t);
   }
#line 12855 "obj/conf/cf-parse.tab.c"
    break;

  case 1226: /* rpki_cache_addr: ipa  */
#line 96 "proto/rpki/config.Y"
       {
     rpki_check_unused_hostname();
     RPKI_CFG->ip = (yyvsp[0].a);
     /* Ensure hostname is filled */
     char *hostname = cfg_allocz(INET6_ADDRSTRLEN + 1);
     bsnprintf(hostname, INET6_ADDRSTRLEN+1, "%I", RPKI_CFG->ip);
     RPKI_CFG->hostname = hostname;
   }
#line 12868 "obj/conf/cf-parse.tab.c"
    break;

  case 1229: /* rpki_transport_tcp_init: %empty  */
#line 112 "proto/rpki/config.Y"
{
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_tcp_config));
  RPKI_CFG->tr_config.type = RPKI_TR_TCP;
}
#line 12878 "obj/conf/cf-parse.tab.c"
    break;

  case 1230: /* rpki_transport_ssh_init: %empty  */
#line 119 "proto/rpki/config.Y"
{
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_ssh_config));
  RPKI_CFG->tr_config.type = RPKI_TR_SSH;
}
#line 12888 "obj/conf/cf-parse.tab.c"
    break;

  case 1233: /* rpki_transport_ssh_item: BIRD PRIVATE KEY text  */
#line 131 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->bird_private_key = (yyvsp[0].t); }
#line 12894 "obj/conf/cf-parse.tab.c"
    break;

  case 1234: /* rpki_transport_ssh_item: REMOTE PUBLIC KEY text  */
#line 132 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->cache_public_key = (yyvsp[0].t); }
#line 12900 "obj/conf/cf-parse.tab.c"
    break;

  case 1235: /* rpki_transport_ssh_item: USER text  */
#line 133 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->user = (yyvsp[0].t); }
#line 12906 "obj/conf/cf-parse.tab.c"
    break;

  case 1236: /* rpki_transport_ssh_check: %empty  */
#line 137 "proto/rpki/config.Y"
{
  if (RPKI_TR_SSH_CFG->user == NULL)
    cf_error("User must be set");
}
#line 12915 "obj/conf/cf-parse.tab.c"
    break;

  case 1238: /* static_proto_start: proto_start STATIC  */
#line 57 "proto/static/config.Y"
{
  this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
  init_list(&STATIC_CFG->routes);
}
#line 12924 "obj/conf/cf-parse.tab.c"
    break;

  case 1241: /* static_proto: static_proto proto_channel ';'  */
#line 65 "proto/static/config.Y"
                                  { this_proto->net_type = (yyvsp[-1].cc)->net_type; }
#line 12930 "obj/conf/cf-parse.tab.c"
    break;

  case 1242: /* static_proto: static_proto CHECK LINK bool ';'  */
#line 66 "proto/static/config.Y"
                                    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 12936 "obj/conf/cf-parse.tab.c"
    break;

  case 1243: /* static_proto: static_proto IGP TABLE rtable ';'  */
#line 67 "proto/static/config.Y"
                                     {
    if ((yyvsp[-1].r)->addr_type == NET_IP4)
      STATIC_CFG->igp_table_ip4 = (yyvsp[-1].r);
    else if ((yyvsp[-1].r)->addr_type == NET_IP6)
      STATIC_CFG->igp_table_ip6 = (yyvsp[-1].r);
    else
      cf_error("Incompatible IGP table type");
   }
#line 12949 "obj/conf/cf-parse.tab.c"
    break;

  case 1244: /* static_proto: static_proto stat_route stat_route_opt_list ';'  */
#line 75 "proto/static/config.Y"
                                                   { static_route_finish(); }
#line 12955 "obj/conf/cf-parse.tab.c"
    break;

  case 1245: /* stat_nexthop: VIA ipa ipa_scope  */
#line 79 "proto/static/config.Y"
                      {
      this_snh = static_nexthop_new();
      this_snh->via = (yyvsp[-1].a);
      this_snh->iface = (yyvsp[0].iface);
    }
#line 12965 "obj/conf/cf-parse.tab.c"
    break;

  case 1246: /* stat_nexthop: VIA TEXT  */
#line 84 "proto/static/config.Y"
             {
      this_snh = static_nexthop_new();
      this_snh->via = IPA_NONE;
      this_snh->iface = if_get_by_name((yyvsp[0].t));
    }
#line 12975 "obj/conf/cf-parse.tab.c"
    break;

  case 1247: /* stat_nexthop: stat_nexthop MPLS label_stack  */
#line 89 "proto/static/config.Y"
                                  {
    this_snh->mls = (yyvsp[0].mls);
  }
#line 12983 "obj/conf/cf-parse.tab.c"
    break;

  case 1248: /* stat_nexthop: stat_nexthop ONLINK bool  */
#line 92 "proto/static/config.Y"
                             {
    this_snh->onlink = (yyvsp[0].i);
  }
#line 12991 "obj/conf/cf-parse.tab.c"
    break;

  case 1249: /* stat_nexthop: stat_nexthop WEIGHT expr  */
#line 95 "proto/static/config.Y"
                             {
    this_snh->weight = (yyvsp[0].i) - 1;
    if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256");
  }
#line 13000 "obj/conf/cf-parse.tab.c"
    break;

  case 1250: /* stat_nexthop: stat_nexthop BFD bool  */
#line 99 "proto/static/config.Y"
                          {
    this_snh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
  }
#line 13008 "obj/conf/cf-parse.tab.c"
    break;

  case 1253: /* stat_route0: ROUTE net_any  */
#line 109 "proto/static/config.Y"
                           {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->routes, &this_srt->n);
     this_srt->net = (yyvsp[0].net_ptr);
     this_srt_cmds = NULL;
     this_srt_last_cmd = NULL;
     this_srt->mp_next = NULL;
     this_snh = NULL;
  }
#line 13022 "obj/conf/cf-parse.tab.c"
    break;

  case 1255: /* stat_route: stat_route0 RECURSIVE ipa  */
#line 122 "proto/static/config.Y"
                             {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 13031 "obj/conf/cf-parse.tab.c"
    break;

  case 1256: /* stat_route: stat_route0 RECURSIVE ipa MPLS label_stack  */
#line 126 "proto/static/config.Y"
                                              {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[-2].a);
      this_srt->mls = (yyvsp[0].mls);
   }
#line 13041 "obj/conf/cf-parse.tab.c"
    break;

  case 1257: /* stat_route: stat_route0  */
#line 131 "proto/static/config.Y"
                                { this_srt->dest = RTD_NONE; }
#line 13047 "obj/conf/cf-parse.tab.c"
    break;

  case 1258: /* stat_route: stat_route0 DROP  */
#line 132 "proto/static/config.Y"
                                { this_srt->dest = RTD_BLACKHOLE; }
#line 13053 "obj/conf/cf-parse.tab.c"
    break;

  case 1259: /* stat_route: stat_route0 REJECT  */
#line 133 "proto/static/config.Y"
                                { this_srt->dest = RTD_UNREACHABLE; }
#line 13059 "obj/conf/cf-parse.tab.c"
    break;

  case 1260: /* stat_route: stat_route0 BLACKHOLE  */
#line 134 "proto/static/config.Y"
                                { this_srt->dest = RTD_BLACKHOLE; }
#line 13065 "obj/conf/cf-parse.tab.c"
    break;

  case 1261: /* stat_route: stat_route0 UNREACHABLE  */
#line 135 "proto/static/config.Y"
                                { this_srt->dest = RTD_UNREACHABLE; }
#line 13071 "obj/conf/cf-parse.tab.c"
    break;

  case 1262: /* stat_route: stat_route0 PROHIBIT  */
#line 136 "proto/static/config.Y"
                                { this_srt->dest = RTD_PROHIBIT; }
#line 13077 "obj/conf/cf-parse.tab.c"
    break;

  case 1263: /* stat_route_item: cmd  */
#line 140 "proto/static/config.Y"
       {
     if (this_srt_last_cmd)
       this_srt_last_cmd->next = (yyvsp[0].x);
     else
       this_srt_cmds = (yyvsp[0].x);
     this_srt_last_cmd = (yyvsp[0].x);
   }
#line 13089 "obj/conf/cf-parse.tab.c"
    break;

  case 1269: /* cmd_SHOW_STATIC: SHOW STATIC optproto END  */
#line 161 "proto/static/config.Y"
{ static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 13095 "obj/conf/cf-parse.tab.c"
    break;

  case 1271: /* kern_sys_item: KERNEL TABLE expr  */
#line 25 "sysdep/linux/netlink.Y"
                     { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 13101 "obj/conf/cf-parse.tab.c"
    break;

  case 1272: /* kern_sys_item: METRIC expr  */
#line 26 "sysdep/linux/netlink.Y"
               { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 13107 "obj/conf/cf-parse.tab.c"
    break;

  case 1273: /* dynamic_attr: KRT_PREFSRC  */
#line 29 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 13113 "obj/conf/cf-parse.tab.c"
    break;

  case 1274: /* dynamic_attr: KRT_REALM  */
#line 30 "sysdep/linux/netlink.Y"
                        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 13119 "obj/conf/cf-parse.tab.c"
    break;

  case 1275: /* dynamic_attr: KRT_SCOPE  */
#line 31 "sysdep/linux/netlink.Y"
                        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 13125 "obj/conf/cf-parse.tab.c"
    break;

  case 1276: /* dynamic_attr: KRT_MTU  */
#line 33 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 13131 "obj/conf/cf-parse.tab.c"
    break;

  case 1277: /* dynamic_attr: KRT_WINDOW  */
#line 34 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 13137 "obj/conf/cf-parse.tab.c"
    break;

  case 1278: /* dynamic_attr: KRT_RTT  */
#line 35 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 13143 "obj/conf/cf-parse.tab.c"
    break;

  case 1279: /* dynamic_attr: KRT_RTTVAR  */
#line 36 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 13149 "obj/conf/cf-parse.tab.c"
    break;

  case 1280: /* dynamic_attr: KRT_SSTRESH  */
#line 37 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 13155 "obj/conf/cf-parse.tab.c"
    break;

  case 1281: /* dynamic_attr: KRT_CWND  */
#line 38 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 13161 "obj/conf/cf-parse.tab.c"
    break;

  case 1282: /* dynamic_attr: KRT_ADVMSS  */
#line 39 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 13167 "obj/conf/cf-parse.tab.c"
    break;

  case 1283: /* dynamic_attr: KRT_REORDERING  */
#line 40 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 13173 "obj/conf/cf-parse.tab.c"
    break;

  case 1284: /* dynamic_attr: KRT_HOPLIMIT  */
#line 41 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 13179 "obj/conf/cf-parse.tab.c"
    break;

  case 1285: /* dynamic_attr: KRT_INITCWND  */
#line 42 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 13185 "obj/conf/cf-parse.tab.c"
    break;

  case 1286: /* dynamic_attr: KRT_RTO_MIN  */
#line 43 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 13191 "obj/conf/cf-parse.tab.c"
    break;

  case 1287: /* dynamic_attr: KRT_INITRWND  */
#line 44 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 13197 "obj/conf/cf-parse.tab.c"
    break;

  case 1288: /* dynamic_attr: KRT_QUICKACK  */
#line 45 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 13203 "obj/conf/cf-parse.tab.c"
    break;

  case 1289: /* dynamic_attr: KRT_LOCK_MTU  */
#line 49 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(2, T_BOOL, EA_KRT_LOCK); }
#line 13209 "obj/conf/cf-parse.tab.c"
    break;

  case 1290: /* dynamic_attr: KRT_LOCK_WINDOW  */
#line 50 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(3, T_BOOL, EA_KRT_LOCK); }
#line 13215 "obj/conf/cf-parse.tab.c"
    break;

  case 1291: /* dynamic_attr: KRT_LOCK_RTT  */
#line 51 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(4, T_BOOL, EA_KRT_LOCK); }
#line 13221 "obj/conf/cf-parse.tab.c"
    break;

  case 1292: /* dynamic_attr: KRT_LOCK_RTTVAR  */
#line 52 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(5, T_BOOL, EA_KRT_LOCK); }
#line 13227 "obj/conf/cf-parse.tab.c"
    break;

  case 1293: /* dynamic_attr: KRT_LOCK_SSTRESH  */
#line 53 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(6, T_BOOL, EA_KRT_LOCK); }
#line 13233 "obj/conf/cf-parse.tab.c"
    break;

  case 1294: /* dynamic_attr: KRT_LOCK_CWND  */
#line 54 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(7, T_BOOL, EA_KRT_LOCK); }
#line 13239 "obj/conf/cf-parse.tab.c"
    break;

  case 1295: /* dynamic_attr: KRT_LOCK_ADVMSS  */
#line 55 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(8, T_BOOL, EA_KRT_LOCK); }
#line 13245 "obj/conf/cf-parse.tab.c"
    break;

  case 1296: /* dynamic_attr: KRT_LOCK_REORDERING  */
#line 56 "sysdep/linux/netlink.Y"
                                  { (yyval.fda) = f_new_dynamic_attr_bit(9, T_BOOL, EA_KRT_LOCK); }
#line 13251 "obj/conf/cf-parse.tab.c"
    break;

  case 1297: /* dynamic_attr: KRT_LOCK_HOPLIMIT  */
#line 57 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(10, T_BOOL, EA_KRT_LOCK); }
#line 13257 "obj/conf/cf-parse.tab.c"
    break;

  case 1298: /* dynamic_attr: KRT_LOCK_RTO_MIN  */
#line 58 "sysdep/linux/netlink.Y"
                               { (yyval.fda) = f_new_dynamic_attr_bit(13, T_BOOL, EA_KRT_LOCK); }
#line 13263 "obj/conf/cf-parse.tab.c"
    break;

  case 1299: /* dynamic_attr: KRT_FEATURE_ECN  */
#line 60 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(0, T_BOOL, EA_KRT_FEATURES); }
#line 13269 "obj/conf/cf-parse.tab.c"
    break;

  case 1300: /* dynamic_attr: KRT_FEATURE_ALLFRAG  */
#line 61 "sysdep/linux/netlink.Y"
                                  { (yyval.fda) = f_new_dynamic_attr(3, T_BOOL, EA_KRT_FEATURES); }
#line 13275 "obj/conf/cf-parse.tab.c"
    break;

  case 1302: /* log_begin: %empty  */
#line 33 "sysdep/unix/config.Y"
           { this_log = cfg_allocz(sizeof(struct log_config)); }
#line 13281 "obj/conf/cf-parse.tab.c"
    break;

  case 1303: /* log_config: LOG log_begin log_file log_mask ';'  */
#line 35 "sysdep/unix/config.Y"
                                                {
    this_log->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &this_log->n);
  }
#line 13290 "obj/conf/cf-parse.tab.c"
    break;

  case 1304: /* syslog_name: NAME text  */
#line 42 "sysdep/unix/config.Y"
             { (yyval.t) = (yyvsp[0].t); }
#line 13296 "obj/conf/cf-parse.tab.c"
    break;

  case 1305: /* syslog_name: %empty  */
#line 43 "sysdep/unix/config.Y"
   { (yyval.t) = bird_name; }
#line 13302 "obj/conf/cf-parse.tab.c"
    break;

  case 1307: /* log_limit: expr text  */
#line 48 "sysdep/unix/config.Y"
             { this_log->limit = (yyvsp[-1].i); this_log->backup = (yyvsp[0].t); }
#line 13308 "obj/conf/cf-parse.tab.c"
    break;

  case 1308: /* log_file: text log_limit  */
#line 52 "sysdep/unix/config.Y"
                  {
     this_log->rf = rf_open(new_config->pool, (yyvsp[-1].t), "a");
     if (!this_log->rf) cf_error("Unable to open log file '%s': %m", (yyvsp[-1].t));
     this_log->fh = rf_file(this_log->rf);
     this_log->pos = -1;
     this_log->filename = (yyvsp[-1].t);
   }
#line 13320 "obj/conf/cf-parse.tab.c"
    break;

  case 1309: /* log_file: SYSLOG syslog_name  */
#line 59 "sysdep/unix/config.Y"
                      { this_log->fh = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 13326 "obj/conf/cf-parse.tab.c"
    break;

  case 1310: /* log_file: STDERR  */
#line 60 "sysdep/unix/config.Y"
          { this_log->fh = stderr; }
#line 13332 "obj/conf/cf-parse.tab.c"
    break;

  case 1311: /* log_mask: ALL  */
#line 64 "sysdep/unix/config.Y"
       { (yyval.i) = ~0; }
#line 13338 "obj/conf/cf-parse.tab.c"
    break;

  case 1312: /* log_mask: '{' log_mask_list '}'  */
#line 65 "sysdep/unix/config.Y"
                         { (yyval.i) = (yyvsp[-1].i); }
#line 13344 "obj/conf/cf-parse.tab.c"
    break;

  case 1313: /* log_mask_list: log_cat  */
#line 69 "sysdep/unix/config.Y"
           { (yyval.i) = 1 << (yyvsp[0].i); }
#line 13350 "obj/conf/cf-parse.tab.c"
    break;

  case 1314: /* log_mask_list: log_mask_list ',' log_cat  */
#line 70 "sysdep/unix/config.Y"
                             { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 13356 "obj/conf/cf-parse.tab.c"
    break;

  case 1315: /* log_cat: DEBUG  */
#line 74 "sysdep/unix/config.Y"
         { (yyval.i) = L_DEBUG[0]; }
#line 13362 "obj/conf/cf-parse.tab.c"
    break;

  case 1316: /* log_cat: TRACE  */
#line 75 "sysdep/unix/config.Y"
         { (yyval.i) = L_TRACE[0]; }
#line 13368 "obj/conf/cf-parse.tab.c"
    break;

  case 1317: /* log_cat: INFO  */
#line 76 "sysdep/unix/config.Y"
        { (yyval.i) = L_INFO[0]; }
#line 13374 "obj/conf/cf-parse.tab.c"
    break;

  case 1318: /* log_cat: REMOTE  */
#line 77 "sysdep/unix/config.Y"
          { (yyval.i) = L_REMOTE[0]; }
#line 13380 "obj/conf/cf-parse.tab.c"
    break;

  case 1319: /* log_cat: WARNING  */
#line 78 "sysdep/unix/config.Y"
           { (yyval.i) = L_WARN[0]; }
#line 13386 "obj/conf/cf-parse.tab.c"
    break;

  case 1320: /* log_cat: ERROR  */
#line 79 "sysdep/unix/config.Y"
         { (yyval.i) = L_ERR[0]; }
#line 13392 "obj/conf/cf-parse.tab.c"
    break;

  case 1321: /* log_cat: AUTH  */
#line 80 "sysdep/unix/config.Y"
        { (yyval.i) = L_AUTH[0]; }
#line 13398 "obj/conf/cf-parse.tab.c"
    break;

  case 1322: /* log_cat: FATAL  */
#line 81 "sysdep/unix/config.Y"
         { (yyval.i) = L_FATAL[0]; }
#line 13404 "obj/conf/cf-parse.tab.c"
    break;

  case 1323: /* log_cat: BUG  */
#line 82 "sysdep/unix/config.Y"
       { (yyval.i) = L_BUG[0]; }
#line 13410 "obj/conf/cf-parse.tab.c"
    break;

  case 1325: /* mrtdump_base: MRTDUMP PROTOCOLS mrtdump_mask ';'  */
#line 89 "sysdep/unix/config.Y"
                                      { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 13416 "obj/conf/cf-parse.tab.c"
    break;

  case 1326: /* mrtdump_base: MRTDUMP text ';'  */
#line 90 "sysdep/unix/config.Y"
                    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = rf_fileno(f);
   }
#line 13426 "obj/conf/cf-parse.tab.c"
    break;

  case 1328: /* debug_unix: DEBUG LATENCY bool  */
#line 101 "sysdep/unix/config.Y"
                      { new_config->latency_debug = (yyvsp[0].i); }
#line 13432 "obj/conf/cf-parse.tab.c"
    break;

  case 1329: /* debug_unix: DEBUG LATENCY LIMIT expr_us  */
#line 102 "sysdep/unix/config.Y"
                               { new_config->latency_limit = (yyvsp[0].time); }
#line 13438 "obj/conf/cf-parse.tab.c"
    break;

  case 1330: /* debug_unix: WATCHDOG WARNING expr_us  */
#line 103 "sysdep/unix/config.Y"
                            { new_config->watchdog_warning = (yyvsp[0].time); }
#line 13444 "obj/conf/cf-parse.tab.c"
    break;

  case 1331: /* debug_unix: WATCHDOG TIMEOUT expr_us  */
#line 104 "sysdep/unix/config.Y"
                            { new_config->watchdog_timeout = ((yyvsp[0].time) + 999999) TO_S; }
#line 13450 "obj/conf/cf-parse.tab.c"
    break;

  case 1333: /* cmd_CONFIGURE: CONFIGURE cfg_name cfg_timeout END  */
#line 113 "sysdep/unix/config.Y"
{ cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 13456 "obj/conf/cf-parse.tab.c"
    break;

  case 1335: /* cmd_CONFIGURE_SOFT: CONFIGURE SOFT cfg_name cfg_timeout END  */
#line 116 "sysdep/unix/config.Y"
{ cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 13462 "obj/conf/cf-parse.tab.c"
    break;

  case 1337: /* cmd_CONFIGURE_CONFIRM: CONFIGURE CONFIRM END  */
#line 123 "sysdep/unix/config.Y"
{ cmd_reconfig_confirm(); }
#line 13468 "obj/conf/cf-parse.tab.c"
    break;

  case 1339: /* cmd_CONFIGURE_UNDO: CONFIGURE UNDO END  */
#line 126 "sysdep/unix/config.Y"
{ cmd_reconfig_undo(); }
#line 13474 "obj/conf/cf-parse.tab.c"
    break;

  case 1341: /* cmd_CONFIGURE_STATUS: CONFIGURE STATUS END  */
#line 129 "sysdep/unix/config.Y"
{ cmd_reconfig_status(); }
#line 13480 "obj/conf/cf-parse.tab.c"
    break;

  case 1343: /* cmd_CONFIGURE_CHECK: CONFIGURE CHECK cfg_name END  */
#line 132 "sysdep/unix/config.Y"
{ cmd_check_config((yyvsp[-1].t)); }
#line 13486 "obj/conf/cf-parse.tab.c"
    break;

  case 1345: /* cmd_DOWN: DOWN END  */
#line 135 "sysdep/unix/config.Y"
{ cmd_shutdown(); }
#line 13492 "obj/conf/cf-parse.tab.c"
    break;

  case 1347: /* cmd_GRACEFUL_RESTART: GRACEFUL RESTART END  */
#line 140 "sysdep/unix/config.Y"
{ cmd_graceful_restart(); }
#line 13498 "obj/conf/cf-parse.tab.c"
    break;

  case 1348: /* cfg_name: %empty  */
#line 144 "sysdep/unix/config.Y"
               { (yyval.t) = NULL; }
#line 13504 "obj/conf/cf-parse.tab.c"
    break;

  case 1350: /* cfg_timeout: %empty  */
#line 149 "sysdep/unix/config.Y"
               { (yyval.i) = 0; }
#line 13510 "obj/conf/cf-parse.tab.c"
    break;

  case 1351: /* cfg_timeout: TIMEOUT  */
#line 150 "sysdep/unix/config.Y"
           { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 13516 "obj/conf/cf-parse.tab.c"
    break;

  case 1352: /* cfg_timeout: TIMEOUT expr  */
#line 151 "sysdep/unix/config.Y"
                { (yyval.i) = (yyvsp[0].i); }
#line 13522 "obj/conf/cf-parse.tab.c"
    break;

  case 1354: /* kern_proto_start: proto_start KERNEL  */
#line 43 "sysdep/unix/krt.Y"
                                     {
     this_proto = krt_init_config((yyvsp[-1].i));
}
#line 13530 "obj/conf/cf-parse.tab.c"
    break;

  case 1357: /* kern_mp_limit: %empty  */
#line 52 "sysdep/unix/krt.Y"
               { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 13536 "obj/conf/cf-parse.tab.c"
    break;

  case 1358: /* kern_mp_limit: LIMIT expr  */
#line 53 "sysdep/unix/krt.Y"
               { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 13542 "obj/conf/cf-parse.tab.c"
    break;

  case 1360: /* kern_item: proto_channel  */
#line 58 "sysdep/unix/krt.Y"
                 { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 13548 "obj/conf/cf-parse.tab.c"
    break;

  case 1361: /* kern_item: PERSIST bool  */
#line 59 "sysdep/unix/krt.Y"
                { THIS_KRT->persist = (yyvsp[0].i); }
#line 13554 "obj/conf/cf-parse.tab.c"
    break;

  case 1362: /* kern_item: SCAN TIME expr  */
#line 60 "sysdep/unix/krt.Y"
                  {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i) S_;
   }
#line 13563 "obj/conf/cf-parse.tab.c"
    break;

  case 1363: /* kern_item: LEARN bool  */
#line 64 "sysdep/unix/krt.Y"
              {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 13575 "obj/conf/cf-parse.tab.c"
    break;

  case 1364: /* kern_item: GRACEFUL RESTART bool  */
#line 71 "sysdep/unix/krt.Y"
                         { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 13581 "obj/conf/cf-parse.tab.c"
    break;

  case 1365: /* kern_item: MERGE PATHS bool kern_mp_limit  */
#line 72 "sysdep/unix/krt.Y"
                                  {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 13593 "obj/conf/cf-parse.tab.c"
    break;

  case 1367: /* kif_proto_start: proto_start DEVICE  */
#line 85 "sysdep/unix/krt.Y"
                                    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 13599 "obj/conf/cf-parse.tab.c"
    break;

  case 1372: /* kif_item: SCAN TIME expr  */
#line 94 "sysdep/unix/krt.Y"
                  {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i) S_;
   }
#line 13608 "obj/conf/cf-parse.tab.c"
    break;

  case 1373: /* kif_iface_start: %empty  */
#line 101 "sysdep/unix/krt.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct kif_iface_config));
  add_tail(&THIS_KIF->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
}
#line 13618 "obj/conf/cf-parse.tab.c"
    break;

  case 1374: /* kif_iface_item: PREFERRED ipa  */
#line 108 "sysdep/unix/krt.Y"
                 { kif_set_preferred((yyvsp[0].a)); }
#line 13624 "obj/conf/cf-parse.tab.c"
    break;

  case 1380: /* dynamic_attr: KRT_SOURCE  */
#line 125 "sysdep/unix/krt.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SOURCE); }
#line 13630 "obj/conf/cf-parse.tab.c"
    break;

  case 1381: /* dynamic_attr: KRT_METRIC  */
#line 126 "sysdep/unix/krt.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_METRIC); }
#line 13636 "obj/conf/cf-parse.tab.c"
    break;


#line 13640 "obj/conf/cf-parse.tab.c"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 49 "conf/gen_parser.m4"

#line 383 "conf/confbase.Y"
/* C Code from conf/confbase.Y */

#line 207 "conf/flowspec.Y"
/* C Code from conf/flowspec.Y */

#line 811 "nest/config.Y"
/* C Code from nest/config.Y */

#line 169 "proto/bfd/config.Y"
/* C Code from proto/bfd/config.Y */

#line 144 "proto/babel/config.Y"
/* C Code from proto/babel/config.Y */

#line 328 "proto/bgp/config.Y"
/* C Code from proto/bgp/config.Y */

#line 66 "proto/mrt/config.Y"
/* C Code from proto/mrt/config.Y */

#line 561 "proto/ospf/config.Y"
/* C Code from proto/ospf/config.Y */

#line 59 "proto/perf/config.Y"
/* C Code from proto/perf/config.Y */

#line 46 "proto/pipe/config.Y"
/* C Code from proto/pipe/config.Y */

#line 341 "proto/radv/config.Y"
/* C Code from proto/radv/config.Y */

#line 201 "proto/rip/config.Y"
/* C Code from proto/rip/config.Y */

#line 142 "proto/rpki/config.Y"
/* C Code from proto/rpki/config.Y */

#line 163 "proto/static/config.Y"
/* C Code from proto/static/config.Y */

#line 64 "sysdep/linux/netlink.Y"
/* C Code from sysdep/linux/netlink.Y */

#line 154 "sysdep/unix/config.Y"
/* C Code from sysdep/unix/config.Y */

#line 128 "sysdep/unix/krt.Y"
/* C Code from sysdep/unix/krt.Y */

