#line 390 "filter/decl.m4"


#if defined(__GNUC__) && __GNUC__ >= 6
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmisleading-indentation"
#endif

#include "nest/bird.h"
#include "filter/filter.h"
#include "filter/f-inst.h"

/* Instruction codes to string */
static const char * const f_instruction_name_str[] = {
#line 211 "filter/f-inst.c"
 /* Code enum to string for FI_ADD */
#line 211
  [FI_ADD] = "FI_ADD",
#line 216 "filter/f-inst.c"
 /* Code enum to string for FI_SUBTRACT */
#line 216
  [FI_SUBTRACT] = "FI_SUBTRACT",
#line 221 "filter/f-inst.c"
 /* Code enum to string for FI_MULTIPLY */
#line 221
  [FI_MULTIPLY] = "FI_MULTIPLY",
#line 227 "filter/f-inst.c"
 /* Code enum to string for FI_DIVIDE */
#line 227
  [FI_DIVIDE] = "FI_DIVIDE",
#line 234 "filter/f-inst.c"
 /* Code enum to string for FI_AND */
#line 234
  [FI_AND] = "FI_AND",
#line 242 "filter/f-inst.c"
 /* Code enum to string for FI_OR */
#line 242
  [FI_OR] = "FI_OR",
#line 252 "filter/f-inst.c"
 /* Code enum to string for FI_PAIR_CONSTRUCT */
#line 252
  [FI_PAIR_CONSTRUCT] = "FI_PAIR_CONSTRUCT",
#line 293 "filter/f-inst.c"
 /* Code enum to string for FI_EC_CONSTRUCT */
#line 293
  [FI_EC_CONSTRUCT] = "FI_EC_CONSTRUCT",
#line 300 "filter/f-inst.c"
 /* Code enum to string for FI_LC_CONSTRUCT */
#line 300
  [FI_LC_CONSTRUCT] = "FI_LC_CONSTRUCT",
#line 339 "filter/f-inst.c"
 /* Code enum to string for FI_PATHMASK_CONSTRUCT */
#line 339
  [FI_PATHMASK_CONSTRUCT] = "FI_PATHMASK_CONSTRUCT",
#line 345 "filter/f-inst.c"
 /* Code enum to string for FI_NEQ */
#line 345
  [FI_NEQ] = "FI_NEQ",
#line 351 "filter/f-inst.c"
 /* Code enum to string for FI_EQ */
#line 351
  [FI_EQ] = "FI_EQ",
#line 360 "filter/f-inst.c"
 /* Code enum to string for FI_LT */
#line 360
  [FI_LT] = "FI_LT",
#line 369 "filter/f-inst.c"
 /* Code enum to string for FI_LTE */
#line 369
  [FI_LTE] = "FI_LTE",
#line 374 "filter/f-inst.c"
 /* Code enum to string for FI_NOT */
#line 374
  [FI_NOT] = "FI_NOT",
#line 383 "filter/f-inst.c"
 /* Code enum to string for FI_MATCH */
#line 383
  [FI_MATCH] = "FI_MATCH",
#line 392 "filter/f-inst.c"
 /* Code enum to string for FI_NOT_MATCH */
#line 392
  [FI_NOT_MATCH] = "FI_NOT_MATCH",
#line 397 "filter/f-inst.c"
 /* Code enum to string for FI_DEFINED */
#line 397
  [FI_DEFINED] = "FI_DEFINED",
#line 409 "filter/f-inst.c"
 /* Code enum to string for FI_TYPE */
#line 409
  [FI_TYPE] = "FI_TYPE",
#line 415 "filter/f-inst.c"
 /* Code enum to string for FI_IS_V4 */
#line 415
  [FI_IS_V4] = "FI_IS_V4",
#line 435 "filter/f-inst.c"
 /* Code enum to string for FI_VAR_SET */
#line 435
  [FI_VAR_SET] = "FI_VAR_SET",
#line 441 "filter/f-inst.c"
 /* Code enum to string for FI_VAR_GET */
#line 441
  [FI_VAR_GET] = "FI_VAR_GET",
#line 453 "filter/f-inst.c"
 /* Code enum to string for FI_CONSTANT */
#line 453
  [FI_CONSTANT] = "FI_CONSTANT",
#line 461 "filter/f-inst.c"
 /* Code enum to string for FI_CONDITION */
#line 461
  [FI_CONDITION] = "FI_CONDITION",
#line 470 "filter/f-inst.c"
 /* Code enum to string for FI_PRINT */
#line 470
  [FI_PRINT] = "FI_PRINT",
#line 477 "filter/f-inst.c"
 /* Code enum to string for FI_FLUSH */
#line 477
  [FI_FLUSH] = "FI_FLUSH",
#line 493 "filter/f-inst.c"
 /* Code enum to string for FI_DIE */
#line 493
  [FI_DIE] = "FI_DIE",
#line 517 "filter/f-inst.c"
 /* Code enum to string for FI_RTA_GET */
#line 517
  [FI_RTA_GET] = "FI_RTA_GET",
#line 587 "filter/f-inst.c"
 /* Code enum to string for FI_RTA_SET */
#line 587
  [FI_RTA_SET] = "FI_RTA_SET",
#line 661 "filter/f-inst.c"
 /* Code enum to string for FI_EA_GET */
#line 661
  [FI_EA_GET] = "FI_EA_GET",
#line 758 "filter/f-inst.c"
 /* Code enum to string for FI_EA_SET */
#line 758
  [FI_EA_SET] = "FI_EA_SET",
#line 780 "filter/f-inst.c"
 /* Code enum to string for FI_EA_UNSET */
#line 780
  [FI_EA_UNSET] = "FI_EA_UNSET",
#line 785 "filter/f-inst.c"
 /* Code enum to string for FI_PREF_GET */
#line 785
  [FI_PREF_GET] = "FI_PREF_GET",
#line 794 "filter/f-inst.c"
 /* Code enum to string for FI_PREF_SET */
#line 794
  [FI_PREF_SET] = "FI_PREF_SET",
#line 806 "filter/f-inst.c"
 /* Code enum to string for FI_LENGTH */
#line 806
  [FI_LENGTH] = "FI_LENGTH",
#line 818 "filter/f-inst.c"
 /* Code enum to string for FI_SADR_SRC */
#line 818
  [FI_SADR_SRC] = "FI_SADR_SRC",
#line 828 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_MAXLEN */
#line 828
  [FI_ROA_MAXLEN] = "FI_ROA_MAXLEN",
#line 838 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_ASN */
#line 838
  [FI_ROA_ASN] = "FI_ROA_ASN",
#line 843 "filter/f-inst.c"
 /* Code enum to string for FI_IP */
#line 843
  [FI_IP] = "FI_IP",
#line 850 "filter/f-inst.c"
 /* Code enum to string for FI_ROUTE_DISTINGUISHER */
#line 850
  [FI_ROUTE_DISTINGUISHER] = "FI_ROUTE_DISTINGUISHER",
#line 857 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_FIRST */
#line 857
  [FI_AS_PATH_FIRST] = "FI_AS_PATH_FIRST",
#line 864 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_LAST */
#line 864
  [FI_AS_PATH_LAST] = "FI_AS_PATH_LAST",
#line 869 "filter/f-inst.c"
 /* Code enum to string for FI_AS_PATH_LAST_NAG */
#line 869
  [FI_AS_PATH_LAST_NAG] = "FI_AS_PATH_LAST_NAG",
#line 896 "filter/f-inst.c"
 /* Code enum to string for FI_RETURN */
#line 896
  [FI_RETURN] = "FI_RETURN",
#line 922 "filter/f-inst.c"
 /* Code enum to string for FI_CALL */
#line 922
  [FI_CALL] = "FI_CALL",
#line 927 "filter/f-inst.c"
 /* Code enum to string for FI_DROP_RESULT */
#line 927
  [FI_DROP_RESULT] = "FI_DROP_RESULT",
#line 946 "filter/f-inst.c"
 /* Code enum to string for FI_SWITCH */
#line 946
  [FI_SWITCH] = "FI_SWITCH",
#line 954 "filter/f-inst.c"
 /* Code enum to string for FI_IP_MASK */
#line 954
  [FI_IP_MASK] = "FI_IP_MASK",
#line 960 "filter/f-inst.c"
 /* Code enum to string for FI_PATH_PREPEND */
#line 960
  [FI_PATH_PREPEND] = "FI_PATH_PREPEND",
#line 1015 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_ADD */
#line 1015
  [FI_CLIST_ADD] = "FI_CLIST_ADD",
#line 1075 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_DEL */
#line 1075
  [FI_CLIST_DEL] = "FI_CLIST_DEL",
#line 1121 "filter/f-inst.c"
 /* Code enum to string for FI_CLIST_FILTER */
#line 1121
  [FI_CLIST_FILTER] = "FI_CLIST_FILTER",
#line 1151 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_CHECK_IMPLICIT */
#line 1151
  [FI_ROA_CHECK_IMPLICIT] = "FI_ROA_CHECK_IMPLICIT",
#line 1173 "filter/f-inst.c"
 /* Code enum to string for FI_ROA_CHECK_EXPLICIT */
#line 1173
  [FI_ROA_CHECK_EXPLICIT] = "FI_ROA_CHECK_EXPLICIT",
#line 1178 "filter/f-inst.c"
 /* Code enum to string for FI_FORMAT */
#line 1178
  [FI_FORMAT] = "FI_FORMAT",
#line 578 "filter/decl.m4"
 /* Code enum to string for FI_ASSERT */
#line 578
  [FI_ASSERT] = "FI_ASSERT",
#line 403 "filter/decl.m4"

};

const char *
f_instruction_name(enum f_instruction_code fi)
{
  if (fi < (sizeof(f_instruction_name_str) / sizeof(f_instruction_name_str[0])))
    return f_instruction_name_str[fi];
  else
    bug("Got unknown instruction code: %d", fi);
}

static inline struct f_inst *
fi_new(enum f_instruction_code fi_code)
{
  struct f_inst *what = cfg_allocz(sizeof(struct f_inst));
  what->lineno = ifs->lino;
  what->size = 1;
  what->fi_code = fi_code;
  return what;
}

static inline struct f_inst *
fi_constant(struct f_inst *what, struct f_val val)
{
  what->fi_code = FI_CONSTANT;
  what->i_FI_CONSTANT.val = val;
  return what;
}

#define v1 whati->f1->i_FI_CONSTANT.val
#define v2 whati->f2->i_FI_CONSTANT.val
#define v3 whati->f3->i_FI_CONSTANT.val
#define vv(i) items[i]->i_FI_CONSTANT.val
#define runtime(fmt, ...) cf_error("filter preevaluation, line %d: " fmt, ifs->lino, ##__VA_ARGS__)
#define fpool cfg_mem
#define falloc(size) cfg_alloc(size)
/* Instruction constructors */
#line 211 "filter/f-inst.c"
 /* Constructor for FI_ADD */
#line 211
struct f_inst *f_new_inst_FI_ADD(enum f_instruction_code fi_code
#line 207 "filter/f-inst.c"
  , struct f_inst * f1
#line 208 "filter/f-inst.c"
  , struct f_inst * f2
#line 211 "filter/f-inst.c"
)
#line 211
  {
#line 211
    /* Allocate the structure */
#line 211
    struct f_inst *what = fi_new(fi_code);
#line 211
    uint constargs = 1;
#line 211

#line 211
    /* Initialize all the members */
#line 211
  #define whati (&(what->i_FI_ADD))
#line 211
  #line 207 "filter/f-inst.c"

#line 207
whati->f1 = f1;
#line 207
for (const struct f_inst *child = f1; child; child = child->next) {
#line 207
  what->size += child->size;
#line 207

#line 207
  if (child->fi_code != FI_CONSTANT)
#line 207
    constargs = 0;
#line 207

#line 207
}
#line 208 "filter/f-inst.c"

#line 208
whati->f2 = f2;
#line 208
for (const struct f_inst *child = f2; child; child = child->next) {
#line 208
  what->size += child->size;
#line 208

#line 208
  if (child->fi_code != FI_CONSTANT)
#line 208
    constargs = 0;
#line 208

#line 208
}

#line 211 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 211
    if (!constargs)
#line 211
      return what;
#line 211

#line 211
    /* Try to pre-calculate the result */
#line 211
    #line 206 "filter/f-inst.c"
 {
    
#line 207 "filter/f-inst.c"

#line 207 "filter/f-inst.c"
;
    
#line 208 "filter/f-inst.c"

#line 208 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i + v2.val.i } );
  }
  
  #undef whati
#line 211 "filter/f-inst.c"
  }
#line 211

#line 211

#line 216 "filter/f-inst.c"
 /* Constructor for FI_SUBTRACT */
#line 216
struct f_inst *f_new_inst_FI_SUBTRACT(enum f_instruction_code fi_code
#line 212 "filter/f-inst.c"
  , struct f_inst * f1
#line 213 "filter/f-inst.c"
  , struct f_inst * f2
#line 216 "filter/f-inst.c"
)
#line 216
  {
#line 216
    /* Allocate the structure */
#line 216
    struct f_inst *what = fi_new(fi_code);
#line 216
    uint constargs = 1;
#line 216

#line 216
    /* Initialize all the members */
#line 216
  #define whati (&(what->i_FI_SUBTRACT))
#line 216
  #line 212 "filter/f-inst.c"

#line 212
whati->f1 = f1;
#line 212
for (const struct f_inst *child = f1; child; child = child->next) {
#line 212
  what->size += child->size;
#line 212

#line 212
  if (child->fi_code != FI_CONSTANT)
#line 212
    constargs = 0;
#line 212

#line 212
}
#line 213 "filter/f-inst.c"

#line 213
whati->f2 = f2;
#line 213
for (const struct f_inst *child = f2; child; child = child->next) {
#line 213
  what->size += child->size;
#line 213

#line 213
  if (child->fi_code != FI_CONSTANT)
#line 213
    constargs = 0;
#line 213

#line 213
}

#line 216 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 216
    if (!constargs)
#line 216
      return what;
#line 216

#line 216
    /* Try to pre-calculate the result */
#line 216
    #line 211 "filter/f-inst.c"
 {
    
#line 212 "filter/f-inst.c"

#line 212 "filter/f-inst.c"
;
    
#line 213 "filter/f-inst.c"

#line 213 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i - v2.val.i } );
  }
  
  #undef whati
#line 216 "filter/f-inst.c"
  }
#line 216

#line 216

#line 221 "filter/f-inst.c"
 /* Constructor for FI_MULTIPLY */
#line 221
struct f_inst *f_new_inst_FI_MULTIPLY(enum f_instruction_code fi_code
#line 217 "filter/f-inst.c"
  , struct f_inst * f1
#line 218 "filter/f-inst.c"
  , struct f_inst * f2
#line 221 "filter/f-inst.c"
)
#line 221
  {
#line 221
    /* Allocate the structure */
#line 221
    struct f_inst *what = fi_new(fi_code);
#line 221
    uint constargs = 1;
#line 221

#line 221
    /* Initialize all the members */
#line 221
  #define whati (&(what->i_FI_MULTIPLY))
#line 221
  #line 217 "filter/f-inst.c"

#line 217
whati->f1 = f1;
#line 217
for (const struct f_inst *child = f1; child; child = child->next) {
#line 217
  what->size += child->size;
#line 217

#line 217
  if (child->fi_code != FI_CONSTANT)
#line 217
    constargs = 0;
#line 217

#line 217
}
#line 218 "filter/f-inst.c"

#line 218
whati->f2 = f2;
#line 218
for (const struct f_inst *child = f2; child; child = child->next) {
#line 218
  what->size += child->size;
#line 218

#line 218
  if (child->fi_code != FI_CONSTANT)
#line 218
    constargs = 0;
#line 218

#line 218
}

#line 221 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 221
    if (!constargs)
#line 221
      return what;
#line 221

#line 221
    /* Try to pre-calculate the result */
#line 221
    #line 216 "filter/f-inst.c"
 {
    
#line 217 "filter/f-inst.c"

#line 217 "filter/f-inst.c"
;
    
#line 218 "filter/f-inst.c"

#line 218 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i * v2.val.i } );
  }
  
  #undef whati
#line 221 "filter/f-inst.c"
  }
#line 221

#line 221

#line 227 "filter/f-inst.c"
 /* Constructor for FI_DIVIDE */
#line 227
struct f_inst *f_new_inst_FI_DIVIDE(enum f_instruction_code fi_code
#line 222 "filter/f-inst.c"
  , struct f_inst * f1
#line 223 "filter/f-inst.c"
  , struct f_inst * f2
#line 227 "filter/f-inst.c"
)
#line 227
  {
#line 227
    /* Allocate the structure */
#line 227
    struct f_inst *what = fi_new(fi_code);
#line 227
    uint constargs = 1;
#line 227

#line 227
    /* Initialize all the members */
#line 227
  #define whati (&(what->i_FI_DIVIDE))
#line 227
  #line 222 "filter/f-inst.c"

#line 222
whati->f1 = f1;
#line 222
for (const struct f_inst *child = f1; child; child = child->next) {
#line 222
  what->size += child->size;
#line 222

#line 222
  if (child->fi_code != FI_CONSTANT)
#line 222
    constargs = 0;
#line 222

#line 222
}
#line 223 "filter/f-inst.c"

#line 223
whati->f2 = f2;
#line 223
for (const struct f_inst *child = f2; child; child = child->next) {
#line 223
  what->size += child->size;
#line 223

#line 223
  if (child->fi_code != FI_CONSTANT)
#line 223
    constargs = 0;
#line 223

#line 223
}

#line 227 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 227
    if (!constargs)
#line 227
      return what;
#line 227

#line 227
    /* Try to pre-calculate the result */
#line 227
    #line 221 "filter/f-inst.c"
 {
    
#line 222 "filter/f-inst.c"

#line 222 "filter/f-inst.c"
;
    
#line 223 "filter/f-inst.c"

#line 223 "filter/f-inst.c"
;
    if (v2.val.i == 0) runtime( "Mother told me not to divide by 0" );
    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = v1.val.i / v2.val.i } );
  }
  
  #undef whati
#line 227 "filter/f-inst.c"
  }
#line 227

#line 227

#line 234 "filter/f-inst.c"
 /* Constructor for FI_AND */
#line 234
struct f_inst *f_new_inst_FI_AND(enum f_instruction_code fi_code
#line 228 "filter/f-inst.c"
  , struct f_inst * f1
#line 230 "filter/f-inst.c"
  , struct f_inst * f2
#line 234 "filter/f-inst.c"
)
#line 234
  {
#line 234
    /* Allocate the structure */
#line 234
    struct f_inst *what = fi_new(fi_code);
#line 234
    uint constargs = 1;
#line 234

#line 234
    /* Initialize all the members */
#line 234
  #define whati (&(what->i_FI_AND))
#line 234
  #line 228 "filter/f-inst.c"

#line 228
whati->f1 = f1;
#line 228
for (const struct f_inst *child = f1; child; child = child->next) {
#line 228
  what->size += child->size;
#line 228

#line 228
  if (child->fi_code != FI_CONSTANT)
#line 228
    constargs = 0;
#line 228

#line 228
}
#line 230 "filter/f-inst.c"
whati->f2 = f2;

#line 234 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 234
    if (!constargs)
#line 234
      return what;
#line 234

#line 234
    /* Try to pre-calculate the result */
#line 234
    #line 227 "filter/f-inst.c"
 {
    
#line 228 "filter/f-inst.c"

#line 228 "filter/f-inst.c"
;
    if (v1.val.i)
      
#line 230 "filter/f-inst.c"
return whati->f2
#line 230
;
    else
      return fi_constant(what, v1);
  }
  
  #undef whati
#line 234 "filter/f-inst.c"
  }
#line 234

#line 234

#line 242 "filter/f-inst.c"
 /* Constructor for FI_OR */
#line 242
struct f_inst *f_new_inst_FI_OR(enum f_instruction_code fi_code
#line 235 "filter/f-inst.c"
  , struct f_inst * f1
#line 237 "filter/f-inst.c"
  , struct f_inst * f2
#line 242 "filter/f-inst.c"
)
#line 242
  {
#line 242
    /* Allocate the structure */
#line 242
    struct f_inst *what = fi_new(fi_code);
#line 242
    uint constargs = 1;
#line 242

#line 242
    /* Initialize all the members */
#line 242
  #define whati (&(what->i_FI_OR))
#line 242
  #line 235 "filter/f-inst.c"

#line 235
whati->f1 = f1;
#line 235
for (const struct f_inst *child = f1; child; child = child->next) {
#line 235
  what->size += child->size;
#line 235

#line 235
  if (child->fi_code != FI_CONSTANT)
#line 235
    constargs = 0;
#line 235

#line 235
}
#line 237 "filter/f-inst.c"
whati->f2 = f2;

#line 242 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 242
    if (!constargs)
#line 242
      return what;
#line 242

#line 242
    /* Try to pre-calculate the result */
#line 242
    #line 234 "filter/f-inst.c"
 {
    
#line 235 "filter/f-inst.c"

#line 235 "filter/f-inst.c"
;
    if (!v1.val.i)
      
#line 237 "filter/f-inst.c"
return whati->f2
#line 237
;
    else
      return fi_constant(what, v1);
  }

  
  #undef whati
#line 242 "filter/f-inst.c"
  }
#line 242

#line 242

#line 252 "filter/f-inst.c"
 /* Constructor for FI_PAIR_CONSTRUCT */
#line 252
struct f_inst *f_new_inst_FI_PAIR_CONSTRUCT(enum f_instruction_code fi_code
#line 243 "filter/f-inst.c"
  , struct f_inst * f1
#line 244 "filter/f-inst.c"
  , struct f_inst * f2
#line 252 "filter/f-inst.c"
)
#line 252
  {
#line 252
    /* Allocate the structure */
#line 252
    struct f_inst *what = fi_new(fi_code);
#line 252
    uint constargs = 1;
#line 252

#line 252
    /* Initialize all the members */
#line 252
  #define whati (&(what->i_FI_PAIR_CONSTRUCT))
#line 252
  #line 243 "filter/f-inst.c"

#line 243
whati->f1 = f1;
#line 243
for (const struct f_inst *child = f1; child; child = child->next) {
#line 243
  what->size += child->size;
#line 243

#line 243
  if (child->fi_code != FI_CONSTANT)
#line 243
    constargs = 0;
#line 243

#line 243
}
#line 244 "filter/f-inst.c"

#line 244
whati->f2 = f2;
#line 244
for (const struct f_inst *child = f2; child; child = child->next) {
#line 244
  what->size += child->size;
#line 244

#line 244
  if (child->fi_code != FI_CONSTANT)
#line 244
    constargs = 0;
#line 244

#line 244
}

#line 252 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 252
    if (!constargs)
#line 252
      return what;
#line 252

#line 252
    /* Try to pre-calculate the result */
#line 252
    #line 242 "filter/f-inst.c"
 {
    
#line 243 "filter/f-inst.c"

#line 243 "filter/f-inst.c"
;
    
#line 244 "filter/f-inst.c"

#line 244 "filter/f-inst.c"
;
    uint u1 = v1.val.i;
    uint u2 = v2.val.i;
    if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
      runtime( "Can't operate with value out of bounds in pair constructor" );
    return fi_constant(what,  (struct f_val) { .type = T_PAIR, .val.i = (u1 << 16) | u2 } );
  }

  
  #undef whati
#line 252 "filter/f-inst.c"
  }
#line 252

#line 252

#line 293 "filter/f-inst.c"
 /* Constructor for FI_EC_CONSTRUCT */
#line 293
struct f_inst *f_new_inst_FI_EC_CONSTRUCT(enum f_instruction_code fi_code
#line 253 "filter/f-inst.c"
  , struct f_inst * f1
#line 254 "filter/f-inst.c"
  , struct f_inst * f2
#line 256 "filter/f-inst.c"
  , enum ec_subtype ecs
#line 293 "filter/f-inst.c"
)
#line 293
  {
#line 293
    /* Allocate the structure */
#line 293
    struct f_inst *what = fi_new(fi_code);
#line 293
    uint constargs = 1;
#line 293

#line 293
    /* Initialize all the members */
#line 293
  #define whati (&(what->i_FI_EC_CONSTRUCT))
#line 293
  #line 253 "filter/f-inst.c"

#line 253
whati->f1 = f1;
#line 253
for (const struct f_inst *child = f1; child; child = child->next) {
#line 253
  what->size += child->size;
#line 253

#line 253
  if (child->fi_code != FI_CONSTANT)
#line 253
    constargs = 0;
#line 253

#line 253
}
#line 254 "filter/f-inst.c"

#line 254
whati->f2 = f2;
#line 254
for (const struct f_inst *child = f2; child; child = child->next) {
#line 254
  what->size += child->size;
#line 254

#line 254
  if (child->fi_code != FI_CONSTANT)
#line 254
    constargs = 0;
#line 254

#line 254
}
#line 256 "filter/f-inst.c"
whati->ecs = ecs;

#line 293 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 293
    if (!constargs)
#line 293
      return what;
#line 293

#line 293
    /* Try to pre-calculate the result */
#line 293
    #line 252 "filter/f-inst.c"
 {
    
#line 253 "filter/f-inst.c"
;
    
#line 254 "filter/f-inst.c"

#line 254 "filter/f-inst.c"
;

    #line 256 "filter/f-inst.c"
;

    int check, ipv4_used;
    u32 key, val;

    if (v1.type == T_INT) {
      ipv4_used = 0; key = v1.val.i;
    }
    else if (v1.type == T_QUAD) {
      ipv4_used = 1; key = v1.val.i;
    }
    /* IP->Quad implicit conversion */
    else if (val_is_ip4(&v1)) {
      ipv4_used = 1; key = ipa_to_u32(v1.val.ip);
    }
    else
      runtime("Argument 1 of EC constructor must be integer or IPv4 address, got 0x%02x", v1.type);

    val = v2.val.i;

    if (ecs == EC_GENERIC) {
      check = 0; return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_generic(key, val) } );
    }
    else if (ipv4_used) {
      check = 1; return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_ip4(ecs, key, val) } );
    }
    else if (key < 0x10000) {
      check = 0; return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_as2(ecs, key, val) } );
    }
    else {
      check = 1; return fi_constant(what,  (struct f_val) { .type = T_EC, .val.ec = ec_as4(ecs, key, val) } );
    }

    if (check && (val > 0xFFFF))
      runtime("Value %u > %u out of bounds in EC constructor", val, 0xFFFF);
  }

  
  #undef whati
#line 293 "filter/f-inst.c"
  }
#line 293

#line 293

#line 300 "filter/f-inst.c"
 /* Constructor for FI_LC_CONSTRUCT */
#line 300
struct f_inst *f_new_inst_FI_LC_CONSTRUCT(enum f_instruction_code fi_code
#line 294 "filter/f-inst.c"
  , struct f_inst * f1
#line 295 "filter/f-inst.c"
  , struct f_inst * f2
#line 296 "filter/f-inst.c"
  , struct f_inst * f3
#line 300 "filter/f-inst.c"
)
#line 300
  {
#line 300
    /* Allocate the structure */
#line 300
    struct f_inst *what = fi_new(fi_code);
#line 300
    uint constargs = 1;
#line 300

#line 300
    /* Initialize all the members */
#line 300
  #define whati (&(what->i_FI_LC_CONSTRUCT))
#line 300
  #line 294 "filter/f-inst.c"

#line 294
whati->f1 = f1;
#line 294
for (const struct f_inst *child = f1; child; child = child->next) {
#line 294
  what->size += child->size;
#line 294

#line 294
  if (child->fi_code != FI_CONSTANT)
#line 294
    constargs = 0;
#line 294

#line 294
}
#line 295 "filter/f-inst.c"

#line 295
whati->f2 = f2;
#line 295
for (const struct f_inst *child = f2; child; child = child->next) {
#line 295
  what->size += child->size;
#line 295

#line 295
  if (child->fi_code != FI_CONSTANT)
#line 295
    constargs = 0;
#line 295

#line 295
}
#line 296 "filter/f-inst.c"

#line 296
whati->f3 = f3;
#line 296
for (const struct f_inst *child = f3; child; child = child->next) {
#line 296
  what->size += child->size;
#line 296

#line 296
  if (child->fi_code != FI_CONSTANT)
#line 296
    constargs = 0;
#line 296

#line 296
}

#line 300 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 300
    if (!constargs)
#line 300
      return what;
#line 300

#line 300
    /* Try to pre-calculate the result */
#line 300
    #line 293 "filter/f-inst.c"
 {
    
#line 294 "filter/f-inst.c"

#line 294 "filter/f-inst.c"
;
    
#line 295 "filter/f-inst.c"

#line 295 "filter/f-inst.c"
;
    
#line 296 "filter/f-inst.c"

#line 296 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_LC, .val.lc = (lcomm) { v1.val.i, v2.val.i, v3.val.i } } );
  }

  
  #undef whati
#line 300 "filter/f-inst.c"
  }
#line 300

#line 300

#line 339 "filter/f-inst.c"
 /* Constructor for FI_PATHMASK_CONSTRUCT */
#line 339
struct f_inst *f_new_inst_FI_PATHMASK_CONSTRUCT(enum f_instruction_code fi_code
#line 301 "filter/f-inst.c"
  , struct f_inst * fvar
#line 339 "filter/f-inst.c"
)
#line 339
  {
#line 339
    /* Allocate the structure */
#line 339
    struct f_inst *what = fi_new(fi_code);
#line 339
    uint constargs = 1;
#line 339

#line 339
    /* Initialize all the members */
#line 339
  #define whati (&(what->i_FI_PATHMASK_CONSTRUCT))
#line 339
  #line 301 "filter/f-inst.c"
whati->varcount = 0;
#line 301
whati->fvar = fvar;
#line 301
for (const struct f_inst *child = fvar; child; child = child->next, whati->varcount++) {
#line 301
  what->size += child->size;
#line 301

#line 301
  if (child->fi_code != FI_CONSTANT)
#line 301
    constargs = 0;
#line 301

#line 301
}
#line 301

#line 301
  const struct f_inst **items = NULL;
#line 301
  if (constargs) {
#line 301
    items = alloca(whati->varcount * sizeof(struct f_inst *));
#line 301
    const struct f_inst *child = fvar;
#line 301
    for (uint i=0; child; i++)
#line 301
      child = (items[i] = child)->next;
#line 301
  }
#line 301


#line 339 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 339
    if (!constargs)
#line 339
      return what;
#line 339

#line 339
    /* Try to pre-calculate the result */
#line 339
    #line 300 "filter/f-inst.c"
 {
    
#line 301 "filter/f-inst.c"

#line 301

#line 301
;

    struct f_path_mask *pm = falloc(sizeof(struct f_path_mask) + whati->varcount * sizeof(struct f_path_mask_item));
    pm->len = whati->varcount;

    for (uint i=0; i<whati->varcount; i++) {
      switch (vv(i).type) {
	case T_PATH_MASK_ITEM:
	  pm->item[i] = vv(i).val.pmi;
	  break;

	case T_INT:
	  pm->item[i] = (struct f_path_mask_item) {
	    .asn = vv(i).val.i,
	    .kind = PM_ASN,
	  };
	  break;

	case T_SET:
	  if (vv(i).val.t->from.type != T_INT)
	    runtime("Only integer sets allowed in path mask");

	  pm->item[i] = (struct f_path_mask_item) {
	    .set = vv(i).val.t,
	    .kind = PM_ASN_SET,
	  };
	  break;

	default:
	  runtime( "Error resolving path mask template: value not an integer" );
      }
    }

    return fi_constant(what,  (struct f_val) { .type = T_PATH_MASK, .val.path_mask = pm } );
  }

/* Relational operators */

  
  #undef whati
#line 339 "filter/f-inst.c"
  }
#line 339

#line 339

#line 345 "filter/f-inst.c"
 /* Constructor for FI_NEQ */
#line 345
struct f_inst *f_new_inst_FI_NEQ(enum f_instruction_code fi_code
#line 340 "filter/f-inst.c"
  , struct f_inst * f1
#line 341 "filter/f-inst.c"
  , struct f_inst * f2
#line 345 "filter/f-inst.c"
)
#line 345
  {
#line 345
    /* Allocate the structure */
#line 345
    struct f_inst *what = fi_new(fi_code);
#line 345
    uint constargs = 1;
#line 345

#line 345
    /* Initialize all the members */
#line 345
  #define whati (&(what->i_FI_NEQ))
#line 345
  #line 340 "filter/f-inst.c"

#line 340
whati->f1 = f1;
#line 340
for (const struct f_inst *child = f1; child; child = child->next) {
#line 340
  what->size += child->size;
#line 340

#line 340
  if (child->fi_code != FI_CONSTANT)
#line 340
    constargs = 0;
#line 340

#line 340
}
#line 341 "filter/f-inst.c"

#line 341
whati->f2 = f2;
#line 341
for (const struct f_inst *child = f2; child; child = child->next) {
#line 341
  what->size += child->size;
#line 341

#line 341
  if (child->fi_code != FI_CONSTANT)
#line 341
    constargs = 0;
#line 341

#line 341
}

#line 345 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 345
    if (!constargs)
#line 345
      return what;
#line 345

#line 345
    /* Try to pre-calculate the result */
#line 345
    #line 339 "filter/f-inst.c"
 {
    
#line 340 "filter/f-inst.c"
;
    
#line 341 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !val_same(&v1, &v2) } );
  }

  
  #undef whati
#line 345 "filter/f-inst.c"
  }
#line 345

#line 345

#line 351 "filter/f-inst.c"
 /* Constructor for FI_EQ */
#line 351
struct f_inst *f_new_inst_FI_EQ(enum f_instruction_code fi_code
#line 346 "filter/f-inst.c"
  , struct f_inst * f1
#line 347 "filter/f-inst.c"
  , struct f_inst * f2
#line 351 "filter/f-inst.c"
)
#line 351
  {
#line 351
    /* Allocate the structure */
#line 351
    struct f_inst *what = fi_new(fi_code);
#line 351
    uint constargs = 1;
#line 351

#line 351
    /* Initialize all the members */
#line 351
  #define whati (&(what->i_FI_EQ))
#line 351
  #line 346 "filter/f-inst.c"

#line 346
whati->f1 = f1;
#line 346
for (const struct f_inst *child = f1; child; child = child->next) {
#line 346
  what->size += child->size;
#line 346

#line 346
  if (child->fi_code != FI_CONSTANT)
#line 346
    constargs = 0;
#line 346

#line 346
}
#line 347 "filter/f-inst.c"

#line 347
whati->f2 = f2;
#line 347
for (const struct f_inst *child = f2; child; child = child->next) {
#line 347
  what->size += child->size;
#line 347

#line 347
  if (child->fi_code != FI_CONSTANT)
#line 347
    constargs = 0;
#line 347

#line 347
}

#line 351 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 351
    if (!constargs)
#line 351
      return what;
#line 351

#line 351
    /* Try to pre-calculate the result */
#line 351
    #line 345 "filter/f-inst.c"
 {
    
#line 346 "filter/f-inst.c"
;
    
#line 347 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = val_same(&v1, &v2) } );
  }

  
  #undef whati
#line 351 "filter/f-inst.c"
  }
#line 351

#line 351

#line 360 "filter/f-inst.c"
 /* Constructor for FI_LT */
#line 360
struct f_inst *f_new_inst_FI_LT(enum f_instruction_code fi_code
#line 352 "filter/f-inst.c"
  , struct f_inst * f1
#line 353 "filter/f-inst.c"
  , struct f_inst * f2
#line 360 "filter/f-inst.c"
)
#line 360
  {
#line 360
    /* Allocate the structure */
#line 360
    struct f_inst *what = fi_new(fi_code);
#line 360
    uint constargs = 1;
#line 360

#line 360
    /* Initialize all the members */
#line 360
  #define whati (&(what->i_FI_LT))
#line 360
  #line 352 "filter/f-inst.c"

#line 352
whati->f1 = f1;
#line 352
for (const struct f_inst *child = f1; child; child = child->next) {
#line 352
  what->size += child->size;
#line 352

#line 352
  if (child->fi_code != FI_CONSTANT)
#line 352
    constargs = 0;
#line 352

#line 352
}
#line 353 "filter/f-inst.c"

#line 353
whati->f2 = f2;
#line 353
for (const struct f_inst *child = f2; child; child = child->next) {
#line 353
  what->size += child->size;
#line 353

#line 353
  if (child->fi_code != FI_CONSTANT)
#line 353
    constargs = 0;
#line 353

#line 353
}

#line 360 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 360
    if (!constargs)
#line 360
      return what;
#line 360

#line 360
    /* Try to pre-calculate the result */
#line 360
    #line 351 "filter/f-inst.c"
 {
    
#line 352 "filter/f-inst.c"
;
    
#line 353 "filter/f-inst.c"
;
    int i = val_compare(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "Can't compare values of incompatible types" );
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (i == -1) } );
  }

  
  #undef whati
#line 360 "filter/f-inst.c"
  }
#line 360

#line 360

#line 369 "filter/f-inst.c"
 /* Constructor for FI_LTE */
#line 369
struct f_inst *f_new_inst_FI_LTE(enum f_instruction_code fi_code
#line 361 "filter/f-inst.c"
  , struct f_inst * f1
#line 362 "filter/f-inst.c"
  , struct f_inst * f2
#line 369 "filter/f-inst.c"
)
#line 369
  {
#line 369
    /* Allocate the structure */
#line 369
    struct f_inst *what = fi_new(fi_code);
#line 369
    uint constargs = 1;
#line 369

#line 369
    /* Initialize all the members */
#line 369
  #define whati (&(what->i_FI_LTE))
#line 369
  #line 361 "filter/f-inst.c"

#line 361
whati->f1 = f1;
#line 361
for (const struct f_inst *child = f1; child; child = child->next) {
#line 361
  what->size += child->size;
#line 361

#line 361
  if (child->fi_code != FI_CONSTANT)
#line 361
    constargs = 0;
#line 361

#line 361
}
#line 362 "filter/f-inst.c"

#line 362
whati->f2 = f2;
#line 362
for (const struct f_inst *child = f2; child; child = child->next) {
#line 362
  what->size += child->size;
#line 362

#line 362
  if (child->fi_code != FI_CONSTANT)
#line 362
    constargs = 0;
#line 362

#line 362
}

#line 369 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 369
    if (!constargs)
#line 369
      return what;
#line 369

#line 369
    /* Try to pre-calculate the result */
#line 369
    #line 360 "filter/f-inst.c"
 {
    
#line 361 "filter/f-inst.c"
;
    
#line 362 "filter/f-inst.c"
;
    int i = val_compare(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "Can't compare values of incompatible types" );
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (i != 1) } );
  }

  
  #undef whati
#line 369 "filter/f-inst.c"
  }
#line 369

#line 369

#line 374 "filter/f-inst.c"
 /* Constructor for FI_NOT */
#line 374
struct f_inst *f_new_inst_FI_NOT(enum f_instruction_code fi_code
#line 370 "filter/f-inst.c"
  , struct f_inst * f1
#line 374 "filter/f-inst.c"
)
#line 374
  {
#line 374
    /* Allocate the structure */
#line 374
    struct f_inst *what = fi_new(fi_code);
#line 374
    uint constargs = 1;
#line 374

#line 374
    /* Initialize all the members */
#line 374
  #define whati (&(what->i_FI_NOT))
#line 374
  #line 370 "filter/f-inst.c"

#line 370
whati->f1 = f1;
#line 370
for (const struct f_inst *child = f1; child; child = child->next) {
#line 370
  what->size += child->size;
#line 370

#line 370
  if (child->fi_code != FI_CONSTANT)
#line 370
    constargs = 0;
#line 370

#line 370
}

#line 374 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 374
    if (!constargs)
#line 374
      return what;
#line 374

#line 374
    /* Try to pre-calculate the result */
#line 374
    #line 369 "filter/f-inst.c"
 {
    
#line 370 "filter/f-inst.c"

#line 370 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !v1.val.i } );
  }

  
  #undef whati
#line 374 "filter/f-inst.c"
  }
#line 374

#line 374

#line 383 "filter/f-inst.c"
 /* Constructor for FI_MATCH */
#line 383
struct f_inst *f_new_inst_FI_MATCH(enum f_instruction_code fi_code
#line 375 "filter/f-inst.c"
  , struct f_inst * f1
#line 376 "filter/f-inst.c"
  , struct f_inst * f2
#line 383 "filter/f-inst.c"
)
#line 383
  {
#line 383
    /* Allocate the structure */
#line 383
    struct f_inst *what = fi_new(fi_code);
#line 383
    uint constargs = 1;
#line 383

#line 383
    /* Initialize all the members */
#line 383
  #define whati (&(what->i_FI_MATCH))
#line 383
  #line 375 "filter/f-inst.c"

#line 375
whati->f1 = f1;
#line 375
for (const struct f_inst *child = f1; child; child = child->next) {
#line 375
  what->size += child->size;
#line 375

#line 375
  if (child->fi_code != FI_CONSTANT)
#line 375
    constargs = 0;
#line 375

#line 375
}
#line 376 "filter/f-inst.c"

#line 376
whati->f2 = f2;
#line 376
for (const struct f_inst *child = f2; child; child = child->next) {
#line 376
  what->size += child->size;
#line 376

#line 376
  if (child->fi_code != FI_CONSTANT)
#line 376
    constargs = 0;
#line 376

#line 376
}

#line 383 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 383
    if (!constargs)
#line 383
      return what;
#line 383

#line 383
    /* Try to pre-calculate the result */
#line 383
    #line 374 "filter/f-inst.c"
 {
    
#line 375 "filter/f-inst.c"
;
    
#line 376 "filter/f-inst.c"
;
    int i = val_in_range(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "~ applied on unknown type pair" );
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !!i } );
  }

  
  #undef whati
#line 383 "filter/f-inst.c"
  }
#line 383

#line 383

#line 392 "filter/f-inst.c"
 /* Constructor for FI_NOT_MATCH */
#line 392
struct f_inst *f_new_inst_FI_NOT_MATCH(enum f_instruction_code fi_code
#line 384 "filter/f-inst.c"
  , struct f_inst * f1
#line 385 "filter/f-inst.c"
  , struct f_inst * f2
#line 392 "filter/f-inst.c"
)
#line 392
  {
#line 392
    /* Allocate the structure */
#line 392
    struct f_inst *what = fi_new(fi_code);
#line 392
    uint constargs = 1;
#line 392

#line 392
    /* Initialize all the members */
#line 392
  #define whati (&(what->i_FI_NOT_MATCH))
#line 392
  #line 384 "filter/f-inst.c"

#line 384
whati->f1 = f1;
#line 384
for (const struct f_inst *child = f1; child; child = child->next) {
#line 384
  what->size += child->size;
#line 384

#line 384
  if (child->fi_code != FI_CONSTANT)
#line 384
    constargs = 0;
#line 384

#line 384
}
#line 385 "filter/f-inst.c"

#line 385
whati->f2 = f2;
#line 385
for (const struct f_inst *child = f2; child; child = child->next) {
#line 385
  what->size += child->size;
#line 385

#line 385
  if (child->fi_code != FI_CONSTANT)
#line 385
    constargs = 0;
#line 385

#line 385
}

#line 392 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 392
    if (!constargs)
#line 392
      return what;
#line 392

#line 392
    /* Try to pre-calculate the result */
#line 392
    #line 383 "filter/f-inst.c"
 {
    
#line 384 "filter/f-inst.c"
;
    
#line 385 "filter/f-inst.c"
;
    int i = val_in_range(&v1, &v2);
    if (i == F_CMP_ERROR)
      runtime( "!~ applied on unknown type pair" );
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = !i } );
  }

  
  #undef whati
#line 392 "filter/f-inst.c"
  }
#line 392

#line 392

#line 397 "filter/f-inst.c"
 /* Constructor for FI_DEFINED */
#line 397
struct f_inst *f_new_inst_FI_DEFINED(enum f_instruction_code fi_code
#line 393 "filter/f-inst.c"
  , struct f_inst * f1
#line 397 "filter/f-inst.c"
)
#line 397
  {
#line 397
    /* Allocate the structure */
#line 397
    struct f_inst *what = fi_new(fi_code);
#line 397
    uint constargs = 1;
#line 397

#line 397
    /* Initialize all the members */
#line 397
  #define whati (&(what->i_FI_DEFINED))
#line 397
  #line 393 "filter/f-inst.c"

#line 393
whati->f1 = f1;
#line 393
for (const struct f_inst *child = f1; child; child = child->next) {
#line 393
  what->size += child->size;
#line 393

#line 393
  if (child->fi_code != FI_CONSTANT)
#line 393
    constargs = 0;
#line 393

#line 393
}

#line 397 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 397
    if (!constargs)
#line 397
      return what;
#line 397

#line 397
    /* Try to pre-calculate the result */
#line 397
    #line 392 "filter/f-inst.c"
 {
    
#line 393 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = (v1.type != T_VOID) && !undef_value(v1) } );
  }

  
  #undef whati
#line 397 "filter/f-inst.c"
  }
#line 397

#line 397

#line 409 "filter/f-inst.c"
 /* Constructor for FI_TYPE */
#line 409
struct f_inst *f_new_inst_FI_TYPE(enum f_instruction_code fi_code
#line 398 "filter/f-inst.c"
  , struct f_inst * f1
#line 409 "filter/f-inst.c"
)
#line 409
  {
#line 409
    /* Allocate the structure */
#line 409
    struct f_inst *what = fi_new(fi_code);
#line 409
    uint constargs = 1;
#line 409

#line 409
    /* Initialize all the members */
#line 409
  #define whati (&(what->i_FI_TYPE))
#line 409
  #line 398 "filter/f-inst.c"

#line 398
whati->f1 = f1;
#line 398
for (const struct f_inst *child = f1; child; child = child->next) {
#line 398
  what->size += child->size;
#line 398

#line 398
  if (child->fi_code != FI_CONSTANT)
#line 398
    constargs = 0;
#line 398

#line 398
}

#line 409 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 409
    if (!constargs)
#line 409
      return what;
#line 409

#line 409
    /* Try to pre-calculate the result */
#line 409
    #line 397 "filter/f-inst.c"
 {
    
#line 398 "filter/f-inst.c"
; /* There may be more types supporting this operation */
    switch (v1.type)
    {
      case T_NET:
	return fi_constant(what,  (struct f_val) { .type = T_ENUM_NETTYPE, .val.i = v1.val.net->type } );
	break;
      default:
	runtime( "Can't determine type of this item" );
    }
  }

  
  #undef whati
#line 409 "filter/f-inst.c"
  }
#line 409

#line 409

#line 415 "filter/f-inst.c"
 /* Constructor for FI_IS_V4 */
#line 415
struct f_inst *f_new_inst_FI_IS_V4(enum f_instruction_code fi_code
#line 410 "filter/f-inst.c"
  , struct f_inst * f1
#line 415 "filter/f-inst.c"
)
#line 415
  {
#line 415
    /* Allocate the structure */
#line 415
    struct f_inst *what = fi_new(fi_code);
#line 415
    uint constargs = 1;
#line 415

#line 415
    /* Initialize all the members */
#line 415
  #define whati (&(what->i_FI_IS_V4))
#line 415
  #line 410 "filter/f-inst.c"

#line 410
whati->f1 = f1;
#line 410
for (const struct f_inst *child = f1; child; child = child->next) {
#line 410
  what->size += child->size;
#line 410

#line 410
  if (child->fi_code != FI_CONSTANT)
#line 410
    constargs = 0;
#line 410

#line 410
}

#line 415 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 415
    if (!constargs)
#line 415
      return what;
#line 415

#line 415
    /* Try to pre-calculate the result */
#line 415
    #line 409 "filter/f-inst.c"
 {
    
#line 410 "filter/f-inst.c"

#line 410 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_BOOL, .val.i = ipa_is_ip4(v1.val.ip) } );
  }

  /* Set to indirect value prepared in v1 */
  
  #undef whati
#line 415 "filter/f-inst.c"
  }
#line 415

#line 415

#line 435 "filter/f-inst.c"
 /* Constructor for FI_VAR_SET */
#line 435
struct f_inst *f_new_inst_FI_VAR_SET(enum f_instruction_code fi_code
#line 417 "filter/f-inst.c"
  , struct f_inst * f1
#line 418 "filter/f-inst.c"
  , struct symbol * sym
#line 435 "filter/f-inst.c"
)
#line 435
  {
#line 435
    /* Allocate the structure */
#line 435
    struct f_inst *what = fi_new(fi_code);
#line 435
    
#line 435

#line 435
    /* Initialize all the members */
#line 435
  #define whati (&(what->i_FI_VAR_SET))
#line 435
  #line 417 "filter/f-inst.c"

#line 417
whati->f1 = f1;
#line 417
for (const struct f_inst *child = f1; child; child = child->next) {
#line 417
  what->size += child->size;
#line 417

#line 417
}
#line 418 "filter/f-inst.c"
whati->sym = sym;

#line 435 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 435
    
#line 435
      return what;
#line 435

#line 435
    /* Try to pre-calculate the result */
#line 435
      #undef whati
#line 435
  }
#line 435

#line 435

#line 441 "filter/f-inst.c"
 /* Constructor for FI_VAR_GET */
#line 441
struct f_inst *f_new_inst_FI_VAR_GET(enum f_instruction_code fi_code
#line 436 "filter/f-inst.c"
  , struct symbol * sym
#line 441 "filter/f-inst.c"
)
#line 441
  {
#line 441
    /* Allocate the structure */
#line 441
    struct f_inst *what = fi_new(fi_code);
#line 441
    
#line 441

#line 441
    /* Initialize all the members */
#line 441
  #define whati (&(what->i_FI_VAR_GET))
#line 441
  #line 436 "filter/f-inst.c"
whati->sym = sym;

#line 441 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 441
    
#line 441
      return what;
#line 441

#line 441
    /* Try to pre-calculate the result */
#line 441
      #undef whati
#line 441
  }
#line 441

#line 441

#line 453 "filter/f-inst.c"
 /* Constructor for FI_CONSTANT */
#line 453
struct f_inst *f_new_inst_FI_CONSTANT(enum f_instruction_code fi_code
#line 442 "filter/f-inst.c"
  , struct f_val val
#line 453 "filter/f-inst.c"
)
#line 453
  {
#line 453
    /* Allocate the structure */
#line 453
    struct f_inst *what = fi_new(fi_code);
#line 453
    uint constargs = 1;
#line 453

#line 453
    /* Initialize all the members */
#line 453
  #define whati (&(what->i_FI_CONSTANT))
#line 453
  #line 442 "filter/f-inst.c"
whati->val = val;

#line 453 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 453
    if (!constargs)
#line 453
      return what;
#line 453

#line 453
    /* Try to pre-calculate the result */
#line 453
    #line 441 "filter/f-inst.c"
 {
    #line 448 "filter/f-inst.c"
;

    return fi_constant(what, val);
  }

  
  #undef whati
#line 453 "filter/f-inst.c"
  }
#line 453

#line 453

#line 461 "filter/f-inst.c"
 /* Constructor for FI_CONDITION */
#line 461
struct f_inst *f_new_inst_FI_CONDITION(enum f_instruction_code fi_code
#line 454 "filter/f-inst.c"
  , struct f_inst * f1
#line 456 "filter/f-inst.c"
  , struct f_inst * f2
#line 458 "filter/f-inst.c"
  , struct f_inst * f3
#line 461 "filter/f-inst.c"
)
#line 461
  {
#line 461
    /* Allocate the structure */
#line 461
    struct f_inst *what = fi_new(fi_code);
#line 461
    uint constargs = 1;
#line 461

#line 461
    /* Initialize all the members */
#line 461
  #define whati (&(what->i_FI_CONDITION))
#line 461
  #line 454 "filter/f-inst.c"

#line 454
whati->f1 = f1;
#line 454
for (const struct f_inst *child = f1; child; child = child->next) {
#line 454
  what->size += child->size;
#line 454

#line 454
  if (child->fi_code != FI_CONSTANT)
#line 454
    constargs = 0;
#line 454

#line 454
}
#line 456 "filter/f-inst.c"
whati->f2 = f2;
#line 458 "filter/f-inst.c"
whati->f3 = f3;

#line 461 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 461
    if (!constargs)
#line 461
      return what;
#line 461

#line 461
    /* Try to pre-calculate the result */
#line 461
    #line 453 "filter/f-inst.c"
 {
    
#line 454 "filter/f-inst.c"

#line 454 "filter/f-inst.c"
;
    if (v1.val.i)
      
#line 456 "filter/f-inst.c"
return whati->f2
#line 456
;
    else
      
#line 458 "filter/f-inst.c"
return whati->f3
#line 458
;
  }

  
  #undef whati
#line 461 "filter/f-inst.c"
  }
#line 461

#line 461

#line 470 "filter/f-inst.c"
 /* Constructor for FI_PRINT */
#line 470
struct f_inst *f_new_inst_FI_PRINT(enum f_instruction_code fi_code
#line 463 "filter/f-inst.c"
  , struct f_inst * fvar
#line 470 "filter/f-inst.c"
)
#line 470
  {
#line 470
    /* Allocate the structure */
#line 470
    struct f_inst *what = fi_new(fi_code);
#line 470
    
#line 470

#line 470
    /* Initialize all the members */
#line 470
  #define whati (&(what->i_FI_PRINT))
#line 470
  #line 463 "filter/f-inst.c"
whati->varcount = 0;
#line 463
whati->fvar = fvar;
#line 463
for (const struct f_inst *child = fvar; child; child = child->next, whati->varcount++) {
#line 463
  what->size += child->size;
#line 463

#line 463
}
#line 463


#line 470 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 470
    
#line 470
      return what;
#line 470

#line 470
    /* Try to pre-calculate the result */
#line 470
      #undef whati
#line 470
  }
#line 470

#line 470

#line 477 "filter/f-inst.c"
 /* Constructor for FI_FLUSH */
#line 477
struct f_inst *f_new_inst_FI_FLUSH(enum f_instruction_code fi_code
#line 477
)
#line 477
  {
#line 477
    /* Allocate the structure */
#line 477
    struct f_inst *what = fi_new(fi_code);
#line 477
    
#line 477

#line 477
    /* Initialize all the members */
#line 477
  #define whati (&(what->i_FI_FLUSH))
#line 477
  
#line 477
    /* If not constant, return the instruction itself */
#line 477
    
#line 477
      return what;
#line 477

#line 477
    /* Try to pre-calculate the result */
#line 477
      #undef whati
#line 477
  }
#line 477

#line 477

#line 493 "filter/f-inst.c"
 /* Constructor for FI_DIE */
#line 493
struct f_inst *f_new_inst_FI_DIE(enum f_instruction_code fi_code
#line 479 "filter/f-inst.c"
  , enum filter_return fret
#line 493 "filter/f-inst.c"
)
#line 493
  {
#line 493
    /* Allocate the structure */
#line 493
    struct f_inst *what = fi_new(fi_code);
#line 493
    
#line 493

#line 493
    /* Initialize all the members */
#line 493
  #define whati (&(what->i_FI_DIE))
#line 493
  #line 479 "filter/f-inst.c"
whati->fret = fret;

#line 493 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 493
    
#line 493
      return what;
#line 493

#line 493
    /* Try to pre-calculate the result */
#line 493
      #undef whati
#line 493
  }
#line 493

#line 493

#line 517 "filter/f-inst.c"
 /* Constructor for FI_RTA_GET */
#line 517
struct f_inst *f_new_inst_FI_RTA_GET(enum f_instruction_code fi_code
#line 495 "filter/f-inst.c"
  , struct f_static_attr sa
#line 517 "filter/f-inst.c"
)
#line 517
  {
#line 517
    /* Allocate the structure */
#line 517
    struct f_inst *what = fi_new(fi_code);
#line 517
    
#line 517

#line 517
    /* Initialize all the members */
#line 517
  #define whati (&(what->i_FI_RTA_GET))
#line 517
  #line 495 "filter/f-inst.c"
whati->sa = sa;

#line 517 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 517
    
#line 517
      return what;
#line 517

#line 517
    /* Try to pre-calculate the result */
#line 517
      #undef whati
#line 517
  }
#line 517

#line 517

#line 587 "filter/f-inst.c"
 /* Constructor for FI_RTA_SET */
#line 587
struct f_inst *f_new_inst_FI_RTA_SET(enum f_instruction_code fi_code
#line 519 "filter/f-inst.c"
  , struct f_inst * f1
#line 520 "filter/f-inst.c"
  , struct f_static_attr sa
#line 587 "filter/f-inst.c"
)
#line 587
  {
#line 587
    /* Allocate the structure */
#line 587
    struct f_inst *what = fi_new(fi_code);
#line 587
    
#line 587

#line 587
    /* Initialize all the members */
#line 587
  #define whati (&(what->i_FI_RTA_SET))
#line 587
  #line 519 "filter/f-inst.c"

#line 519
whati->f1 = f1;
#line 519
for (const struct f_inst *child = f1; child; child = child->next) {
#line 519
  what->size += child->size;
#line 519

#line 519
}
#line 520 "filter/f-inst.c"
whati->sa = sa;

#line 587 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 587
    
#line 587
      return what;
#line 587

#line 587
    /* Try to pre-calculate the result */
#line 587
      #undef whati
#line 587
  }
#line 587

#line 587

#line 661 "filter/f-inst.c"
 /* Constructor for FI_EA_GET */
#line 661
struct f_inst *f_new_inst_FI_EA_GET(enum f_instruction_code fi_code
#line 588 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 661 "filter/f-inst.c"
)
#line 661
  {
#line 661
    /* Allocate the structure */
#line 661
    struct f_inst *what = fi_new(fi_code);
#line 661
    
#line 661

#line 661
    /* Initialize all the members */
#line 661
  #define whati (&(what->i_FI_EA_GET))
#line 661
  #line 588 "filter/f-inst.c"
whati->da = da;

#line 661 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 661
    
#line 661
      return what;
#line 661

#line 661
    /* Try to pre-calculate the result */
#line 661
      #undef whati
#line 661
  }
#line 661

#line 661

#line 758 "filter/f-inst.c"
 /* Constructor for FI_EA_SET */
#line 758
struct f_inst *f_new_inst_FI_EA_SET(enum f_instruction_code fi_code
#line 664 "filter/f-inst.c"
  , struct f_inst * f1
#line 665 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 758 "filter/f-inst.c"
)
#line 758
  {
#line 758
    /* Allocate the structure */
#line 758
    struct f_inst *what = fi_new(fi_code);
#line 758
    
#line 758

#line 758
    /* Initialize all the members */
#line 758
  #define whati (&(what->i_FI_EA_SET))
#line 758
  #line 664 "filter/f-inst.c"

#line 664
whati->f1 = f1;
#line 664
for (const struct f_inst *child = f1; child; child = child->next) {
#line 664
  what->size += child->size;
#line 664

#line 664
}
#line 665 "filter/f-inst.c"
whati->da = da;

#line 758 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 758
    
#line 758
      return what;
#line 758

#line 758
    /* Try to pre-calculate the result */
#line 758
      #undef whati
#line 758
  }
#line 758

#line 758

#line 780 "filter/f-inst.c"
 /* Constructor for FI_EA_UNSET */
#line 780
struct f_inst *f_new_inst_FI_EA_UNSET(enum f_instruction_code fi_code
#line 759 "filter/f-inst.c"
  , struct f_dynamic_attr da
#line 780 "filter/f-inst.c"
)
#line 780
  {
#line 780
    /* Allocate the structure */
#line 780
    struct f_inst *what = fi_new(fi_code);
#line 780
    
#line 780

#line 780
    /* Initialize all the members */
#line 780
  #define whati (&(what->i_FI_EA_UNSET))
#line 780
  #line 759 "filter/f-inst.c"
whati->da = da;

#line 780 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 780
    
#line 780
      return what;
#line 780

#line 780
    /* Try to pre-calculate the result */
#line 780
      #undef whati
#line 780
  }
#line 780

#line 780

#line 785 "filter/f-inst.c"
 /* Constructor for FI_PREF_GET */
#line 785
struct f_inst *f_new_inst_FI_PREF_GET(enum f_instruction_code fi_code
#line 785
)
#line 785
  {
#line 785
    /* Allocate the structure */
#line 785
    struct f_inst *what = fi_new(fi_code);
#line 785
    
#line 785

#line 785
    /* Initialize all the members */
#line 785
  #define whati (&(what->i_FI_PREF_GET))
#line 785
  
#line 785
    /* If not constant, return the instruction itself */
#line 785
    
#line 785
      return what;
#line 785

#line 785
    /* Try to pre-calculate the result */
#line 785
      #undef whati
#line 785
  }
#line 785

#line 785

#line 794 "filter/f-inst.c"
 /* Constructor for FI_PREF_SET */
#line 794
struct f_inst *f_new_inst_FI_PREF_SET(enum f_instruction_code fi_code
#line 787 "filter/f-inst.c"
  , struct f_inst * f1
#line 794 "filter/f-inst.c"
)
#line 794
  {
#line 794
    /* Allocate the structure */
#line 794
    struct f_inst *what = fi_new(fi_code);
#line 794
    
#line 794

#line 794
    /* Initialize all the members */
#line 794
  #define whati (&(what->i_FI_PREF_SET))
#line 794
  #line 787 "filter/f-inst.c"

#line 787
whati->f1 = f1;
#line 787
for (const struct f_inst *child = f1; child; child = child->next) {
#line 787
  what->size += child->size;
#line 787

#line 787
}

#line 794 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 794
    
#line 794
      return what;
#line 794

#line 794
    /* Try to pre-calculate the result */
#line 794
      #undef whati
#line 794
  }
#line 794

#line 794

#line 806 "filter/f-inst.c"
 /* Constructor for FI_LENGTH */
#line 806
struct f_inst *f_new_inst_FI_LENGTH(enum f_instruction_code fi_code
#line 795 "filter/f-inst.c"
  , struct f_inst * f1
#line 806 "filter/f-inst.c"
)
#line 806
  {
#line 806
    /* Allocate the structure */
#line 806
    struct f_inst *what = fi_new(fi_code);
#line 806
    uint constargs = 1;
#line 806

#line 806
    /* Initialize all the members */
#line 806
  #define whati (&(what->i_FI_LENGTH))
#line 806
  #line 795 "filter/f-inst.c"

#line 795
whati->f1 = f1;
#line 795
for (const struct f_inst *child = f1; child; child = child->next) {
#line 795
  what->size += child->size;
#line 795

#line 795
  if (child->fi_code != FI_CONSTANT)
#line 795
    constargs = 0;
#line 795

#line 795
}

#line 806 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 806
    if (!constargs)
#line 806
      return what;
#line 806

#line 806
    /* Try to pre-calculate the result */
#line 806
    #line 794 "filter/f-inst.c"
 {	/* Get length of */
    
#line 795 "filter/f-inst.c"
;
    switch(v1.type) {
    case T_NET:    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = net_pxlen(v1.val.net) } ); break;
    case T_PATH:   return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as_path_getlen(v1.val.ad) } ); break;
    case T_CLIST:  return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = int_set_get_size(v1.val.ad) } ); break;
    case T_ECLIST: return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = ec_set_get_size(v1.val.ad) } ); break;
    case T_LCLIST: return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = lc_set_get_size(v1.val.ad) } ); break;
    default: runtime( "Prefix, path, clist or eclist expected" );
    }
  }

  
  #undef whati
#line 806 "filter/f-inst.c"
  }
#line 806

#line 806

#line 818 "filter/f-inst.c"
 /* Constructor for FI_SADR_SRC */
#line 818
struct f_inst *f_new_inst_FI_SADR_SRC(enum f_instruction_code fi_code
#line 807 "filter/f-inst.c"
  , struct f_inst * f1
#line 818 "filter/f-inst.c"
)
#line 818
  {
#line 818
    /* Allocate the structure */
#line 818
    struct f_inst *what = fi_new(fi_code);
#line 818
    uint constargs = 1;
#line 818

#line 818
    /* Initialize all the members */
#line 818
  #define whati (&(what->i_FI_SADR_SRC))
#line 818
  #line 807 "filter/f-inst.c"

#line 807
whati->f1 = f1;
#line 807
for (const struct f_inst *child = f1; child; child = child->next) {
#line 807
  what->size += child->size;
#line 807

#line 807
  if (child->fi_code != FI_CONSTANT)
#line 807
    constargs = 0;
#line 807

#line 807
}

#line 818 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 818
    if (!constargs)
#line 818
      return what;
#line 818

#line 818
    /* Try to pre-calculate the result */
#line 818
    #line 806 "filter/f-inst.c"
 { 	/* Get SADR src prefix */
    
#line 807 "filter/f-inst.c"

#line 807 "filter/f-inst.c"
;
    if (!net_is_sadr(v1.val.net))
      runtime( "SADR expected" );

    net_addr_ip6_sadr *net = (void *) v1.val.net;
    net_addr *src = falloc(sizeof(net_addr_ip6));
    net_fill_ip6(src, net->src_prefix, net->src_pxlen);

    return fi_constant(what,  (struct f_val) { .type = T_NET, .val.net = src } );
  }

  
  #undef whati
#line 818 "filter/f-inst.c"
  }
#line 818

#line 818

#line 828 "filter/f-inst.c"
 /* Constructor for FI_ROA_MAXLEN */
#line 828
struct f_inst *f_new_inst_FI_ROA_MAXLEN(enum f_instruction_code fi_code
#line 819 "filter/f-inst.c"
  , struct f_inst * f1
#line 828 "filter/f-inst.c"
)
#line 828
  {
#line 828
    /* Allocate the structure */
#line 828
    struct f_inst *what = fi_new(fi_code);
#line 828
    uint constargs = 1;
#line 828

#line 828
    /* Initialize all the members */
#line 828
  #define whati (&(what->i_FI_ROA_MAXLEN))
#line 828
  #line 819 "filter/f-inst.c"

#line 819
whati->f1 = f1;
#line 819
for (const struct f_inst *child = f1; child; child = child->next) {
#line 819
  what->size += child->size;
#line 819

#line 819
  if (child->fi_code != FI_CONSTANT)
#line 819
    constargs = 0;
#line 819

#line 819
}

#line 828 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 828
    if (!constargs)
#line 828
      return what;
#line 828

#line 828
    /* Try to pre-calculate the result */
#line 828
    #line 818 "filter/f-inst.c"
 { 	/* Get ROA max prefix length */
    
#line 819 "filter/f-inst.c"

#line 819 "filter/f-inst.c"
;
    if (!net_is_roa(v1.val.net))
      runtime( "ROA expected" );

    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = (v1.val.net->type == NET_ROA4) ?
#line 823
      ((net_addr_roa4 *) v1.val.net)->max_pxlen :
#line 823
      ((net_addr_roa6 *) v1.val.net)->max_pxlen } );
#line 826
  }

  
  #undef whati
#line 828 "filter/f-inst.c"
  }
#line 828

#line 828

#line 838 "filter/f-inst.c"
 /* Constructor for FI_ROA_ASN */
#line 838
struct f_inst *f_new_inst_FI_ROA_ASN(enum f_instruction_code fi_code
#line 829 "filter/f-inst.c"
  , struct f_inst * f1
#line 838 "filter/f-inst.c"
)
#line 838
  {
#line 838
    /* Allocate the structure */
#line 838
    struct f_inst *what = fi_new(fi_code);
#line 838
    uint constargs = 1;
#line 838

#line 838
    /* Initialize all the members */
#line 838
  #define whati (&(what->i_FI_ROA_ASN))
#line 838
  #line 829 "filter/f-inst.c"

#line 829
whati->f1 = f1;
#line 829
for (const struct f_inst *child = f1; child; child = child->next) {
#line 829
  what->size += child->size;
#line 829

#line 829
  if (child->fi_code != FI_CONSTANT)
#line 829
    constargs = 0;
#line 829

#line 829
}

#line 838 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 838
    if (!constargs)
#line 838
      return what;
#line 838

#line 838
    /* Try to pre-calculate the result */
#line 838
    #line 828 "filter/f-inst.c"
 { 	/* Get ROA ASN */
    
#line 829 "filter/f-inst.c"

#line 829 "filter/f-inst.c"
;
    if (!net_is_roa(v1.val.net))
      runtime( "ROA expected" );

    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = (v1.val.net->type == NET_ROA4) ?
#line 833
      ((net_addr_roa4 *) v1.val.net)->asn :
#line 833
      ((net_addr_roa6 *) v1.val.net)->asn } );
#line 836
  }

  
  #undef whati
#line 838 "filter/f-inst.c"
  }
#line 838

#line 838

#line 843 "filter/f-inst.c"
 /* Constructor for FI_IP */
#line 843
struct f_inst *f_new_inst_FI_IP(enum f_instruction_code fi_code
#line 839 "filter/f-inst.c"
  , struct f_inst * f1
#line 843 "filter/f-inst.c"
)
#line 843
  {
#line 843
    /* Allocate the structure */
#line 843
    struct f_inst *what = fi_new(fi_code);
#line 843
    uint constargs = 1;
#line 843

#line 843
    /* Initialize all the members */
#line 843
  #define whati (&(what->i_FI_IP))
#line 843
  #line 839 "filter/f-inst.c"

#line 839
whati->f1 = f1;
#line 839
for (const struct f_inst *child = f1; child; child = child->next) {
#line 839
  what->size += child->size;
#line 839

#line 839
  if (child->fi_code != FI_CONSTANT)
#line 839
    constargs = 0;
#line 839

#line 839
}

#line 843 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 843
    if (!constargs)
#line 843
      return what;
#line 843

#line 843
    /* Try to pre-calculate the result */
#line 843
    #line 838 "filter/f-inst.c"
 {	/* Convert prefix to ... */
    
#line 839 "filter/f-inst.c"

#line 839 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_IP, .val.ip = net_prefix(v1.val.net) } );
  }

  
  #undef whati
#line 843 "filter/f-inst.c"
  }
#line 843

#line 843

#line 850 "filter/f-inst.c"
 /* Constructor for FI_ROUTE_DISTINGUISHER */
#line 850
struct f_inst *f_new_inst_FI_ROUTE_DISTINGUISHER(enum f_instruction_code fi_code
#line 844 "filter/f-inst.c"
  , struct f_inst * f1
#line 850 "filter/f-inst.c"
)
#line 850
  {
#line 850
    /* Allocate the structure */
#line 850
    struct f_inst *what = fi_new(fi_code);
#line 850
    uint constargs = 1;
#line 850

#line 850
    /* Initialize all the members */
#line 850
  #define whati (&(what->i_FI_ROUTE_DISTINGUISHER))
#line 850
  #line 844 "filter/f-inst.c"

#line 844
whati->f1 = f1;
#line 844
for (const struct f_inst *child = f1; child; child = child->next) {
#line 844
  what->size += child->size;
#line 844

#line 844
  if (child->fi_code != FI_CONSTANT)
#line 844
    constargs = 0;
#line 844

#line 844
}

#line 850 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 850
    if (!constargs)
#line 850
      return what;
#line 850

#line 850
    /* Try to pre-calculate the result */
#line 850
    #line 843 "filter/f-inst.c"
 {
    
#line 844 "filter/f-inst.c"

#line 844 "filter/f-inst.c"
;
    if (!net_is_vpn(v1.val.net))
      runtime( "VPN address expected" );
    return fi_constant(what,  (struct f_val) { .type = T_RD, .val.ec = net_rd(v1.val.net) } );
  }

  
  #undef whati
#line 850 "filter/f-inst.c"
  }
#line 850

#line 850

#line 857 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_FIRST */
#line 857
struct f_inst *f_new_inst_FI_AS_PATH_FIRST(enum f_instruction_code fi_code
#line 851 "filter/f-inst.c"
  , struct f_inst * f1
#line 857 "filter/f-inst.c"
)
#line 857
  {
#line 857
    /* Allocate the structure */
#line 857
    struct f_inst *what = fi_new(fi_code);
#line 857
    uint constargs = 1;
#line 857

#line 857
    /* Initialize all the members */
#line 857
  #define whati (&(what->i_FI_AS_PATH_FIRST))
#line 857
  #line 851 "filter/f-inst.c"

#line 851
whati->f1 = f1;
#line 851
for (const struct f_inst *child = f1; child; child = child->next) {
#line 851
  what->size += child->size;
#line 851

#line 851
  if (child->fi_code != FI_CONSTANT)
#line 851
    constargs = 0;
#line 851

#line 851
}

#line 857 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 857
    if (!constargs)
#line 857
      return what;
#line 857

#line 857
    /* Try to pre-calculate the result */
#line 857
    #line 850 "filter/f-inst.c"
 {	/* Get first ASN from AS PATH */
    
#line 851 "filter/f-inst.c"

#line 851 "filter/f-inst.c"
;
    int as = 0;
    as_path_get_first(v1.val.ad, &as);
    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as } );
  }

  
  #undef whati
#line 857 "filter/f-inst.c"
  }
#line 857

#line 857

#line 864 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_LAST */
#line 864
struct f_inst *f_new_inst_FI_AS_PATH_LAST(enum f_instruction_code fi_code
#line 858 "filter/f-inst.c"
  , struct f_inst * f1
#line 864 "filter/f-inst.c"
)
#line 864
  {
#line 864
    /* Allocate the structure */
#line 864
    struct f_inst *what = fi_new(fi_code);
#line 864
    uint constargs = 1;
#line 864

#line 864
    /* Initialize all the members */
#line 864
  #define whati (&(what->i_FI_AS_PATH_LAST))
#line 864
  #line 858 "filter/f-inst.c"

#line 858
whati->f1 = f1;
#line 858
for (const struct f_inst *child = f1; child; child = child->next) {
#line 858
  what->size += child->size;
#line 858

#line 858
  if (child->fi_code != FI_CONSTANT)
#line 858
    constargs = 0;
#line 858

#line 858
}

#line 864 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 864
    if (!constargs)
#line 864
      return what;
#line 864

#line 864
    /* Try to pre-calculate the result */
#line 864
    #line 857 "filter/f-inst.c"
 {		/* Get last ASN from AS PATH */
    
#line 858 "filter/f-inst.c"

#line 858 "filter/f-inst.c"
;
    int as = 0;
    as_path_get_last(v1.val.ad, &as);
    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as } );
  }

  
  #undef whati
#line 864 "filter/f-inst.c"
  }
#line 864

#line 864

#line 869 "filter/f-inst.c"
 /* Constructor for FI_AS_PATH_LAST_NAG */
#line 869
struct f_inst *f_new_inst_FI_AS_PATH_LAST_NAG(enum f_instruction_code fi_code
#line 865 "filter/f-inst.c"
  , struct f_inst * f1
#line 869 "filter/f-inst.c"
)
#line 869
  {
#line 869
    /* Allocate the structure */
#line 869
    struct f_inst *what = fi_new(fi_code);
#line 869
    uint constargs = 1;
#line 869

#line 869
    /* Initialize all the members */
#line 869
  #define whati (&(what->i_FI_AS_PATH_LAST_NAG))
#line 869
  #line 865 "filter/f-inst.c"

#line 865
whati->f1 = f1;
#line 865
for (const struct f_inst *child = f1; child; child = child->next) {
#line 865
  what->size += child->size;
#line 865

#line 865
  if (child->fi_code != FI_CONSTANT)
#line 865
    constargs = 0;
#line 865

#line 865
}

#line 869 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 869
    if (!constargs)
#line 869
      return what;
#line 869

#line 869
    /* Try to pre-calculate the result */
#line 869
    #line 864 "filter/f-inst.c"
 {	/* Get last ASN from non-aggregated part of AS PATH */
    
#line 865 "filter/f-inst.c"

#line 865 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_INT, .val.i = as_path_get_last_nonaggregated(v1.val.ad) } );
  }

  
  #undef whati
#line 869 "filter/f-inst.c"
  }
#line 869

#line 869

#line 896 "filter/f-inst.c"
 /* Constructor for FI_RETURN */
#line 896
struct f_inst *f_new_inst_FI_RETURN(enum f_instruction_code fi_code
#line 872 "filter/f-inst.c"
  , struct f_inst * f1
#line 896 "filter/f-inst.c"
)
#line 896
  {
#line 896
    /* Allocate the structure */
#line 896
    struct f_inst *what = fi_new(fi_code);
#line 896
    
#line 896

#line 896
    /* Initialize all the members */
#line 896
  #define whati (&(what->i_FI_RETURN))
#line 896
  #line 872 "filter/f-inst.c"

#line 872
whati->f1 = f1;
#line 872
for (const struct f_inst *child = f1; child; child = child->next) {
#line 872
  what->size += child->size;
#line 872

#line 872
}

#line 896 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 896
    
#line 896
      return what;
#line 896

#line 896
    /* Try to pre-calculate the result */
#line 896
      #undef whati
#line 896
  }
#line 896

#line 896

#line 922 "filter/f-inst.c"
 /* Constructor for FI_CALL */
#line 922
struct f_inst *f_new_inst_FI_CALL(enum f_instruction_code fi_code
#line 898 "filter/f-inst.c"
  , struct symbol * sym
#line 922 "filter/f-inst.c"
)
#line 922
  {
#line 922
    /* Allocate the structure */
#line 922
    struct f_inst *what = fi_new(fi_code);
#line 922
    
#line 922

#line 922
    /* Initialize all the members */
#line 922
  #define whati (&(what->i_FI_CALL))
#line 922
  #line 898 "filter/f-inst.c"
whati->sym = sym;

#line 922 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 922
    
#line 922
      return what;
#line 922

#line 922
    /* Try to pre-calculate the result */
#line 922
      #undef whati
#line 922
  }
#line 922

#line 922

#line 927 "filter/f-inst.c"
 /* Constructor for FI_DROP_RESULT */
#line 927
struct f_inst *f_new_inst_FI_DROP_RESULT(enum f_instruction_code fi_code
#line 924 "filter/f-inst.c"
  , struct f_inst * f1
#line 927 "filter/f-inst.c"
)
#line 927
  {
#line 927
    /* Allocate the structure */
#line 927
    struct f_inst *what = fi_new(fi_code);
#line 927
    
#line 927

#line 927
    /* Initialize all the members */
#line 927
  #define whati (&(what->i_FI_DROP_RESULT))
#line 927
  #line 924 "filter/f-inst.c"

#line 924
whati->f1 = f1;
#line 924
for (const struct f_inst *child = f1; child; child = child->next) {
#line 924
  what->size += child->size;
#line 924

#line 924
}

#line 927 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 927
    
#line 927
      return what;
#line 927

#line 927
    /* Try to pre-calculate the result */
#line 927
      #undef whati
#line 927
  }
#line 927

#line 927

#line 946 "filter/f-inst.c"
 /* Constructor for FI_SWITCH */
#line 946
struct f_inst *f_new_inst_FI_SWITCH(enum f_instruction_code fi_code
#line 928 "filter/f-inst.c"
  , struct f_inst * f1
#line 930 "filter/f-inst.c"
  , struct f_tree * tree
#line 946 "filter/f-inst.c"
)
#line 946
  {
#line 946
    /* Allocate the structure */
#line 946
    struct f_inst *what = fi_new(fi_code);
#line 946
    uint constargs = 1;
#line 946

#line 946
    /* Initialize all the members */
#line 946
  #define whati (&(what->i_FI_SWITCH))
#line 946
  #line 928 "filter/f-inst.c"

#line 928
whati->f1 = f1;
#line 928
for (const struct f_inst *child = f1; child; child = child->next) {
#line 928
  what->size += child->size;
#line 928

#line 928
  if (child->fi_code != FI_CONSTANT)
#line 928
    constargs = 0;
#line 928

#line 928
}
#line 930 "filter/f-inst.c"
whati->tree = tree;

#line 946 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 946
    if (!constargs)
#line 946
      return what;
#line 946

#line 946
    /* Try to pre-calculate the result */
#line 946
    #line 927 "filter/f-inst.c"
 {
    
#line 928 "filter/f-inst.c"
;

    #line 930 "filter/f-inst.c"
;

    const struct f_tree *t = find_tree(tree, &v1);
    if (!t) {
      v1.type = T_VOID;
      t = find_tree(tree, &v1);
      if (!t) {
	debug( "No else statement?\n");
	return NULL;
      }
    }
    /* It is actually possible to have t->data NULL */

    return t->data ;
#line 944 "filter/f-inst.c"
  }

  
  #undef whati
#line 946 "filter/f-inst.c"
  }
#line 946

#line 946

#line 954 "filter/f-inst.c"
 /* Constructor for FI_IP_MASK */
#line 954
struct f_inst *f_new_inst_FI_IP_MASK(enum f_instruction_code fi_code
#line 947 "filter/f-inst.c"
  , struct f_inst * f1
#line 948 "filter/f-inst.c"
  , struct f_inst * f2
#line 954 "filter/f-inst.c"
)
#line 954
  {
#line 954
    /* Allocate the structure */
#line 954
    struct f_inst *what = fi_new(fi_code);
#line 954
    uint constargs = 1;
#line 954

#line 954
    /* Initialize all the members */
#line 954
  #define whati (&(what->i_FI_IP_MASK))
#line 954
  #line 947 "filter/f-inst.c"

#line 947
whati->f1 = f1;
#line 947
for (const struct f_inst *child = f1; child; child = child->next) {
#line 947
  what->size += child->size;
#line 947

#line 947
  if (child->fi_code != FI_CONSTANT)
#line 947
    constargs = 0;
#line 947

#line 947
}
#line 948 "filter/f-inst.c"

#line 948
whati->f2 = f2;
#line 948
for (const struct f_inst *child = f2; child; child = child->next) {
#line 948
  what->size += child->size;
#line 948

#line 948
  if (child->fi_code != FI_CONSTANT)
#line 948
    constargs = 0;
#line 948

#line 948
}

#line 954 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 954
    if (!constargs)
#line 954
      return what;
#line 954

#line 954
    /* Try to pre-calculate the result */
#line 954
    #line 946 "filter/f-inst.c"
 { /* IP.MASK(val) */
    
#line 947 "filter/f-inst.c"

#line 947 "filter/f-inst.c"
;
    
#line 948 "filter/f-inst.c"

#line 948 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_IP, .val.ip =  ipa_is_ip4(v1.val.ip) ?
#line 949
      ipa_from_ip4(ip4_and(ipa_to_ip4(v1.val.ip), ip4_mkmask(v2.val.i))) :
#line 949
      ipa_from_ip6(ip6_and(ipa_to_ip6(v1.val.ip), ip6_mkmask(v2.val.i)))  } );
#line 952
  }

  
  #undef whati
#line 954 "filter/f-inst.c"
  }
#line 954

#line 954

#line 960 "filter/f-inst.c"
 /* Constructor for FI_PATH_PREPEND */
#line 960
struct f_inst *f_new_inst_FI_PATH_PREPEND(enum f_instruction_code fi_code
#line 955 "filter/f-inst.c"
  , struct f_inst * f1
#line 956 "filter/f-inst.c"
  , struct f_inst * f2
#line 960 "filter/f-inst.c"
)
#line 960
  {
#line 960
    /* Allocate the structure */
#line 960
    struct f_inst *what = fi_new(fi_code);
#line 960
    uint constargs = 1;
#line 960

#line 960
    /* Initialize all the members */
#line 960
  #define whati (&(what->i_FI_PATH_PREPEND))
#line 960
  #line 955 "filter/f-inst.c"

#line 955
whati->f1 = f1;
#line 955
for (const struct f_inst *child = f1; child; child = child->next) {
#line 955
  what->size += child->size;
#line 955

#line 955
  if (child->fi_code != FI_CONSTANT)
#line 955
    constargs = 0;
#line 955

#line 955
}
#line 956 "filter/f-inst.c"

#line 956
whati->f2 = f2;
#line 956
for (const struct f_inst *child = f2; child; child = child->next) {
#line 956
  what->size += child->size;
#line 956

#line 956
  if (child->fi_code != FI_CONSTANT)
#line 956
    constargs = 0;
#line 956

#line 956
}

#line 960 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 960
    if (!constargs)
#line 960
      return what;
#line 960

#line 960
    /* Try to pre-calculate the result */
#line 960
    #line 954 "filter/f-inst.c"
 {	/* Path prepend */
    
#line 955 "filter/f-inst.c"

#line 955 "filter/f-inst.c"
;
    
#line 956 "filter/f-inst.c"

#line 956 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_prepend(fpool, v1.val.ad, v2.val.i)  } );
  }

  
  #undef whati
#line 960 "filter/f-inst.c"
  }
#line 960

#line 960

#line 1015 "filter/f-inst.c"
 /* Constructor for FI_CLIST_ADD */
#line 1015
struct f_inst *f_new_inst_FI_CLIST_ADD(enum f_instruction_code fi_code
#line 961 "filter/f-inst.c"
  , struct f_inst * f1
#line 962 "filter/f-inst.c"
  , struct f_inst * f2
#line 1015 "filter/f-inst.c"
)
#line 1015
  {
#line 1015
    /* Allocate the structure */
#line 1015
    struct f_inst *what = fi_new(fi_code);
#line 1015
    uint constargs = 1;
#line 1015

#line 1015
    /* Initialize all the members */
#line 1015
  #define whati (&(what->i_FI_CLIST_ADD))
#line 1015
  #line 961 "filter/f-inst.c"

#line 961
whati->f1 = f1;
#line 961
for (const struct f_inst *child = f1; child; child = child->next) {
#line 961
  what->size += child->size;
#line 961

#line 961
  if (child->fi_code != FI_CONSTANT)
#line 961
    constargs = 0;
#line 961

#line 961
}
#line 962 "filter/f-inst.c"

#line 962
whati->f2 = f2;
#line 962
for (const struct f_inst *child = f2; child; child = child->next) {
#line 962
  what->size += child->size;
#line 962

#line 962
  if (child->fi_code != FI_CONSTANT)
#line 962
    constargs = 0;
#line 962

#line 962
}

#line 1015 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1015
    if (!constargs)
#line 1015
      return what;
#line 1015

#line 1015
    /* Try to pre-calculate the result */
#line 1015
    #line 960 "filter/f-inst.c"
 {	/* (Extended) Community list add */
    
#line 961 "filter/f-inst.c"
;
    
#line 962 "filter/f-inst.c"
;
    if (v1.type == T_PATH)
      runtime("Can't add to path");

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_PAIR) || (v2.type == T_QUAD))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_add(fpool, v1.val.ad, v2.val.i)  } );
      /* IP->Quad implicit conversion */
      else if (val_is_ip4(&v2))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_add(fpool, v1.val.ad, ipa_to_u32(v2.val.ip))  } );
      else if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy))
	runtime("Can't add set");
      else if (v2.type == T_CLIST)
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else
	runtime("Can't add non-pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t))
	runtime("Can't add set");
      else if (v2.type == T_ECLIST)
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else if (v2.type != T_EC)
	runtime("Can't add non-ec");
      else
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_add(fpool, v1.val.ad, v2.val.ec)  } );
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t))
	runtime("Can't add set");
      else if (v2.type == T_LCLIST)
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_union(fpool, v1.val.ad, v2.val.ad)  } );
      else if (v2.type != T_LC)
	runtime("Can't add non-lc");
      else
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_add(fpool, v1.val.ad, v2.val.lc)  } );

    }

    else
      runtime("Can't add to non-[e|l]clist");
  }

  
  #undef whati
#line 1015 "filter/f-inst.c"
  }
#line 1015

#line 1015

#line 1075 "filter/f-inst.c"
 /* Constructor for FI_CLIST_DEL */
#line 1075
struct f_inst *f_new_inst_FI_CLIST_DEL(enum f_instruction_code fi_code
#line 1016 "filter/f-inst.c"
  , struct f_inst * f1
#line 1017 "filter/f-inst.c"
  , struct f_inst * f2
#line 1075 "filter/f-inst.c"
)
#line 1075
  {
#line 1075
    /* Allocate the structure */
#line 1075
    struct f_inst *what = fi_new(fi_code);
#line 1075
    uint constargs = 1;
#line 1075

#line 1075
    /* Initialize all the members */
#line 1075
  #define whati (&(what->i_FI_CLIST_DEL))
#line 1075
  #line 1016 "filter/f-inst.c"

#line 1016
whati->f1 = f1;
#line 1016
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1016
  what->size += child->size;
#line 1016

#line 1016
  if (child->fi_code != FI_CONSTANT)
#line 1016
    constargs = 0;
#line 1016

#line 1016
}
#line 1017 "filter/f-inst.c"

#line 1017
whati->f2 = f2;
#line 1017
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1017
  what->size += child->size;
#line 1017

#line 1017
  if (child->fi_code != FI_CONSTANT)
#line 1017
    constargs = 0;
#line 1017

#line 1017
}

#line 1075 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1075
    if (!constargs)
#line 1075
      return what;
#line 1075

#line 1075
    /* Try to pre-calculate the result */
#line 1075
    #line 1015 "filter/f-inst.c"
 {	/* (Extended) Community list add or delete */
    
#line 1016 "filter/f-inst.c"
;
    
#line 1017 "filter/f-inst.c"
;
    if (v1.type == T_PATH)
    {
      const struct f_tree *set = NULL;
      u32 key = 0;

      if (v2.type == T_INT)
	key = v2.val.i;
      else if ((v2.type == T_SET) && (v2.val.t->from.type == T_INT))
	set = v2.val.t;
      else
	runtime("Can't delete non-integer (set)");

      return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_filter(fpool, v1.val.ad, set, key, 0)  } );
    }

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_PAIR) || (v2.type == T_QUAD))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_del(fpool, v1.val.ad, v2.val.i)  } );
      /* IP->Quad implicit conversion */
      else if (val_is_ip4(&v2))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  int_set_del(fpool, v1.val.ad, ipa_to_u32(v2.val.ip))  } );
      else if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy) || (v2.type == T_CLIST))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  clist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else
	runtime("Can't delete non-pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t) || (v2.type == T_ECLIST))
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  eclist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else if (v2.type != T_EC)
	runtime("Can't delete non-ec");
      else
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  ec_set_del(fpool, v1.val.ad, v2.val.ec)  } );
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t) || (v2.type == T_LCLIST))
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lclist_filter(fpool, v1.val.ad, &v2, 0)  } );
      else if (v2.type != T_LC)
	runtime("Can't delete non-lc");
      else
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lc_set_del(fpool, v1.val.ad, v2.val.lc)  } );
    }

    else
      runtime("Can't delete in non-[e|l]clist");
  }

  
  #undef whati
#line 1075 "filter/f-inst.c"
  }
#line 1075

#line 1075

#line 1121 "filter/f-inst.c"
 /* Constructor for FI_CLIST_FILTER */
#line 1121
struct f_inst *f_new_inst_FI_CLIST_FILTER(enum f_instruction_code fi_code
#line 1076 "filter/f-inst.c"
  , struct f_inst * f1
#line 1077 "filter/f-inst.c"
  , struct f_inst * f2
#line 1121 "filter/f-inst.c"
)
#line 1121
  {
#line 1121
    /* Allocate the structure */
#line 1121
    struct f_inst *what = fi_new(fi_code);
#line 1121
    uint constargs = 1;
#line 1121

#line 1121
    /* Initialize all the members */
#line 1121
  #define whati (&(what->i_FI_CLIST_FILTER))
#line 1121
  #line 1076 "filter/f-inst.c"

#line 1076
whati->f1 = f1;
#line 1076
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1076
  what->size += child->size;
#line 1076

#line 1076
  if (child->fi_code != FI_CONSTANT)
#line 1076
    constargs = 0;
#line 1076

#line 1076
}
#line 1077 "filter/f-inst.c"

#line 1077
whati->f2 = f2;
#line 1077
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1077
  what->size += child->size;
#line 1077

#line 1077
  if (child->fi_code != FI_CONSTANT)
#line 1077
    constargs = 0;
#line 1077

#line 1077
}

#line 1121 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1121
    if (!constargs)
#line 1121
      return what;
#line 1121

#line 1121
    /* Try to pre-calculate the result */
#line 1121
    #line 1075 "filter/f-inst.c"
 {	/* (Extended) Community list add or delete */
    
#line 1076 "filter/f-inst.c"
;
    
#line 1077 "filter/f-inst.c"
;
    if (v1.type == T_PATH)
    {
      u32 key = 0;

      if ((v2.type == T_SET) && (v2.val.t->from.type == T_INT))
	return fi_constant(what,  (struct f_val) { .type = T_PATH, .val.ad =  as_path_filter(fpool, v1.val.ad, v2.val.t, key, 1)  } );
      else
	runtime("Can't filter integer");
    }

    else if (v1.type == T_CLIST)
    {
      /* Community (or cluster) list */
      struct f_val dummy;

      if ((v2.type == T_SET) && clist_set_type(v2.val.t, &dummy) || (v2.type == T_CLIST))
	return fi_constant(what,  (struct f_val) { .type = T_CLIST, .val.ad =  clist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter pair");
    }

    else if (v1.type == T_ECLIST)
    {
      /* v2.val is either EC or EC-set */
      if ((v2.type == T_SET) && eclist_set_type(v2.val.t) || (v2.type == T_ECLIST))
	return fi_constant(what,  (struct f_val) { .type = T_ECLIST, .val.ad =  eclist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter ec");
    }

    else if (v1.type == T_LCLIST)
    {
      /* v2.val is either LC or LC-set */
      if ((v2.type == T_SET) && lclist_set_type(v2.val.t) || (v2.type == T_LCLIST))
	return fi_constant(what,  (struct f_val) { .type = T_LCLIST, .val.ad =  lclist_filter(fpool, v1.val.ad, &v2, 1)  } );
      else
	runtime("Can't filter lc");
    }

    else
      runtime("Can't filter non-[e|l]clist");
  }

  
  #undef whati
#line 1121 "filter/f-inst.c"
  }
#line 1121

#line 1121

#line 1151 "filter/f-inst.c"
 /* Constructor for FI_ROA_CHECK_IMPLICIT */
#line 1151
struct f_inst *f_new_inst_FI_ROA_CHECK_IMPLICIT(enum f_instruction_code fi_code
#line 1123 "filter/f-inst.c"
  , struct rtable_config * rtc
#line 1151 "filter/f-inst.c"
)
#line 1151
  {
#line 1151
    /* Allocate the structure */
#line 1151
    struct f_inst *what = fi_new(fi_code);
#line 1151
    
#line 1151

#line 1151
    /* Initialize all the members */
#line 1151
  #define whati (&(what->i_FI_ROA_CHECK_IMPLICIT))
#line 1151
  #line 1123 "filter/f-inst.c"
whati->rtc = rtc;

#line 1151 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1151
    
#line 1151
      return what;
#line 1151

#line 1151
    /* Try to pre-calculate the result */
#line 1151
      #undef whati
#line 1151
  }
#line 1151

#line 1151

#line 1173 "filter/f-inst.c"
 /* Constructor for FI_ROA_CHECK_EXPLICIT */
#line 1173
struct f_inst *f_new_inst_FI_ROA_CHECK_EXPLICIT(enum f_instruction_code fi_code
#line 1153 "filter/f-inst.c"
  , struct f_inst * f1
#line 1154 "filter/f-inst.c"
  , struct f_inst * f2
#line 1155 "filter/f-inst.c"
  , struct rtable_config * rtc
#line 1173 "filter/f-inst.c"
)
#line 1173
  {
#line 1173
    /* Allocate the structure */
#line 1173
    struct f_inst *what = fi_new(fi_code);
#line 1173
    
#line 1173

#line 1173
    /* Initialize all the members */
#line 1173
  #define whati (&(what->i_FI_ROA_CHECK_EXPLICIT))
#line 1173
  #line 1153 "filter/f-inst.c"

#line 1153
whati->f1 = f1;
#line 1153
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1153
  what->size += child->size;
#line 1153

#line 1153
}
#line 1154 "filter/f-inst.c"

#line 1154
whati->f2 = f2;
#line 1154
for (const struct f_inst *child = f2; child; child = child->next) {
#line 1154
  what->size += child->size;
#line 1154

#line 1154
}
#line 1155 "filter/f-inst.c"
whati->rtc = rtc;

#line 1173 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1173
    
#line 1173
      return what;
#line 1173

#line 1173
    /* Try to pre-calculate the result */
#line 1173
      #undef whati
#line 1173
  }
#line 1173

#line 1173

#line 1178 "filter/f-inst.c"
 /* Constructor for FI_FORMAT */
#line 1178
struct f_inst *f_new_inst_FI_FORMAT(enum f_instruction_code fi_code
#line 1174 "filter/f-inst.c"
  , struct f_inst * f1
#line 1178 "filter/f-inst.c"
)
#line 1178
  {
#line 1178
    /* Allocate the structure */
#line 1178
    struct f_inst *what = fi_new(fi_code);
#line 1178
    uint constargs = 1;
#line 1178

#line 1178
    /* Initialize all the members */
#line 1178
  #define whati (&(what->i_FI_FORMAT))
#line 1178
  #line 1174 "filter/f-inst.c"

#line 1174
whati->f1 = f1;
#line 1174
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1174
  what->size += child->size;
#line 1174

#line 1174
  if (child->fi_code != FI_CONSTANT)
#line 1174
    constargs = 0;
#line 1174

#line 1174
}

#line 1178 "filter/f-inst.c"
    /* If not constant, return the instruction itself */
#line 1178
    if (!constargs)
#line 1178
      return what;
#line 1178

#line 1178
    /* Try to pre-calculate the result */
#line 1178
    #line 1173 "filter/f-inst.c"
 {	/* Format */
    
#line 1174 "filter/f-inst.c"
;
    return fi_constant(what,  (struct f_val) { .type = T_STRING, .val.s = val_format_str(fpool, &v1) } );
  }

  
  #undef whati
#line 1178 "filter/f-inst.c"
  }
#line 1178

#line 1178

#line 578 "filter/decl.m4"
 /* Constructor for FI_ASSERT */
#line 578
struct f_inst *f_new_inst_FI_ASSERT(enum f_instruction_code fi_code
#line 1180 "filter/f-inst.c"
  , struct f_inst * f1
#line 1182 "filter/f-inst.c"
  , char * s
#line 578 "filter/decl.m4"
)
#line 578
  {
#line 578
    /* Allocate the structure */
#line 578
    struct f_inst *what = fi_new(fi_code);
#line 578
    
#line 578

#line 578
    /* Initialize all the members */
#line 578
  #define whati (&(what->i_FI_ASSERT))
#line 578
  #line 1180 "filter/f-inst.c"

#line 1180
whati->f1 = f1;
#line 1180
for (const struct f_inst *child = f1; child; child = child->next) {
#line 1180
  what->size += child->size;
#line 1180

#line 1180
}
#line 1182 "filter/f-inst.c"
whati->s = s;

#line 578 "filter/decl.m4"
    /* If not constant, return the instruction itself */
#line 578
    
#line 578
      return what;
#line 578

#line 578
    /* Try to pre-calculate the result */
#line 578
      #undef whati
#line 578
  }
#line 578

#line 578

#line 441 "filter/decl.m4"

#undef v1
#undef v2
#undef v3
#undef vv

/* Line dumpers */
#define INDENT (((const char *) f_dump_line_indent_str) + sizeof(f_dump_line_indent_str) - (indent) - 1)
static const char f_dump_line_indent_str[] = "                                ";

#line 211 "filter/f-inst.c"
 /* Dump line for FI_ADD */
#line 211
static inline void f_dump_line_item_FI_ADD(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 211

#line 211
{
#line 211
#define item (&(item_->i_FI_ADD))
#line 211
#undef item
#line 211
}
#line 211

#line 216 "filter/f-inst.c"
 /* Dump line for FI_SUBTRACT */
#line 216
static inline void f_dump_line_item_FI_SUBTRACT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 216

#line 216
{
#line 216
#define item (&(item_->i_FI_SUBTRACT))
#line 216
#undef item
#line 216
}
#line 216

#line 221 "filter/f-inst.c"
 /* Dump line for FI_MULTIPLY */
#line 221
static inline void f_dump_line_item_FI_MULTIPLY(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 221

#line 221
{
#line 221
#define item (&(item_->i_FI_MULTIPLY))
#line 221
#undef item
#line 221
}
#line 221

#line 227 "filter/f-inst.c"
 /* Dump line for FI_DIVIDE */
#line 227
static inline void f_dump_line_item_FI_DIVIDE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 227

#line 227
{
#line 227
#define item (&(item_->i_FI_DIVIDE))
#line 227
#undef item
#line 227
}
#line 227

#line 234 "filter/f-inst.c"
 /* Dump line for FI_AND */
#line 234
static inline void f_dump_line_item_FI_AND(const struct f_line_item *item_, const int indent)
#line 234

#line 234
{
#line 234
#define item (&(item_->i_FI_AND))
#line 230 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 234 "filter/f-inst.c"
#undef item
#line 234
}
#line 234

#line 242 "filter/f-inst.c"
 /* Dump line for FI_OR */
#line 242
static inline void f_dump_line_item_FI_OR(const struct f_line_item *item_, const int indent)
#line 242

#line 242
{
#line 242
#define item (&(item_->i_FI_OR))
#line 237 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 242 "filter/f-inst.c"
#undef item
#line 242
}
#line 242

#line 252 "filter/f-inst.c"
 /* Dump line for FI_PAIR_CONSTRUCT */
#line 252
static inline void f_dump_line_item_FI_PAIR_CONSTRUCT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 252

#line 252
{
#line 252
#define item (&(item_->i_FI_PAIR_CONSTRUCT))
#line 252
#undef item
#line 252
}
#line 252

#line 293 "filter/f-inst.c"
 /* Dump line for FI_EC_CONSTRUCT */
#line 293
static inline void f_dump_line_item_FI_EC_CONSTRUCT(const struct f_line_item *item_, const int indent)
#line 293

#line 293
{
#line 293
#define item (&(item_->i_FI_EC_CONSTRUCT))
#line 256 "filter/f-inst.c"
debug("%s" "ec subtype %s" "\n", INDENT, ec_subtype_str(item->ecs));
#line 256

#line 293 "filter/f-inst.c"
#undef item
#line 293
}
#line 293

#line 300 "filter/f-inst.c"
 /* Dump line for FI_LC_CONSTRUCT */
#line 300
static inline void f_dump_line_item_FI_LC_CONSTRUCT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 300

#line 300
{
#line 300
#define item (&(item_->i_FI_LC_CONSTRUCT))
#line 300
#undef item
#line 300
}
#line 300

#line 339 "filter/f-inst.c"
 /* Dump line for FI_PATHMASK_CONSTRUCT */
#line 339
static inline void f_dump_line_item_FI_PATHMASK_CONSTRUCT(const struct f_line_item *item_, const int indent)
#line 339

#line 339
{
#line 339
#define item (&(item_->i_FI_PATHMASK_CONSTRUCT))
#line 301 "filter/f-inst.c"
  debug("%snumber of varargs %u\n", INDENT, item->varcount);
#line 339 "filter/f-inst.c"
#undef item
#line 339
}
#line 339

#line 345 "filter/f-inst.c"
 /* Dump line for FI_NEQ */
#line 345
static inline void f_dump_line_item_FI_NEQ(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 345

#line 345
{
#line 345
#define item (&(item_->i_FI_NEQ))
#line 345
#undef item
#line 345
}
#line 345

#line 351 "filter/f-inst.c"
 /* Dump line for FI_EQ */
#line 351
static inline void f_dump_line_item_FI_EQ(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 351

#line 351
{
#line 351
#define item (&(item_->i_FI_EQ))
#line 351
#undef item
#line 351
}
#line 351

#line 360 "filter/f-inst.c"
 /* Dump line for FI_LT */
#line 360
static inline void f_dump_line_item_FI_LT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 360

#line 360
{
#line 360
#define item (&(item_->i_FI_LT))
#line 360
#undef item
#line 360
}
#line 360

#line 369 "filter/f-inst.c"
 /* Dump line for FI_LTE */
#line 369
static inline void f_dump_line_item_FI_LTE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 369

#line 369
{
#line 369
#define item (&(item_->i_FI_LTE))
#line 369
#undef item
#line 369
}
#line 369

#line 374 "filter/f-inst.c"
 /* Dump line for FI_NOT */
#line 374
static inline void f_dump_line_item_FI_NOT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 374

#line 374
{
#line 374
#define item (&(item_->i_FI_NOT))
#line 374
#undef item
#line 374
}
#line 374

#line 383 "filter/f-inst.c"
 /* Dump line for FI_MATCH */
#line 383
static inline void f_dump_line_item_FI_MATCH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 383

#line 383
{
#line 383
#define item (&(item_->i_FI_MATCH))
#line 383
#undef item
#line 383
}
#line 383

#line 392 "filter/f-inst.c"
 /* Dump line for FI_NOT_MATCH */
#line 392
static inline void f_dump_line_item_FI_NOT_MATCH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 392

#line 392
{
#line 392
#define item (&(item_->i_FI_NOT_MATCH))
#line 392
#undef item
#line 392
}
#line 392

#line 397 "filter/f-inst.c"
 /* Dump line for FI_DEFINED */
#line 397
static inline void f_dump_line_item_FI_DEFINED(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 397

#line 397
{
#line 397
#define item (&(item_->i_FI_DEFINED))
#line 397
#undef item
#line 397
}
#line 397

#line 409 "filter/f-inst.c"
 /* Dump line for FI_TYPE */
#line 409
static inline void f_dump_line_item_FI_TYPE(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 409

#line 409
{
#line 409
#define item (&(item_->i_FI_TYPE))
#line 409
#undef item
#line 409
}
#line 409

#line 415 "filter/f-inst.c"
 /* Dump line for FI_IS_V4 */
#line 415
static inline void f_dump_line_item_FI_IS_V4(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 415

#line 415
{
#line 415
#define item (&(item_->i_FI_IS_V4))
#line 415
#undef item
#line 415
}
#line 415

#line 435 "filter/f-inst.c"
 /* Dump line for FI_VAR_SET */
#line 435
static inline void f_dump_line_item_FI_VAR_SET(const struct f_line_item *item_, const int indent)
#line 435

#line 435
{
#line 435
#define item (&(item_->i_FI_VAR_SET))
#line 418 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 418

#line 435 "filter/f-inst.c"
#undef item
#line 435
}
#line 435

#line 441 "filter/f-inst.c"
 /* Dump line for FI_VAR_GET */
#line 441
static inline void f_dump_line_item_FI_VAR_GET(const struct f_line_item *item_, const int indent)
#line 441

#line 441
{
#line 441
#define item (&(item_->i_FI_VAR_GET))
#line 436 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 436

#line 441 "filter/f-inst.c"
#undef item
#line 441
}
#line 441

#line 453 "filter/f-inst.c"
 /* Dump line for FI_CONSTANT */
#line 453
static inline void f_dump_line_item_FI_CONSTANT(const struct f_line_item *item_, const int indent)
#line 453

#line 453
{
#line 453
#define item (&(item_->i_FI_CONSTANT))
#line 442 "filter/f-inst.c"
debug("%s" "value %s" "\n", INDENT, val_dump(&(item->val))
#line 442
    );
#line 442

#line 453 "filter/f-inst.c"
#undef item
#line 453
}
#line 453

#line 461 "filter/f-inst.c"
 /* Dump line for FI_CONDITION */
#line 461
static inline void f_dump_line_item_FI_CONDITION(const struct f_line_item *item_, const int indent)
#line 461

#line 461
{
#line 461
#define item (&(item_->i_FI_CONDITION))
#line 456 "filter/f-inst.c"
f_dump_line(item->fl2, indent + 1);
#line 458 "filter/f-inst.c"
f_dump_line(item->fl3, indent + 1);
#line 461 "filter/f-inst.c"
#undef item
#line 461
}
#line 461

#line 470 "filter/f-inst.c"
 /* Dump line for FI_PRINT */
#line 470
static inline void f_dump_line_item_FI_PRINT(const struct f_line_item *item_, const int indent)
#line 470

#line 470
{
#line 470
#define item (&(item_->i_FI_PRINT))
#line 463 "filter/f-inst.c"
  debug("%snumber of varargs %u\n", INDENT, item->varcount);
#line 470 "filter/f-inst.c"
#undef item
#line 470
}
#line 470

#line 477 "filter/f-inst.c"
 /* Dump line for FI_FLUSH */
#line 477
static inline void f_dump_line_item_FI_FLUSH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 477

#line 477
{
#line 477
#define item (&(item_->i_FI_FLUSH))
#line 477
#undef item
#line 477
}
#line 477

#line 493 "filter/f-inst.c"
 /* Dump line for FI_DIE */
#line 493
static inline void f_dump_line_item_FI_DIE(const struct f_line_item *item_, const int indent)
#line 493

#line 493
{
#line 493
#define item (&(item_->i_FI_DIE))
#line 479 "filter/f-inst.c"
debug("%s" "%s" "\n", INDENT, filter_return_str(item->fret));
#line 479

#line 493 "filter/f-inst.c"
#undef item
#line 493
}
#line 493

#line 517 "filter/f-inst.c"
 /* Dump line for FI_RTA_GET */
#line 517
static inline void f_dump_line_item_FI_RTA_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 517

#line 517
{
#line 517
#define item (&(item_->i_FI_RTA_GET))
#line 517
#undef item
#line 517
}
#line 517

#line 587 "filter/f-inst.c"
 /* Dump line for FI_RTA_SET */
#line 587
static inline void f_dump_line_item_FI_RTA_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 587

#line 587
{
#line 587
#define item (&(item_->i_FI_RTA_SET))
#line 587
#undef item
#line 587
}
#line 587

#line 661 "filter/f-inst.c"
 /* Dump line for FI_EA_GET */
#line 661
static inline void f_dump_line_item_FI_EA_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 661

#line 661
{
#line 661
#define item (&(item_->i_FI_EA_GET))
#line 661
#undef item
#line 661
}
#line 661

#line 758 "filter/f-inst.c"
 /* Dump line for FI_EA_SET */
#line 758
static inline void f_dump_line_item_FI_EA_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 758

#line 758
{
#line 758
#define item (&(item_->i_FI_EA_SET))
#line 758
#undef item
#line 758
}
#line 758

#line 780 "filter/f-inst.c"
 /* Dump line for FI_EA_UNSET */
#line 780
static inline void f_dump_line_item_FI_EA_UNSET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 780

#line 780
{
#line 780
#define item (&(item_->i_FI_EA_UNSET))
#line 780
#undef item
#line 780
}
#line 780

#line 785 "filter/f-inst.c"
 /* Dump line for FI_PREF_GET */
#line 785
static inline void f_dump_line_item_FI_PREF_GET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 785

#line 785
{
#line 785
#define item (&(item_->i_FI_PREF_GET))
#line 785
#undef item
#line 785
}
#line 785

#line 794 "filter/f-inst.c"
 /* Dump line for FI_PREF_SET */
#line 794
static inline void f_dump_line_item_FI_PREF_SET(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 794

#line 794
{
#line 794
#define item (&(item_->i_FI_PREF_SET))
#line 794
#undef item
#line 794
}
#line 794

#line 806 "filter/f-inst.c"
 /* Dump line for FI_LENGTH */
#line 806
static inline void f_dump_line_item_FI_LENGTH(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 806

#line 806
{
#line 806
#define item (&(item_->i_FI_LENGTH))
#line 806
#undef item
#line 806
}
#line 806

#line 818 "filter/f-inst.c"
 /* Dump line for FI_SADR_SRC */
#line 818
static inline void f_dump_line_item_FI_SADR_SRC(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 818

#line 818
{
#line 818
#define item (&(item_->i_FI_SADR_SRC))
#line 818
#undef item
#line 818
}
#line 818

#line 828 "filter/f-inst.c"
 /* Dump line for FI_ROA_MAXLEN */
#line 828
static inline void f_dump_line_item_FI_ROA_MAXLEN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 828

#line 828
{
#line 828
#define item (&(item_->i_FI_ROA_MAXLEN))
#line 828
#undef item
#line 828
}
#line 828

#line 838 "filter/f-inst.c"
 /* Dump line for FI_ROA_ASN */
#line 838
static inline void f_dump_line_item_FI_ROA_ASN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 838

#line 838
{
#line 838
#define item (&(item_->i_FI_ROA_ASN))
#line 838
#undef item
#line 838
}
#line 838

#line 843 "filter/f-inst.c"
 /* Dump line for FI_IP */
#line 843
static inline void f_dump_line_item_FI_IP(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 843

#line 843
{
#line 843
#define item (&(item_->i_FI_IP))
#line 843
#undef item
#line 843
}
#line 843

#line 850 "filter/f-inst.c"
 /* Dump line for FI_ROUTE_DISTINGUISHER */
#line 850
static inline void f_dump_line_item_FI_ROUTE_DISTINGUISHER(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 850

#line 850
{
#line 850
#define item (&(item_->i_FI_ROUTE_DISTINGUISHER))
#line 850
#undef item
#line 850
}
#line 850

#line 857 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_FIRST */
#line 857
static inline void f_dump_line_item_FI_AS_PATH_FIRST(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 857

#line 857
{
#line 857
#define item (&(item_->i_FI_AS_PATH_FIRST))
#line 857
#undef item
#line 857
}
#line 857

#line 864 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_LAST */
#line 864
static inline void f_dump_line_item_FI_AS_PATH_LAST(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 864

#line 864
{
#line 864
#define item (&(item_->i_FI_AS_PATH_LAST))
#line 864
#undef item
#line 864
}
#line 864

#line 869 "filter/f-inst.c"
 /* Dump line for FI_AS_PATH_LAST_NAG */
#line 869
static inline void f_dump_line_item_FI_AS_PATH_LAST_NAG(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 869

#line 869
{
#line 869
#define item (&(item_->i_FI_AS_PATH_LAST_NAG))
#line 869
#undef item
#line 869
}
#line 869

#line 896 "filter/f-inst.c"
 /* Dump line for FI_RETURN */
#line 896
static inline void f_dump_line_item_FI_RETURN(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 896

#line 896
{
#line 896
#define item (&(item_->i_FI_RETURN))
#line 896
#undef item
#line 896
}
#line 896

#line 922 "filter/f-inst.c"
 /* Dump line for FI_CALL */
#line 922
static inline void f_dump_line_item_FI_CALL(const struct f_line_item *item_, const int indent)
#line 922

#line 922
{
#line 922
#define item (&(item_->i_FI_CALL))
#line 898 "filter/f-inst.c"
debug("%s" "symbol %s" "\n", INDENT, item->sym->name);
#line 898

#line 922 "filter/f-inst.c"
#undef item
#line 922
}
#line 922

#line 927 "filter/f-inst.c"
 /* Dump line for FI_DROP_RESULT */
#line 927
static inline void f_dump_line_item_FI_DROP_RESULT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 927

#line 927
{
#line 927
#define item (&(item_->i_FI_DROP_RESULT))
#line 927
#undef item
#line 927
}
#line 927

#line 946 "filter/f-inst.c"
 /* Dump line for FI_SWITCH */
#line 946
static inline void f_dump_line_item_FI_SWITCH(const struct f_line_item *item_, const int indent)
#line 946

#line 946
{
#line 946
#define item (&(item_->i_FI_SWITCH))
#line 930 "filter/f-inst.c"
debug("%s" "tree %p" "\n", INDENT, item->tree);
#line 930

#line 946 "filter/f-inst.c"
#undef item
#line 946
}
#line 946

#line 954 "filter/f-inst.c"
 /* Dump line for FI_IP_MASK */
#line 954
static inline void f_dump_line_item_FI_IP_MASK(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 954

#line 954
{
#line 954
#define item (&(item_->i_FI_IP_MASK))
#line 954
#undef item
#line 954
}
#line 954

#line 960 "filter/f-inst.c"
 /* Dump line for FI_PATH_PREPEND */
#line 960
static inline void f_dump_line_item_FI_PATH_PREPEND(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 960

#line 960
{
#line 960
#define item (&(item_->i_FI_PATH_PREPEND))
#line 960
#undef item
#line 960
}
#line 960

#line 1015 "filter/f-inst.c"
 /* Dump line for FI_CLIST_ADD */
#line 1015
static inline void f_dump_line_item_FI_CLIST_ADD(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1015

#line 1015
{
#line 1015
#define item (&(item_->i_FI_CLIST_ADD))
#line 1015
#undef item
#line 1015
}
#line 1015

#line 1075 "filter/f-inst.c"
 /* Dump line for FI_CLIST_DEL */
#line 1075
static inline void f_dump_line_item_FI_CLIST_DEL(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1075

#line 1075
{
#line 1075
#define item (&(item_->i_FI_CLIST_DEL))
#line 1075
#undef item
#line 1075
}
#line 1075

#line 1121 "filter/f-inst.c"
 /* Dump line for FI_CLIST_FILTER */
#line 1121
static inline void f_dump_line_item_FI_CLIST_FILTER(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1121

#line 1121
{
#line 1121
#define item (&(item_->i_FI_CLIST_FILTER))
#line 1121
#undef item
#line 1121
}
#line 1121

#line 1151 "filter/f-inst.c"
 /* Dump line for FI_ROA_CHECK_IMPLICIT */
#line 1151
static inline void f_dump_line_item_FI_ROA_CHECK_IMPLICIT(const struct f_line_item *item_, const int indent)
#line 1151

#line 1151
{
#line 1151
#define item (&(item_->i_FI_ROA_CHECK_IMPLICIT))
#line 1123 "filter/f-inst.c"
debug("%s" "route table %s" "\n", INDENT, item->rtc->name);
#line 1123

#line 1151 "filter/f-inst.c"
#undef item
#line 1151
}
#line 1151

#line 1173 "filter/f-inst.c"
 /* Dump line for FI_ROA_CHECK_EXPLICIT */
#line 1173
static inline void f_dump_line_item_FI_ROA_CHECK_EXPLICIT(const struct f_line_item *item_, const int indent)
#line 1173

#line 1173
{
#line 1173
#define item (&(item_->i_FI_ROA_CHECK_EXPLICIT))
#line 1155 "filter/f-inst.c"
debug("%s" "route table %s" "\n", INDENT, item->rtc->name);
#line 1155

#line 1173 "filter/f-inst.c"
#undef item
#line 1173
}
#line 1173

#line 1178 "filter/f-inst.c"
 /* Dump line for FI_FORMAT */
#line 1178
static inline void f_dump_line_item_FI_FORMAT(const struct f_line_item *item UNUSED, const int indent UNUSED)
#line 1178

#line 1178
{
#line 1178
#define item (&(item_->i_FI_FORMAT))
#line 1178
#undef item
#line 1178
}
#line 1178

#line 578 "filter/decl.m4"
 /* Dump line for FI_ASSERT */
#line 578
static inline void f_dump_line_item_FI_ASSERT(const struct f_line_item *item_, const int indent)
#line 578

#line 578
{
#line 578
#define item (&(item_->i_FI_ASSERT))
#line 1182 "filter/f-inst.c"
debug("%s" "string %s" "\n", INDENT, item->s);
#line 1182

#line 578 "filter/decl.m4"
#undef item
#line 578
}
#line 578

#line 451 "filter/decl.m4"


void f_dump_line(const struct f_line *dest, uint indent)
{
  if (!dest) {
    debug("%sNo filter line (NULL)\n", INDENT);
    return;
  }
  debug("%sFilter line %p (len=%u)\n", INDENT, dest, dest->len);
  for (uint i=0; i<dest->len; i++) {
    const struct f_line_item *item = &dest->items[i];
    debug("%sInstruction %s at line %u\n", INDENT, f_instruction_name(item->fi_code), item->lineno);
    switch (item->fi_code) {
#line 211 "filter/f-inst.c"
 /* Dump line caller for FI_ADD */
#line 211
case FI_ADD: f_dump_line_item_FI_ADD(item, indent + 1); break;
#line 211

#line 216 "filter/f-inst.c"
 /* Dump line caller for FI_SUBTRACT */
#line 216
case FI_SUBTRACT: f_dump_line_item_FI_SUBTRACT(item, indent + 1); break;
#line 216

#line 221 "filter/f-inst.c"
 /* Dump line caller for FI_MULTIPLY */
#line 221
case FI_MULTIPLY: f_dump_line_item_FI_MULTIPLY(item, indent + 1); break;
#line 221

#line 227 "filter/f-inst.c"
 /* Dump line caller for FI_DIVIDE */
#line 227
case FI_DIVIDE: f_dump_line_item_FI_DIVIDE(item, indent + 1); break;
#line 227

#line 234 "filter/f-inst.c"
 /* Dump line caller for FI_AND */
#line 234
case FI_AND: f_dump_line_item_FI_AND(item, indent + 1); break;
#line 234

#line 242 "filter/f-inst.c"
 /* Dump line caller for FI_OR */
#line 242
case FI_OR: f_dump_line_item_FI_OR(item, indent + 1); break;
#line 242

#line 252 "filter/f-inst.c"
 /* Dump line caller for FI_PAIR_CONSTRUCT */
#line 252
case FI_PAIR_CONSTRUCT: f_dump_line_item_FI_PAIR_CONSTRUCT(item, indent + 1); break;
#line 252

#line 293 "filter/f-inst.c"
 /* Dump line caller for FI_EC_CONSTRUCT */
#line 293
case FI_EC_CONSTRUCT: f_dump_line_item_FI_EC_CONSTRUCT(item, indent + 1); break;
#line 293

#line 300 "filter/f-inst.c"
 /* Dump line caller for FI_LC_CONSTRUCT */
#line 300
case FI_LC_CONSTRUCT: f_dump_line_item_FI_LC_CONSTRUCT(item, indent + 1); break;
#line 300

#line 339 "filter/f-inst.c"
 /* Dump line caller for FI_PATHMASK_CONSTRUCT */
#line 339
case FI_PATHMASK_CONSTRUCT: f_dump_line_item_FI_PATHMASK_CONSTRUCT(item, indent + 1); break;
#line 339

#line 345 "filter/f-inst.c"
 /* Dump line caller for FI_NEQ */
#line 345
case FI_NEQ: f_dump_line_item_FI_NEQ(item, indent + 1); break;
#line 345

#line 351 "filter/f-inst.c"
 /* Dump line caller for FI_EQ */
#line 351
case FI_EQ: f_dump_line_item_FI_EQ(item, indent + 1); break;
#line 351

#line 360 "filter/f-inst.c"
 /* Dump line caller for FI_LT */
#line 360
case FI_LT: f_dump_line_item_FI_LT(item, indent + 1); break;
#line 360

#line 369 "filter/f-inst.c"
 /* Dump line caller for FI_LTE */
#line 369
case FI_LTE: f_dump_line_item_FI_LTE(item, indent + 1); break;
#line 369

#line 374 "filter/f-inst.c"
 /* Dump line caller for FI_NOT */
#line 374
case FI_NOT: f_dump_line_item_FI_NOT(item, indent + 1); break;
#line 374

#line 383 "filter/f-inst.c"
 /* Dump line caller for FI_MATCH */
#line 383
case FI_MATCH: f_dump_line_item_FI_MATCH(item, indent + 1); break;
#line 383

#line 392 "filter/f-inst.c"
 /* Dump line caller for FI_NOT_MATCH */
#line 392
case FI_NOT_MATCH: f_dump_line_item_FI_NOT_MATCH(item, indent + 1); break;
#line 392

#line 397 "filter/f-inst.c"
 /* Dump line caller for FI_DEFINED */
#line 397
case FI_DEFINED: f_dump_line_item_FI_DEFINED(item, indent + 1); break;
#line 397

#line 409 "filter/f-inst.c"
 /* Dump line caller for FI_TYPE */
#line 409
case FI_TYPE: f_dump_line_item_FI_TYPE(item, indent + 1); break;
#line 409

#line 415 "filter/f-inst.c"
 /* Dump line caller for FI_IS_V4 */
#line 415
case FI_IS_V4: f_dump_line_item_FI_IS_V4(item, indent + 1); break;
#line 415

#line 435 "filter/f-inst.c"
 /* Dump line caller for FI_VAR_SET */
#line 435
case FI_VAR_SET: f_dump_line_item_FI_VAR_SET(item, indent + 1); break;
#line 435

#line 441 "filter/f-inst.c"
 /* Dump line caller for FI_VAR_GET */
#line 441
case FI_VAR_GET: f_dump_line_item_FI_VAR_GET(item, indent + 1); break;
#line 441

#line 453 "filter/f-inst.c"
 /* Dump line caller for FI_CONSTANT */
#line 453
case FI_CONSTANT: f_dump_line_item_FI_CONSTANT(item, indent + 1); break;
#line 453

#line 461 "filter/f-inst.c"
 /* Dump line caller for FI_CONDITION */
#line 461
case FI_CONDITION: f_dump_line_item_FI_CONDITION(item, indent + 1); break;
#line 461

#line 470 "filter/f-inst.c"
 /* Dump line caller for FI_PRINT */
#line 470
case FI_PRINT: f_dump_line_item_FI_PRINT(item, indent + 1); break;
#line 470

#line 477 "filter/f-inst.c"
 /* Dump line caller for FI_FLUSH */
#line 477
case FI_FLUSH: f_dump_line_item_FI_FLUSH(item, indent + 1); break;
#line 477

#line 493 "filter/f-inst.c"
 /* Dump line caller for FI_DIE */
#line 493
case FI_DIE: f_dump_line_item_FI_DIE(item, indent + 1); break;
#line 493

#line 517 "filter/f-inst.c"
 /* Dump line caller for FI_RTA_GET */
#line 517
case FI_RTA_GET: f_dump_line_item_FI_RTA_GET(item, indent + 1); break;
#line 517

#line 587 "filter/f-inst.c"
 /* Dump line caller for FI_RTA_SET */
#line 587
case FI_RTA_SET: f_dump_line_item_FI_RTA_SET(item, indent + 1); break;
#line 587

#line 661 "filter/f-inst.c"
 /* Dump line caller for FI_EA_GET */
#line 661
case FI_EA_GET: f_dump_line_item_FI_EA_GET(item, indent + 1); break;
#line 661

#line 758 "filter/f-inst.c"
 /* Dump line caller for FI_EA_SET */
#line 758
case FI_EA_SET: f_dump_line_item_FI_EA_SET(item, indent + 1); break;
#line 758

#line 780 "filter/f-inst.c"
 /* Dump line caller for FI_EA_UNSET */
#line 780
case FI_EA_UNSET: f_dump_line_item_FI_EA_UNSET(item, indent + 1); break;
#line 780

#line 785 "filter/f-inst.c"
 /* Dump line caller for FI_PREF_GET */
#line 785
case FI_PREF_GET: f_dump_line_item_FI_PREF_GET(item, indent + 1); break;
#line 785

#line 794 "filter/f-inst.c"
 /* Dump line caller for FI_PREF_SET */
#line 794
case FI_PREF_SET: f_dump_line_item_FI_PREF_SET(item, indent + 1); break;
#line 794

#line 806 "filter/f-inst.c"
 /* Dump line caller for FI_LENGTH */
#line 806
case FI_LENGTH: f_dump_line_item_FI_LENGTH(item, indent + 1); break;
#line 806

#line 818 "filter/f-inst.c"
 /* Dump line caller for FI_SADR_SRC */
#line 818
case FI_SADR_SRC: f_dump_line_item_FI_SADR_SRC(item, indent + 1); break;
#line 818

#line 828 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_MAXLEN */
#line 828
case FI_ROA_MAXLEN: f_dump_line_item_FI_ROA_MAXLEN(item, indent + 1); break;
#line 828

#line 838 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_ASN */
#line 838
case FI_ROA_ASN: f_dump_line_item_FI_ROA_ASN(item, indent + 1); break;
#line 838

#line 843 "filter/f-inst.c"
 /* Dump line caller for FI_IP */
#line 843
case FI_IP: f_dump_line_item_FI_IP(item, indent + 1); break;
#line 843

#line 850 "filter/f-inst.c"
 /* Dump line caller for FI_ROUTE_DISTINGUISHER */
#line 850
case FI_ROUTE_DISTINGUISHER: f_dump_line_item_FI_ROUTE_DISTINGUISHER(item, indent + 1); break;
#line 850

#line 857 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_FIRST */
#line 857
case FI_AS_PATH_FIRST: f_dump_line_item_FI_AS_PATH_FIRST(item, indent + 1); break;
#line 857

#line 864 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_LAST */
#line 864
case FI_AS_PATH_LAST: f_dump_line_item_FI_AS_PATH_LAST(item, indent + 1); break;
#line 864

#line 869 "filter/f-inst.c"
 /* Dump line caller for FI_AS_PATH_LAST_NAG */
#line 869
case FI_AS_PATH_LAST_NAG: f_dump_line_item_FI_AS_PATH_LAST_NAG(item, indent + 1); break;
#line 869

#line 896 "filter/f-inst.c"
 /* Dump line caller for FI_RETURN */
#line 896
case FI_RETURN: f_dump_line_item_FI_RETURN(item, indent + 1); break;
#line 896

#line 922 "filter/f-inst.c"
 /* Dump line caller for FI_CALL */
#line 922
case FI_CALL: f_dump_line_item_FI_CALL(item, indent + 1); break;
#line 922

#line 927 "filter/f-inst.c"
 /* Dump line caller for FI_DROP_RESULT */
#line 927
case FI_DROP_RESULT: f_dump_line_item_FI_DROP_RESULT(item, indent + 1); break;
#line 927

#line 946 "filter/f-inst.c"
 /* Dump line caller for FI_SWITCH */
#line 946
case FI_SWITCH: f_dump_line_item_FI_SWITCH(item, indent + 1); break;
#line 946

#line 954 "filter/f-inst.c"
 /* Dump line caller for FI_IP_MASK */
#line 954
case FI_IP_MASK: f_dump_line_item_FI_IP_MASK(item, indent + 1); break;
#line 954

#line 960 "filter/f-inst.c"
 /* Dump line caller for FI_PATH_PREPEND */
#line 960
case FI_PATH_PREPEND: f_dump_line_item_FI_PATH_PREPEND(item, indent + 1); break;
#line 960

#line 1015 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_ADD */
#line 1015
case FI_CLIST_ADD: f_dump_line_item_FI_CLIST_ADD(item, indent + 1); break;
#line 1015

#line 1075 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_DEL */
#line 1075
case FI_CLIST_DEL: f_dump_line_item_FI_CLIST_DEL(item, indent + 1); break;
#line 1075

#line 1121 "filter/f-inst.c"
 /* Dump line caller for FI_CLIST_FILTER */
#line 1121
case FI_CLIST_FILTER: f_dump_line_item_FI_CLIST_FILTER(item, indent + 1); break;
#line 1121

#line 1151 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_CHECK_IMPLICIT */
#line 1151
case FI_ROA_CHECK_IMPLICIT: f_dump_line_item_FI_ROA_CHECK_IMPLICIT(item, indent + 1); break;
#line 1151

#line 1173 "filter/f-inst.c"
 /* Dump line caller for FI_ROA_CHECK_EXPLICIT */
#line 1173
case FI_ROA_CHECK_EXPLICIT: f_dump_line_item_FI_ROA_CHECK_EXPLICIT(item, indent + 1); break;
#line 1173

#line 1178 "filter/f-inst.c"
 /* Dump line caller for FI_FORMAT */
#line 1178
case FI_FORMAT: f_dump_line_item_FI_FORMAT(item, indent + 1); break;
#line 1178

#line 578 "filter/decl.m4"
 /* Dump line caller for FI_ASSERT */
#line 578
case FI_ASSERT: f_dump_line_item_FI_ASSERT(item, indent + 1); break;
#line 578

#line 464 "filter/decl.m4"

      default: bug("Unknown instruction %x in f_dump_line", item->fi_code);
    }
  }
  debug("%sFilter line %p dump done\n", INDENT, dest);
}

/* Linearize */
static uint
linearize(struct f_line *dest, const struct f_inst *what, uint pos)
{
  for ( ; what; what = what->next) {
    switch (what->fi_code) {
#line 211 "filter/f-inst.c"
 /* Linearize for FI_ADD */
#line 211
case FI_ADD: {
#line 211
#define whati (&(what->i_FI_ADD))
#line 211
#define item (&(dest->items[pos].i_FI_ADD))
#line 211
  #line 207 "filter/f-inst.c"

#line 207
pos = linearize(dest, whati->f1, pos);
#line 208 "filter/f-inst.c"

#line 208
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 211 "filter/f-inst.c"
#undef item
#line 211
  dest->items[pos].fi_code = what->fi_code;
#line 211
  dest->items[pos].lineno = what->lineno;
#line 211
  break;
#line 211
}
#line 211

#line 216 "filter/f-inst.c"
 /* Linearize for FI_SUBTRACT */
#line 216
case FI_SUBTRACT: {
#line 216
#define whati (&(what->i_FI_SUBTRACT))
#line 216
#define item (&(dest->items[pos].i_FI_SUBTRACT))
#line 216
  #line 212 "filter/f-inst.c"

#line 212
pos = linearize(dest, whati->f1, pos);
#line 213 "filter/f-inst.c"

#line 213
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 216 "filter/f-inst.c"
#undef item
#line 216
  dest->items[pos].fi_code = what->fi_code;
#line 216
  dest->items[pos].lineno = what->lineno;
#line 216
  break;
#line 216
}
#line 216

#line 221 "filter/f-inst.c"
 /* Linearize for FI_MULTIPLY */
#line 221
case FI_MULTIPLY: {
#line 221
#define whati (&(what->i_FI_MULTIPLY))
#line 221
#define item (&(dest->items[pos].i_FI_MULTIPLY))
#line 221
  #line 217 "filter/f-inst.c"

#line 217
pos = linearize(dest, whati->f1, pos);
#line 218 "filter/f-inst.c"

#line 218
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 221 "filter/f-inst.c"
#undef item
#line 221
  dest->items[pos].fi_code = what->fi_code;
#line 221
  dest->items[pos].lineno = what->lineno;
#line 221
  break;
#line 221
}
#line 221

#line 227 "filter/f-inst.c"
 /* Linearize for FI_DIVIDE */
#line 227
case FI_DIVIDE: {
#line 227
#define whati (&(what->i_FI_DIVIDE))
#line 227
#define item (&(dest->items[pos].i_FI_DIVIDE))
#line 227
  #line 222 "filter/f-inst.c"

#line 222
pos = linearize(dest, whati->f1, pos);
#line 223 "filter/f-inst.c"

#line 223
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 227 "filter/f-inst.c"
#undef item
#line 227
  dest->items[pos].fi_code = what->fi_code;
#line 227
  dest->items[pos].lineno = what->lineno;
#line 227
  break;
#line 227
}
#line 227

#line 234 "filter/f-inst.c"
 /* Linearize for FI_AND */
#line 234
case FI_AND: {
#line 234
#define whati (&(what->i_FI_AND))
#line 234
#define item (&(dest->items[pos].i_FI_AND))
#line 234
  #line 228 "filter/f-inst.c"

#line 228
pos = linearize(dest, whati->f1, pos);
#line 230 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#undef whati
#line 234 "filter/f-inst.c"
#undef item
#line 234
  dest->items[pos].fi_code = what->fi_code;
#line 234
  dest->items[pos].lineno = what->lineno;
#line 234
  break;
#line 234
}
#line 234

#line 242 "filter/f-inst.c"
 /* Linearize for FI_OR */
#line 242
case FI_OR: {
#line 242
#define whati (&(what->i_FI_OR))
#line 242
#define item (&(dest->items[pos].i_FI_OR))
#line 242
  #line 235 "filter/f-inst.c"

#line 235
pos = linearize(dest, whati->f1, pos);
#line 237 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#undef whati
#line 242 "filter/f-inst.c"
#undef item
#line 242
  dest->items[pos].fi_code = what->fi_code;
#line 242
  dest->items[pos].lineno = what->lineno;
#line 242
  break;
#line 242
}
#line 242

#line 252 "filter/f-inst.c"
 /* Linearize for FI_PAIR_CONSTRUCT */
#line 252
case FI_PAIR_CONSTRUCT: {
#line 252
#define whati (&(what->i_FI_PAIR_CONSTRUCT))
#line 252
#define item (&(dest->items[pos].i_FI_PAIR_CONSTRUCT))
#line 252
  #line 243 "filter/f-inst.c"

#line 243
pos = linearize(dest, whati->f1, pos);
#line 244 "filter/f-inst.c"

#line 244
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 252 "filter/f-inst.c"
#undef item
#line 252
  dest->items[pos].fi_code = what->fi_code;
#line 252
  dest->items[pos].lineno = what->lineno;
#line 252
  break;
#line 252
}
#line 252

#line 293 "filter/f-inst.c"
 /* Linearize for FI_EC_CONSTRUCT */
#line 293
case FI_EC_CONSTRUCT: {
#line 293
#define whati (&(what->i_FI_EC_CONSTRUCT))
#line 293
#define item (&(dest->items[pos].i_FI_EC_CONSTRUCT))
#line 293
  #line 253 "filter/f-inst.c"

#line 253
pos = linearize(dest, whati->f1, pos);
#line 254 "filter/f-inst.c"

#line 254
pos = linearize(dest, whati->f2, pos);
#line 256 "filter/f-inst.c"
item->ecs = whati->ecs;
#line 256

#undef whati
#line 293 "filter/f-inst.c"
#undef item
#line 293
  dest->items[pos].fi_code = what->fi_code;
#line 293
  dest->items[pos].lineno = what->lineno;
#line 293
  break;
#line 293
}
#line 293

#line 300 "filter/f-inst.c"
 /* Linearize for FI_LC_CONSTRUCT */
#line 300
case FI_LC_CONSTRUCT: {
#line 300
#define whati (&(what->i_FI_LC_CONSTRUCT))
#line 300
#define item (&(dest->items[pos].i_FI_LC_CONSTRUCT))
#line 300
  #line 294 "filter/f-inst.c"

#line 294
pos = linearize(dest, whati->f1, pos);
#line 295 "filter/f-inst.c"

#line 295
pos = linearize(dest, whati->f2, pos);
#line 296 "filter/f-inst.c"

#line 296
pos = linearize(dest, whati->f3, pos);
#undef whati
#line 300 "filter/f-inst.c"
#undef item
#line 300
  dest->items[pos].fi_code = what->fi_code;
#line 300
  dest->items[pos].lineno = what->lineno;
#line 300
  break;
#line 300
}
#line 300

#line 339 "filter/f-inst.c"
 /* Linearize for FI_PATHMASK_CONSTRUCT */
#line 339
case FI_PATHMASK_CONSTRUCT: {
#line 339
#define whati (&(what->i_FI_PATHMASK_CONSTRUCT))
#line 339
#define item (&(dest->items[pos].i_FI_PATHMASK_CONSTRUCT))
#line 339
  #line 301 "filter/f-inst.c"
  pos = linearize(dest, whati->fvar, pos);
#line 301
  item->varcount = whati->varcount;
#undef whati
#line 339 "filter/f-inst.c"
#undef item
#line 339
  dest->items[pos].fi_code = what->fi_code;
#line 339
  dest->items[pos].lineno = what->lineno;
#line 339
  break;
#line 339
}
#line 339

#line 345 "filter/f-inst.c"
 /* Linearize for FI_NEQ */
#line 345
case FI_NEQ: {
#line 345
#define whati (&(what->i_FI_NEQ))
#line 345
#define item (&(dest->items[pos].i_FI_NEQ))
#line 345
  #line 340 "filter/f-inst.c"

#line 340
pos = linearize(dest, whati->f1, pos);
#line 341 "filter/f-inst.c"

#line 341
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 345 "filter/f-inst.c"
#undef item
#line 345
  dest->items[pos].fi_code = what->fi_code;
#line 345
  dest->items[pos].lineno = what->lineno;
#line 345
  break;
#line 345
}
#line 345

#line 351 "filter/f-inst.c"
 /* Linearize for FI_EQ */
#line 351
case FI_EQ: {
#line 351
#define whati (&(what->i_FI_EQ))
#line 351
#define item (&(dest->items[pos].i_FI_EQ))
#line 351
  #line 346 "filter/f-inst.c"

#line 346
pos = linearize(dest, whati->f1, pos);
#line 347 "filter/f-inst.c"

#line 347
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 351 "filter/f-inst.c"
#undef item
#line 351
  dest->items[pos].fi_code = what->fi_code;
#line 351
  dest->items[pos].lineno = what->lineno;
#line 351
  break;
#line 351
}
#line 351

#line 360 "filter/f-inst.c"
 /* Linearize for FI_LT */
#line 360
case FI_LT: {
#line 360
#define whati (&(what->i_FI_LT))
#line 360
#define item (&(dest->items[pos].i_FI_LT))
#line 360
  #line 352 "filter/f-inst.c"

#line 352
pos = linearize(dest, whati->f1, pos);
#line 353 "filter/f-inst.c"

#line 353
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 360 "filter/f-inst.c"
#undef item
#line 360
  dest->items[pos].fi_code = what->fi_code;
#line 360
  dest->items[pos].lineno = what->lineno;
#line 360
  break;
#line 360
}
#line 360

#line 369 "filter/f-inst.c"
 /* Linearize for FI_LTE */
#line 369
case FI_LTE: {
#line 369
#define whati (&(what->i_FI_LTE))
#line 369
#define item (&(dest->items[pos].i_FI_LTE))
#line 369
  #line 361 "filter/f-inst.c"

#line 361
pos = linearize(dest, whati->f1, pos);
#line 362 "filter/f-inst.c"

#line 362
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 369 "filter/f-inst.c"
#undef item
#line 369
  dest->items[pos].fi_code = what->fi_code;
#line 369
  dest->items[pos].lineno = what->lineno;
#line 369
  break;
#line 369
}
#line 369

#line 374 "filter/f-inst.c"
 /* Linearize for FI_NOT */
#line 374
case FI_NOT: {
#line 374
#define whati (&(what->i_FI_NOT))
#line 374
#define item (&(dest->items[pos].i_FI_NOT))
#line 374
  #line 370 "filter/f-inst.c"

#line 370
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 374 "filter/f-inst.c"
#undef item
#line 374
  dest->items[pos].fi_code = what->fi_code;
#line 374
  dest->items[pos].lineno = what->lineno;
#line 374
  break;
#line 374
}
#line 374

#line 383 "filter/f-inst.c"
 /* Linearize for FI_MATCH */
#line 383
case FI_MATCH: {
#line 383
#define whati (&(what->i_FI_MATCH))
#line 383
#define item (&(dest->items[pos].i_FI_MATCH))
#line 383
  #line 375 "filter/f-inst.c"

#line 375
pos = linearize(dest, whati->f1, pos);
#line 376 "filter/f-inst.c"

#line 376
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 383 "filter/f-inst.c"
#undef item
#line 383
  dest->items[pos].fi_code = what->fi_code;
#line 383
  dest->items[pos].lineno = what->lineno;
#line 383
  break;
#line 383
}
#line 383

#line 392 "filter/f-inst.c"
 /* Linearize for FI_NOT_MATCH */
#line 392
case FI_NOT_MATCH: {
#line 392
#define whati (&(what->i_FI_NOT_MATCH))
#line 392
#define item (&(dest->items[pos].i_FI_NOT_MATCH))
#line 392
  #line 384 "filter/f-inst.c"

#line 384
pos = linearize(dest, whati->f1, pos);
#line 385 "filter/f-inst.c"

#line 385
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 392 "filter/f-inst.c"
#undef item
#line 392
  dest->items[pos].fi_code = what->fi_code;
#line 392
  dest->items[pos].lineno = what->lineno;
#line 392
  break;
#line 392
}
#line 392

#line 397 "filter/f-inst.c"
 /* Linearize for FI_DEFINED */
#line 397
case FI_DEFINED: {
#line 397
#define whati (&(what->i_FI_DEFINED))
#line 397
#define item (&(dest->items[pos].i_FI_DEFINED))
#line 397
  #line 393 "filter/f-inst.c"

#line 393
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 397 "filter/f-inst.c"
#undef item
#line 397
  dest->items[pos].fi_code = what->fi_code;
#line 397
  dest->items[pos].lineno = what->lineno;
#line 397
  break;
#line 397
}
#line 397

#line 409 "filter/f-inst.c"
 /* Linearize for FI_TYPE */
#line 409
case FI_TYPE: {
#line 409
#define whati (&(what->i_FI_TYPE))
#line 409
#define item (&(dest->items[pos].i_FI_TYPE))
#line 409
  #line 398 "filter/f-inst.c"

#line 398
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 409 "filter/f-inst.c"
#undef item
#line 409
  dest->items[pos].fi_code = what->fi_code;
#line 409
  dest->items[pos].lineno = what->lineno;
#line 409
  break;
#line 409
}
#line 409

#line 415 "filter/f-inst.c"
 /* Linearize for FI_IS_V4 */
#line 415
case FI_IS_V4: {
#line 415
#define whati (&(what->i_FI_IS_V4))
#line 415
#define item (&(dest->items[pos].i_FI_IS_V4))
#line 415
  #line 410 "filter/f-inst.c"

#line 410
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 415 "filter/f-inst.c"
#undef item
#line 415
  dest->items[pos].fi_code = what->fi_code;
#line 415
  dest->items[pos].lineno = what->lineno;
#line 415
  break;
#line 415
}
#line 415

#line 435 "filter/f-inst.c"
 /* Linearize for FI_VAR_SET */
#line 435
case FI_VAR_SET: {
#line 435
#define whati (&(what->i_FI_VAR_SET))
#line 435
#define item (&(dest->items[pos].i_FI_VAR_SET))
#line 435
  #line 417 "filter/f-inst.c"

#line 417
pos = linearize(dest, whati->f1, pos);
#line 418 "filter/f-inst.c"
item->sym = whati->sym;
#line 418

#undef whati
#line 435 "filter/f-inst.c"
#undef item
#line 435
  dest->items[pos].fi_code = what->fi_code;
#line 435
  dest->items[pos].lineno = what->lineno;
#line 435
  break;
#line 435
}
#line 435

#line 441 "filter/f-inst.c"
 /* Linearize for FI_VAR_GET */
#line 441
case FI_VAR_GET: {
#line 441
#define whati (&(what->i_FI_VAR_GET))
#line 441
#define item (&(dest->items[pos].i_FI_VAR_GET))
#line 441
  #line 436 "filter/f-inst.c"
item->sym = whati->sym;
#line 436

#undef whati
#line 441 "filter/f-inst.c"
#undef item
#line 441
  dest->items[pos].fi_code = what->fi_code;
#line 441
  dest->items[pos].lineno = what->lineno;
#line 441
  break;
#line 441
}
#line 441

#line 453 "filter/f-inst.c"
 /* Linearize for FI_CONSTANT */
#line 453
case FI_CONSTANT: {
#line 453
#define whati (&(what->i_FI_CONSTANT))
#line 453
#define item (&(dest->items[pos].i_FI_CONSTANT))
#line 453
  #line 442 "filter/f-inst.c"
item->val = whati->val;
#line 442

#undef whati
#line 453 "filter/f-inst.c"
#undef item
#line 453
  dest->items[pos].fi_code = what->fi_code;
#line 453
  dest->items[pos].lineno = what->lineno;
#line 453
  break;
#line 453
}
#line 453

#line 461 "filter/f-inst.c"
 /* Linearize for FI_CONDITION */
#line 461
case FI_CONDITION: {
#line 461
#define whati (&(what->i_FI_CONDITION))
#line 461
#define item (&(dest->items[pos].i_FI_CONDITION))
#line 461
  #line 454 "filter/f-inst.c"

#line 454
pos = linearize(dest, whati->f1, pos);
#line 456 "filter/f-inst.c"
item->fl2 = f_linearize(whati->f2);
#line 458 "filter/f-inst.c"
item->fl3 = f_linearize(whati->f3);
#undef whati
#line 461 "filter/f-inst.c"
#undef item
#line 461
  dest->items[pos].fi_code = what->fi_code;
#line 461
  dest->items[pos].lineno = what->lineno;
#line 461
  break;
#line 461
}
#line 461

#line 470 "filter/f-inst.c"
 /* Linearize for FI_PRINT */
#line 470
case FI_PRINT: {
#line 470
#define whati (&(what->i_FI_PRINT))
#line 470
#define item (&(dest->items[pos].i_FI_PRINT))
#line 470
  #line 463 "filter/f-inst.c"
  pos = linearize(dest, whati->fvar, pos);
#line 463
  item->varcount = whati->varcount;
#undef whati
#line 470 "filter/f-inst.c"
#undef item
#line 470
  dest->items[pos].fi_code = what->fi_code;
#line 470
  dest->items[pos].lineno = what->lineno;
#line 470
  break;
#line 470
}
#line 470

#line 477 "filter/f-inst.c"
 /* Linearize for FI_FLUSH */
#line 477
case FI_FLUSH: {
#line 477
#define whati (&(what->i_FI_FLUSH))
#line 477
#define item (&(dest->items[pos].i_FI_FLUSH))
#line 477
  #undef whati
#line 477
#undef item
#line 477
  dest->items[pos].fi_code = what->fi_code;
#line 477
  dest->items[pos].lineno = what->lineno;
#line 477
  break;
#line 477
}
#line 477

#line 493 "filter/f-inst.c"
 /* Linearize for FI_DIE */
#line 493
case FI_DIE: {
#line 493
#define whati (&(what->i_FI_DIE))
#line 493
#define item (&(dest->items[pos].i_FI_DIE))
#line 493
  #line 479 "filter/f-inst.c"
item->fret = whati->fret;
#line 479

#undef whati
#line 493 "filter/f-inst.c"
#undef item
#line 493
  dest->items[pos].fi_code = what->fi_code;
#line 493
  dest->items[pos].lineno = what->lineno;
#line 493
  break;
#line 493
}
#line 493

#line 517 "filter/f-inst.c"
 /* Linearize for FI_RTA_GET */
#line 517
case FI_RTA_GET: {
#line 517
#define whati (&(what->i_FI_RTA_GET))
#line 517
#define item (&(dest->items[pos].i_FI_RTA_GET))
#line 517
  #line 495 "filter/f-inst.c"
item->sa = whati->sa;
#line 495

#undef whati
#line 517 "filter/f-inst.c"
#undef item
#line 517
  dest->items[pos].fi_code = what->fi_code;
#line 517
  dest->items[pos].lineno = what->lineno;
#line 517
  break;
#line 517
}
#line 517

#line 587 "filter/f-inst.c"
 /* Linearize for FI_RTA_SET */
#line 587
case FI_RTA_SET: {
#line 587
#define whati (&(what->i_FI_RTA_SET))
#line 587
#define item (&(dest->items[pos].i_FI_RTA_SET))
#line 587
  #line 519 "filter/f-inst.c"

#line 519
pos = linearize(dest, whati->f1, pos);
#line 520 "filter/f-inst.c"
item->sa = whati->sa;
#line 520

#undef whati
#line 587 "filter/f-inst.c"
#undef item
#line 587
  dest->items[pos].fi_code = what->fi_code;
#line 587
  dest->items[pos].lineno = what->lineno;
#line 587
  break;
#line 587
}
#line 587

#line 661 "filter/f-inst.c"
 /* Linearize for FI_EA_GET */
#line 661
case FI_EA_GET: {
#line 661
#define whati (&(what->i_FI_EA_GET))
#line 661
#define item (&(dest->items[pos].i_FI_EA_GET))
#line 661
  #line 588 "filter/f-inst.c"
item->da = whati->da;
#line 588

#undef whati
#line 661 "filter/f-inst.c"
#undef item
#line 661
  dest->items[pos].fi_code = what->fi_code;
#line 661
  dest->items[pos].lineno = what->lineno;
#line 661
  break;
#line 661
}
#line 661

#line 758 "filter/f-inst.c"
 /* Linearize for FI_EA_SET */
#line 758
case FI_EA_SET: {
#line 758
#define whati (&(what->i_FI_EA_SET))
#line 758
#define item (&(dest->items[pos].i_FI_EA_SET))
#line 758
  #line 664 "filter/f-inst.c"

#line 664
pos = linearize(dest, whati->f1, pos);
#line 665 "filter/f-inst.c"
item->da = whati->da;
#line 665

#undef whati
#line 758 "filter/f-inst.c"
#undef item
#line 758
  dest->items[pos].fi_code = what->fi_code;
#line 758
  dest->items[pos].lineno = what->lineno;
#line 758
  break;
#line 758
}
#line 758

#line 780 "filter/f-inst.c"
 /* Linearize for FI_EA_UNSET */
#line 780
case FI_EA_UNSET: {
#line 780
#define whati (&(what->i_FI_EA_UNSET))
#line 780
#define item (&(dest->items[pos].i_FI_EA_UNSET))
#line 780
  #line 759 "filter/f-inst.c"
item->da = whati->da;
#line 759

#undef whati
#line 780 "filter/f-inst.c"
#undef item
#line 780
  dest->items[pos].fi_code = what->fi_code;
#line 780
  dest->items[pos].lineno = what->lineno;
#line 780
  break;
#line 780
}
#line 780

#line 785 "filter/f-inst.c"
 /* Linearize for FI_PREF_GET */
#line 785
case FI_PREF_GET: {
#line 785
#define whati (&(what->i_FI_PREF_GET))
#line 785
#define item (&(dest->items[pos].i_FI_PREF_GET))
#line 785
  #undef whati
#line 785
#undef item
#line 785
  dest->items[pos].fi_code = what->fi_code;
#line 785
  dest->items[pos].lineno = what->lineno;
#line 785
  break;
#line 785
}
#line 785

#line 794 "filter/f-inst.c"
 /* Linearize for FI_PREF_SET */
#line 794
case FI_PREF_SET: {
#line 794
#define whati (&(what->i_FI_PREF_SET))
#line 794
#define item (&(dest->items[pos].i_FI_PREF_SET))
#line 794
  #line 787 "filter/f-inst.c"

#line 787
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 794 "filter/f-inst.c"
#undef item
#line 794
  dest->items[pos].fi_code = what->fi_code;
#line 794
  dest->items[pos].lineno = what->lineno;
#line 794
  break;
#line 794
}
#line 794

#line 806 "filter/f-inst.c"
 /* Linearize for FI_LENGTH */
#line 806
case FI_LENGTH: {
#line 806
#define whati (&(what->i_FI_LENGTH))
#line 806
#define item (&(dest->items[pos].i_FI_LENGTH))
#line 806
  #line 795 "filter/f-inst.c"

#line 795
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 806 "filter/f-inst.c"
#undef item
#line 806
  dest->items[pos].fi_code = what->fi_code;
#line 806
  dest->items[pos].lineno = what->lineno;
#line 806
  break;
#line 806
}
#line 806

#line 818 "filter/f-inst.c"
 /* Linearize for FI_SADR_SRC */
#line 818
case FI_SADR_SRC: {
#line 818
#define whati (&(what->i_FI_SADR_SRC))
#line 818
#define item (&(dest->items[pos].i_FI_SADR_SRC))
#line 818
  #line 807 "filter/f-inst.c"

#line 807
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 818 "filter/f-inst.c"
#undef item
#line 818
  dest->items[pos].fi_code = what->fi_code;
#line 818
  dest->items[pos].lineno = what->lineno;
#line 818
  break;
#line 818
}
#line 818

#line 828 "filter/f-inst.c"
 /* Linearize for FI_ROA_MAXLEN */
#line 828
case FI_ROA_MAXLEN: {
#line 828
#define whati (&(what->i_FI_ROA_MAXLEN))
#line 828
#define item (&(dest->items[pos].i_FI_ROA_MAXLEN))
#line 828
  #line 819 "filter/f-inst.c"

#line 819
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 828 "filter/f-inst.c"
#undef item
#line 828
  dest->items[pos].fi_code = what->fi_code;
#line 828
  dest->items[pos].lineno = what->lineno;
#line 828
  break;
#line 828
}
#line 828

#line 838 "filter/f-inst.c"
 /* Linearize for FI_ROA_ASN */
#line 838
case FI_ROA_ASN: {
#line 838
#define whati (&(what->i_FI_ROA_ASN))
#line 838
#define item (&(dest->items[pos].i_FI_ROA_ASN))
#line 838
  #line 829 "filter/f-inst.c"

#line 829
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 838 "filter/f-inst.c"
#undef item
#line 838
  dest->items[pos].fi_code = what->fi_code;
#line 838
  dest->items[pos].lineno = what->lineno;
#line 838
  break;
#line 838
}
#line 838

#line 843 "filter/f-inst.c"
 /* Linearize for FI_IP */
#line 843
case FI_IP: {
#line 843
#define whati (&(what->i_FI_IP))
#line 843
#define item (&(dest->items[pos].i_FI_IP))
#line 843
  #line 839 "filter/f-inst.c"

#line 839
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 843 "filter/f-inst.c"
#undef item
#line 843
  dest->items[pos].fi_code = what->fi_code;
#line 843
  dest->items[pos].lineno = what->lineno;
#line 843
  break;
#line 843
}
#line 843

#line 850 "filter/f-inst.c"
 /* Linearize for FI_ROUTE_DISTINGUISHER */
#line 850
case FI_ROUTE_DISTINGUISHER: {
#line 850
#define whati (&(what->i_FI_ROUTE_DISTINGUISHER))
#line 850
#define item (&(dest->items[pos].i_FI_ROUTE_DISTINGUISHER))
#line 850
  #line 844 "filter/f-inst.c"

#line 844
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 850 "filter/f-inst.c"
#undef item
#line 850
  dest->items[pos].fi_code = what->fi_code;
#line 850
  dest->items[pos].lineno = what->lineno;
#line 850
  break;
#line 850
}
#line 850

#line 857 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_FIRST */
#line 857
case FI_AS_PATH_FIRST: {
#line 857
#define whati (&(what->i_FI_AS_PATH_FIRST))
#line 857
#define item (&(dest->items[pos].i_FI_AS_PATH_FIRST))
#line 857
  #line 851 "filter/f-inst.c"

#line 851
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 857 "filter/f-inst.c"
#undef item
#line 857
  dest->items[pos].fi_code = what->fi_code;
#line 857
  dest->items[pos].lineno = what->lineno;
#line 857
  break;
#line 857
}
#line 857

#line 864 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_LAST */
#line 864
case FI_AS_PATH_LAST: {
#line 864
#define whati (&(what->i_FI_AS_PATH_LAST))
#line 864
#define item (&(dest->items[pos].i_FI_AS_PATH_LAST))
#line 864
  #line 858 "filter/f-inst.c"

#line 858
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 864 "filter/f-inst.c"
#undef item
#line 864
  dest->items[pos].fi_code = what->fi_code;
#line 864
  dest->items[pos].lineno = what->lineno;
#line 864
  break;
#line 864
}
#line 864

#line 869 "filter/f-inst.c"
 /* Linearize for FI_AS_PATH_LAST_NAG */
#line 869
case FI_AS_PATH_LAST_NAG: {
#line 869
#define whati (&(what->i_FI_AS_PATH_LAST_NAG))
#line 869
#define item (&(dest->items[pos].i_FI_AS_PATH_LAST_NAG))
#line 869
  #line 865 "filter/f-inst.c"

#line 865
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 869 "filter/f-inst.c"
#undef item
#line 869
  dest->items[pos].fi_code = what->fi_code;
#line 869
  dest->items[pos].lineno = what->lineno;
#line 869
  break;
#line 869
}
#line 869

#line 896 "filter/f-inst.c"
 /* Linearize for FI_RETURN */
#line 896
case FI_RETURN: {
#line 896
#define whati (&(what->i_FI_RETURN))
#line 896
#define item (&(dest->items[pos].i_FI_RETURN))
#line 896
  #line 872 "filter/f-inst.c"

#line 872
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 896 "filter/f-inst.c"
#undef item
#line 896
  dest->items[pos].fi_code = what->fi_code;
#line 896
  dest->items[pos].lineno = what->lineno;
#line 896
  break;
#line 896
}
#line 896

#line 922 "filter/f-inst.c"
 /* Linearize for FI_CALL */
#line 922
case FI_CALL: {
#line 922
#define whati (&(what->i_FI_CALL))
#line 922
#define item (&(dest->items[pos].i_FI_CALL))
#line 922
  #line 898 "filter/f-inst.c"
item->sym = whati->sym;
#line 898

#undef whati
#line 922 "filter/f-inst.c"
#undef item
#line 922
  dest->items[pos].fi_code = what->fi_code;
#line 922
  dest->items[pos].lineno = what->lineno;
#line 922
  break;
#line 922
}
#line 922

#line 927 "filter/f-inst.c"
 /* Linearize for FI_DROP_RESULT */
#line 927
case FI_DROP_RESULT: {
#line 927
#define whati (&(what->i_FI_DROP_RESULT))
#line 927
#define item (&(dest->items[pos].i_FI_DROP_RESULT))
#line 927
  #line 924 "filter/f-inst.c"

#line 924
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 927 "filter/f-inst.c"
#undef item
#line 927
  dest->items[pos].fi_code = what->fi_code;
#line 927
  dest->items[pos].lineno = what->lineno;
#line 927
  break;
#line 927
}
#line 927

#line 946 "filter/f-inst.c"
 /* Linearize for FI_SWITCH */
#line 946
case FI_SWITCH: {
#line 946
#define whati (&(what->i_FI_SWITCH))
#line 946
#define item (&(dest->items[pos].i_FI_SWITCH))
#line 946
  #line 928 "filter/f-inst.c"

#line 928
pos = linearize(dest, whati->f1, pos);
#line 930 "filter/f-inst.c"
item->tree = whati->tree;
#line 930

#undef whati
#line 946 "filter/f-inst.c"
#undef item
#line 946
  dest->items[pos].fi_code = what->fi_code;
#line 946
  dest->items[pos].lineno = what->lineno;
#line 946
  break;
#line 946
}
#line 946

#line 954 "filter/f-inst.c"
 /* Linearize for FI_IP_MASK */
#line 954
case FI_IP_MASK: {
#line 954
#define whati (&(what->i_FI_IP_MASK))
#line 954
#define item (&(dest->items[pos].i_FI_IP_MASK))
#line 954
  #line 947 "filter/f-inst.c"

#line 947
pos = linearize(dest, whati->f1, pos);
#line 948 "filter/f-inst.c"

#line 948
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 954 "filter/f-inst.c"
#undef item
#line 954
  dest->items[pos].fi_code = what->fi_code;
#line 954
  dest->items[pos].lineno = what->lineno;
#line 954
  break;
#line 954
}
#line 954

#line 960 "filter/f-inst.c"
 /* Linearize for FI_PATH_PREPEND */
#line 960
case FI_PATH_PREPEND: {
#line 960
#define whati (&(what->i_FI_PATH_PREPEND))
#line 960
#define item (&(dest->items[pos].i_FI_PATH_PREPEND))
#line 960
  #line 955 "filter/f-inst.c"

#line 955
pos = linearize(dest, whati->f1, pos);
#line 956 "filter/f-inst.c"

#line 956
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 960 "filter/f-inst.c"
#undef item
#line 960
  dest->items[pos].fi_code = what->fi_code;
#line 960
  dest->items[pos].lineno = what->lineno;
#line 960
  break;
#line 960
}
#line 960

#line 1015 "filter/f-inst.c"
 /* Linearize for FI_CLIST_ADD */
#line 1015
case FI_CLIST_ADD: {
#line 1015
#define whati (&(what->i_FI_CLIST_ADD))
#line 1015
#define item (&(dest->items[pos].i_FI_CLIST_ADD))
#line 1015
  #line 961 "filter/f-inst.c"

#line 961
pos = linearize(dest, whati->f1, pos);
#line 962 "filter/f-inst.c"

#line 962
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1015 "filter/f-inst.c"
#undef item
#line 1015
  dest->items[pos].fi_code = what->fi_code;
#line 1015
  dest->items[pos].lineno = what->lineno;
#line 1015
  break;
#line 1015
}
#line 1015

#line 1075 "filter/f-inst.c"
 /* Linearize for FI_CLIST_DEL */
#line 1075
case FI_CLIST_DEL: {
#line 1075
#define whati (&(what->i_FI_CLIST_DEL))
#line 1075
#define item (&(dest->items[pos].i_FI_CLIST_DEL))
#line 1075
  #line 1016 "filter/f-inst.c"

#line 1016
pos = linearize(dest, whati->f1, pos);
#line 1017 "filter/f-inst.c"

#line 1017
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1075 "filter/f-inst.c"
#undef item
#line 1075
  dest->items[pos].fi_code = what->fi_code;
#line 1075
  dest->items[pos].lineno = what->lineno;
#line 1075
  break;
#line 1075
}
#line 1075

#line 1121 "filter/f-inst.c"
 /* Linearize for FI_CLIST_FILTER */
#line 1121
case FI_CLIST_FILTER: {
#line 1121
#define whati (&(what->i_FI_CLIST_FILTER))
#line 1121
#define item (&(dest->items[pos].i_FI_CLIST_FILTER))
#line 1121
  #line 1076 "filter/f-inst.c"

#line 1076
pos = linearize(dest, whati->f1, pos);
#line 1077 "filter/f-inst.c"

#line 1077
pos = linearize(dest, whati->f2, pos);
#undef whati
#line 1121 "filter/f-inst.c"
#undef item
#line 1121
  dest->items[pos].fi_code = what->fi_code;
#line 1121
  dest->items[pos].lineno = what->lineno;
#line 1121
  break;
#line 1121
}
#line 1121

#line 1151 "filter/f-inst.c"
 /* Linearize for FI_ROA_CHECK_IMPLICIT */
#line 1151
case FI_ROA_CHECK_IMPLICIT: {
#line 1151
#define whati (&(what->i_FI_ROA_CHECK_IMPLICIT))
#line 1151
#define item (&(dest->items[pos].i_FI_ROA_CHECK_IMPLICIT))
#line 1151
  #line 1123 "filter/f-inst.c"
item->rtc = whati->rtc;
#line 1123

#undef whati
#line 1151 "filter/f-inst.c"
#undef item
#line 1151
  dest->items[pos].fi_code = what->fi_code;
#line 1151
  dest->items[pos].lineno = what->lineno;
#line 1151
  break;
#line 1151
}
#line 1151

#line 1173 "filter/f-inst.c"
 /* Linearize for FI_ROA_CHECK_EXPLICIT */
#line 1173
case FI_ROA_CHECK_EXPLICIT: {
#line 1173
#define whati (&(what->i_FI_ROA_CHECK_EXPLICIT))
#line 1173
#define item (&(dest->items[pos].i_FI_ROA_CHECK_EXPLICIT))
#line 1173
  #line 1153 "filter/f-inst.c"

#line 1153
pos = linearize(dest, whati->f1, pos);
#line 1154 "filter/f-inst.c"

#line 1154
pos = linearize(dest, whati->f2, pos);
#line 1155 "filter/f-inst.c"
item->rtc = whati->rtc;
#line 1155

#undef whati
#line 1173 "filter/f-inst.c"
#undef item
#line 1173
  dest->items[pos].fi_code = what->fi_code;
#line 1173
  dest->items[pos].lineno = what->lineno;
#line 1173
  break;
#line 1173
}
#line 1173

#line 1178 "filter/f-inst.c"
 /* Linearize for FI_FORMAT */
#line 1178
case FI_FORMAT: {
#line 1178
#define whati (&(what->i_FI_FORMAT))
#line 1178
#define item (&(dest->items[pos].i_FI_FORMAT))
#line 1178
  #line 1174 "filter/f-inst.c"

#line 1174
pos = linearize(dest, whati->f1, pos);
#undef whati
#line 1178 "filter/f-inst.c"
#undef item
#line 1178
  dest->items[pos].fi_code = what->fi_code;
#line 1178
  dest->items[pos].lineno = what->lineno;
#line 1178
  break;
#line 1178
}
#line 1178

#line 578 "filter/decl.m4"
 /* Linearize for FI_ASSERT */
#line 578
case FI_ASSERT: {
#line 578
#define whati (&(what->i_FI_ASSERT))
#line 578
#define item (&(dest->items[pos].i_FI_ASSERT))
#line 578
  #line 1180 "filter/f-inst.c"

#line 1180
pos = linearize(dest, whati->f1, pos);
#line 1182 "filter/f-inst.c"
item->s = whati->s;
#line 1182

#undef whati
#line 578 "filter/decl.m4"
#undef item
#line 578
  dest->items[pos].fi_code = what->fi_code;
#line 578
  dest->items[pos].lineno = what->lineno;
#line 578
  break;
#line 578
}
#line 578

#line 477 "filter/decl.m4"

    }
    pos++;
  }
  return pos;
}

struct f_line *
f_linearize_concat(const struct f_inst * const inst[], uint count)
{
  uint len = 0;
  for (uint i=0; i<count; i++)
    for (const struct f_inst *what = inst[i]; what; what = what->next)
      len += what->size;

  struct f_line *out = cfg_allocz(sizeof(struct f_line) + sizeof(struct f_line_item)*len);

  for (uint i=0; i<count; i++)
    out->len = linearize(out, inst[i], out->len);

#if DEBUGGING
  f_dump_line(out, 0);
#endif
  return out;
}

/* Filter line comparison */
int
f_same(const struct f_line *fl1, const struct f_line *fl2)
{
  if ((!fl1) && (!fl2))
    return 1;
  if ((!fl1) || (!fl2))
    return 0;
  if (fl1->len != fl2->len)
    return 0;
  for (uint i=0; i<fl1->len; i++) {
#define f1_ (&(fl1->items[i]))
#define f2_ (&(fl2->items[i]))
    if (f1_->fi_code != f2_->fi_code)
      return 0;
    if (f1_->flags != f2_->flags)
      return 0;

    switch(f1_->fi_code) {
#line 211 "filter/f-inst.c"
 /* Comparison for FI_ADD */
#line 211
case FI_ADD:
#line 211
#define f1 (&(f1_->i_FI_ADD))
#line 211
#define f2 (&(f2_->i_FI_ADD))
#line 211
#undef f1
#line 211
#undef f2
#line 211
break;
#line 211

#line 216 "filter/f-inst.c"
 /* Comparison for FI_SUBTRACT */
#line 216
case FI_SUBTRACT:
#line 216
#define f1 (&(f1_->i_FI_SUBTRACT))
#line 216
#define f2 (&(f2_->i_FI_SUBTRACT))
#line 216
#undef f1
#line 216
#undef f2
#line 216
break;
#line 216

#line 221 "filter/f-inst.c"
 /* Comparison for FI_MULTIPLY */
#line 221
case FI_MULTIPLY:
#line 221
#define f1 (&(f1_->i_FI_MULTIPLY))
#line 221
#define f2 (&(f2_->i_FI_MULTIPLY))
#line 221
#undef f1
#line 221
#undef f2
#line 221
break;
#line 221

#line 227 "filter/f-inst.c"
 /* Comparison for FI_DIVIDE */
#line 227
case FI_DIVIDE:
#line 227
#define f1 (&(f1_->i_FI_DIVIDE))
#line 227
#define f2 (&(f2_->i_FI_DIVIDE))
#line 227
#undef f1
#line 227
#undef f2
#line 227
break;
#line 227

#line 234 "filter/f-inst.c"
 /* Comparison for FI_AND */
#line 234
case FI_AND:
#line 234
#define f1 (&(f1_->i_FI_AND))
#line 234
#define f2 (&(f2_->i_FI_AND))
#line 230 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 234 "filter/f-inst.c"
#undef f1
#line 234
#undef f2
#line 234
break;
#line 234

#line 242 "filter/f-inst.c"
 /* Comparison for FI_OR */
#line 242
case FI_OR:
#line 242
#define f1 (&(f1_->i_FI_OR))
#line 242
#define f2 (&(f2_->i_FI_OR))
#line 237 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 242 "filter/f-inst.c"
#undef f1
#line 242
#undef f2
#line 242
break;
#line 242

#line 252 "filter/f-inst.c"
 /* Comparison for FI_PAIR_CONSTRUCT */
#line 252
case FI_PAIR_CONSTRUCT:
#line 252
#define f1 (&(f1_->i_FI_PAIR_CONSTRUCT))
#line 252
#define f2 (&(f2_->i_FI_PAIR_CONSTRUCT))
#line 252
#undef f1
#line 252
#undef f2
#line 252
break;
#line 252

#line 293 "filter/f-inst.c"
 /* Comparison for FI_EC_CONSTRUCT */
#line 293
case FI_EC_CONSTRUCT:
#line 293
#define f1 (&(f1_->i_FI_EC_CONSTRUCT))
#line 293
#define f2 (&(f2_->i_FI_EC_CONSTRUCT))
#line 256 "filter/f-inst.c"
if (f1->ecs != f2->ecs) return 0;
#line 256

#line 256

#line 293 "filter/f-inst.c"
#undef f1
#line 293
#undef f2
#line 293
break;
#line 293

#line 300 "filter/f-inst.c"
 /* Comparison for FI_LC_CONSTRUCT */
#line 300
case FI_LC_CONSTRUCT:
#line 300
#define f1 (&(f1_->i_FI_LC_CONSTRUCT))
#line 300
#define f2 (&(f2_->i_FI_LC_CONSTRUCT))
#line 300
#undef f1
#line 300
#undef f2
#line 300
break;
#line 300

#line 339 "filter/f-inst.c"
 /* Comparison for FI_PATHMASK_CONSTRUCT */
#line 339
case FI_PATHMASK_CONSTRUCT:
#line 339
#define f1 (&(f1_->i_FI_PATHMASK_CONSTRUCT))
#line 339
#define f2 (&(f2_->i_FI_PATHMASK_CONSTRUCT))
#line 301 "filter/f-inst.c"
  if (f1->varcount != f2->varcount) return 0;
#line 339 "filter/f-inst.c"
#undef f1
#line 339
#undef f2
#line 339
break;
#line 339

#line 345 "filter/f-inst.c"
 /* Comparison for FI_NEQ */
#line 345
case FI_NEQ:
#line 345
#define f1 (&(f1_->i_FI_NEQ))
#line 345
#define f2 (&(f2_->i_FI_NEQ))
#line 345
#undef f1
#line 345
#undef f2
#line 345
break;
#line 345

#line 351 "filter/f-inst.c"
 /* Comparison for FI_EQ */
#line 351
case FI_EQ:
#line 351
#define f1 (&(f1_->i_FI_EQ))
#line 351
#define f2 (&(f2_->i_FI_EQ))
#line 351
#undef f1
#line 351
#undef f2
#line 351
break;
#line 351

#line 360 "filter/f-inst.c"
 /* Comparison for FI_LT */
#line 360
case FI_LT:
#line 360
#define f1 (&(f1_->i_FI_LT))
#line 360
#define f2 (&(f2_->i_FI_LT))
#line 360
#undef f1
#line 360
#undef f2
#line 360
break;
#line 360

#line 369 "filter/f-inst.c"
 /* Comparison for FI_LTE */
#line 369
case FI_LTE:
#line 369
#define f1 (&(f1_->i_FI_LTE))
#line 369
#define f2 (&(f2_->i_FI_LTE))
#line 369
#undef f1
#line 369
#undef f2
#line 369
break;
#line 369

#line 374 "filter/f-inst.c"
 /* Comparison for FI_NOT */
#line 374
case FI_NOT:
#line 374
#define f1 (&(f1_->i_FI_NOT))
#line 374
#define f2 (&(f2_->i_FI_NOT))
#line 374
#undef f1
#line 374
#undef f2
#line 374
break;
#line 374

#line 383 "filter/f-inst.c"
 /* Comparison for FI_MATCH */
#line 383
case FI_MATCH:
#line 383
#define f1 (&(f1_->i_FI_MATCH))
#line 383
#define f2 (&(f2_->i_FI_MATCH))
#line 383
#undef f1
#line 383
#undef f2
#line 383
break;
#line 383

#line 392 "filter/f-inst.c"
 /* Comparison for FI_NOT_MATCH */
#line 392
case FI_NOT_MATCH:
#line 392
#define f1 (&(f1_->i_FI_NOT_MATCH))
#line 392
#define f2 (&(f2_->i_FI_NOT_MATCH))
#line 392
#undef f1
#line 392
#undef f2
#line 392
break;
#line 392

#line 397 "filter/f-inst.c"
 /* Comparison for FI_DEFINED */
#line 397
case FI_DEFINED:
#line 397
#define f1 (&(f1_->i_FI_DEFINED))
#line 397
#define f2 (&(f2_->i_FI_DEFINED))
#line 397
#undef f1
#line 397
#undef f2
#line 397
break;
#line 397

#line 409 "filter/f-inst.c"
 /* Comparison for FI_TYPE */
#line 409
case FI_TYPE:
#line 409
#define f1 (&(f1_->i_FI_TYPE))
#line 409
#define f2 (&(f2_->i_FI_TYPE))
#line 409
#undef f1
#line 409
#undef f2
#line 409
break;
#line 409

#line 415 "filter/f-inst.c"
 /* Comparison for FI_IS_V4 */
#line 415
case FI_IS_V4:
#line 415
#define f1 (&(f1_->i_FI_IS_V4))
#line 415
#define f2 (&(f2_->i_FI_IS_V4))
#line 415
#undef f1
#line 415
#undef f2
#line 415
break;
#line 415

#line 435 "filter/f-inst.c"
 /* Comparison for FI_VAR_SET */
#line 435
case FI_VAR_SET:
#line 435
#define f1 (&(f1_->i_FI_VAR_SET))
#line 435
#define f2 (&(f2_->i_FI_VAR_SET))
#line 418 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 418

#line 418

#line 435 "filter/f-inst.c"
#undef f1
#line 435
#undef f2
#line 435
break;
#line 435

#line 441 "filter/f-inst.c"
 /* Comparison for FI_VAR_GET */
#line 441
case FI_VAR_GET:
#line 441
#define f1 (&(f1_->i_FI_VAR_GET))
#line 441
#define f2 (&(f2_->i_FI_VAR_GET))
#line 436 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 436

#line 436

#line 441 "filter/f-inst.c"
#undef f1
#line 441
#undef f2
#line 441
break;
#line 441

#line 453 "filter/f-inst.c"
 /* Comparison for FI_CONSTANT */
#line 453
case FI_CONSTANT:
#line 453
#define f1 (&(f1_->i_FI_CONSTANT))
#line 453
#define f2 (&(f2_->i_FI_CONSTANT))
#line 442 "filter/f-inst.c"
if ( !val_same(&(f1->val), &(f2->val)) ) return 0;
#line 442

#line 442

#line 453 "filter/f-inst.c"
#undef f1
#line 453
#undef f2
#line 453
break;
#line 453

#line 461 "filter/f-inst.c"
 /* Comparison for FI_CONDITION */
#line 461
case FI_CONDITION:
#line 461
#define f1 (&(f1_->i_FI_CONDITION))
#line 461
#define f2 (&(f2_->i_FI_CONDITION))
#line 456 "filter/f-inst.c"
if (!f_same(f1->fl2, f2->fl2)) return 0;
#line 458 "filter/f-inst.c"
if (!f_same(f1->fl3, f2->fl3)) return 0;
#line 461 "filter/f-inst.c"
#undef f1
#line 461
#undef f2
#line 461
break;
#line 461

#line 470 "filter/f-inst.c"
 /* Comparison for FI_PRINT */
#line 470
case FI_PRINT:
#line 470
#define f1 (&(f1_->i_FI_PRINT))
#line 470
#define f2 (&(f2_->i_FI_PRINT))
#line 463 "filter/f-inst.c"
  if (f1->varcount != f2->varcount) return 0;
#line 470 "filter/f-inst.c"
#undef f1
#line 470
#undef f2
#line 470
break;
#line 470

#line 477 "filter/f-inst.c"
 /* Comparison for FI_FLUSH */
#line 477
case FI_FLUSH:
#line 477
#define f1 (&(f1_->i_FI_FLUSH))
#line 477
#define f2 (&(f2_->i_FI_FLUSH))
#line 477
#undef f1
#line 477
#undef f2
#line 477
break;
#line 477

#line 493 "filter/f-inst.c"
 /* Comparison for FI_DIE */
#line 493
case FI_DIE:
#line 493
#define f1 (&(f1_->i_FI_DIE))
#line 493
#define f2 (&(f2_->i_FI_DIE))
#line 479 "filter/f-inst.c"
if (f1->fret != f2->fret) return 0;
#line 479

#line 479

#line 493 "filter/f-inst.c"
#undef f1
#line 493
#undef f2
#line 493
break;
#line 493

#line 517 "filter/f-inst.c"
 /* Comparison for FI_RTA_GET */
#line 517
case FI_RTA_GET:
#line 517
#define f1 (&(f1_->i_FI_RTA_GET))
#line 517
#define f2 (&(f2_->i_FI_RTA_GET))
#line 495 "filter/f-inst.c"
if (f1->sa.sa_code != f2->sa.sa_code) return 0;
#line 495

#line 495

#line 517 "filter/f-inst.c"
#undef f1
#line 517
#undef f2
#line 517
break;
#line 517

#line 587 "filter/f-inst.c"
 /* Comparison for FI_RTA_SET */
#line 587
case FI_RTA_SET:
#line 587
#define f1 (&(f1_->i_FI_RTA_SET))
#line 587
#define f2 (&(f2_->i_FI_RTA_SET))
#line 520 "filter/f-inst.c"
if (f1->sa.sa_code != f2->sa.sa_code) return 0;
#line 520

#line 520

#line 587 "filter/f-inst.c"
#undef f1
#line 587
#undef f2
#line 587
break;
#line 587

#line 661 "filter/f-inst.c"
 /* Comparison for FI_EA_GET */
#line 661
case FI_EA_GET:
#line 661
#define f1 (&(f1_->i_FI_EA_GET))
#line 661
#define f2 (&(f2_->i_FI_EA_GET))
#line 588 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 588

#line 588

#line 661 "filter/f-inst.c"
#undef f1
#line 661
#undef f2
#line 661
break;
#line 661

#line 758 "filter/f-inst.c"
 /* Comparison for FI_EA_SET */
#line 758
case FI_EA_SET:
#line 758
#define f1 (&(f1_->i_FI_EA_SET))
#line 758
#define f2 (&(f2_->i_FI_EA_SET))
#line 665 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 665

#line 665

#line 758 "filter/f-inst.c"
#undef f1
#line 758
#undef f2
#line 758
break;
#line 758

#line 780 "filter/f-inst.c"
 /* Comparison for FI_EA_UNSET */
#line 780
case FI_EA_UNSET:
#line 780
#define f1 (&(f1_->i_FI_EA_UNSET))
#line 780
#define f2 (&(f2_->i_FI_EA_UNSET))
#line 759 "filter/f-inst.c"
if (f1->da.ea_code != f2->da.ea_code) return 0;
#line 759

#line 759

#line 780 "filter/f-inst.c"
#undef f1
#line 780
#undef f2
#line 780
break;
#line 780

#line 785 "filter/f-inst.c"
 /* Comparison for FI_PREF_GET */
#line 785
case FI_PREF_GET:
#line 785
#define f1 (&(f1_->i_FI_PREF_GET))
#line 785
#define f2 (&(f2_->i_FI_PREF_GET))
#line 785
#undef f1
#line 785
#undef f2
#line 785
break;
#line 785

#line 794 "filter/f-inst.c"
 /* Comparison for FI_PREF_SET */
#line 794
case FI_PREF_SET:
#line 794
#define f1 (&(f1_->i_FI_PREF_SET))
#line 794
#define f2 (&(f2_->i_FI_PREF_SET))
#line 794
#undef f1
#line 794
#undef f2
#line 794
break;
#line 794

#line 806 "filter/f-inst.c"
 /* Comparison for FI_LENGTH */
#line 806
case FI_LENGTH:
#line 806
#define f1 (&(f1_->i_FI_LENGTH))
#line 806
#define f2 (&(f2_->i_FI_LENGTH))
#line 806
#undef f1
#line 806
#undef f2
#line 806
break;
#line 806

#line 818 "filter/f-inst.c"
 /* Comparison for FI_SADR_SRC */
#line 818
case FI_SADR_SRC:
#line 818
#define f1 (&(f1_->i_FI_SADR_SRC))
#line 818
#define f2 (&(f2_->i_FI_SADR_SRC))
#line 818
#undef f1
#line 818
#undef f2
#line 818
break;
#line 818

#line 828 "filter/f-inst.c"
 /* Comparison for FI_ROA_MAXLEN */
#line 828
case FI_ROA_MAXLEN:
#line 828
#define f1 (&(f1_->i_FI_ROA_MAXLEN))
#line 828
#define f2 (&(f2_->i_FI_ROA_MAXLEN))
#line 828
#undef f1
#line 828
#undef f2
#line 828
break;
#line 828

#line 838 "filter/f-inst.c"
 /* Comparison for FI_ROA_ASN */
#line 838
case FI_ROA_ASN:
#line 838
#define f1 (&(f1_->i_FI_ROA_ASN))
#line 838
#define f2 (&(f2_->i_FI_ROA_ASN))
#line 838
#undef f1
#line 838
#undef f2
#line 838
break;
#line 838

#line 843 "filter/f-inst.c"
 /* Comparison for FI_IP */
#line 843
case FI_IP:
#line 843
#define f1 (&(f1_->i_FI_IP))
#line 843
#define f2 (&(f2_->i_FI_IP))
#line 843
#undef f1
#line 843
#undef f2
#line 843
break;
#line 843

#line 850 "filter/f-inst.c"
 /* Comparison for FI_ROUTE_DISTINGUISHER */
#line 850
case FI_ROUTE_DISTINGUISHER:
#line 850
#define f1 (&(f1_->i_FI_ROUTE_DISTINGUISHER))
#line 850
#define f2 (&(f2_->i_FI_ROUTE_DISTINGUISHER))
#line 850
#undef f1
#line 850
#undef f2
#line 850
break;
#line 850

#line 857 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_FIRST */
#line 857
case FI_AS_PATH_FIRST:
#line 857
#define f1 (&(f1_->i_FI_AS_PATH_FIRST))
#line 857
#define f2 (&(f2_->i_FI_AS_PATH_FIRST))
#line 857
#undef f1
#line 857
#undef f2
#line 857
break;
#line 857

#line 864 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_LAST */
#line 864
case FI_AS_PATH_LAST:
#line 864
#define f1 (&(f1_->i_FI_AS_PATH_LAST))
#line 864
#define f2 (&(f2_->i_FI_AS_PATH_LAST))
#line 864
#undef f1
#line 864
#undef f2
#line 864
break;
#line 864

#line 869 "filter/f-inst.c"
 /* Comparison for FI_AS_PATH_LAST_NAG */
#line 869
case FI_AS_PATH_LAST_NAG:
#line 869
#define f1 (&(f1_->i_FI_AS_PATH_LAST_NAG))
#line 869
#define f2 (&(f2_->i_FI_AS_PATH_LAST_NAG))
#line 869
#undef f1
#line 869
#undef f2
#line 869
break;
#line 869

#line 896 "filter/f-inst.c"
 /* Comparison for FI_RETURN */
#line 896
case FI_RETURN:
#line 896
#define f1 (&(f1_->i_FI_RETURN))
#line 896
#define f2 (&(f2_->i_FI_RETURN))
#line 896
#undef f1
#line 896
#undef f2
#line 896
break;
#line 896

#line 922 "filter/f-inst.c"
 /* Comparison for FI_CALL */
#line 922
case FI_CALL:
#line 922
#define f1 (&(f1_->i_FI_CALL))
#line 922
#define f2 (&(f2_->i_FI_CALL))
#line 898 "filter/f-inst.c"
if (strcmp(f1->sym->name, f2->sym->name) || (f1->sym->class != f2->sym->class)) return 0;
#line 898

#line 898


#line 901 "filter/f-inst.c"
      if (!(f2->sym->flags & SYM_FLAG_SAME))
	return 0;
    #line 922 "filter/f-inst.c"
#undef f1
#line 922
#undef f2
#line 922
break;
#line 922

#line 927 "filter/f-inst.c"
 /* Comparison for FI_DROP_RESULT */
#line 927
case FI_DROP_RESULT:
#line 927
#define f1 (&(f1_->i_FI_DROP_RESULT))
#line 927
#define f2 (&(f2_->i_FI_DROP_RESULT))
#line 927
#undef f1
#line 927
#undef f2
#line 927
break;
#line 927

#line 946 "filter/f-inst.c"
 /* Comparison for FI_SWITCH */
#line 946
case FI_SWITCH:
#line 946
#define f1 (&(f1_->i_FI_SWITCH))
#line 946
#define f2 (&(f2_->i_FI_SWITCH))
#line 930 "filter/f-inst.c"
if (!same_tree(f1->tree, f2->tree)) return 0;
#line 930

#line 930

#line 946 "filter/f-inst.c"
#undef f1
#line 946
#undef f2
#line 946
break;
#line 946

#line 954 "filter/f-inst.c"
 /* Comparison for FI_IP_MASK */
#line 954
case FI_IP_MASK:
#line 954
#define f1 (&(f1_->i_FI_IP_MASK))
#line 954
#define f2 (&(f2_->i_FI_IP_MASK))
#line 954
#undef f1
#line 954
#undef f2
#line 954
break;
#line 954

#line 960 "filter/f-inst.c"
 /* Comparison for FI_PATH_PREPEND */
#line 960
case FI_PATH_PREPEND:
#line 960
#define f1 (&(f1_->i_FI_PATH_PREPEND))
#line 960
#define f2 (&(f2_->i_FI_PATH_PREPEND))
#line 960
#undef f1
#line 960
#undef f2
#line 960
break;
#line 960

#line 1015 "filter/f-inst.c"
 /* Comparison for FI_CLIST_ADD */
#line 1015
case FI_CLIST_ADD:
#line 1015
#define f1 (&(f1_->i_FI_CLIST_ADD))
#line 1015
#define f2 (&(f2_->i_FI_CLIST_ADD))
#line 1015
#undef f1
#line 1015
#undef f2
#line 1015
break;
#line 1015

#line 1075 "filter/f-inst.c"
 /* Comparison for FI_CLIST_DEL */
#line 1075
case FI_CLIST_DEL:
#line 1075
#define f1 (&(f1_->i_FI_CLIST_DEL))
#line 1075
#define f2 (&(f2_->i_FI_CLIST_DEL))
#line 1075
#undef f1
#line 1075
#undef f2
#line 1075
break;
#line 1075

#line 1121 "filter/f-inst.c"
 /* Comparison for FI_CLIST_FILTER */
#line 1121
case FI_CLIST_FILTER:
#line 1121
#define f1 (&(f1_->i_FI_CLIST_FILTER))
#line 1121
#define f2 (&(f2_->i_FI_CLIST_FILTER))
#line 1121
#undef f1
#line 1121
#undef f2
#line 1121
break;
#line 1121

#line 1151 "filter/f-inst.c"
 /* Comparison for FI_ROA_CHECK_IMPLICIT */
#line 1151
case FI_ROA_CHECK_IMPLICIT:
#line 1151
#define f1 (&(f1_->i_FI_ROA_CHECK_IMPLICIT))
#line 1151
#define f2 (&(f2_->i_FI_ROA_CHECK_IMPLICIT))
#line 1123 "filter/f-inst.c"
if (strcmp(f1->rtc->name, f2->rtc->name)) return 0;
#line 1123

#line 1123

#line 1151 "filter/f-inst.c"
#undef f1
#line 1151
#undef f2
#line 1151
break;
#line 1151

#line 1173 "filter/f-inst.c"
 /* Comparison for FI_ROA_CHECK_EXPLICIT */
#line 1173
case FI_ROA_CHECK_EXPLICIT:
#line 1173
#define f1 (&(f1_->i_FI_ROA_CHECK_EXPLICIT))
#line 1173
#define f2 (&(f2_->i_FI_ROA_CHECK_EXPLICIT))
#line 1155 "filter/f-inst.c"
if (strcmp(f1->rtc->name, f2->rtc->name)) return 0;
#line 1155

#line 1155

#line 1173 "filter/f-inst.c"
#undef f1
#line 1173
#undef f2
#line 1173
break;
#line 1173

#line 1178 "filter/f-inst.c"
 /* Comparison for FI_FORMAT */
#line 1178
case FI_FORMAT:
#line 1178
#define f1 (&(f1_->i_FI_FORMAT))
#line 1178
#define f2 (&(f2_->i_FI_FORMAT))
#line 1178
#undef f1
#line 1178
#undef f2
#line 1178
break;
#line 1178

#line 578 "filter/decl.m4"
 /* Comparison for FI_ASSERT */
#line 578
case FI_ASSERT:
#line 578
#define f1 (&(f1_->i_FI_ASSERT))
#line 578
#define f2 (&(f2_->i_FI_ASSERT))
#line 1182 "filter/f-inst.c"
if (strcmp(f1->s, f2->s)) return 0;
#line 1182

#line 1182

#line 578 "filter/decl.m4"
#undef f1
#line 578
#undef f2
#line 578
break;
#line 578

#line 522 "filter/decl.m4"

    }
  }
#undef f1_
#undef f2_
  return 1;
}

#if defined(__GNUC__) && __GNUC__ >= 6
#pragma GCC diagnostic pop
#endif

